/*
 * $Id: Get_datatype.h,v 3.1 1999/11/05 14:13:42 posypkin Exp $
 */


# ifndef MPC_GET_DATATYPE
# define NoMPC_Type (tMPC_Type) 0L
# define kMPC_Type 1
# define kMPC_Basic 2
# define kMPC_Enum 3
# define kMPC_Typedef 4
# define kMPC_BitField 5
# define kMPC_Array 6
# define kMPC_Pointer 7
# define kMPC_Struct 8
# define kMPC_Union 9
# define kMPC_Function 10
# define kMPC_List 11

typedef int MPC_Rts_datatype;

typedef unsigned char MPC_TypeKind;
typedef union MPC_Type_Node * tMPC_Type;


typedef struct {
  MPC_TypeKind Kind;
  char* Name;
  int UniqueNumber;
  MPC_Rts_datatype Datatype;
} MPC_Type;

typedef struct {
  MPC_Type Base;
  int Constructor;
} MPC_Basic;

typedef MPC_Type MPC_Enum;

typedef struct {
  MPC_Type Base;
  tMPC_Type Type;
} MPC_Typedef;

typedef struct {
  MPC_Type Base;
  int Length;
  tMPC_Type Type;
} MPC_BitField;

typedef struct {
  MPC_Type Base;
  int Step;
  int Number;
  tMPC_Type Type;
  int Bit;
} MPC_Array;

typedef struct {
  MPC_Type Base;
  int Step;
  tMPC_Type Type;
} MPC_Pointer;

typedef struct {
  MPC_Type Base;
  tMPC_Type List;
} MPC_Struct;

typedef MPC_Struct MPC_Union;
typedef MPC_Type MPC_Function;

typedef struct {
  tMPC_Type Type;
  tMPC_Type Next;
} MPC_List;


typedef struct { MPC_Type_tNodeHead yyHead; char* Name; int UniqueNumber; MPC_Rts_datatype Datatype; } yMPC_Function;
typedef struct { MPC_Type_tNodeHead yyHead; tMPC_Type Type; tMPC_Type Next; } yMPC_List;

union MPC_Type_Node {
 MPC_TypeKind Kind;
 MPC_Type MPC_Type;
 MPC_Basic MPC_Basic;
 MPC_Enum MPC_Enum;
 MPC_Typedef MPC_Typedef;
 MPC_BitField MPC_BitField;
 MPC_Array MPC_Array;
 MPC_Pointer MPC_Pointer;
 MPC_Struct MPC_Struct;
 MPC_Union MPC_Union;
 MPC_Function MPC_Function;
 MPC_List MPC_List;
};

# endif
