/*****************************************************************************/
/* mpCtriv - contains set of trivial topology functions                      */
/* Coded by Dm. Arapov for A.Lastovtsky 1995-1996                            */
/* Release 1.10.96                                                           */    
/*****************************************************************************/
#include "mpC.h"
#include "mpCtriv.h"
/****************** MPC_NetType_trivial_node *********************************/
Int MPC_NetType_trivial_node( Int num, const Int* aparams,
                              Int ppower, Int ** pnodes, Int ** plinks )
  {   
    return (num == 0) ? 256 : 0; 
  }  /* MPC_NetType_trivial_node */

/***************** MPC_NetType_trivial_link **********************************/
Int MPC_NetType_trivial_link(Int fromnum, Int tonum, const Int* aparams,
                             Int ppower, Int ** pnodes, Int ** plinks)
  {
    return MPC_SHORTEST_LINK; 
  } /* MPC_NetType_trivial_link */

/**************** MPC_NetType_trivial_parent *********************************/
Int MPC_NetType_trivial_parent(const Int* params,
                               Int ppower, Int ** pnodes, Int ** plinks) 
  { 
    return 0;
  } /* MPC_NetType_trivial_parent */

/*************** MPC_NetType_trivial_power ***********************************/
Int MPC_NetType_trivial_power(const Int *p1,
                              Int ppower, Int ** pnodes, Int ** plinks) 
  {
    return 1;
  } /* MPC_NetType_trivial_power */

/************** MPC_NetType_trivial_num2coord ********************************/
void MPC_NetType_trivial_num2coord(Int num, const Int* params, Int *coord,
                                   Int ppower, Int ** pnodes, Int ** plinks) 
  {
    return;
  } /* MPC_NetType_trivial_coord */

/************** MPC_NetType_trivial_coord2num ********************************/
Int MPC_NetType_trivial_coord2num(const Int* coord, const Int *params,
                                  Int ppower, Int ** pnodes, Int ** plinks) 
  {
    return 0;
  } /* MPC_NetType_trivial_number */

                                     
