
#ifndef __HSCAL_CB_CHER2_HH
#define __HSCAL_CB_CHER2_HH



#include "../../../../include/hscalapack.h"

int hscal_cher2(
    char *uplo,
    int  *n, 
    char *calpha,
    int  *incx, 
    int  *incy, 
    int  *lda, 
    double  *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5, i__6;
    int info;
    int i__, j;
    hscalcomplex *alpha = (hscalcomplex*)calpha;

    info   = 0;
    *tcomp = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*n)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0 || alpha->r == 0.f && alpha->i == 0.f) {
	return HSCAL_SUCCESS;
    }
    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 22;
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 22;
		    }
                    *tcomp += 21;
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 22;
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 24;
		    }
                    *tcomp += 21;
		}
                *tcomp += 2;
	    }
	}
    } else {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 43;
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 22;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 43;
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 24;
		    }
		}
                *tcomp += 2;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
