
#ifndef __HSCAL_CB_CSYRK_HH
#define __HSCAL_CB_CSYRK_HH



#include "../../../../include/hscalapack.h"

int hscal_csyrk(
    char   *uplo, 
    char   *trans, 
    int    *n, 
    int    *k, 
    char   *calpha, 
    int    *lda,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, c_dim1, c_offset, i__1, i__2, i__3, i__4, i__5, 
	    i__6;
    int info;
    int i__, j, l;
    int nrowa;
    hscallogical upper;
    hscalcomplex *alpha = (hscalcomplex*)calpha;
    hscalcomplex *beta  = (hscalcomplex*)cbeta;

    *tcomp = 0;

    if (hscal_lsame(trans, "N")) {
	nrowa = *n;
    } else {
	nrowa = *k;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T")) {
	info = 2;
    } else if (*n < 0) {
	info = 3;
    } else if (*k < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldc < max(1,*n)) {
	info = 10;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || (alpha->r == 0.f && alpha->i == 0.f || *k == 0) && (
	    beta->r == 1.f && beta->i == 0.f)) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 0.f && alpha->i == 0.f) {
	if (upper) {
	    if (beta->r == 0.f && beta->i == 0.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += j*4;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += j*12;
		}
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 4;
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 12;
		    }
		}
	    }
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(trans, "N")) {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		if (beta->r == 0.f && beta->i == 0.f) {
                    *tcomp += j*4;
		} else if (beta->r != 1.f || beta->i != 0.f) {
                    *tcomp += j*12;
		}
		i__2 = *k;
		for (l = 1; l <= i__2; ++l) {
                    {
                        *tcomp += 10 + j*16;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		if (beta->r == 0.f && beta->i == 0.f) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 4;
		    }
		} else if (beta->r != 1.f || beta->i != 0.f) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 12;
		    }
		}
		i__2 = *k;
		for (l = 1; l <= i__2; ++l) {
                    {
                        *tcomp += 10;
			for (i__ = j; i__ <= i__3; ++i__) {
                            *tcomp += 16;
			}
		    }
		}
	    }
	}
    } else {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = j;
		for (i__ = 1; i__ <= i__2; ++i__) {
                    *tcomp += (*k)*14;
		    if (beta->r == 0.f && beta->i == 0.f) {
                        *tcomp += 10;
		    } else {
                        *tcomp += 20;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *n;
		for (i__ = j; i__ <= i__2; ++i__) {
                    *tcomp += (*k)*14;
		    if (beta->r == 0.f && beta->i == 0.f) {
                       *tcomp += 10;
		    } else {
                       *tcomp += 20;
		    }
		}
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
