
#ifndef __HSCAL_CB_DSYR2_HH
#define __HSCAL_CB_DSYR2_HH



#include "../../../../include/hscalapack.h"

int hscal_dsyr2(
    char   *uplo, 
    int    *n, 
    char   *calpha, 
    int    *incx,
    int    *incy,
    int    *lda, 
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2;
    int info;
    int i__, j;
    hscaldoublereal *alpha = (hscaldoublereal*)calpha;

    info   = 0;
    *tcomp = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*n)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0.) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                *tcomp += 2 + j*6;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                *tcomp += 4 + j*8;
	    }
	}
    } else {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 2;
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 6;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
                    *tcomp += 2;
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 8;
		    }
		}
                *tcomp += 2;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
