
#ifndef __HSCAL_CB_SSYMM_HH
#define __HSCAL_CB_SSYMM_HH



#include "../../../../include/hscalapack.h"

int hscal_ssymm(
    char   *side, 
    char   *uplo, 
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3;
    int info;
    int i__, j, k;
    int nrowa;
    hscallogical upper;

    hscalreal *alpha = (hscalreal*)calpha;
    hscalreal *beta  = (hscalreal*)cbeta;

    *tcomp = 0;

    if (hscal_lsame(side, "L")) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! hscal_lsame(side, "L") && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (*m < 0) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,*m)) {
	info = 9;
    } else if (*ldc < max(1,*m)) {
	info = 12;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*m == 0 || *n == 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

    if (*alpha == 0.f) {
	if (*beta == 0.f) {
          *tcomp += (*n)*(*m)*2;
	} else {
          *tcomp += (*n)*(*m)*3;
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(side, "L")) {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *m;
		for (i__ = 1; i__ <= i__2; ++i__) {
                *tcomp += 4;
		    i__3 = i__ - 1;
		    for (k = 1; k <= i__3; ++k) {
                  *tcomp += 12;
		    }
		    if (*beta == 0.f) {
                  *tcomp += 7;
		    } else {
                  *tcomp += 9;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		for (i__ = *m; i__ >= 1; --i__) {
                *tcomp += 4;
		    i__2 = *m;
		    for (k = i__ + 1; k <= i__2; ++k) {
                  *tcomp += 12;
		    }
		    if (*beta == 0.f) {
                  *tcomp += 7;
		    } else {
                  *tcomp += 9;
		    }
		}
	    }
	}
    } else {
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
          *tcomp += 3;
	    if (*beta == 0.f) {
            *tcomp += (*m)*3;
	    } else {
            *tcomp += (*m)*5;
	    }
	    i__2 = j - 1;
	    for (k = 1; k <= i__2; ++k) {
		if (upper) {
               *tcomp += 3;
		} else {
               *tcomp += 3;
		}
            *tcomp += (*m)*6;
	    }
	    i__2 = *n;
	    for (k = j + 1; k <= i__2; ++k) {
		if (upper) {
               *tcomp += 3;
		} else {
               *tcomp += 3;
		}
            *tcomp += (*m)*6;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
