
#ifndef __HSCAL_CB_SSYMV_HH
#define __HSCAL_CB_SSYMV_HH



#include "../../../../include/hscalapack.h"

int hscal_ssymv(
    char *uplo, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    hscalreal *alpha = (hscalreal*)calpha;
    hscalreal *beta  = (hscalreal*)cbeta;

    int a_dim1, a_offset, i__1, i__2;
    int info;
    int i__, j;

    *tcomp = 0;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*lda < max(1,*n)) {
	info = 5;
    } else if (*incx == 0) {
	info = 7;
    } else if (*incy == 0) {
	info = 10;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0.f && *beta == 1.f) {
	return HSCAL_SUCCESS;
    }

    if (*beta != 1.f) {
	if (*incy == 1) {
	    if (*beta == 0.f) {
                *tcomp += (*n);
	    } else {
                *tcomp += (*n);
	    }
	} else {
	    if (*beta == 0.f) {
                *tcomp += (*n)*2;
	    } else {
                *tcomp += (*n)*2;
	    }
	}
    }

    if (*alpha == 0.f) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = j - 1;
		for (i__ = 1; i__ <= i__2; ++i__) {
                    *tcomp += 8;
		}
                *tcomp += 8;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = j - 1;
		for (i__ = 1; i__ <= i__2; ++i__) {
                    *tcomp += 10;
		}
                *tcomp += 10;
	    }
	}
    } else {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *n;
		for (i__ = j + 1; i__ <= i__2; ++i__) {
                    *tcomp += 8;
		}
                *tcomp += 8;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *n;
		for (i__ = j + 1; i__ <= i__2; ++i__) {
                    *tcomp += 10;
		}
                *tcomp += 10;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif

