
#ifndef __HSCAL_CB_SSYR_HH
#define __HSCAL_CB_SSYR_HH



#include "../../../../include/hscalapack.h"

int hscal_ssyr(
    char   *uplo, 
    int    *n, 
    char   *calpha, 
    int    *incx,
    int    *lda, 
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2;
    int info;
    int i__, j;
    hscalreal *alpha = (hscalreal*)calpha;

    info    = 0;
    *tcomp  = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*lda < max(1,*n)) {
	info = 7;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0.f) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                *tcomp += 1 + j*4;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                *tcomp += 2 + j*5;
	    }
	}
    } else {
	if (*incx == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
		    *tcomp += 1;
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 4;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                {
		    *tcomp += 1;
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 5;
		    }
		}
                *tcomp += 1;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
