
#ifndef __HSCAL_CB_STRMM_HH
#define __HSCAL_CB_STRMM_HH



#include "../../../../include/hscalapack.h"

int hscal_strmm(
    char   *side, 
    char   *uplo, 
    char   *transa, 
    char   *diag,
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3;
    int info;
    int i__, j, k;
    hscallogical lside;
    int nrowa;
    hscallogical upper;
    hscallogical nounit;

    hscalreal *alpha = (hscalreal*)calpha;

    lside = hscal_lsame(side, "L");
    if (lside) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    nounit = hscal_lsame(diag, "N");
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! lside && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (! hscal_lsame(transa, "N") && ! hscal_lsame(transa,
	     "T") && ! hscal_lsame(transa, "C")) {
	info = 3;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 4;
    } else if (*m < 0) {
	info = 5;
    } else if (*n < 0) {
	info = 6;
    } else if (*lda < max(1,nrowa)) {
	info = 9;
    } else if (*ldb < max(1,*m)) {
	info = 11;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    if (*alpha == 0.f) {
      *tcomp += (*n)*(*m)*4;
	return HSCAL_SUCCESS;
    }

    if (lside) {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *m;
		    for (k = 1; k <= i__2; ++k) {
			{
                      *tcomp += 3;
			    i__3 = k - 1;
			    for (i__ = 1; i__ <= i__3; ++i__) {
                        *tcomp += 6;
			    }
			    if (nounit) {
                        *tcomp += 3;
			    }
                      *tcomp += 2;
			}
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    for (k = *m; k >= 1; --k) {
			{
                      *tcomp += 5;
			    if (nounit) {
                        *tcomp += 5;
			    }
			    i__2 = *m;
			    for (i__ = k + 1; i__ <= i__2; ++i__) {
                        *tcomp += 6;
			    }
			}
		    }
		}
	    }
	} else {
	    if (upper) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    for (i__ = *m; i__ >= 1; --i__) {
                  *tcomp += 2;
			if (nounit) {
                      *tcomp += 3;
			}
			i__2 = i__ - 1;
			for (k = 1; k <= i__2; ++k) {
                      *tcomp += 6;
			}
                  *tcomp += 3;
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *m;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                  *tcomp += 2;
			if (nounit) {
                      *tcomp += 3;
			}
			i__3 = *m;
			for (k = i__ + 1; k <= i__3; ++k) {
                      *tcomp += 6;
			}
                  *tcomp += 3;
		    }
		}
	    }
	}
    } else {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
		for (j = *n; j >= 1; --j) {
                *tcomp += 1;
		    if (nounit) {
                  *tcomp += 3;
		    }
		    i__1 = *m;
		    for (i__ = 1; i__ <= i__1; ++i__) {
                  *tcomp += 3;
		    }
		    i__1 = j - 1;
		    for (k = 1; k <= i__1; ++k) {
			{
                      *tcomp += 3;
			    i__2 = *m;
			    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 6;
			    }
			}
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                *tcomp += 1;
		    if (nounit) {
                  *tcomp += 3;
		    }
                *tcomp += (*m)*3;
		    i__2 = *n;
		    for (k = j + 1; k <= i__2; ++k) {
			{
                      *tcomp += (*m)*6+3;
			}
		    }
		}
	    }
	} else {
	    if (upper) {
		i__1 = *n;
		for (k = 1; k <= i__1; ++k) {
		    i__2 = k - 1;
		    for (j = 1; j <= i__2; ++j) {
			{
                      *tcomp += (*m)*6+3;
			}
		    }
                *tcomp += 1;
		    if (nounit) {
                  *tcomp += 3;
		    }
		    {
                  *tcomp += (*m)*3;
		    }
		}
	    } else {
		for (k = *n; k >= 1; --k) {
		    i__1 = *n;
		    for (j = k + 1; j <= i__1; ++j) {
			{
                      *tcomp += (*m)*6+3;
			}
		    }
                *tcomp += 1;
		    if (nounit) {
                  *tcomp += 3;
		    }
		    {
                  *tcomp += (*m)*3;
		    }
		}
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
