
#ifndef __HSCAL_CB_ZGERU_HH
#define __HSCAL_CB_ZGERU_HH



#include "../../../../include/hscalapack.h"

int hscal_zgeru(
    int *m, 
    int *n, 
    char *calpha,
    int *incx, 
    int *incy,
    int *lda, 
    double *tcomp
)
{
    int info;
    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;

    info = 0;
    *tcomp = 0;

    if (*m < 0) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*incx == 0) {
	info = 5;
    } else if (*incy == 0) {
	info = 7;
    } else if (*lda < max(1,*m)) {
	info = 9;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*m == 0 || *n == 0 || alpha->r == 0. && alpha->i == 0.) {
	return HSCAL_SUCCESS;
    }
    if (*incx == 1) {
       *tcomp += (*n) * ((*m)*14 + 9);
    } else {
       *tcomp += (*n) * ((*m)*15 + 9);
    }
    return HSCAL_SUCCESS;
}

#endif
