
#ifndef __HSCAL_CB_ZSYMM_HH
#define __HSCAL_CB_ZSYMM_HH



#include "../../../../include/hscalapack.h"

int hscal_zsymm(
    char   *side, 
    char   *uplo, 
    int    *m, 
    int    *n, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3, i__4, i__5, i__6;

    int info;
    int i__, j, k;
    int nrowa;
    hscallogical upper;

    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta  = (hscaldoublecomplex*)cbeta;

    *tcomp = 0;

    if (hscal_lsame(side, "L")) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! hscal_lsame(side, "L") && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (*m < 0) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,*m)) {
	info = 9;
    } else if (*ldc < max(1,*m)) {
	info = 12;
    }

    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*m == 0 || *n == 0 || alpha->r == 0. && alpha->i == 0. && (beta->r == 
	    1. && beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 0. && alpha->i == 0.) {
	if (beta->r == 0. && beta->i == 0.) {
          *tcomp += (*n)*(*m)*4;
	} else {
          *tcomp += (*n)*(*m)*12;
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(side, "L")) {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *m;
		for (i__ = 1; i__ <= i__2; ++i__) {
                *tcomp += 12;
		    i__3 = i__ - 1;
		    for (k = 1; k <= i__3; ++k) {
                  *tcomp += 30;
		    }
		    if (beta->r == 0. && beta->i == 0.) {
                  *tcomp += 20;
		    } else {
                  *tcomp += 30;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		for (i__ = *m; i__ >= 1; --i__) {
                *tcomp += 12;
		    i__2 = *m;
		    for (k = i__ + 1; k <= i__2; ++k) {
                  *tcomp += 30;
		    }
		    if (beta->r == 0. && beta->i == 0.) {
                  *tcomp += 20;
		    } else {
                  *tcomp += 30;
		    }
		}
	    }
	}
    } else {
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
          *tcomp += 10;
	    if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (*m)*12;
	    } else {
            *tcomp += (*m)*22;
	    }
	    i__2 = j - 1;
	    for (k = 1; k <= i__2; ++k) {
		if (upper) {
                *tcomp += 10;
		} else {
                *tcomp += 10;
		}
            *tcomp += (*m)*16;
	    }
	    i__2 = *n;
	    for (k = j + 1; k <= i__2; ++k) {
		if (upper) {
                *tcomp += 10;
		} else {
                *tcomp += 10;
		}
            *tcomp += (*m)*16;
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
