
#ifndef __HSCAL_CB_ZSYR2K_HH
#define __HSCAL_CB_ZSYR2K_HH



#include "../../../../include/hscalapack.h"

int hscal_zsyr2k(
    char   *uplo, 
    char   *trans, 
    int    *n, 
    int    *k, 
    char   *calpha, 
    int    *lda,
    int    *ldb,
    char   *cbeta,
    int    *ldc, 
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, i__1, i__2, 
	    i__3, i__4, i__5, i__6, i__7;
    int info;
    int i__, j, l;
    int nrowa;
    hscallogical upper;

    hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
    hscaldoublecomplex *beta  = (hscaldoublecomplex*)cbeta;

    *tcomp = 0;

    if (hscal_lsame(trans, "N")) {
	nrowa = *n;
    } else {
	nrowa = *k;
    }
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T")) {
	info = 2;
    } else if (*n < 0) {
	info = 3;
    } else if (*k < 0) {
	info = 4;
    } else if (*lda < max(1,nrowa)) {
	info = 7;
    } else if (*ldb < max(1,nrowa)) {
	info = 9;
    } else if (*ldc < max(1,*n)) {
	info = 12;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || (alpha->r == 0. && alpha->i == 0. || *k == 0) && (beta->r 
	    == 1. && beta->i == 0.)) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 0. && alpha->i == 0.) {
	if (upper) {
	    if (beta->r == 0. && beta->i == 0.) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += j*4;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += j*12;
		}
	    }
	} else {
	    if (beta->r == 0. && beta->i == 0.) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 4;
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 12;
		    }
		}
	    }
	}
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(trans, "N")) {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		if (beta->r == 0. && beta->i == 0.) {
                    *tcomp += j*4;
		} else if (beta->r != 1. || beta->i != 0.) {
                    *tcomp += j*12;
		}
		i__2 = *k;
		for (l = 1; l <= i__2; ++l) {
                    {
                        *tcomp += (22 + j*26);
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		if (beta->r == 0. && beta->i == 0.) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 4;
		    }
		} else if (beta->r != 1. || beta->i != 0.) {
		    i__2 = *n;
		    for (i__ = j; i__ <= i__2; ++i__) {
                        *tcomp += 12;
		    }
		}
		i__2 = *k;
		for (l = 1; l <= i__2; ++l) {
                    {
                        *tcomp += 22;
			i__3 = *n;
			for (i__ = j; i__ <= i__3; ++i__) {
                            *tcomp += 26;
			}
		    }
		}
	    }
	}
    } else {
	if (upper) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = j;
		for (i__ = 1; i__ <= i__2; ++i__) {
                    *tcomp += (*k)*28;
		    if (beta->r == 0. && beta->i == 0.) {
                        *tcomp += 18;
		    } else {
                        *tcomp += 28;
		    }
		}
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
		i__2 = *n;
		for (i__ = j; i__ <= i__2; ++i__) {
                    *tcomp += (*k)*28;
		    if (beta->r == 0. && beta->i == 0.) {
                        *tcomp += 18;
		    } else {
                        *tcomp += 28;
		    }
		}
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
