
#ifndef __HSCAL_CB_ZTRMV_HH
#define __HSCAL_CB_ZTRMV_HH



#include "../../../../include/hscalapack.h"

int hscal_ztrmv(
    char *uplo, 
    char *trans, 
    char *diag, 
    int *n, 
    int *lda, 
    int *incx,
    double *tcomp
)
{
    int i__1, i__2, i__3, i__4, i__5;
    int info;
    int i__, j;
    hscallogical noconj, nounit;

    *tcomp = 0;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, 
	    "T") && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,*n)) {
	info = 6;
    } else if (*incx == 0) {
	info = 8;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }
    if (*n == 0) {
	return HSCAL_SUCCESS;
    }
    noconj = hscal_lsame(trans, "T");
    nounit = hscal_lsame(diag, "N");

    if (hscal_lsame(trans, "N")) {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 2;
			i__2 = j - 1;
			for (i__ = 1; i__ <= i__2; ++i__) {
                            *tcomp += 12;
			}
			if (nounit) {
                            *tcomp += 10;
			}
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 2;                    
			i__2 = j - 1;
			for (i__ = 1; i__ <= i__2; ++i__) {
                            *tcomp += 13;
			}
			if (nounit) {
                            *tcomp += 10;
			}
		    }
                    *tcomp += 1;
		}
	    }
	} else {
	    if (*incx == 1) {
		for (j = *n; j >= 1; --j) {
                    {
                        *tcomp += 2;
			i__1 = j + 1;
			for (i__ = *n; i__ >= i__1; --i__) {
                            *tcomp += 12;
			}
			if (nounit) {
                            *tcomp += 10;
			}
		    }
		}
	    } else {
		for (j = *n; j >= 1; --j) {
                    {
                        *tcomp += 2;
			i__1 = j + 1;
			for (i__ = *n; i__ >= i__1; --i__) {
                            *tcomp += 13;
			}
			if (nounit) {
                            *tcomp += 10;
			}
		    }
                    *tcomp += 1;
		}
	    }
	}
    } else {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
		for (j = *n; j >= 1; --j) {
                    *tcomp += 2;
		    if (noconj) {
			if (nounit) {
                            *tcomp += 10;
			}
			for (i__ = j - 1; i__ >= 1; --i__) {
                            *tcomp += 12;
			}
		    } else {
			if (nounit) {
                            *tcomp += 11;
			}
			for (i__ = j - 1; i__ >= 1; --i__) {
                            *tcomp += 13;
			}
		    }
                    *tcomp += 2;
		}
	    } else {
		for (j = *n; j >= 1; --j) {
                    *tcomp += 2;
		    if (noconj) {
			if (nounit) {
                            *tcomp += 10;
			}
			for (i__ = j - 1; i__ >= 1; --i__) {
                            *tcomp += 13;
			}
		    } else {
			if (nounit) {
                            *tcomp += 11;
			}
			for (i__ = j - 1; i__ >= 1; --i__) {
                            *tcomp += 14;
			}
		    }
                    *tcomp += 3;
		}
	    }
	} else {
	    if (*incx == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += 2;
		    if (noconj) {
			if (nounit) {
                            *tcomp += 10;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                            *tcomp += 12;
			}
		    } else {
			if (nounit) {
                            *tcomp += 11;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                            *tcomp += 13;
			}
		    }
                    *tcomp += 2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    *tcomp += 2;
		    if (noconj) {
			if (nounit) {
                            *tcomp += 10;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                            *tcomp += 13;
			}
		    } else {
			if (nounit) {
                            *tcomp += 11;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                            *tcomp += 14;
			}
		    }
                    *tcomp += 3;
		}
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
