
#ifndef __HSCAL_CB_ZTRSM_HH
#define __HSCAL_CB_ZTRSM_HH



#include "../../../../include/hscalapack.h"

int hscal_ztrsm(
    char *side, 
    char *uplo, 
    char *transa, 
    char *diag, 
    int *m, 
    int *n, 
    char *alphac,
    int *lda, 
    int *ldb,
    double *tcomp
)
{
    hscaldoublecomplex c_b1 = {1.,0.};
    hscaldoublecomplex *alpha = (hscaldoublecomplex*)alphac;

    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4, i__5, 
	    i__6, i__7;
    int info;
    int i__, j, k;
    hscallogical lside;
    int nrowa;
    hscallogical upper;
    hscallogical noconj, nounit;

    *tcomp = 0;

    lside = hscal_lsame(side, "L");
    if (lside) {
	nrowa = *m;
    } else {
	nrowa = *n;
    }
    noconj = hscal_lsame(transa, "T");
    nounit = hscal_lsame(diag, "N");
    upper = hscal_lsame(uplo, "U");
    info = 0;
    if (! lside && ! hscal_lsame(side, "R")) {
	info = 1;
    } else if (! upper && ! hscal_lsame(uplo, "L")) {
	info = 2;
    } else if (! hscal_lsame(transa, "N") && ! hscal_lsame(transa,
	     "T") && ! hscal_lsame(transa, "C")) {
	info = 3;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, 
	    "N")) {
	info = 4;
    } else if (*m < 0) {
	info = 5;
    } else if (*n < 0) {
	info = 6;
    } else if (*lda < max(1,nrowa)) {
	info = 9;
    } else if (*ldb < max(1,*m)) {
	info = 11;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0) {
	return HSCAL_SUCCESS;
    }

    if (alpha->r == 0. && alpha->i == 0.) {
      *tcomp += (*n)*(*m)*4;
	return HSCAL_SUCCESS;
    }

    if (lside) {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		    for (k = *m; k >= 1; --k) {
			{
			    if (nounit) {
                        *tcomp += 18;
			    }
                      *tcomp += 16*(k-1);
			}
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		    i__2 = *m;
		    for (k = 1; k <= i__2; ++k) {
			{
			    if (nounit) {
                        *tcomp += 18;
			    }
			    i__3 = *m;
			    for (i__ = k + 1; i__ <= i__3; ++i__) {
                        *tcomp += 16;
			    }
			}
		    }
		}
	    }
	} else {
	    if (upper) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = *m;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                  *tcomp += 10;
			if (noconj) {
			    i__3 = i__ - 1;
			    for (k = 1; k <= i__3; ++k) {
                        *tcomp += 14;
			    }
			    if (nounit) {
                        *tcomp += 14;
			    }
			} else {
			    i__3 = i__ - 1;
			    for (k = 1; k <= i__3; ++k) {
                        *tcomp += 17;
			    }
			    if (nounit) {
                        *tcomp += 17;
			    }
			}
                  *tcomp += 4;
		    }
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    for (i__ = *m; i__ >= 1; --i__) {
                  *tcomp += 10;
			if (noconj) {
			    i__2 = *m;
			    for (k = i__ + 1; k <= i__2; ++k) {
                        *tcomp += 14;
			    }
			    if (nounit) {
                        *tcomp += 14;
			    }
			} else {
			    i__2 = *m;
			    for (k = i__ + 1; k <= i__2; ++k) {
                        *tcomp += 17;
			    }
			    if (nounit) {
                        *tcomp += 17;
			    }
			}
                  *tcomp += 4;
		    }
		}
	    }
	}
    } else {
	if (hscal_lsame(transa, "N")) {
	    if (upper) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		    i__2 = j - 1;
		    for (k = 1; k <= i__2; ++k) {
			{
                      *tcomp += (*m)*16;
			}
		    }
		    if (nounit) {
                  *tcomp += 14 + (*m)*10;
		    }
		}
	    } else {
		for (j = *n; j >= 1; --j) {
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		    i__1 = *n;
		    for (k = j + 1; k <= i__1; ++k) {
			{
                      *tcomp += (*m)*16;
			}
		    }
		    if (nounit) {
                  *tcomp += 14 + (*m)*10;
		    }
		}
	    }
	} else {
	    if (upper) {
		for (k = *n; k >= 1; --k) {
		    if (nounit) {
			if (noconj) {
                      *tcomp += 14;
			} else {
                      *tcomp += 17;
			}
                  *tcomp += (*m)*10;
		    }
		    i__1 = k - 1;
		    for (j = 1; j <= i__1; ++j) {
			{
			    if (noconj) {
                        *tcomp += 4;
			    } else {
                        *tcomp += 7;
			    }
                      *tcomp += (*m)*14;
			}
		    }
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		}
	    } else {
		i__1 = *n;
		for (k = 1; k <= i__1; ++k) {
		    if (nounit) {
			if (noconj) {
                      *tcomp += 14;
			} else {
                      *tcomp += 17;
			}
                  *tcomp += (*m)*10;
		    }
		    i__2 = *n;
		    for (j = k + 1; j <= i__2; ++j) {
			{
			    if (noconj) {
                        *tcomp += 4;
			    } else {
                        *tcomp += 7;
			    }
                      *tcomp += (*m)*14;
			}
		    }
		    if (alpha->r != 1. || alpha->i != 0.) {
                  *tcomp += (*m)*10;
		    }
		}
	    }
	}
    }
    return HSCAL_SUCCESS;
}

#endif
