
#ifndef __HSCAL_PTZB_CSYMV_HSCALFUNC_HH
#define __HSCAL_PTZB_CSYMV_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_csymv(
    char *uplo, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    hscalcomplex *alpha = (hscalcomplex*)calpha;
    hscalcomplex *beta  = (hscalcomplex*)cbeta;

    int a_dim1, a_offset, i__1, i__2, i__3, i__4, i__5;
    int i__, j, ix, iy, jx, jy, kx, ky, info;

    info = 0;
    *tcomp = 0;
    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (*n < 0) {
	info = 2;
    } else if (*lda < max(1,*n)) {
	info = 5;
    } else if (*incx == 0) {
	info = 7;
    } else if (*incy == 0) {
	info = 10;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || alpha->r == 0.f && alpha->i == 0.f && (beta->r == 1.f && 
	    beta->i == 0.f)) {
	return HSCAL_SUCCESS;
    }

    if (beta->r != 1.f || beta->i != 0.f) {
	if (*incy == 1) {
	    if (beta->r == 0.f && beta->i == 0.f) {
             *tcomp += (*n)*3;
	    } else {
             *tcomp += (*n)*10;
	    }
	} else {
	    if (beta->r == 0.f && beta->i == 0.f) {
             *tcomp += (*n)*4;
	    } else {
             *tcomp += (*n)*11;
	    }
	}
    }

    if (alpha->r == 0.f && alpha->i == 0.f) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(uplo, "U")) {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
            *tcomp += 10;
		i__2 = j - 1;
		for (i__ = 1; i__ <= i__2; ++i__) {
                *tcomp += 27;
		}
            *tcomp += 22;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
            *tcomp += 12;
		i__2 = j - 1;
		for (i__ = 1; i__ <= i__2; ++i__) {
                *tcomp += 29;
		}
            *tcomp += 24;
	    }
	}
    } else {
	if (*incx == 1 && *incy == 1) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
            *tcomp += 24;
		i__2 = *n;
		for (i__ = j + 1; i__ <= i__2; ++i__) {
                *tcomp += 27;
		}
            *tcomp += 12;
	    }
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
            *tcomp += 27;
		i__2 = *n;
		for (i__ = j + 1; i__ <= i__2; ++i__) {
                *tcomp += 29;
		}
            *tcomp += 14;
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
