
#ifndef __HSCAL_PTZB_DMMTCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_DMMTCADD_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_dmmtcadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscaldoublereal c_b7 = 1.;
hscaldoublereal *alpha = (hscaldoublereal*)calpha;
hscaldoublereal *beta = (hscaldoublereal*)cbeta;

*tcomp = 0;

{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;
    if (*m >= *n) {
	if (*alpha == 1.) {
	    if (*beta == 0.) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_dcopy(
                         m, &c__1, ldb,
                         &t
                    );
                    *tcomp += t;
		}
	    } else if (*beta != 1.) {
                *tcomp += (*n * *m * 8);
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_daxpy(
                         m, (char*)&c_b7, &c__1, ldb,
                         &t
                    );
                    *tcomp += t;
		}
	    }
	} else if (*alpha != 0.) {
	    if (*beta == 0.) {
                *tcomp += (*n * *m * 5);
	    } else if (*beta != 1.) {
                *tcomp += (*n * *m * 9);
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_daxpy(
                         m, calpha, &c__1, ldb,
                         &t
                    );
                    *tcomp += t; 
		}
	    }
	} else {
	    if (*beta == 0.) {
                *tcomp += (*n * *m * 2);
	    } else if (*beta != 1.) {
		i__1 = *m;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_dscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t; 
		}
	    }
	}
    } else {
	if (*alpha == 1.) {
	    if (*beta == 0.) {
		i__1 = *m;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_dcopy(
                         n, lda, &c__1,
                         &t
                    );
                    *tcomp += t; 
		}
	    } else if (*beta != 1.) {
                *tcomp += (*n * *m * 8);
	    } else {
		i__1 = *m;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_daxpy(
                         n, (char*)&c_b7, lda, &c__1, &t
                    );
                    *tcomp += t; 
		}
	    }
	} else if (*alpha != 0.) {
	    if (*beta == 0.) {
                *tcomp += (*n * *m * 5);
	    } else if (*beta != 1.) {
                *tcomp += (*n * *m * 9);
	    } else {
		i__1 = *m;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_daxpy(
                         n, calpha, lda, &c__1,
                         &t
                    );
                    *tcomp += t;
		}
	    }
	} else {
	    if (*beta == 0.) {
                *tcomp += (*n * *m * 2);
	    } else if (*beta != 1.) {
		i__1 = *m;
		for (j = 1; j <= i__1; ++j) {
                    double t;
		    hscal_dscal(
                         n, cbeta, &c__1,
                         &t
                    );
                    *tcomp += t;
		}
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

