
#ifndef __HSCAL_PTZB_SMMADD_HSCALFUNC_HH
#define __HSCAL_PTZB_SMMADD_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_smmadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta, 
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscalreal c_b8 = 1.f;
hscalreal *alpha = (hscalreal*)calpha;
hscalreal *beta = (hscalreal*)cbeta;

*tcomp = 0;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;
    if (*alpha == 1.f) {
	if (*beta == 0.f) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                double t;
		hscal_scopy(
                     m, &c__1, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	} else if (*beta != 1.f) {
            *tcomp += (*n * *m * 8);
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                double t;
		hscal_saxpy(
                     m, (char*)&c_b8, &c__1, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}
    } else if (*alpha != 0.f) {
	if (*beta == 0.f) {
            *tcomp += (*n * *m * 5);
	} else if (*beta != 1.f) {
            *tcomp += (*n * *m * 9);
	} else {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                double t;
		hscal_saxpy(
                     m, calpha, &c__1, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}
    } else {
	if (*beta == 0.f) {
            *tcomp += (*n * *m * 2);
	} else if (*beta != 1.f) {
	    i__1 = *n;
	    for (j = 1; j <= i__1; ++j) {
                double t;
		hscal_sscal(
                     m, cbeta, &c__1,
                     &t
                );
                *tcomp += t;
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

