
#ifndef __HSCAL_PTZB_ZATRMV_HSCALFUNC_HH
#define __HSCAL_PTZB_ZATRMV_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_zatrmv(
    char *uplo, 
    char *trans, 
    char *diag, 
    int *n, 
    char *calpha, 
    int *lda, 
    int *incx, 
    char *cbeta, 
    int *incy,
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    int i__, j, ix, iy, jx, jy, kx, ky, info;
    hscallogical nounit;

    hscaldoublereal *alpha = (hscaldoublereal*)calpha;
    hscaldoublereal *beta  = (hscaldoublereal*)cbeta;

    *tcomp = 0;
    info = 0;

    if (! hscal_lsame(uplo, "U") && ! hscal_lsame(uplo, "L")) {
	info = 1;
    } else if (! hscal_lsame(trans, "N") && ! hscal_lsame(trans, "T") 
               && ! hscal_lsame(trans, "C")) {
	info = 2;
    } else if (! hscal_lsame(diag, "U") && ! hscal_lsame(diag, "N")) {
	info = 3;
    } else if (*n < 0) {
	info = 4;
    } else if (*lda < max(1,*n)) {
	info = 7;
    } else if (*incx == 0) {
	info = 9;
    } else if (*incy == 0) {
	info = 12;
    }
    if (info != 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 0 || *alpha == 0. && *beta == 1.) {
	return HSCAL_SUCCESS;
    }

    nounit = hscal_lsame(diag, "N");

    if (*incy == 1) {
	if (*beta == 0.) {
            *tcomp += (*n);
	} else if (*beta == 1.) {
            *tcomp += (*n);
	} else {
            *tcomp += (*n);
	}
    } else {
	if (*beta == 0.) {
            *tcomp += (*n)*2;
	} else if (*beta == 1.) {
            *tcomp += (*n)*2;
	} else {
            *tcomp += (*n)*2;
	}
    }

    if (*alpha == 0.) {
	return HSCAL_SUCCESS;
    }

    if (hscal_lsame(trans, "N")) {
	if (hscal_lsame(uplo, "U")) {
	    if (*incy == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 1;
			i__2 = j - 1;
			for (i__ = 1; i__ <= i__2; ++i__) {
                            *tcomp += 7;
			}
			if (nounit) {
                            *tcomp += 7;
			} else {
                            *tcomp += 1;
			}
		    }
                    *tcomp += 2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 1;
			i__2 = j - 1;
			for (i__ = 1; i__ <= i__2; ++i__) {
                            *tcomp += 8;
			}
			if (nounit) {
                            *tcomp += 7;
			} else {
                            *tcomp += 1;
			}
		    }
                    *tcomp += 2;
		}
	    }
	} else {
	    jx = kx;
	    if (*incy == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 1;
			if (nounit) {
                            *tcomp += 7;
			} else {
                            *tcomp += 1;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                            *tcomp += 7;
			}
		    }
                    *tcomp += 2;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
                    {
                        *tcomp += 1;
			if (nounit) {
                           *tcomp += 7;
			} else {
                           *tcomp += 1;
			}
			i__2 = *n;
			for (i__ = j + 1; i__ <= i__2; ++i__) {
                           *tcomp += 8;
			}
		    }
                    *tcomp += 2;
		}
	    }
	}
    } else {
	if (hscal_lsame(uplo, "U")) {
	    if (*incx == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 8;
		    }
		    if (nounit) {
                        *tcomp += 8;
		    } else {
                        *tcomp += 2;
		    }
                    *tcomp += 3;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    i__2 = j - 1;
		    for (i__ = 1; i__ <= i__2; ++i__) {
                        *tcomp += 9;
		    }
		    if (nounit) {
                        *tcomp += 8;
		    } else {
                        *tcomp += 2;
		    }
                    *tcomp += 3;
		}
	    }
	} else {
	    if (*incx == 1) {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    if (nounit) {
                        *tcomp += 7;
		    } else {
                        *tcomp += 1;
		    }
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 8;
		    }
                    *tcomp += 3;
		}
	    } else {
		i__1 = *n;
		for (j = 1; j <= i__1; ++j) {
		    if (nounit) {
                        *tcomp += 7;
		    } else {
                        *tcomp += 1;
		    }
		    i__2 = *n;
		    for (i__ = j + 1; i__ <= i__2; ++i__) {
                        *tcomp += 9;
		    }
                    *tcomp += 3;
		}
	    }
	}
    }

    return HSCAL_SUCCESS;
}

#endif
