
#ifndef __HSCAL_PTZB_ZMMDDAT_HSCALFUNC_HH
#define __HSCAL_PTZB_ZMMDDAT_HSCALFUNC_HH



#include "../../../../include/hscalapack.h"

int hscal_zmmddat(
    int *m, 
    int *n, 
    char *calpha,
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscaldoublecomplex c_b1 = {1.,0.};
hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
hscaldoublecomplex *beta = (hscaldoublecomplex*)cbeta;
int c__1 = 1;

*tcomp = 0;

{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4, i__5;
    int i__, j;

    if (*m >= *n) {
	if (beta->r == 1. && beta->i == 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
		hscal_zcopy(
                     m, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    } else if (alpha->r != 1. || alpha->i != 0.) {
                *tcomp += (*n * *m * 16);
	    } else {
		hscal_zaxpy(
                     m, (char*)&c_b1, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	} else if (beta->r != 0. || beta->i != 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += (*n * *m * 12);
	    } else if (alpha->r != 1. || alpha->i != 0.) {
                *tcomp += (*n * *m * 22);
	    } else {
		hscal_zaxpy(
                     m, cbeta, ldb, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	} else {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += (*n * *m * 4);
	    } else if (alpha->r != 1. || alpha->i != 0.) {
		hscal_zscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    } else {
	if (beta->r == 1. && beta->i == 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
                hscal_zcopy(
                     n, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    } else if (alpha->r != 1. || alpha->i != 0.) {
                *tcomp += (*n * *m * 16);
	    } else {
		hscal_zaxpy(
                     n, (char*)&c_b1, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    }
	} else if (beta->r != 0. || beta->i != 0.) {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += (*n * *m * 12);
	    } else if (alpha->r != 1. || alpha->i != 0.) {
                *tcomp += (*n * *m * 22);
	    } else {
		hscal_zaxpy(
                     n, cbeta, &c__1, lda, tcomp
                );
                *tcomp *= *m;
	    }
	} else {
	    if (alpha->r == 0. && alpha->i == 0.) {
                *tcomp += (*n * *m * 4);
	    } else if (alpha->r != 1. || alpha->i != 0.) {
		hscal_zscal(
                     m, calpha, &c__1, tcomp
                );
                *tcomp *= *n;
	    }
	}
    }

    return HSCAL_SUCCESS;
}
}

#endif
