
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include <hmpi.h>
#include <f2c.h>
#include <scalapack.h>

#include "problem_parameters_serial.h"

int main(int argc, char **argv)
{
    int     DESCA[DLEN_];
    int     myrow, mycol, rc;
    int     Ka;
    int     p = nprow;
    int     q = npcol;
    int     desc_numroc, Ka_numroc, desc_Mnumroc, Ka_Mnumroc;

    for (myrow = 0; myrow < nprow; myrow++)
    {
        for (mycol = 0; mycol < npcol; mycol++)
        {
            DESCA[DTYPE_] = BLOCK_CYCLIC_2D_INB;
            DESCA[M_]     = M;
            DESCA[N_]     = N;
            DESCA[IMB_]   = MB;
            DESCA[INB_]   = NB;
            DESCA[MB_]    = MB;
            DESCA[NB_]    = NB;
            DESCA[RSRC_]  = 0;
            DESCA[CSRC_]  = 0;

            DESCA[LLD_]   = max(1, PB_Cnumroc(DESCA[M_],
                                              0,
                                              DESCA[IMB_],
                                              DESCA[MB_],
                                              myrow,
                                              DESCA[RSRC_],
                                              p
                               )
            );

            Ka            = max(1, PB_Cnumroc(JA+DESCA[N_]-1,
                                              0,
                                              DESCA[INB_],
                                              DESCA[NB_],
                                              mycol,
                                              DESCA[CSRC_],
                                              q
                               )
            );

            Mnumroc(
                                      desc_Mnumroc,
                                      DESCA[M_],
                                      0,
                                      DESCA[IMB_],
                                      DESCA[MB_],
                                      myrow,
                                      DESCA[RSRC_],
                                      p
            );

            Mnumroc(
                                      Ka_Mnumroc,
                                      JA+DESCA[N_]-1,
                                      0,
                                      DESCA[INB_],
                                      DESCA[NB_],
                                      mycol,
                                      DESCA[CSRC_],
                                      q
            );

            desc_numroc   = max(1, numroc_(&DESCA[M_],
                                           &DESCA[MB_],
                                           &myrow,
                                           &DESCA[RSRC_],
                                           &p
                               )
            );

            Ka_numroc     = max(1, numroc_(&DESCA[N_],
                                           &DESCA[NB_],
                                           &mycol,
                                           &DESCA[CSRC_],
                                           &q
                               )
            );

            printf(
               "(%d, %d): DESCA[LLD_]=%d, Ka=%d, desc_Mnumroc=%d, Ka_Mnumroc=%d, desc_numroc=%d, Ka_numroc=%d\n",
               myrow, 
               mycol,
               DESCA[LLD_],
               Ka,
               desc_Mnumroc,
               Ka_Mnumroc,
               desc_numroc,
               Ka_numroc
            );
        }
    }

    return 0;
}

