
#include "hscal_hashtab.h"

#include <stdlib.h>
#include <stdio.h>

hscal_hashtable *hasht;

typedef struct { double time; int p; int q; int gid; } CTXT;

/*--------------------------------------------------------------------------*/

int main()
{
    CTXT value[3]   = {
                      {3.00, 4, 4, 1},
                      {2.00, 3, 3, 2},
                      {1.00, 2, 2, 3},
    };
    int key[3] = {4, 5, 6};
    CTXT *found;
    int ictxt;

    hasht = hscal_create_hashtable(16, hscal_hashfromkey, hscal_equalkeys);

    if (hasht == NULL)
    {
       return -1;
    }

    if (!hscal_hashtable_insert(hasht, &key[0], &value[0]))
    {
       return -1;
    }

    if (!hscal_hashtable_insert(hasht, &key[1], &value[1]))
    {
       return -1;
    }

    if (!hscal_hashtable_insert(hasht, &key[2], &value[2]))
    {
       return -1;
    }

    if (NULL == (found = hscal_hashtable_search(hasht, &key[0]) ))
    {
       return -1;
    }

    printf("Value1 %d found\n", found->gid);

    if (NULL == (found = hscal_hashtable_search(hasht, &key[1]) ))
    {
       return -1;
    }

    printf("Value2 %d found\n", found->gid);

    if (NULL == (found = hscal_hashtable_search(hasht, &key[2]) ))
    {
       return -1;
    }

    printf("Value3 %d found\n", found->gid);

    if (NULL == (found = hscal_hashtable_remove(hasht, &key[0]) ))
    {
       return -1;
    }

    printf("Value1 %d removed\n", found->gid);

    if (NULL == (found = hscal_hashtable_remove(hasht, &key[1]) ))
    {
       return -1;
    }

    printf("Value2 %d removed\n", found->gid);

    if (NULL == (found = hscal_hashtable_remove(hasht, &key[2]) ))
    {
       return -1;
    }

    printf("Value3 %d removed\n", found->gid);

    hscal_hashtable_destroy(hasht, 0);

    return 0;
}
