#!/bin/sh

if [ "$1" = "" ]; then
        echo "Usage: $0 {file to test} {parameters file}"
        echo "For example:"
        echo "$0 hscal_vpm_level3 hscalapack_pcgemm_parameters.h"
        exit 1
fi

if [ "$#" != "2" ]; then
        echo "Usage: $0 {file to test} {parameters file}"
        echo "For example:"
        echo "$0 hscal_vpm_level3 hscalapack_pcgemm_parameters.h"
        exit 2
fi

for arg in $*
do
    case $arg in 
    -help | -h | --help | --h)
	echo "Usage: $0 {file to test}"
	echo "For example:"
	echo "$0 hscal_vpm_level3 hscalapack_pcgemm_parameters.h"
	exit 0
        ;;
    esac
done

TOOLSFILE="$1"
PARAMETERSFILE="$2"

echo "Killing rogue '$TOOLSFILE' processes"
killall $TOOLSFILE > /dev/null 2>&1

echo "Removing '$TOOLSFILE' from MPCLOAD"
/bin/rm -f `find $MPCLOAD/.. -name $TOOLSFILE`

echo "Broadcasting '${TOOLSFILE}.c' '${PARAMETERSFILE}'"
hmpibcast ${TOOLSFILE}.c ${PARAMETERSFILE}

if [ $? -gt 0 ]; then
	echo Error broadcasting the files
	exit 2
fi

echo "Creating '${TOOLSFILE}'"
hmpiload -I\$HSCALAPACKHOME/include -o ${TOOLSFILE} ${TOOLSFILE}.c -L\$HSCALAPACKHOME/lib -lhscaltest -lhscalapack -L\$LIBSCALAPACKDIR\$LIBSSCALAPACK -L\$LIBBLACSDIR\$LIBSBLACS -L\$LIBBLASDIR\$LIBSBLAS -L\$LIBF2CDIR\$LIBSF2C

if [ $? -gt 0 ]; then
	echo Error while loading the files
	exit 3
fi

echo "Running '${TOOLSFILE}'"
hmpirun ${TOOLSFILE}
