#!/bin/sh

. ./cparameters.sh

UNIQ_FILENAME=gemm_`date '+%m:%d:%y:%H:%M:%S'`.txt

hmpibcast mxm.c mxm_i.c mxm_i.h Load_balance.c

PSIZE_COUNT=9

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do
	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgemm_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgemm_parameters.h
	echo ""                                                     >> hscalapack_pdgemm_parameters.h
	echo "int     TRANSAI          = 'N';"                      >> hscalapack_pdgemm_parameters.h
	echo "int     TRANSBI          = 'N';"                      >> hscalapack_pdgemm_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdgemm_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgemm_parameters.h
	echo "int     K                = $PSIZE;"                   >> hscalapack_pdgemm_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pdgemm_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pdgemm_parameters.h
	echo "int     KB               = 32;"                       >> hscalapack_pdgemm_parameters.h
	echo "double  ALPHA            = 1.;"                       >> hscalapack_pdgemm_parameters.h
	echo "double  BETA             = 1.;"                       >> hscalapack_pdgemm_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo "int     IC               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo "int     JC               = 1;"                        >> hscalapack_pdgemm_parameters.h
	echo ""                                                     >> hscalapack_pdgemm_parameters.h
	echo "#endif"                                               >> hscalapack_pdgemm_parameters.h

	hmpibcast hscalapack_pdgemm_parameters.h
	hmpiload -I\$HSCALAPACKHOME/include -o mxm mxm.c -L\$HSCALAPACKHOME/lib -lhscaltest -lhscalapack -L\$(LIBSCALAPACKDIR) \$(LIBSSCALAPACK) -L\$(LIBBLACSDIR) \$(LIBSBLACS) -L\$(LIBBLASDIR) \$(LIBSBLAS) -L\$(LIBF2CDIR) \$(LIBSF2C)
	hmpirun mxm >> $UNIQ_FILENAME 2>&1

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

exit 0
