/* $Id: Parser.c,v 2.10 1992/09/24 15:53:35 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "mpcPars.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    include "Errors.h"
#    include <string.h>
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    include "Errors.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define mpcScan_GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } mpcScan_tScanAttribute;
        static	mpcScan_tScanAttribute	mpcScan_Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define mpcScan_ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "mpcScan.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 2 "mpcPars.lalr" */



 /* mpC-grammar -- massively-parallel extension of ANSI C; *
  * Copyright (C) 1995,1996 I.N.Ledovskih,                 *
  * All rights reserved                                    *
  * Portions copyright (C) 1989,1990 James A. Roskind.     */

#include "context.h"
#include "Tree.h"
#include "mpc_diag.h"
#include "mpc_pass1.h"
#include "mpc_pass2.h"
#include "topo_fun.h"
#include "options.h"



#ifndef __CB_COMPILER__
# include "mpc_demo.h"

extern tTree MPI_Int_Type,
	     TopoGraph_Type;
extern void  Emit_TopoPattern();
#endif


char EmptyString[] = "";

int Default_Class = EXTERN;
int Scope_Depth = 0;

#ifndef __CB_COMPILER__
tIdent DummyIdent;           /* for generation of MPC_CoordExpr in case of network operand; */
tTree  DummyVar;             /* for generation of MPC_CoordExpr in case of network operand; */
#endif

static tTree LabelList;           /* pointer to list of all labels of the current function; */
static tTree Original_ParamList   /* point to list of formal params in function definition; */
                             = NoTree;




#ifdef __WRK
# include "c2mpC.h"
#else
# define END_OF_HEADER_STRING "header_end"
#endif


typedef struct { tTree Tree; bool IsIntConst; int Value; bool Ignore; tPosition Position; tPosition EndPos; } yyconstant;
typedef struct { tTree Tree; int Length; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yystring_literal_list;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyprimary_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yynet_cast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yypostfix_expression;
typedef struct { short OpCode; tPosition Position; tPosition EndPos; } yypostfix_linear_operator;
typedef struct { tTree NetArgument; tTree NetworkArgList; bool Ignore; tPosition BegPos; } yyspecial_arguments;
typedef struct { tTree Tree; bool Ignore; } yyargument_expression_list_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition BegPos; } yyargument_expression_list;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyunary_expression;
typedef struct { short OpCode; tPosition Position; } yyunary_operator;
typedef struct { short OpCode; tPosition Position; int Length; } yylinear_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yycast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yymultiplicative_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yymax_or_min_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyadditive_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyshift_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyrelational_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyequality_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyAND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyexclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyinclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yylogical_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yylogical_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconditional_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition EndPos; } yyconditional_expression_opt;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyquaternary_assignment;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyassignment_expression;
typedef struct { short OpCode; tPosition Position; } yyassignment_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyexpression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Scope; bool Ignore; tPosition Position; tPosition BegPos; } yyexpression_opt;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_unary_expression;
typedef struct { short OpCode; tPosition Position; } yyconst_unary_operator;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_cast_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_multiplicative_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_max_or_min_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_additive_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_shift_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_relational_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_equality_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_exclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_inclusive_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_logical_AND_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_logical_OR_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconst_conditional_expression;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition EndPos; } yyconst_conditional_expression_opt;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Sizeof; bool Ignore; tPosition Position; tPosition BegPos; tPosition EndPos; } yyconstant_expression;
typedef struct { tTree Tree; bool IsIntConst; bool Sizeof; int Value; bool Ignore; } yyconst_expression_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration;
typedef struct { tTree Tree; tTree NetType; int Class; bool Ignore; tPosition Position; } yynet_declaring_list;
typedef struct { tTree Tree; tTree NetType; int Class; bool Ignore; tPosition Position; } yysingle_net_declaring_list;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yynet_declarator;
typedef struct { tTree Tree; int Class; bool Exported; bool Ignore; tPosition Position; } yynet_declaration_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yynet_type_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yynet_type_declaration;
typedef struct { int Class; tPosition Position; } yystorage_class_opt;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yytopo_parameter_list;
typedef struct { tIdent Ident; tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yytopo_parameter;
typedef struct { tTree Tree; bool Ignore; } yynet_declaration;
typedef struct { tTree Tree; bool Ignore; } yycoord_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yycoord_list;
typedef struct { tIdent Ident; tTree Range; bool Ignore; tPosition Position; tPosition EndPos; } yycoord_declarator;
typedef struct { tTree Tree; bool Ignore; } yynode_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yynode_declaring_list;
typedef struct { tTree Predicate; tTree NodeQual; int NodeType; bool Dynamic; bool Ignore; tPosition Position; tPosition EndPos; } yynode_declarator;
typedef struct { tTree NodeQual; int NodeType; bool Dynamic; } yynode_type_specifier;
typedef struct { tTree Tree; int NodeQual; bool Dynamic; tPosition Position; } yyspeed_specifier;
typedef struct { tTree Tree; int NodeQual; tPosition Position; tPosition EndPos; } yyfast_node_specifier;
typedef struct { tTree Tree; int NodeQual; tPosition Position; tPosition EndPos; } yyslow_node_specifier;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yybench_node_specifier;
typedef struct { tTree Tree; bool Ignore; } yylink_declaration;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yylink_declaring_list;
typedef struct { tTree Predicate; tTree LinkTypeSpec; int LinkType; bool Dynamic; tTree LinkList; bool Ignore; tPosition Position; tPosition EndPos; } yylink_declaration_member;
typedef struct { tTree LinkTypeSpec; int LinkType; bool Dynamic; tTree LinkList; bool Ignore; } yylink_declarator_list;
typedef struct { tTree Tree; bool Pair; bool Ignore; } yylink_declarator;
typedef struct { tTree Tree; bool Ignore; } yyfree_coord_list;
typedef struct { tTree Tree; int LinkType; bool Dynamic; bool Ignore; } yylink_type_specifier;
typedef struct { tTree Tree; bool Ignore; } yyparent_node_declaration;
typedef struct { tTree Tree; bool Ignore; } yyconstant_expression_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yysubnet_declaring_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_declarator;
typedef struct { tTree Tree; bool Flexible; bool WithPredicate; bool Ignore; tPosition Position; tPosition EndPos; } yysubnet_specifier;
typedef struct { tTree Tree; bool Ignore; tPosition Position; } yyrelation_declaration;
typedef struct { tTree Tree; bool Ignore; } yyrelation_declarator;
typedef struct { int OpCode; tPosition Position; } yyrelational_operator;
typedef struct { tTree Tree; tTree Type; int Class; bool NoClass; bool Ignore; tPosition Position; tPosition EndPos; } yydefault_declaring_list;
typedef struct { tTree Tree; tTree Type; int Class; bool NoClass; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaring_list;
typedef struct { tTree Type; int Class; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration_specifier;
typedef struct { tTree Type; int Class; bool Ignore; tPosition Position; tPosition EndPos; } yytype_specifier;
typedef struct { int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yydeclaration_qualifier_list;
typedef struct { int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytype_qualifier_list;
typedef struct { tQual Qual; int Class; tPosition Position; tPosition EndPos; } yydeclaration_qualifier;
typedef struct { tQual Qual; tPosition Position; tPosition EndPos; } yytype_qualifier;
typedef struct { int TypeName; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_declaration_specifier;
typedef struct { int TypeName; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_type_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yysue_declaration_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yysue_type_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytypedef_declaration_specifier;
typedef struct { tTree Type; int Class; tQual Qual; bool Ignore; tPosition Position; tPosition EndPos; } yytypedef_type_specifier;
typedef struct { int Class; tPosition Position; tPosition EndPos; } yystorage_class;
typedef struct { int TypeName; bool Ignore; tPosition Position; tPosition EndPos; } yybasic_type_name;
typedef struct { tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yyelaborated_type_name;
typedef struct { tTree Type; tIdent Ident; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_or_union_specifier;
typedef struct { tTree Tree; tPosition Position; } yystruct_or_union;
typedef struct { tTree Tree; bool Ignore; } yystruct_declaration_list;
typedef struct { tTree Tree; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_declaration;
typedef struct { tTree Tree; tTree Type; bool Ignore; tPosition Position; } yystruct_default_declaring_list;
typedef struct { tTree Tree; tTree Type; bool Ignore; tPosition Position; } yystruct_declaring_list;
typedef struct { tIdent Ident; int BitFieldLength; tTree BitFieldSize_Expr; bool Ignore; tPosition Position; tPosition EndPos; } yystruct_declarator;
typedef struct { int Length; tTree Tree; bool Ignore; tPosition EndPos; } yybit_field_size_opt;
typedef struct { tTree Tree; int Length; bool Ignore; tPosition Position; tPosition EndPos; } yybit_field_size;
typedef struct { tTree Type; bool Ignore; tPosition Position; tPosition EndPos; } yyenum_specifier;
typedef struct { tTree Tree; bool Ignore; } yyenumerator_list;
typedef struct { int Present; int Value; bool Ignore; tPosition EndPos; } yyenumerator_value_opt;
typedef struct { tTree Tree; int Length; bool Ignore; } yyparameter_type_list;
typedef struct { tTree Tree; int Length; bool Ignore; } yyparameter_list;
typedef struct { tTree Tree; bool WithIdent; bool Ignore; } yyparameter_declaration;
typedef struct { tTree Tree; bool Ignore; int Length; tPosition Position; } yyidentifier_list;
typedef struct { tTree Type; bool Ignore; } yytype_name;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yyinitializer_opt;
typedef struct { tTree Tree; tPosition Position; tPosition EndPos; } yyinitializer;
typedef struct { tTree Tree; int Length; } yyinitializer_list;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yystatement;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yylabeled_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycompound_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yydeclaration_list;
typedef struct { tTree Tree; bool Ignore; } yystatement_list;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyexpression_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyselection_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyiteration_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyjump_statement;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yyrecon_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yyfan_statement;
typedef struct { tTree Tree; bool Ignore; } yytranslation_unit;
typedef struct { tTree Tree; bool Ignore; } yyexternal_definition;
typedef struct { tTree Tree; bool Ignore; } yyfunction_definition;
typedef struct { tTree Var; tTree Type; bool Ignore; tPosition Position; } yyfunction_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yydeclarator;
typedef struct { tIdent Ident; tTree Distribution; int Pointer; bool Ignore; tPosition Position; tPosition EndPos; } yyunary_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yypostfix_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yyparen_declarator;
typedef struct { tTree Tree; bool Simple; bool Ignore; tPosition Position; } yynet_specifier;
typedef struct { tTree Tree; bool Simple; bool Ignore; tPosition Position; } yynet_name_specifier;
typedef struct { tIdent Ident; bool Ignore; tPosition Position; tPosition EndPos; } yygeneral_identifier;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yyold_function_declarator;
typedef struct { tIdent Ident; tTree Distribution; bool Ignore; tPosition Position; tPosition EndPos; } yypostfix_old_function_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yyabstract_declarator;
typedef struct { bool Ignore; tPosition Position; tPosition EndPos; } yypostfixing_abstract_declarator;
typedef struct { bool Ignore; tPosition Position; tPosition EndPos; } yyarray_abstract_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yyunary_abstract_declarator;
typedef struct { bool Ignore; tPosition EndPos; } yypostfix_abstract_declarator;
typedef struct { int Value; tTree Tree; bool Ignore; tPosition EndPos; } yystep;
typedef struct { tTree Tree; bool IsIntConst; int Value; bool Scope; bool Ignore; tPosition Position; } yygrid_step;
typedef struct { tTree Tree; int Class; bool Ignore; } yyempty_net_declaring_list;
typedef struct { tTree Tree; bool Ignore; } yyscheme_declaration;
typedef struct { tTree Tree; bool Ignore; } yyscheme_declaring_list;
typedef struct { tTree Tree; tTree Chain; bool Ignore; tPosition EndPos; } yyscheme_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycomputation_statement;
typedef struct { tTree Tree; bool Ignore; tPosition EndPos; } yycommunication_statement;

typedef union {
 mpcScan_tScanAttribute Scan;
 yyconstant constant;
 yystring_literal_list string_literal_list;
 yyprimary_expression primary_expression;
 yynet_cast_expression net_cast_expression;
 yypostfix_expression postfix_expression;
 yypostfix_linear_operator postfix_linear_operator;
 yyspecial_arguments special_arguments;
 yyargument_expression_list_opt argument_expression_list_opt;
 yyargument_expression_list argument_expression_list;
 yyunary_expression unary_expression;
 yyunary_operator unary_operator;
 yylinear_operator linear_operator;
 yycast_expression cast_expression;
 yymultiplicative_expression multiplicative_expression;
 yymax_or_min_expression max_or_min_expression;
 yyadditive_expression additive_expression;
 yyshift_expression shift_expression;
 yyrelational_expression relational_expression;
 yyequality_expression equality_expression;
 yyAND_expression AND_expression;
 yyexclusive_OR_expression exclusive_OR_expression;
 yyinclusive_OR_expression inclusive_OR_expression;
 yylogical_AND_expression logical_AND_expression;
 yylogical_OR_expression logical_OR_expression;
 yyconditional_expression conditional_expression;
 yyconditional_expression_opt conditional_expression_opt;
 yyquaternary_assignment quaternary_assignment;
 yyassignment_expression assignment_expression;
 yyassignment_operator assignment_operator;
 yyexpression expression;
 yyexpression_opt expression_opt;
 yyconst_unary_expression const_unary_expression;
 yyconst_unary_operator const_unary_operator;
 yyconst_cast_expression const_cast_expression;
 yyconst_multiplicative_expression const_multiplicative_expression;
 yyconst_max_or_min_expression const_max_or_min_expression;
 yyconst_additive_expression const_additive_expression;
 yyconst_shift_expression const_shift_expression;
 yyconst_relational_expression const_relational_expression;
 yyconst_equality_expression const_equality_expression;
 yyconst_AND_expression const_AND_expression;
 yyconst_exclusive_OR_expression const_exclusive_OR_expression;
 yyconst_inclusive_OR_expression const_inclusive_OR_expression;
 yyconst_logical_AND_expression const_logical_AND_expression;
 yyconst_logical_OR_expression const_logical_OR_expression;
 yyconst_conditional_expression const_conditional_expression;
 yyconst_conditional_expression_opt const_conditional_expression_opt;
 yyconstant_expression constant_expression;
 yyconst_expression_opt const_expression_opt;
 yydeclaration declaration;
 yynet_declaring_list net_declaring_list;
 yysingle_net_declaring_list single_net_declaring_list;
 yynet_declarator net_declarator;
 yynet_declaration_specifier net_declaration_specifier;
 yynet_type_specifier net_type_specifier;
 yynet_type_declaration net_type_declaration;
 yystorage_class_opt storage_class_opt;
 yytopo_parameter_list topo_parameter_list;
 yytopo_parameter topo_parameter;
 yynet_declaration net_declaration;
 yycoord_declaration coord_declaration;
 yycoord_list coord_list;
 yycoord_declarator coord_declarator;
 yynode_declaration node_declaration;
 yynode_declaring_list node_declaring_list;
 yynode_declarator node_declarator;
 yynode_type_specifier node_type_specifier;
 yyspeed_specifier speed_specifier;
 yyfast_node_specifier fast_node_specifier;
 yyslow_node_specifier slow_node_specifier;
 yybench_node_specifier bench_node_specifier;
 yylink_declaration link_declaration;
 yylink_declaring_list link_declaring_list;
 yylink_declaration_member link_declaration_member;
 yylink_declarator_list link_declarator_list;
 yylink_declarator link_declarator;
 yyfree_coord_list free_coord_list;
 yylink_type_specifier link_type_specifier;
 yyparent_node_declaration parent_node_declaration;
 yyconstant_expression_list constant_expression_list;
 yysubnet_declaring_list subnet_declaring_list;
 yysubnet_list subnet_list;
 yysubnet_declarator subnet_declarator;
 yysubnet_specifier subnet_specifier;
 yyrelation_declaration relation_declaration;
 yyrelation_declarator relation_declarator;
 yyrelational_operator relational_operator;
 yydefault_declaring_list default_declaring_list;
 yydeclaring_list declaring_list;
 yydeclaration_specifier declaration_specifier;
 yytype_specifier type_specifier;
 yydeclaration_qualifier_list declaration_qualifier_list;
 yytype_qualifier_list type_qualifier_list;
 yydeclaration_qualifier declaration_qualifier;
 yytype_qualifier type_qualifier;
 yybasic_declaration_specifier basic_declaration_specifier;
 yybasic_type_specifier basic_type_specifier;
 yysue_declaration_specifier sue_declaration_specifier;
 yysue_type_specifier sue_type_specifier;
 yytypedef_declaration_specifier typedef_declaration_specifier;
 yytypedef_type_specifier typedef_type_specifier;
 yystorage_class storage_class;
 yybasic_type_name basic_type_name;
 yyelaborated_type_name elaborated_type_name;
 yystruct_or_union_specifier struct_or_union_specifier;
 yystruct_or_union struct_or_union;
 yystruct_declaration_list struct_declaration_list;
 yystruct_declaration struct_declaration;
 yystruct_default_declaring_list struct_default_declaring_list;
 yystruct_declaring_list struct_declaring_list;
 yystruct_declarator struct_declarator;
 yybit_field_size_opt bit_field_size_opt;
 yybit_field_size bit_field_size;
 yyenum_specifier enum_specifier;
 yyenumerator_list enumerator_list;
 yyenumerator_value_opt enumerator_value_opt;
 yyparameter_type_list parameter_type_list;
 yyparameter_list parameter_list;
 yyparameter_declaration parameter_declaration;
 yyidentifier_list identifier_list;
 yytype_name type_name;
 yyinitializer_opt initializer_opt;
 yyinitializer initializer;
 yyinitializer_list initializer_list;
 yystatement statement;
 yylabeled_statement labeled_statement;
 yycompound_statement compound_statement;
 yydeclaration_list declaration_list;
 yystatement_list statement_list;
 yyexpression_statement expression_statement;
 yyselection_statement selection_statement;
 yyiteration_statement iteration_statement;
 yyjump_statement jump_statement;
 yyrecon_statement recon_statement;
 yyfan_statement fan_statement;
 yytranslation_unit translation_unit;
 yyexternal_definition external_definition;
 yyfunction_definition function_definition;
 yyfunction_declarator function_declarator;
 yydeclarator declarator;
 yyunary_declarator unary_declarator;
 yypostfix_declarator postfix_declarator;
 yyparen_declarator paren_declarator;
 yynet_specifier net_specifier;
 yynet_name_specifier net_name_specifier;
 yygeneral_identifier general_identifier;
 yyold_function_declarator old_function_declarator;
 yypostfix_old_function_declarator postfix_old_function_declarator;
 yyabstract_declarator abstract_declarator;
 yypostfixing_abstract_declarator postfixing_abstract_declarator;
 yyarray_abstract_declarator array_abstract_declarator;
 yyunary_abstract_declarator unary_abstract_declarator;
 yypostfix_abstract_declarator postfix_abstract_declarator;
 yystep step;
 yygrid_step grid_step;
 yyempty_net_declaring_list empty_net_declaring_list;
 yyscheme_declaration scheme_declaration;
 yyscheme_declaring_list scheme_declaring_list;
 yyscheme_statement scheme_statement;
 yycomputation_statement computation_statement;
 yycommunication_statement communication_statement;
} tParsAttribute;


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		135
# define yyTableMax		4785
# define yyNTableMax		7038
# define yyFirstReadState	1
# define yyLastReadState	564
# define yyFirstReadTermState	565
# define yyLastReadTermState	735
# define yyLastReadNontermState	949
# define yyFirstReduceState	950
# define yyLastReduceState	1473
# define yyStartState		1
# define yyStopState		950

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		mpcPars_TokenName	[yyLastTerminal + 2] = {
"_EndOfFile",
"IDENTIFIER",
"NETorSUBNETname",
"TYPEDEFname",
"FLOATINGconstant",
"INTEGERconstant",
"OCTALconstant",
"HEXconstant",
"CHARACTERconstant",
"STRINGliteral",
"HEADER",
"SOURCE",
"bench",
"coord",
"coordof",
"fan",
"fast",
"flex",
"host",
"length",
"link",
"memory",
"net",
"nettype",
"node",
"parent",
"recon",
"relation",
"repl",
"scalar",
"slow",
"subnet",
"vector",
"par",
"scheme",
"timeof",
"[",
"]",
"[*]",
"(",
",",
")",
":",
"+",
"-",
"~",
"!",
"sizeof",
"mpc_sizeof",
"void",
"char",
"short",
"int",
"long",
"float",
"double",
"signed",
"unsigned",
"const",
"volatile",
"struct",
"union",
"{",
";",
"}",
"enum",
"=",
"*",
"[]",
"typedef",
"extern",
"static",
"auto",
"register",
"...",
"/",
"%",
"?<",
"?>",
"<<",
">>",
"<",
">",
"<=",
">=",
"==",
"!=",
"&",
"^",
"|",
"&&",
"||",
"?",
".",
"->",
"++",
"--",
"[?<]",
"[?>]",
"[+]",
"[&]",
"[^]",
"[|]",
"[&&]",
"[||]",
"[<",
">]",
"[>",
"<]",
"*=",
"/=",
"%=",
"+=",
"-=",
"<<=",
">>=",
"&=",
"^=",
"|=",
"<-",
"@",
"@@",
"default",
"<->",
"case",
"if",
"else",
"switch",
"while",
"do",
"for",
"goto",
"continue",
"break",
"return",
"%%",
""
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{331, 951},
{1, 565},
{6, 573},
{116, 624},
{117, 625},
{3, 1143},
{3, 1143},
{3, 1143},
{230, 657},
{296, 297},
{221, 14},
{311, 689},
{313, 314},
{322, 1456},
{323, 690},
{325, 691},
{336, 310},
{19, 569},
{13, 222},
{23, 24},
{393, 377},
{511, 642},
{22, 2},
{354, 355},
{5, 959},
{15, 16},
{221, 222},
{478, 570},
{478, 571},
{478, 572},
{221, 2},
{533, 366},
{541, 642},
{564, 950},
{0, 0},
{0, 0},
{1, 13},
{14, 587},
{1, 656},
{1, 318},
{3, 1143},
{3, 1143},
{3, 1143},
{3, 4},
{5, 959},
{3, 1143},
{8, 9},
{10, 585},
{11, 586},
{12, 1463},
{16, 589},
{5, 959},
{5, 959},
{17, 1456},
{18, 19},
{5, 959},
{20, 590},
{21, 591},
{24, 25},
{28, 29},
{5, 959},
{29, 30},
{30, 593},
{32, 983},
{5, 959},
{5, 959},
{33, 34},
{1, 319},
{35, 36},
{19, 580},
{19, 581},
{19, 582},
{19, 583},
{19, 584},
{38, 28},
{31, 961},
{46, 23},
{48, 610},
{49, 622},
{44, 609},
{28, 32},
{5, 959},
{5, 959},
{31, 594},
{44, 1072},
{107, 1071},
{108, 109},
{5, 959},
{114, 38},
{122, 123},
{123, 1071},
{124, 1454},
{127, 630},
{128, 631},
{126, 1455},
{31, 961},
{124, 125},
{126, 45},
{130, 131},
{134, 23},
{137, 138},
{139, 140},
{31, 961},
{31, 961},
{143, 641},
{148, 149},
{31, 961},
{152, 644},
{155, 1441},
{155, 147},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{53, 1072},
{54, 55},
{55, 1071},
{56, 57},
{53, 1072},
{110, 1071},
{111, 112},
{112, 1071},
{113, 114},
{207, 1123},
{5, 959},
{121, 45},
{5, 959},
{31, 961},
{31, 961},
{119, 45},
{208, 209},
{210, 646},
{31, 961},
{31, 961},
{146, 643},
{31, 961},
{31, 961},
{31, 961},
{5, 959},
{146, 147},
{53, 1072},
{211, 647},
{212, 1443},
{214, 1444},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{31, 961},
{42, 987},
{153, 154},
{121, 629},
{153, 1329},
{119, 628},
{53, 1072},
{53, 1072},
{53, 1072},
{222, 650},
{224, 652},
{223, 651},
{225, 653},
{226, 654},
{31, 961},
{154, 146},
{223, 147},
{227, 655},
{154, 154},
{231, 658},
{234, 147},
{42, 987},
{213, 632},
{229, 1441},
{229, 1441},
{229, 147},
{238, 233},
{241, 242},
{42, 987},
{42, 987},
{153, 155},
{243, 659},
{42, 987},
{144, 1236},
{244, 1458},
{213, 1442},
{245, 246},
{42, 987},
{248, 1443},
{248, 1443},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{251, 660},
{154, 155},
{154, 645},
{250, 1444},
{250, 1444},
{252, 253},
{254, 661},
{213, 633},
{213, 634},
{238, 234},
{253, 1449},
{253, 1449},
{231, 232},
{42, 987},
{42, 987},
{145, 642},
{256, 257},
{264, 671},
{42, 987},
{42, 987},
{268, 259},
{42, 987},
{42, 987},
{144, 1236},
{247, 146},
{144, 1236},
{144, 1236},
{247, 237},
{144, 1236},
{144, 1236},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{145, 146},
{217, 569},
{271, 674},
{145, 154},
{279, 280},
{145, 1331},
{144, 1236},
{144, 1236},
{247, 645},
{47, 988},
{273, 1315},
{273, 1315},
{280, 281},
{42, 987},
{282, 675},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{42, 987},
{47, 988},
{220, 221},
{145, 155},
{145, 645},
{220, 228},
{220, 1318},
{220, 1318},
{47, 988},
{47, 988},
{283, 676},
{285, 1309},
{47, 988},
{260, 1301},
{42, 987},
{260, 259},
{47, 43},
{47, 988},
{47, 592},
{47, 48},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{217, 580},
{217, 581},
{217, 582},
{217, 583},
{217, 584},
{265, 266},
{267, 268},
{290, 678},
{220, 229},
{220, 645},
{285, 1309},
{260, 1301},
{285, 133},
{47, 988},
{47, 988},
{293, 679},
{294, 984},
{295, 296},
{47, 988},
{47, 988},
{297, 298},
{47, 988},
{47, 988},
{47, 623},
{298, 680},
{301, 1460},
{302, 1462},
{303, 304},
{265, 672},
{267, 673},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 116},
{47, 117},
{47, 626},
{47, 627},
{47, 601},
{47, 602},
{47, 603},
{47, 604},
{47, 605},
{47, 606},
{47, 607},
{47, 608},
{47, 118},
{47, 988},
{47, 120},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{47, 988},
{51, 1016},
{236, 1397},
{236, 1397},
{236, 1397},
{288, 284},
{249, 632},
{305, 681},
{314, 15},
{51, 1016},
{308, 50},
{308, 682},
{51, 1016},
{228, 565},
{47, 988},
{316, 1210},
{319, 147},
{51, 1016},
{249, 1442},
{249, 1442},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{236, 1397},
{324, 325},
{324, 692},
{236, 1397},
{288, 677},
{310, 683},
{310, 684},
{310, 685},
{310, 686},
{310, 687},
{310, 688},
{249, 633},
{249, 634},
{328, 329},
{272, 642},
{330, 322},
{334, 694},
{337, 696},
{51, 1016},
{51, 1016},
{344, 344},
{51, 611},
{51, 1016},
{228, 221},
{345, 346},
{228, 656},
{228, 228},
{242, 1404},
{242, 1404},
{242, 1404},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{51, 1016},
{345, 700},
{242, 1404},
{242, 1404},
{272, 1324},
{272, 1324},
{242, 1404},
{228, 229},
{149, 1459},
{321, 1397},
{321, 1397},
{332, 333},
{346, 699},
{335, 336},
{51, 1016},
{356, 1456},
{51, 1016},
{51, 612},
{51, 613},
{51, 614},
{51, 615},
{51, 616},
{51, 617},
{51, 618},
{51, 619},
{51, 620},
{51, 621},
{51, 52},
{51, 1016},
{51, 110},
{59, 1022},
{321, 1397},
{321, 1397},
{149, 1459},
{332, 693},
{321, 1397},
{335, 695},
{326, 632},
{59, 1022},
{218, 1233},
{350, 13},
{59, 1022},
{350, 656},
{51, 1016},
{359, 360},
{359, 364},
{59, 1022},
{339, 1236},
{340, 341},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{149, 1459},
{326, 633},
{326, 634},
{364, 365},
{149, 1459},
{340, 701},
{59, 1022},
{59, 1022},
{218, 1233},
{367, 368},
{218, 1233},
{218, 1233},
{218, 1233},
{218, 1233},
{371, 704},
{347, 348},
{339, 1236},
{373, 374},
{339, 1236},
{339, 1236},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{59, 1022},
{372, 404},
{63, 1025},
{347, 702},
{218, 1233},
{218, 1233},
{361, 1150},
{361, 1150},
{339, 698},
{375, 376},
{63, 1025},
{219, 1236},
{339, 1236},
{63, 1025},
{59, 1022},
{377, 378},
{59, 1022},
{353, 317},
{63, 1025},
{357, 358},
{380, 381},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{381, 382},
{59, 1022},
{59, 1022},
{59, 1022},
{255, 662},
{255, 663},
{255, 664},
{255, 665},
{255, 666},
{255, 667},
{255, 668},
{255, 669},
{255, 670},
{382, 383},
{353, 1211},
{372, 1154},
{357, 533},
{59, 1022},
{63, 1025},
{63, 1025},
{219, 1236},
{384, 705},
{219, 1236},
{219, 1236},
{219, 1236},
{219, 1236},
{386, 387},
{274, 221},
{388, 706},
{381, 386},
{274, 228},
{274, 1321},
{274, 1321},
{369, 370},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{63, 1025},
{389, 707},
{65, 1023},
{391, 379},
{219, 1236},
{219, 1236},
{392, 393},
{395, 396},
{396, 709},
{369, 703},
{65, 1023},
{274, 229},
{274, 645},
{65, 1023},
{63, 1025},
{258, 565},
{63, 1025},
{258, 642},
{65, 1023},
{394, 390},
{397, 398},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{400, 401},
{63, 1025},
{63, 1025},
{63, 1025},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{358, 1275},
{263, 1237},
{399, 370},
{399, 710},
{394, 708},
{63, 1025},
{65, 1023},
{65, 1023},
{401, 375},
{402, 403},
{403, 711},
{404, 405},
{258, 13},
{405, 406},
{258, 656},
{258, 233},
{406, 407},
{408, 409},
{258, 259},
{418, 713},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{65, 1023},
{263, 1237},
{67, 1024},
{263, 1237},
{263, 1237},
{420, 421},
{263, 1237},
{263, 1237},
{258, 234},
{422, 717},
{67, 1024},
{423, 424},
{424, 718},
{67, 1024},
{65, 1023},
{362, 157},
{65, 1023},
{425, 426},
{67, 1024},
{362, 1153},
{362, 1153},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{427, 428},
{65, 1023},
{65, 1023},
{65, 1023},
{428, 719},
{429, 430},
{263, 1237},
{263, 1237},
{433, 313},
{436, 441},
{437, 14},
{438, 439},
{410, 1193},
{276, 1234},
{439, 1411},
{441, 1071},
{442, 1072},
{65, 1023},
{67, 1024},
{67, 1024},
{410, 1193},
{362, 1153},
{67, 60},
{410, 1193},
{443, 444},
{445, 446},
{437, 438},
{447, 448},
{450, 451},
{276, 569},
{67, 61},
{67, 62},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{67, 1024},
{276, 1234},
{68, 1028},
{276, 1234},
{276, 1234},
{276, 1234},
{276, 1234},
{410, 1193},
{452, 453},
{455, 456},
{68, 1028},
{277, 1235},
{457, 458},
{68, 1028},
{67, 1024},
{459, 460},
{67, 1024},
{461, 462},
{68, 1028},
{463, 464},
{465, 466},
{68, 1028},
{68, 1028},
{68, 1028},
{467, 468},
{470, 471},
{472, 473},
{67, 1024},
{67, 1024},
{67, 1024},
{474, 475},
{475, 1071},
{276, 1234},
{276, 1234},
{276, 580},
{276, 581},
{276, 582},
{276, 583},
{276, 584},
{476, 477},
{479, 721},
{480, 722},
{450, 720},
{67, 1024},
{68, 1028},
{68, 1028},
{277, 1235},
{481, 723},
{277, 1235},
{277, 1235},
{277, 1235},
{277, 1235},
{482, 724},
{483, 1071},
{484, 725},
{486, 487},
{488, 489},
{485, 45},
{490, 491},
{489, 726},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{68, 1028},
{493, 727},
{70, 1026},
{481, 482},
{277, 1235},
{277, 1235},
{492, 493},
{485, 1072},
{494, 495},
{492, 385},
{70, 1026},
{278, 1237},
{496, 1413},
{70, 1026},
{68, 1028},
{497, 728},
{68, 1028},
{489, 490},
{70, 1026},
{498, 499},
{500, 501},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{491, 17},
{68, 1028},
{68, 1028},
{68, 1028},
{491, 134},
{502, 503},
{503, 504},
{506, 729},
{491, 637},
{491, 638},
{491, 639},
{491, 640},
{491, 139},
{491, 148},
{505, 45},
{505, 506},
{517, 730},
{68, 1028},
{70, 1026},
{70, 1026},
{278, 1237},
{518, 731},
{278, 1237},
{278, 1237},
{278, 1237},
{278, 1237},
{509, 233},
{515, 233},
{519, 732},
{521, 522},
{522, 733},
{299, 1461},
{523, 524},
{524, 734},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{70, 1026},
{525, 1155},
{72, 1027},
{527, 1157},
{278, 1237},
{278, 1237},
{485, 486},
{509, 234},
{515, 234},
{299, 1461},
{72, 1027},
{528, 1160},
{526, 373},
{72, 1027},
{70, 1026},
{529, 1161},
{70, 1026},
{534, 735},
{72, 1027},
{536, 1384},
{537, 1389},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{542, 1385},
{70, 1026},
{70, 1026},
{70, 1026},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{299, 1461},
{70, 1026},
{72, 1027},
{72, 1027},
{299, 1461},
{378, 588},
{531, 429},
{530, 425},
{378, 574},
{378, 575},
{378, 576},
{378, 577},
{378, 578},
{378, 579},
{526, 1156},
{300, 566},
{72, 64},
{72, 66},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{72, 1027},
{543, 1390},
{73, 1031},
{548, 1382},
{549, 1387},
{531, 1159},
{554, 1383},
{555, 1388},
{559, 449},
{300, 632},
{73, 1031},
{563, 1460},
{378, 26},
{73, 1031},
{72, 1027},
{530, 1158},
{72, 1027},
{0, 0},
{73, 1031},
{0, 0},
{0, 0},
{73, 1031},
{73, 1031},
{73, 1031},
{0, 0},
{0, 0},
{516, 1333},
{72, 1027},
{72, 1027},
{72, 1027},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 1275},
{300, 633},
{300, 634},
{300, 635},
{300, 636},
{72, 1027},
{73, 1031},
{73, 1031},
{300, 130},
{0, 0},
{413, 1189},
{516, 1333},
{416, 1192},
{0, 0},
{516, 343},
{0, 0},
{0, 0},
{0, 0},
{413, 1189},
{0, 0},
{416, 1192},
{413, 1189},
{0, 0},
{416, 1192},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{73, 1031},
{532, 146},
{75, 1029},
{0, 0},
{411, 1188},
{532, 1149},
{532, 1149},
{0, 0},
{0, 0},
{0, 0},
{75, 1029},
{0, 0},
{411, 1188},
{75, 1029},
{73, 1031},
{411, 1188},
{73, 1031},
{413, 1189},
{75, 1029},
{416, 1192},
{0, 0},
{75, 1029},
{75, 1029},
{75, 1029},
{0, 0},
{0, 0},
{0, 0},
{73, 1031},
{73, 1031},
{73, 1031},
{0, 0},
{0, 0},
{0, 0},
{532, 645},
{0, 0},
{562, 567},
{562, 568},
{0, 0},
{0, 0},
{535, 565},
{0, 0},
{535, 649},
{0, 0},
{73, 1031},
{75, 1029},
{75, 1029},
{411, 1188},
{562, 2},
{562, 1147},
{0, 0},
{411, 412},
{0, 0},
{562, 309},
{0, 0},
{0, 0},
{0, 0},
{562, 312},
{0, 0},
{0, 0},
{0, 0},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{75, 1029},
{535, 13},
{77, 1030},
{535, 656},
{535, 318},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{414, 1191},
{77, 1030},
{0, 0},
{0, 0},
{77, 1030},
{75, 1029},
{0, 0},
{75, 1029},
{414, 1191},
{77, 1030},
{0, 0},
{414, 1191},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 69},
{77, 71},
{0, 0},
{75, 1029},
{75, 1029},
{75, 1029},
{0, 0},
{0, 0},
{535, 319},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{87, 1039},
{0, 0},
{0, 0},
{0, 0},
{419, 714},
{75, 1029},
{77, 1030},
{77, 1030},
{87, 1039},
{0, 0},
{0, 0},
{87, 1039},
{419, 715},
{414, 1191},
{0, 0},
{419, 716},
{87, 1039},
{414, 415},
{0, 0},
{87, 1039},
{87, 1039},
{87, 1039},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{77, 1030},
{0, 0},
{78, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{87, 1039},
{87, 1039},
{0, 0},
{78, 1036},
{419, 1182},
{0, 0},
{78, 1036},
{77, 1030},
{0, 0},
{77, 1030},
{0, 0},
{78, 1036},
{0, 0},
{0, 0},
{78, 1036},
{78, 1036},
{78, 1036},
{553, 565},
{0, 0},
{0, 0},
{77, 1030},
{77, 1030},
{77, 1030},
{0, 0},
{87, 1039},
{87, 1039},
{87, 1039},
{87, 1039},
{87, 1039},
{87, 1039},
{0, 0},
{417, 1190},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 1030},
{78, 1036},
{78, 1036},
{417, 1190},
{0, 0},
{0, 0},
{417, 1190},
{87, 1039},
{0, 0},
{87, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{417, 45},
{0, 0},
{553, 13},
{0, 0},
{553, 656},
{553, 318},
{87, 1039},
{87, 1039},
{87, 1039},
{78, 1036},
{78, 1036},
{78, 1036},
{78, 1036},
{78, 1036},
{78, 1036},
{78, 1036},
{78, 1036},
{0, 0},
{80, 1032},
{0, 0},
{0, 0},
{0, 0},
{87, 1039},
{417, 1190},
{0, 0},
{0, 0},
{80, 1032},
{0, 0},
{0, 0},
{80, 1032},
{78, 1036},
{0, 0},
{78, 1036},
{553, 319},
{80, 1032},
{0, 0},
{0, 0},
{80, 1032},
{80, 1032},
{80, 1032},
{0, 0},
{0, 0},
{0, 0},
{78, 1036},
{78, 1036},
{78, 1036},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{338, 1233},
{0, 0},
{78, 1036},
{80, 1032},
{80, 1032},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{338, 569},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{80, 1032},
{0, 0},
{82, 1033},
{338, 1233},
{0, 0},
{338, 1233},
{338, 1233},
{0, 0},
{0, 0},
{0, 0},
{82, 1033},
{0, 0},
{0, 0},
{82, 1033},
{80, 1032},
{0, 0},
{80, 1032},
{0, 0},
{82, 1033},
{0, 0},
{0, 0},
{82, 1033},
{82, 1033},
{82, 1033},
{0, 0},
{0, 0},
{0, 0},
{80, 1032},
{80, 1032},
{80, 1032},
{338, 697},
{0, 0},
{0, 0},
{0, 0},
{338, 1233},
{0, 0},
{338, 580},
{338, 581},
{338, 582},
{338, 583},
{338, 584},
{0, 0},
{0, 0},
{80, 1032},
{82, 1033},
{82, 1033},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{82, 1033},
{0, 0},
{84, 1034},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1034},
{0, 0},
{0, 0},
{84, 1034},
{82, 1033},
{0, 0},
{82, 1033},
{0, 0},
{84, 1034},
{0, 0},
{0, 0},
{84, 1034},
{84, 1034},
{84, 1034},
{0, 0},
{0, 0},
{0, 0},
{82, 1033},
{82, 1033},
{82, 1033},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{421, 408},
{0, 0},
{0, 0},
{0, 0},
{421, 411},
{0, 0},
{82, 1033},
{84, 1034},
{84, 1034},
{421, 1184},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{421, 1184},
{421, 414},
{0, 0},
{421, 1184},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{84, 1034},
{421, 712},
{86, 1035},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{86, 1035},
{0, 0},
{0, 0},
{86, 1035},
{84, 1034},
{421, 1184},
{84, 1034},
{0, 0},
{86, 1035},
{0, 0},
{0, 0},
{86, 1035},
{86, 1035},
{86, 1035},
{0, 0},
{0, 0},
{0, 0},
{84, 1034},
{84, 1034},
{84, 1034},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{84, 1034},
{86, 1035},
{86, 1035},
{92, 1041},
{0, 0},
{0, 0},
{92, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{0, 0},
{0, 0},
{92, 1041},
{92, 1041},
{92, 1041},
{86, 74},
{86, 76},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{86, 1035},
{0, 0},
{89, 1037},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{92, 1041},
{0, 0},
{89, 1037},
{0, 0},
{0, 0},
{89, 1037},
{86, 1035},
{0, 0},
{86, 1035},
{0, 0},
{89, 1037},
{0, 0},
{0, 0},
{89, 1037},
{89, 1037},
{89, 1037},
{0, 0},
{0, 0},
{0, 0},
{86, 1035},
{86, 1035},
{86, 1035},
{0, 0},
{0, 0},
{92, 1041},
{92, 1041},
{92, 1041},
{92, 1041},
{92, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{86, 1035},
{89, 1037},
{89, 1037},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{0, 0},
{92, 1041},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{92, 1041},
{92, 1041},
{89, 1037},
{89, 1037},
{89, 1037},
{89, 1037},
{89, 1037},
{89, 1037},
{89, 1037},
{89, 1037},
{0, 0},
{91, 1038},
{0, 0},
{0, 0},
{0, 0},
{92, 1041},
{0, 0},
{0, 0},
{0, 0},
{91, 1038},
{0, 0},
{0, 0},
{91, 1038},
{89, 1037},
{0, 0},
{89, 1037},
{0, 0},
{91, 1038},
{0, 0},
{0, 0},
{91, 1038},
{91, 1038},
{91, 1038},
{0, 0},
{0, 0},
{0, 0},
{89, 1037},
{89, 1037},
{89, 1037},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1040},
{0, 0},
{0, 0},
{0, 0},
{89, 1037},
{91, 1038},
{91, 1038},
{0, 0},
{94, 1040},
{0, 0},
{0, 0},
{94, 1040},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1040},
{0, 0},
{0, 0},
{94, 1040},
{94, 1040},
{94, 1040},
{0, 0},
{91, 79},
{91, 81},
{91, 83},
{91, 85},
{91, 1038},
{91, 1038},
{91, 1038},
{91, 1038},
{91, 1038},
{91, 1038},
{91, 1038},
{91, 1038},
{0, 0},
{95, 1043},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1040},
{94, 1040},
{95, 1043},
{0, 0},
{0, 0},
{95, 1043},
{91, 1038},
{0, 0},
{91, 1038},
{0, 0},
{95, 1043},
{0, 0},
{0, 0},
{95, 1043},
{95, 1043},
{95, 1043},
{0, 0},
{0, 0},
{0, 0},
{91, 1038},
{91, 1038},
{91, 1038},
{94, 88},
{94, 90},
{94, 1040},
{94, 1040},
{94, 1040},
{94, 1040},
{94, 1040},
{94, 1040},
{0, 0},
{97, 1042},
{0, 0},
{0, 0},
{0, 0},
{91, 1038},
{95, 1043},
{95, 1043},
{0, 0},
{97, 1042},
{0, 0},
{0, 0},
{97, 1042},
{94, 1040},
{0, 0},
{94, 1040},
{0, 0},
{97, 1042},
{0, 0},
{0, 0},
{97, 1042},
{97, 1042},
{97, 1042},
{0, 0},
{0, 0},
{0, 0},
{94, 1040},
{94, 1040},
{94, 1040},
{0, 0},
{0, 0},
{0, 0},
{95, 1043},
{95, 1043},
{95, 1043},
{95, 1043},
{0, 0},
{98, 1045},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{94, 1040},
{97, 1042},
{97, 1042},
{98, 1045},
{0, 0},
{0, 0},
{98, 1045},
{95, 1043},
{0, 0},
{95, 1043},
{0, 0},
{98, 1045},
{0, 0},
{0, 0},
{98, 1045},
{98, 1045},
{98, 1045},
{0, 0},
{0, 0},
{0, 0},
{95, 1043},
{95, 1043},
{95, 1043},
{0, 0},
{0, 0},
{97, 93},
{97, 1042},
{97, 1042},
{97, 1042},
{97, 1042},
{97, 1042},
{0, 0},
{100, 1044},
{0, 0},
{0, 0},
{0, 0},
{95, 1043},
{98, 1045},
{98, 1045},
{0, 0},
{100, 1044},
{0, 0},
{0, 0},
{100, 1044},
{97, 1042},
{0, 0},
{97, 1042},
{0, 0},
{100, 1044},
{0, 0},
{0, 0},
{100, 1044},
{100, 1044},
{100, 1044},
{0, 0},
{0, 0},
{0, 0},
{97, 1042},
{97, 1042},
{97, 1042},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{98, 1045},
{98, 1045},
{98, 1045},
{0, 0},
{101, 1047},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{97, 1042},
{100, 1044},
{100, 1044},
{101, 1047},
{0, 0},
{0, 0},
{101, 1047},
{98, 1045},
{0, 0},
{98, 1045},
{0, 0},
{101, 1047},
{0, 0},
{0, 0},
{101, 1047},
{101, 1047},
{101, 1047},
{0, 0},
{0, 0},
{0, 0},
{98, 1045},
{98, 1045},
{98, 1045},
{0, 0},
{0, 0},
{0, 0},
{100, 96},
{100, 1044},
{100, 1044},
{100, 1044},
{100, 1044},
{0, 0},
{103, 1046},
{0, 0},
{0, 0},
{0, 0},
{98, 1045},
{101, 1047},
{101, 1047},
{0, 0},
{103, 1046},
{0, 0},
{0, 0},
{103, 1046},
{100, 1044},
{0, 0},
{100, 1044},
{0, 0},
{103, 1046},
{0, 0},
{0, 0},
{103, 1046},
{103, 1046},
{103, 1046},
{0, 0},
{0, 0},
{0, 0},
{100, 1044},
{100, 1044},
{100, 1044},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{101, 1047},
{101, 1047},
{0, 0},
{104, 1049},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{100, 1044},
{103, 1046},
{103, 1046},
{104, 1049},
{0, 0},
{0, 0},
{104, 1049},
{101, 1047},
{0, 0},
{101, 1047},
{0, 0},
{104, 1049},
{0, 0},
{0, 0},
{104, 1049},
{104, 1049},
{104, 1049},
{0, 0},
{0, 0},
{0, 0},
{101, 1047},
{101, 1047},
{101, 1047},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{103, 99},
{103, 1046},
{103, 1046},
{103, 1046},
{0, 0},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{101, 1047},
{104, 1049},
{104, 1049},
{0, 0},
{106, 1048},
{0, 0},
{0, 0},
{106, 1048},
{103, 1046},
{0, 0},
{103, 1046},
{0, 0},
{106, 1048},
{0, 0},
{0, 0},
{106, 1048},
{106, 1048},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{103, 1046},
{103, 1046},
{103, 1046},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{104, 105},
{104, 107},
{0, 0},
{109, 1051},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{103, 1046},
{106, 1048},
{106, 1048},
{109, 1051},
{0, 0},
{0, 0},
{109, 1051},
{104, 1049},
{0, 0},
{104, 1049},
{0, 0},
{109, 1051},
{0, 0},
{0, 0},
{109, 1051},
{109, 1051},
{109, 1051},
{0, 0},
{0, 0},
{0, 0},
{104, 1049},
{104, 1049},
{104, 1049},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{106, 102},
{106, 1048},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{104, 1049},
{109, 1051},
{109, 1051},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{106, 1048},
{0, 0},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{106, 1048},
{106, 1048},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1431},
{156, 1431},
{106, 1048},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{156, 1431},
{0, 0},
{109, 1051},
{0, 0},
{109, 1051},
{156, 1431},
{156, 1431},
{0, 0},
{0, 0},
{0, 0},
{156, 1431},
{156, 1431},
{0, 0},
{0, 0},
{156, 1431},
{109, 1051},
{109, 1051},
{109, 1051},
{0, 0},
{156, 157},
{0, 0},
{0, 0},
{0, 0},
{156, 1431},
{156, 1431},
{156, 1431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1091},
{109, 1051},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{0, 0},
{156, 1431},
{156, 1431},
{209, 1120},
{0, 0},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{156, 1431},
{159, 1091},
{0, 0},
{209, 1120},
{209, 1120},
{0, 0},
{209, 1120},
{209, 1120},
{209, 1120},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{209, 1120},
{209, 1120},
{0, 0},
{0, 0},
{0, 0},
{209, 1120},
{209, 1120},
{159, 1091},
{159, 1091},
{209, 1120},
{209, 1120},
{0, 0},
{159, 1091},
{159, 1091},
{0, 0},
{163, 1094},
{0, 0},
{159, 1091},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{159, 1091},
{163, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{163, 1094},
{163, 1094},
{0, 0},
{0, 0},
{0, 0},
{163, 1094},
{163, 1094},
{0, 0},
{165, 1092},
{163, 1094},
{163, 1094},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{163, 1094},
{165, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1092},
{165, 1092},
{0, 0},
{0, 0},
{0, 0},
{165, 1092},
{165, 1092},
{0, 0},
{167, 1093},
{0, 0},
{165, 1092},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{165, 1092},
{167, 1093},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 1093},
{167, 1093},
{275, 1232},
{0, 0},
{0, 0},
{167, 1093},
{167, 1093},
{0, 0},
{168, 1097},
{167, 160},
{167, 1093},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 161},
{167, 162},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{167, 1093},
{168, 1097},
{0, 0},
{275, 1232},
{0, 0},
{275, 1232},
{275, 1232},
{275, 1232},
{275, 1232},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{275, 1275},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 1097},
{168, 1097},
{0, 0},
{275, 1232},
{275, 1232},
{168, 1097},
{168, 1097},
{0, 0},
{170, 1095},
{168, 1097},
{168, 1097},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{168, 1097},
{170, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1095},
{170, 1095},
{0, 0},
{0, 0},
{0, 0},
{170, 1095},
{170, 1095},
{0, 0},
{172, 1096},
{170, 1095},
{170, 1095},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{170, 1095},
{172, 1096},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 1096},
{172, 1096},
{0, 0},
{0, 0},
{0, 0},
{172, 1096},
{172, 1096},
{0, 0},
{173, 1100},
{172, 1096},
{172, 1096},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{172, 164},
{172, 166},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{172, 1096},
{173, 1100},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 1100},
{173, 1100},
{0, 0},
{0, 0},
{0, 0},
{173, 1100},
{173, 1100},
{0, 0},
{175, 1098},
{173, 1100},
{173, 1100},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{173, 1100},
{175, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1098},
{175, 1098},
{0, 0},
{0, 0},
{0, 0},
{175, 1098},
{175, 1098},
{0, 0},
{177, 1099},
{175, 1098},
{175, 1098},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{175, 1098},
{177, 1099},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 169},
{177, 171},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{177, 1099},
{177, 1099},
{0, 0},
{0, 0},
{0, 0},
{177, 1099},
{177, 1099},
{0, 0},
{178, 1105},
{177, 1099},
{177, 1099},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{177, 1099},
{178, 1105},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{180, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{178, 1105},
{178, 1105},
{0, 0},
{0, 0},
{0, 0},
{178, 1105},
{178, 1105},
{0, 0},
{0, 0},
{178, 1105},
{178, 1105},
{0, 0},
{180, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{178, 1105},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{180, 1101},
{180, 1101},
{0, 0},
{0, 0},
{0, 0},
{180, 1101},
{180, 1101},
{0, 0},
{182, 1102},
{180, 1101},
{180, 1101},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{180, 1101},
{182, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{182, 1102},
{182, 1102},
{0, 0},
{0, 0},
{0, 0},
{182, 1102},
{182, 1102},
{0, 0},
{184, 1103},
{182, 1102},
{182, 1102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{182, 1102},
{184, 1103},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{184, 1103},
{184, 1103},
{0, 0},
{0, 0},
{0, 0},
{184, 1103},
{184, 1103},
{0, 0},
{186, 1104},
{184, 1103},
{184, 1103},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{187, 1108},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{184, 1103},
{186, 1104},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{187, 1108},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{186, 1104},
{186, 1104},
{0, 0},
{0, 0},
{0, 0},
{186, 1104},
{186, 1104},
{187, 1108},
{187, 1108},
{186, 1104},
{186, 1104},
{0, 0},
{187, 1108},
{187, 1108},
{0, 0},
{189, 1106},
{187, 1108},
{187, 1108},
{0, 0},
{0, 0},
{0, 0},
{186, 174},
{186, 176},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{186, 1104},
{0, 0},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{187, 1108},
{189, 1106},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{191, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{189, 1106},
{189, 1106},
{0, 0},
{0, 0},
{0, 0},
{189, 1106},
{189, 1106},
{0, 0},
{0, 0},
{189, 1106},
{189, 1106},
{0, 0},
{191, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{189, 1106},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 1107},
{191, 1107},
{0, 0},
{0, 0},
{0, 0},
{191, 1107},
{191, 1107},
{0, 0},
{192, 1110},
{191, 1107},
{191, 1107},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{191, 179},
{191, 181},
{191, 183},
{191, 185},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{191, 1107},
{192, 1110},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{194, 1109},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{192, 1110},
{192, 1110},
{0, 0},
{0, 0},
{0, 0},
{192, 1110},
{192, 1110},
{0, 0},
{0, 0},
{192, 1110},
{192, 1110},
{0, 0},
{194, 1109},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{195, 1112},
{0, 0},
{0, 0},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{192, 1110},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{194, 1109},
{194, 1109},
{0, 0},
{0, 0},
{0, 0},
{194, 1109},
{194, 1109},
{0, 0},
{0, 0},
{194, 1109},
{194, 1109},
{0, 0},
{195, 1112},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{195, 1112},
{195, 1112},
{195, 1112},
{195, 1112},
{195, 1112},
{195, 1112},
{195, 1112},
{194, 188},
{194, 190},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{194, 1109},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{195, 1112},
{195, 1112},
{197, 1111},
{0, 0},
{0, 0},
{195, 1112},
{195, 1112},
{0, 0},
{0, 0},
{195, 1112},
{195, 1112},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1114},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{197, 1111},
{0, 0},
{195, 1112},
{195, 1112},
{195, 1112},
{195, 1112},
{0, 0},
{0, 0},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{198, 1114},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1114},
{198, 1114},
{198, 1114},
{198, 1114},
{198, 1114},
{198, 1114},
{198, 1114},
{197, 1111},
{197, 1111},
{0, 0},
{0, 0},
{0, 0},
{197, 1111},
{197, 1111},
{0, 0},
{0, 0},
{197, 1111},
{197, 1111},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{198, 1114},
{198, 1114},
{200, 1113},
{0, 0},
{0, 0},
{198, 1114},
{198, 1114},
{0, 0},
{0, 0},
{198, 1114},
{198, 1114},
{0, 0},
{0, 0},
{0, 0},
{197, 193},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{197, 1111},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{200, 1113},
{0, 0},
{0, 0},
{198, 1114},
{198, 1114},
{198, 1114},
{0, 0},
{0, 0},
{200, 1113},
{200, 1113},
{200, 1113},
{200, 1113},
{200, 1113},
{200, 1113},
{200, 1113},
{201, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{200, 1113},
{200, 1113},
{0, 0},
{0, 0},
{0, 0},
{200, 1113},
{200, 1113},
{0, 0},
{0, 0},
{200, 1113},
{200, 1113},
{0, 0},
{201, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1116},
{201, 1116},
{201, 1116},
{201, 1116},
{201, 1116},
{201, 1116},
{201, 1116},
{203, 1115},
{0, 0},
{0, 0},
{200, 196},
{200, 1113},
{200, 1113},
{200, 1113},
{200, 1113},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1116},
{201, 1116},
{0, 0},
{0, 0},
{0, 0},
{201, 1116},
{201, 1116},
{0, 0},
{0, 0},
{201, 1116},
{201, 1116},
{0, 0},
{203, 1115},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{203, 1115},
{203, 1115},
{203, 1115},
{203, 1115},
{203, 1115},
{203, 1115},
{203, 1115},
{204, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{201, 1116},
{201, 1116},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{203, 1115},
{203, 1115},
{0, 0},
{0, 0},
{0, 0},
{203, 1115},
{203, 1115},
{0, 0},
{0, 0},
{203, 1115},
{203, 1115},
{0, 0},
{204, 1118},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{204, 1118},
{204, 1118},
{204, 1118},
{204, 1118},
{204, 1118},
{204, 1118},
{204, 1118},
{206, 1117},
{0, 0},
{0, 0},
{0, 0},
{203, 199},
{203, 1115},
{203, 1115},
{203, 1115},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{204, 1118},
{204, 1118},
{0, 0},
{0, 0},
{0, 0},
{204, 1118},
{204, 1118},
{0, 0},
{0, 0},
{204, 1118},
{204, 1118},
{0, 0},
{206, 1117},
{0, 0},
{0, 0},
{215, 1457},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{206, 1117},
{206, 1117},
{206, 1117},
{206, 1117},
{206, 1117},
{206, 1117},
{206, 1117},
{0, 0},
{0, 0},
{215, 1457},
{0, 0},
{0, 0},
{0, 0},
{204, 205},
{204, 207},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 1457},
{0, 0},
{206, 1117},
{206, 1117},
{0, 0},
{0, 0},
{0, 0},
{206, 1117},
{206, 1117},
{0, 0},
{0, 0},
{206, 1117},
{206, 1117},
{215, 1457},
{0, 0},
{0, 0},
{262, 1235},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{206, 202},
{206, 1117},
{206, 1117},
{215, 1457},
{216, 1459},
{0, 0},
{0, 0},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{215, 1457},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{262, 1235},
{216, 1459},
{262, 1235},
{262, 1235},
{0, 0},
{262, 1235},
{262, 1235},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{216, 1459},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{262, 1275},
{0, 0},
{0, 0},
{0, 0},
{216, 648},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{262, 1235},
{262, 1235},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{237, 1456},
{0, 0},
{0, 0},
{216, 1459},
{0, 0},
{0, 0},
{0, 0},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{216, 1459},
{0, 0},
{0, 0},
{237, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1288},
{0, 0},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{0, 0},
{269, 1288},
{0, 0},
{237, 1456},
{0, 0},
{0, 0},
{0, 0},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{237, 1456},
{269, 1288},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1288},
{0, 0},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{286, 1306},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{269, 1288},
{269, 1288},
{0, 0},
{0, 0},
{269, 270},
{269, 1288},
{286, 1306},
{0, 0},
{0, 0},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{269, 1288},
{0, 0},
{286, 1306},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{286, 1306},
{0, 0},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{286, 1306},
{286, 1306},
{0, 0},
{0, 0},
{286, 287},
{286, 1306},
{0, 0},
{0, 0},
{0, 0},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{286, 1306},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{329, 1426},
{0, 0},
{0, 0},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{0, 0},
{351, 1238},
{329, 1426},
{351, 1238},
{0, 0},
{0, 0},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{329, 1426},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1238},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1148},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1238},
{0, 0},
{0, 0},
{351, 352},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1238},
{0, 0},
{351, 1238},
{351, 1238},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{0, 0},
{0, 0},
{0, 0},
{351, 1238},
{0, 0},
{351, 1238},
{430, 432},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{351, 1238},
{0, 0},
{430, 567},
{430, 568},
{0, 0},
{0, 0},
{431, 6},
{0, 0},
{0, 0},
{430, 569},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{430, 2},
{430, 1147},
{0, 0},
{0, 0},
{0, 0},
{430, 309},
{430, 632},
{0, 0},
{0, 0},
{430, 312},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{431, 959},
{0, 0},
{431, 959},
{431, 959},
{431, 959},
{0, 0},
{431, 1417},
{431, 959},
{431, 959},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 1275},
{430, 633},
{430, 634},
{430, 635},
{430, 636},
{0, 0},
{431, 959},
{0, 0},
{430, 130},
{431, 959},
{431, 959},
{431, 959},
{430, 580},
{430, 581},
{430, 582},
{430, 583},
{430, 584},
{0, 0},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{0, 0},
{431, 959},
{0, 0},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{431, 959},
{440, 1007},
{431, 959},
{0, 0},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{451, 1265},
{0, 0},
{431, 959},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{451, 1265},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1007},
{440, 1007},
{0, 0},
{440, 1007},
{440, 1007},
{0, 0},
{451, 1265},
{440, 1412},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{451, 1265},
{0, 0},
{451, 1265},
{451, 1265},
{0, 0},
{0, 0},
{451, 1419},
{508, 431},
{508, 571},
{508, 572},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1007},
{0, 0},
{0, 0},
{508, 433},
{451, 1265},
{451, 1265},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{451, 1265},
{508, 435},
{451, 1265},
{451, 1265},
{451, 1265},
{451, 1265},
{451, 1265},
{440, 1007},
{508, 436},
{0, 0},
{0, 0},
{508, 437},
{0, 0},
{508, 440},
{0, 0},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{440, 1007},
{449, 1456},
{449, 1456},
{0, 0},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{508, 449},
{0, 0},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{0, 0},
{449, 1456},
{449, 1456},
{0, 0},
{449, 1456},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{449, 1456},
{449, 1456},
{0, 0},
{0, 0},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{504, 5},
{0, 0},
{508, 452},
{0, 0},
{508, 454},
{508, 457},
{0, 0},
{508, 461},
{508, 465},
{508, 469},
{508, 470},
{508, 478},
{508, 480},
{508, 481},
{508, 483},
{0, 0},
{449, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{504, 7},
{0, 0},
{0, 0},
{504, 592},
{504, 27},
{0, 0},
{0, 0},
{0, 0},
{504, 595},
{504, 596},
{504, 597},
{504, 598},
{504, 33},
{504, 35},
{0, 0},
{0, 0},
{0, 0},
{449, 1456},
{0, 0},
{449, 1456},
{449, 1456},
{0, 0},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{449, 1456},
{0, 0},
{0, 0},
{504, 599},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{504, 600},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{504, 37},
{504, 39},
{504, 601},
{504, 602},
{504, 603},
{504, 604},
{504, 605},
{504, 606},
{504, 607},
{504, 608},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{507, 1363},
{507, 1363},
{0, 0},
{507, 1363},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{507, 1363},
{507, 1363},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{507, 1363},
{0, 0},
{507, 1363},
{507, 1363},
{507, 508},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{507, 1363},
{560, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1456},
{560, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1456},
{560, 1456},
{0, 0},
{0, 0},
{0, 0},
{560, 1456},
{560, 1456},
{0, 0},
{0, 0},
{560, 1456},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1386},
{0, 0},
{0, 0},
{560, 1456},
{0, 0},
{561, 1459},
{0, 0},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{560, 1456},
{561, 1459},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{561, 1459},
{0, 0},
{0, 0},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{561, 1459},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
331,
564,
738,
31,
739,
0,
0,
230,
793,
738,
31,
742,
738,
31,
740,
127,
741,
40,
41,
42,
761,
762,
308,
137,
744,
46,
870,
760,
51,
58,
750,
8,
306,
793,
18,
738,
31,
743,
143,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
115,
757,
10,
11,
20,
21,
152,
215,
841,
839,
290,
332,
872,
334,
335,
337,
338,
339,
340,
347,
293,
350,
3,
231,
736,
351,
354,
738,
31,
740,
767,
741,
40,
41,
42,
225,
737,
286,
226,
744,
46,
132,
217,
859,
58,
856,
269,
857,
307,
12,
285,
12,
736,
22,
736,
22,
300,
535,
941,
302,
541,
547,
553,
275,
276,
277,
278,
791,
784,
821,
255,
808,
809,
256,
738,
31,
740,
766,
768,
40,
41,
738,
31,
740,
850,
741,
40,
41,
42,
788,
812,
813,
820,
744,
46,
851,
132,
853,
58,
215,
283,
788,
949,
946,
559,
560,
796,
321,
798,
211,
766,
224,
865,
241,
245,
216,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
789,
790,
305,
738,
31,
740,
128,
741,
40,
41,
42,
303,
836,
790,
156,
744,
46,
156,
749,
51,
58,
750,
299,
838,
288,
282,
156,
156,
156,
855,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
858,
757,
738,
31,
740,
860,
741,
40,
41,
42,
311,
861,
294,
156,
744,
46,
295,
760,
51,
58,
750,
738,
31,
740,
820,
741,
40,
41,
47,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
843,
757,
738,
31,
740,
128,
741,
40,
41,
42,
797,
323,
315,
801,
744,
46,
873,
749,
51,
58,
750,
291,
251,
802,
781,
252,
254,
782,
783,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
837,
757,
738,
31,
740,
818,
741,
40,
41,
42,
803,
878,
324,
879,
744,
46,
356,
357,
852,
58,
738,
31,
740,
128,
741,
40,
41,
42,
156,
362,
881,
397,
744,
46,
880,
749,
51,
58,
750,
129,
216,
361,
363,
819,
888,
255,
890,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
371,
757,
738,
31,
740,
372,
741,
40,
41,
42,
862,
400,
434,
367,
744,
46,
450,
479,
765,
58,
738,
31,
740,
255,
741,
40,
41,
42,
369,
884,
919,
315,
744,
46,
920,
921,
764,
58,
738,
31,
740,
44,
741,
40,
41,
42,
122,
922,
869,
932,
744,
46,
933,
749,
51,
58,
750,
738,
31,
740,
934,
768,
40,
41,
937,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
367,
757,
738,
31,
740,
538,
741,
40,
41,
42,
315,
389,
889,
391,
744,
46,
883,
763,
51,
58,
750,
539,
769,
158,
848,
529,
811,
156,
935,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
534,
757,
738,
31,
740,
372,
741,
40,
41,
42,
316,
863,
49,
531,
744,
46,
938,
760,
51,
58,
750,
544,
545,
779,
814,
255,
808,
809,
256,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
846,
757,
738,
31,
740,
880,
741,
40,
41,
42,
550,
359,
532,
363,
744,
46,
551,
745,
51,
58,
750,
738,
31,
885,
781,
353,
863,
782,
783,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
556,
757,
738,
31,
740,
53,
741,
40,
41,
42,
54,
557,
255,
947,
744,
46,
561,
749,
51,
58,
750,
738,
31,
740,
562,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
53,
741,
40,
41,
42,
56,
394,
889,
391,
744,
46,
0,
749,
51,
58,
750,
0,
769,
158,
772,
525,
526,
530,
939,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
788,
741,
40,
41,
42,
834,
0,
0,
367,
744,
46,
0,
0,
746,
58,
738,
31,
740,
0,
741,
40,
41,
42,
399,
884,
0,
0,
744,
46,
0,
0,
747,
58,
748,
738,
31,
740,
0,
741,
40,
41,
42,
835,
790,
0,
255,
744,
46,
0,
0,
747,
58,
751,
738,
31,
740,
0,
741,
40,
41,
42,
527,
0,
528,
936,
744,
46,
0,
0,
747,
58,
752,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
753,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
65,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
67,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
70,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
72,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
75,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
77,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
68,
80,
744,
46,
306,
793,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
68,
82,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
68,
84,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
741,
40,
41,
42,
59,
63,
68,
86,
744,
46,
0,
0,
747,
58,
750,
0,
0,
871,
0,
857,
307,
0,
0,
59,
63,
68,
73,
89,
738,
31,
740,
0,
741,
40,
41,
42,
230,
793,
0,
0,
744,
46,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
91,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
94,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
231,
0,
744,
46,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
97,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
100,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
0,
0,
0,
0,
0,
244,
247,
798,
59,
63,
68,
73,
78,
87,
92,
95,
103,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
106,
738,
31,
740,
53,
741,
40,
41,
42,
108,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
769,
158,
773,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
747,
58,
750,
738,
31,
740,
0,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
754,
755,
738,
31,
740,
53,
741,
40,
41,
42,
111,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
769,
158,
774,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
53,
741,
40,
41,
42,
113,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
758,
58,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
759,
51,
58,
750,
738,
31,
740,
0,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
119,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
769,
158,
771,
165,
0,
156,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
121,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
779,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
780,
757,
738,
31,
740,
53,
741,
40,
41,
42,
124,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
289,
781,
0,
0,
782,
783,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
126,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
144,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
767,
757,
738,
31,
740,
0,
768,
40,
41,
0,
0,
738,
31,
740,
136,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
847,
58,
0,
145,
0,
153,
0,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
144,
849,
738,
31,
740,
128,
741,
40,
41,
42,
0,
230,
793,
767,
744,
46,
0,
749,
51,
58,
750,
135,
142,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
145,
0,
153,
0,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
738,
31,
740,
128,
741,
40,
41,
42,
0,
0,
0,
144,
744,
46,
0,
749,
51,
58,
750,
141,
156,
231,
0,
0,
767,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
0,
768,
40,
41,
0,
212,
0,
0,
0,
0,
145,
0,
153,
784,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
738,
31,
740,
0,
768,
40,
41,
785,
0,
0,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
213,
781,
223,
0,
782,
783,
240,
243,
798,
0,
0,
151,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
845,
738,
31,
740,
0,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
0,
844,
58,
738,
31,
740,
128,
741,
40,
41,
42,
0,
144,
0,
0,
744,
46,
0,
749,
51,
58,
750,
150,
0,
0,
767,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
145,
227,
153,
0,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
210,
738,
31,
740,
0,
741,
40,
41,
42,
769,
158,
771,
167,
744,
46,
0,
0,
747,
58,
770,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
769,
158,
771,
159,
170,
0,
0,
769,
158,
771,
159,
172,
0,
0,
769,
158,
771,
159,
163,
175,
0,
769,
158,
771,
159,
163,
177,
0,
769,
158,
771,
159,
163,
168,
180,
769,
158,
771,
159,
163,
168,
182,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
738,
31,
740,
0,
768,
40,
41,
0,
738,
31,
740,
0,
768,
40,
41,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
184,
769,
158,
771,
159,
163,
168,
186,
769,
158,
771,
159,
163,
168,
173,
189,
769,
158,
771,
159,
163,
168,
173,
191,
769,
158,
771,
159,
163,
168,
173,
178,
194,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
197,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
200,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
203,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
206,
738,
31,
740,
156,
768,
40,
41,
0,
0,
0,
0,
0,
0,
230,
793,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
230,
793,
0,
215,
0,
214,
0,
0,
0,
0,
0,
156,
0,
784,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
208,
787,
778,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
776,
779,
777,
0,
218,
219,
231,
0,
781,
0,
0,
782,
783,
792,
156,
0,
0,
0,
767,
786,
231,
0,
788,
0,
0,
230,
793,
804,
156,
0,
0,
0,
0,
230,
793,
0,
0,
0,
0,
0,
0,
0,
0,
781,
0,
220,
782,
783,
272,
273,
274,
275,
276,
277,
278,
805,
784,
821,
255,
808,
809,
256,
0,
0,
806,
790,
807,
255,
808,
809,
256,
279,
0,
842,
738,
31,
740,
0,
768,
40,
41,
0,
0,
826,
0,
0,
0,
230,
793,
240,
243,
798,
231,
251,
230,
793,
252,
254,
230,
793,
231,
230,
793,
796,
236,
798,
0,
781,
156,
0,
782,
783,
0,
230,
793,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
223,
0,
794,
0,
248,
0,
0,
0,
0,
0,
0,
0,
784,
0,
225,
0,
0,
0,
0,
0,
0,
231,
0,
230,
793,
0,
0,
0,
231,
0,
785,
0,
231,
0,
0,
231,
0,
0,
0,
0,
0,
328,
240,
330,
798,
0,
0,
231,
865,
0,
796,
236,
798,
249,
781,
156,
795,
782,
783,
0,
0,
0,
0,
794,
0,
235,
779,
799,
0,
239,
800,
0,
0,
784,
230,
793,
0,
784,
0,
0,
779,
0,
795,
230,
793,
0,
0,
0,
0,
0,
231,
0,
779,
0,
0,
0,
0,
0,
156,
227,
0,
0,
0,
0,
796,
236,
798,
0,
0,
144,
780,
796,
236,
798,
238,
796,
236,
798,
796,
236,
798,
0,
767,
0,
0,
799,
0,
250,
230,
793,
796,
236,
798,
0,
781,
784,
0,
782,
783,
0,
0,
231,
0,
0,
0,
0,
0,
0,
0,
156,
231,
0,
258,
787,
261,
0,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
264,
825,
265,
267,
0,
0,
0,
796,
236,
798,
800,
781,
0,
0,
782,
783,
230,
793,
0,
260,
779,
0,
0,
0,
0,
0,
0,
0,
0,
231,
0,
0,
0,
0,
0,
0,
811,
0,
786,
817,
0,
816,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
230,
793,
0,
0,
0,
0,
796,
236,
798,
0,
781,
0,
260,
782,
783,
796,
236,
798,
0,
0,
144,
0,
779,
814,
255,
808,
809,
256,
0,
0,
0,
231,
815,
767,
816,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
810,
0,
230,
793,
0,
0,
0,
0,
796,
236,
798,
258,
0,
261,
260,
231,
262,
263,
0,
784,
821,
255,
808,
809,
256,
0,
822,
265,
267,
0,
144,
0,
0,
0,
823,
0,
816,
0,
230,
793,
0,
0,
0,
767,
0,
0,
0,
292,
0,
0,
260,
0,
0,
230,
793,
0,
0,
0,
0,
0,
0,
0,
796,
236,
798,
0,
0,
0,
0,
231,
824,
827,
816,
258,
0,
261,
811,
156,
262,
263,
0,
784,
821,
255,
808,
809,
256,
271,
825,
265,
267,
0,
0,
144,
0,
0,
0,
0,
796,
236,
798,
0,
0,
0,
828,
231,
767,
0,
0,
0,
0,
0,
0,
156,
779,
814,
255,
808,
809,
256,
231,
0,
0,
0,
0,
218,
219,
0,
156,
0,
230,
793,
829,
0,
792,
0,
145,
0,
153,
767,
830,
262,
263,
0,
784,
821,
255,
808,
809,
256,
0,
0,
796,
236,
798,
832,
781,
0,
0,
782,
783,
0,
301,
0,
230,
793,
220,
0,
831,
272,
273,
274,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
833,
0,
230,
793,
0,
796,
236,
798,
0,
781,
0,
840,
782,
783,
231,
230,
793,
0,
0,
0,
796,
236,
798,
0,
781,
144,
0,
782,
783,
738,
31,
740,
0,
741,
40,
41,
42,
0,
767,
0,
0,
744,
46,
0,
0,
747,
58,
854,
231,
794,
0,
320,
0,
0,
230,
793,
0,
230,
793,
784,
0,
230,
793,
0,
0,
0,
0,
0,
145,
231,
153,
0,
0,
262,
263,
0,
784,
821,
255,
808,
809,
256,
231,
795,
0,
0,
0,
0,
0,
0,
0,
0,
0,
779,
0,
0,
866,
796,
321,
798,
326,
0,
0,
865,
799,
0,
327,
0,
0,
0,
0,
0,
0,
0,
784,
0,
0,
800,
0,
230,
793,
231,
0,
0,
231,
0,
0,
779,
231,
0,
864,
796,
321,
798,
0,
0,
0,
865,
870,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
868,
796,
321,
798,
0,
342,
0,
865,
349,
0,
0,
0,
514,
867,
796,
321,
798,
0,
0,
0,
865,
0,
0,
332,
872,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
231,
736,
351,
354,
0,
0,
0,
767,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
796,
236,
798,
796,
236,
798,
0,
796,
236,
798,
0,
0,
0,
0,
0,
0,
535,
941,
0,
541,
547,
553,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
882,
230,
793,
0,
0,
0,
0,
0,
0,
0,
0,
945,
946,
559,
560,
796,
321,
798,
738,
31,
740,
865,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
874,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
0,
741,
40,
41,
42,
0,
231,
0,
0,
744,
46,
0,
874,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
516,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
874,
51,
58,
750,
738,
31,
740,
0,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
796,
236,
798,
0,
877,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
392,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
875,
345,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
395,
0,
892,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
876,
886,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
886,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
230,
793,
0,
0,
738,
31,
740,
380,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
384,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
887,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
886,
738,
31,
740,
231,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
548,
0,
0,
388,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
392,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
392,
738,
31,
740,
0,
768,
40,
41,
549,
796,
321,
798,
0,
0,
0,
865,
0,
0,
0,
0,
891,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
402,
0,
892,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
420,
0,
0,
0,
738,
31,
740,
417,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
423,
897,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
410,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
418,
419,
893,
894,
895,
738,
31,
740,
413,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
416,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
417,
741,
40,
41,
42,
0,
230,
793,
0,
744,
46,
0,
749,
51,
58,
750,
738,
31,
740,
0,
768,
40,
41,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
231,
0,
420,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
422,
419,
893,
894,
895,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
896,
0,
0,
554,
0,
0,
0,
0,
0,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
886,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
555,
796,
321,
798,
0,
870,
0,
865,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
427,
738,
31,
740,
0,
768,
40,
41,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
498,
500,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
0,
0,
455,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
930,
900,
901,
902,
903,
904,
905,
906,
907,
520,
0,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
523,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
898,
929,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
908,
909,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
928,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
908,
909,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
927,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
442,
741,
40,
41,
42,
443,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
299,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
53,
741,
40,
41,
42,
445,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
53,
741,
40,
41,
42,
447,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
459,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
870,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
926,
900,
901,
902,
903,
904,
905,
906,
907,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
498,
500,
736,
351,
354,
0,
908,
909,
767,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
923,
900,
901,
902,
903,
904,
905,
906,
907,
517,
519,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
898,
917,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
738,
31,
740,
0,
768,
40,
41,
0,
498,
500,
0,
908,
909,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
916,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
908,
909,
886,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
507,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
463,
741,
40,
41,
42,
488,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
467,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
914,
900,
901,
902,
903,
904,
905,
906,
907,
0,
230,
793,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
0,
0,
0,
0,
908,
909,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
231,
0,
827,
0,
0,
0,
0,
811,
0,
898,
913,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
498,
500,
0,
0,
738,
31,
740,
53,
741,
40,
41,
42,
472,
512,
908,
909,
744,
46,
0,
749,
51,
58,
750,
779,
814,
255,
808,
809,
256,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
796,
236,
798,
0,
0,
0,
0,
898,
502,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
53,
741,
40,
41,
42,
474,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
53,
741,
40,
41,
42,
476,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
53,
741,
40,
41,
42,
484,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
738,
31,
740,
505,
741,
40,
41,
42,
0,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
738,
31,
740,
0,
768,
40,
41,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
912,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
769,
158,
771,
159,
163,
168,
173,
178,
187,
192,
195,
198,
201,
204,
775,
908,
909,
886,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
492,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
498,
500,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
898,
911,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
908,
909,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
910,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
230,
793,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
908,
909,
0,
0,
0,
0,
0,
0,
230,
793,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
899,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
231,
0,
788,
0,
0,
0,
0,
804,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
231,
757,
788,
0,
0,
0,
0,
804,
0,
0,
0,
0,
0,
0,
0,
510,
0,
0,
0,
0,
0,
0,
0,
0,
806,
790,
807,
255,
808,
809,
256,
0,
498,
500,
0,
536,
0,
0,
0,
0,
0,
0,
0,
0,
806,
790,
807,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
796,
236,
798,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
537,
796,
321,
798,
0,
0,
0,
865,
0,
230,
793,
0,
0,
0,
0,
0,
0,
0,
898,
915,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
940,
0,
0,
870,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
231,
0,
827,
0,
0,
0,
0,
811,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
924,
334,
335,
337,
338,
339,
340,
347,
0,
350,
498,
500,
736,
351,
354,
542,
0,
0,
767,
0,
0,
0,
0,
0,
0,
779,
814,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
543,
796,
321,
798,
0,
0,
0,
865,
0,
0,
0,
0,
0,
0,
0,
0,
898,
923,
900,
901,
902,
903,
904,
905,
906,
907,
0,
518,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
0,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
498,
500,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
0,
0,
0,
744,
46,
0,
749,
51,
58,
750,
0,
0,
942,
0,
0,
870,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
925,
900,
901,
902,
903,
904,
905,
906,
907,
332,
924,
334,
335,
337,
338,
339,
340,
347,
0,
350,
498,
500,
736,
351,
354,
0,
908,
909,
767,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
898,
930,
900,
901,
902,
903,
904,
905,
906,
907,
0,
0,
0,
0,
0,
0,
0,
738,
31,
740,
485,
741,
494,
496,
42,
497,
521,
908,
909,
744,
46,
0,
749,
51,
58,
750,
0,
0,
0,
0,
0,
870,
0,
0,
59,
63,
68,
73,
78,
87,
92,
95,
98,
101,
104,
756,
0,
757,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
498,
500,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
870,
0,
0,
0,
0,
0,
0,
898,
931,
900,
901,
902,
903,
904,
905,
906,
907,
540,
0,
0,
870,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
908,
909,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
870,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
943,
0,
0,
870,
0,
0,
546,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
918,
334,
335,
337,
338,
339,
340,
347,
552,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
0,
0,
332,
924,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
944,
0,
0,
870,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
870,
0,
0,
558,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
332,
924,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
332,
918,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
948,
0,
509,
870,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
332,
924,
334,
335,
337,
338,
339,
340,
347,
0,
350,
0,
0,
736,
351,
354,
0,
0,
0,
767,
0,
0,
0,
0,
0,
0,
563,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
0,
511,
513,
515,
275,
276,
277,
278,
0,
784,
821,
255,
808,
809,
256,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [4],
& yyTComb [0],
& yyTComb [23],
& yyTComb [0],
& yyTComb [0],
& yyTComb [7],
& yyTComb [0],
& yyTComb [6],
& yyTComb [7],
& yyTComb [8],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [13],
& yyTComb [14],
& yyTComb [15],
& yyTComb [0],
& yyTComb [15],
& yyTComb [16],
& yyTComb [0],
& yyTComb [1],
& yyTComb [21],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [41],
& yyTComb [24],
& yyTComb [21],
& yyTComb [74],
& yyTComb [22],
& yyTComb [27],
& yyTComb [0],
& yyTComb [29],
& yyTComb [0],
& yyTComb [0],
& yyTComb [38],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [195],
& yyTComb [0],
& yyTComb [42],
& yyTComb [0],
& yyTComb [40],
& yyTComb [296],
& yyTComb [36],
& yyTComb [37],
& yyTComb [0],
& yyTComb [397],
& yyTComb [0],
& yyTComb [82],
& yyTComb [0],
& yyTComb [1],
& yyTComb [2],
& yyTComb [0],
& yyTComb [0],
& yyTComb [498],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [571],
& yyTComb [0],
& yyTComb [644],
& yyTComb [0],
& yyTComb [717],
& yyTComb [790],
& yyTComb [0],
& yyTComb [863],
& yyTComb [0],
& yyTComb [936],
& yyTComb [1009],
& yyTComb [0],
& yyTComb [1082],
& yyTComb [0],
& yyTComb [1155],
& yyTComb [1228],
& yyTComb [0],
& yyTComb [1301],
& yyTComb [0],
& yyTComb [1374],
& yyTComb [0],
& yyTComb [1447],
& yyTComb [0],
& yyTComb [1520],
& yyTComb [1191],
& yyTComb [0],
& yyTComb [1593],
& yyTComb [0],
& yyTComb [1666],
& yyTComb [1556],
& yyTComb [0],
& yyTComb [1703],
& yyTComb [1739],
& yyTComb [0],
& yyTComb [1776],
& yyTComb [1812],
& yyTComb [0],
& yyTComb [1849],
& yyTComb [1885],
& yyTComb [0],
& yyTComb [1922],
& yyTComb [1958],
& yyTComb [0],
& yyTComb [1995],
& yyTComb [43],
& yyTComb [44],
& yyTComb [2031],
& yyTComb [3],
& yyTComb [4],
& yyTComb [7],
& yyTComb [8],
& yyTComb [49],
& yyTComb [0],
& yyTComb [2],
& yyTComb [3],
& yyTComb [0],
& yyTComb [94],
& yyTComb [0],
& yyTComb [90],
& yyTComb [47],
& yyTComb [53],
& yyTComb [54],
& yyTComb [0],
& yyTComb [57],
& yyTComb [55],
& yyTComb [52],
& yyTComb [0],
& yyTComb [36],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [63],
& yyTComb [0],
& yyTComb [0],
& yyTComb [59],
& yyTComb [0],
& yyTComb [62],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [63],
& yyTComb [227],
& yyTComb [252],
& yyTComb [102],
& yyTComb [0],
& yyTComb [66],
& yyTComb [494],
& yyTComb [0],
& yyTComb [0],
& yyTComb [66],
& yyTComb [158],
& yyTComb [174],
& yyTComb [67],
& yyTComb [2118],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2164],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2229],
& yyTComb [0],
& yyTComb [2294],
& yyTComb [0],
& yyTComb [2359],
& yyTComb [2424],
& yyTComb [0],
& yyTComb [2489],
& yyTComb [0],
& yyTComb [2554],
& yyTComb [2619],
& yyTComb [0],
& yyTComb [2684],
& yyTComb [0],
& yyTComb [2749],
& yyTComb [2814],
& yyTComb [0],
& yyTComb [2856],
& yyTComb [0],
& yyTComb [2921],
& yyTComb [0],
& yyTComb [2986],
& yyTComb [0],
& yyTComb [3051],
& yyTComb [3058],
& yyTComb [0],
& yyTComb [3123],
& yyTComb [0],
& yyTComb [3165],
& yyTComb [3230],
& yyTComb [0],
& yyTComb [3272],
& yyTComb [3314],
& yyTComb [0],
& yyTComb [3373],
& yyTComb [3388],
& yyTComb [0],
& yyTComb [3447],
& yyTComb [3489],
& yyTComb [0],
& yyTComb [3531],
& yyTComb [3573],
& yyTComb [0],
& yyTComb [3615],
& yyTComb [86],
& yyTComb [93],
& yyTComb [2157],
& yyTComb [99],
& yyTComb [109],
& yyTComb [106],
& yyTComb [189],
& yyTComb [107],
& yyTComb [3643],
& yyTComb [3706],
& yyTComb [272],
& yyTComb [527],
& yyTComb [600],
& yyTComb [282],
& yyTComb [8],
& yyTComb [167],
& yyTComb [169],
& yyTComb [168],
& yyTComb [170],
& yyTComb [171],
& yyTComb [175],
& yyTComb [429],
& yyTComb [178],
& yyTComb [7],
& yyTComb [213],
& yyTComb [0],
& yyTComb [0],
& yyTComb [173],
& yyTComb [0],
& yyTComb [379],
& yyTComb [3765],
& yyTComb [182],
& yyTComb [0],
& yyTComb [0],
& yyTComb [181],
& yyTComb [429],
& yyTComb [185],
& yyTComb [188],
& yyTComb [190],
& yyTComb [0],
& yyTComb [228],
& yyTComb [193],
& yyTComb [395],
& yyTComb [203],
& yyTComb [199],
& yyTComb [204],
& yyTComb [210],
& yyTComb [205],
& yyTComb [571],
& yyTComb [194],
& yyTComb [0],
& yyTComb [677],
& yyTComb [0],
& yyTComb [289],
& yyTComb [0],
& yyTComb [3686],
& yyTComb [701],
& yyTComb [193],
& yyTComb [306],
& yyTComb [0],
& yyTComb [307],
& yyTComb [218],
& yyTComb [3811],
& yyTComb [0],
& yyTComb [226],
& yyTComb [453],
& yyTComb [258],
& yyTComb [607],
& yyTComb [2418],
& yyTComb [774],
& yyTComb [819],
& yyTComb [892],
& yyTComb [252],
& yyTComb [226],
& yyTComb [0],
& yyTComb [261],
& yyTComb [262],
& yyTComb [0],
& yyTComb [287],
& yyTComb [3858],
& yyTComb [0],
& yyTComb [382],
& yyTComb [0],
& yyTComb [307],
& yyTComb [0],
& yyTComb [0],
& yyTComb [315],
& yyTComb [316],
& yyTComb [317],
& yyTComb [7],
& yyTComb [324],
& yyTComb [324],
& yyTComb [936],
& yyTComb [1009],
& yyTComb [325],
& yyTComb [326],
& yyTComb [327],
& yyTComb [0],
& yyTComb [387],
& yyTComb [0],
& yyTComb [0],
& yyTComb [387],
& yyTComb [0],
& yyTComb [366],
& yyTComb [9],
& yyTComb [0],
& yyTComb [10],
& yyTComb [383],
& yyTComb [0],
& yyTComb [369],
& yyTComb [0],
& yyTComb [0],
& yyTComb [391],
& yyTComb [0],
& yyTComb [458],
& yyTComb [12],
& yyTComb [13],
& yyTComb [403],
& yyTComb [14],
& yyTComb [498],
& yyTComb [0],
& yyTComb [414],
& yyTComb [3929],
& yyTComb [418],
& yyTComb [0],
& yyTComb [460],
& yyTComb [0],
& yyTComb [395],
& yyTComb [462],
& yyTComb [14],
& yyTComb [396],
& yyTComb [1360],
& yyTComb [535],
& yyTComb [497],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [400],
& yyTComb [426],
& yyTComb [437],
& yyTComb [530],
& yyTComb [0],
& yyTComb [0],
& yyTComb [493],
& yyTComb [3992],
& yyTComb [0],
& yyTComb [567],
& yyTComb [0],
& yyTComb [0],
& yyTComb [442],
& yyTComb [570],
& yyTComb [644],
& yyTComb [493],
& yyTComb [0],
& yyTComb [556],
& yyTComb [715],
& yyTComb [0],
& yyTComb [496],
& yyTComb [0],
& yyTComb [0],
& yyTComb [498],
& yyTComb [0],
& yyTComb [609],
& yyTComb [0],
& yyTComb [505],
& yyTComb [567],
& yyTComb [510],
& yyTComb [0],
& yyTComb [557],
& yyTComb [0],
& yyTComb [538],
& yyTComb [1001],
& yyTComb [0],
& yyTComb [573],
& yyTComb [522],
& yyTComb [593],
& yyTComb [0],
& yyTComb [600],
& yyTComb [0],
& yyTComb [606],
& yyTComb [0],
& yyTComb [607],
& yyTComb [601],
& yyTComb [0],
& yyTComb [630],
& yyTComb [627],
& yyTComb [1],
& yyTComb [642],
& yyTComb [606],
& yyTComb [608],
& yyTComb [644],
& yyTComb [0],
& yyTComb [663],
& yyTComb [627],
& yyTComb [587],
& yyTComb [646],
& yyTComb [648],
& yyTComb [650],
& yyTComb [592],
& yyTComb [675],
& yyTComb [0],
& yyTComb [651],
& yyTComb [0],
& yyTComb [753],
& yyTComb [1084],
& yyTComb [0],
& yyTComb [1055],
& yyTComb [1162],
& yyTComb [0],
& yyTComb [1057],
& yyTComb [1264],
& yyTComb [657],
& yyTComb [1195],
& yyTComb [699],
& yyTComb [1491],
& yyTComb [682],
& yyTComb [683],
& yyTComb [685],
& yyTComb [717],
& yyTComb [0],
& yyTComb [725],
& yyTComb [703],
& yyTComb [705],
& yyTComb [4057],
& yyTComb [4057],
& yyTComb [0],
& yyTComb [734],
& yyTComb [0],
& yyTComb [0],
& yyTComb [732],
& yyTComb [770],
& yyTComb [736],
& yyTComb [734],
& yyTComb [4176],
& yyTComb [714],
& yyTComb [715],
& yyTComb [723],
& yyTComb [0],
& yyTComb [724],
& yyTComb [0],
& yyTComb [748],
& yyTComb [0],
& yyTComb [4280],
& yyTComb [787],
& yyTComb [4189],
& yyTComb [775],
& yyTComb [0],
& yyTComb [0],
& yyTComb [776],
& yyTComb [0],
& yyTComb [782],
& yyTComb [0],
& yyTComb [783],
& yyTComb [0],
& yyTComb [787],
& yyTComb [0],
& yyTComb [787],
& yyTComb [0],
& yyTComb [790],
& yyTComb [0],
& yyTComb [792],
& yyTComb [0],
& yyTComb [0],
& yyTComb [795],
& yyTComb [0],
& yyTComb [772],
& yyTComb [0],
& yyTComb [776],
& yyTComb [799],
& yyTComb [807],
& yyTComb [0],
& yyTComb [26],
& yyTComb [786],
& yyTComb [787],
& yyTComb [793],
& yyTComb [798],
& yyTComb [799],
& yyTComb [800],
& yyTComb [826],
& yyTComb [828],
& yyTComb [0],
& yyTComb [828],
& yyTComb [805],
& yyTComb [831],
& yyTComb [873],
& yyTComb [851],
& yyTComb [820],
& yyTComb [848],
& yyTComb [0],
& yyTComb [852],
& yyTComb [834],
& yyTComb [859],
& yyTComb [0],
& yyTComb [860],
& yyTComb [0],
& yyTComb [785],
& yyTComb [875],
& yyTComb [4350],
& yyTComb [882],
& yyTComb [852],
& yyTComb [4454],
& yyTComb [4231],
& yyTComb [895],
& yyTComb [0],
& yyTComb [18],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [896],
& yyTComb [1014],
& yyTComb [860],
& yyTComb [865],
& yyTComb [872],
& yyTComb [0],
& yyTComb [873],
& yyTComb [875],
& yyTComb [876],
& yyTComb [878],
& yyTComb [892],
& yyTComb [947],
& yyTComb [894],
& yyTComb [902],
& yyTComb [906],
& yyTComb [979],
& yyTComb [969],
& yyTComb [1066],
& yyTComb [18],
& yyTComb [908],
& yyTComb [1139],
& yyTComb [912],
& yyTComb [913],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [29],
& yyTComb [919],
& yyTComb [967],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [969],
& yyTComb [970],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1270],
& yyTComb [972],
& yyTComb [973],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [974],
& yyTComb [4586],
& yyTComb [4650],
& yyTComb [1126],
& yyTComb [977],
& yyTComb [33],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-126],
& yyNComb [-136],
& yyNComb [-60],
& yyNComb [-129],
& yyNComb [-136],
& yyNComb [-108],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-111],
& yyNComb [-125],
& yyNComb [-136],
& yyNComb [-13],
& yyNComb [-136],
& yyNComb [-126],
& yyNComb [-136],
& yyNComb [-106],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-124],
& yyNComb [-125],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [47],
& yyNComb [47],
& yyNComb [-125],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [88],
& yyNComb [-6],
& yyNComb [129],
& yyNComb [170],
& yyNComb [188],
& yyNComb [229],
& yyNComb [47],
& yyNComb [247],
& yyNComb [-129],
& yyNComb [-103],
& yyNComb [-129],
& yyNComb [265],
& yyNComb [-136],
& yyNComb [306],
& yyNComb [107],
& yyNComb [-129],
& yyNComb [347],
& yyNComb [-136],
& yyNComb [388],
& yyNComb [-128],
& yyNComb [429],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [470],
& yyNComb [-136],
& yyNComb [511],
& yyNComb [529],
& yyNComb [-136],
& yyNComb [548],
& yyNComb [567],
& yyNComb [586],
& yyNComb [-136],
& yyNComb [605],
& yyNComb [-136],
& yyNComb [624],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [643],
& yyNComb [-136],
& yyNComb [662],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [681],
& yyNComb [-136],
& yyNComb [700],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [719],
& yyNComb [-136],
& yyNComb [738],
& yyNComb [-136],
& yyNComb [757],
& yyNComb [-136],
& yyNComb [776],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [795],
& yyNComb [-136],
& yyNComb [827],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [859],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [892],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [926],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [961],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [997],
& yyNComb [-136],
& yyNComb [1034],
& yyNComb [-136],
& yyNComb [1075],
& yyNComb [1115],
& yyNComb [-136],
& yyNComb [1156],
& yyNComb [-136],
& yyNComb [1197],
& yyNComb [1215],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1256],
& yyNComb [-136],
& yyNComb [1297],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1338],
& yyNComb [-132],
& yyNComb [1379],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1339],
& yyNComb [-121],
& yyNComb [-117],
& yyNComb [-134],
& yyNComb [1420],
& yyNComb [1480],
& yyNComb [1412],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [284],
& yyNComb [1429],
& yyNComb [1535],
& yyNComb [1480],
& yyNComb [-121],
& yyNComb [-136],
& yyNComb [-127],
& yyNComb [251],
& yyNComb [1576],
& yyNComb [1603],
& yyNComb [1663],
& yyNComb [1681],
& yyNComb [1624],
& yyNComb [-102],
& yyNComb [-136],
& yyNComb [-8],
& yyNComb [-10],
& yyNComb [1475],
& yyNComb [-136],
& yyNComb [1722],
& yyNComb [1782],
& yyNComb [-136],
& yyNComb [448],
& yyNComb [1016],
& yyNComb [1094],
& yyNComb [-136],
& yyNComb [1234],
& yyNComb [-136],
& yyNComb [1748],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1801],
& yyNComb [-136],
& yyNComb [1808],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1815],
& yyNComb [-136],
& yyNComb [1822],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1829],
& yyNComb [-136],
& yyNComb [1836],
& yyNComb [-136],
& yyNComb [1885],
& yyNComb [-136],
& yyNComb [1892],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1899],
& yyNComb [-136],
& yyNComb [1907],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1915],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1966],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1976],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1987],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1999],
& yyNComb [-136],
& yyNComb [2054],
& yyNComb [-136],
& yyNComb [2072],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [1201],
& yyNComb [1977],
& yyNComb [2012],
& yyNComb [-136],
& yyNComb [-64],
& yyNComb [2067],
& yyNComb [-72],
& yyNComb [-94],
& yyNComb [2076],
& yyNComb [2202],
& yyNComb [-136],
& yyNComb [-134],
& yyNComb [-136],
& yyNComb [-120],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [2062],
& yyNComb [2156],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [830],
& yyNComb [1484],
& yyNComb [2217],
& yyNComb [2210],
& yyNComb [-22],
& yyNComb [-102],
& yyNComb [2221],
& yyNComb [2224],
& yyNComb [-134],
& yyNComb [-136],
& yyNComb [-19],
& yyNComb [-22],
& yyNComb [-133],
& yyNComb [-136],
& yyNComb [-9],
& yyNComb [-22],
& yyNComb [2236],
& yyNComb [2279],
& yyNComb [2330],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [19],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-112],
& yyNComb [2304],
& yyNComb [2384],
& yyNComb [2472],
& yyNComb [-125],
& yyNComb [2339],
& yyNComb [94],
& yyNComb [-112],
& yyNComb [2433],
& yyNComb [-136],
& yyNComb [2438],
& yyNComb [-136],
& yyNComb [2474],
& yyNComb [-136],
& yyNComb [2495],
& yyNComb [2433],
& yyNComb [2528],
& yyNComb [2564],
& yyNComb [2579],
& yyNComb [440],
& yyNComb [-60],
& yyNComb [94],
& yyNComb [-7],
& yyNComb [-100],
& yyNComb [2591],
& yyNComb [-99],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-108],
& yyNComb [-123],
& yyNComb [-136],
& yyNComb [-62],
& yyNComb [-136],
& yyNComb [-98],
& yyNComb [-136],
& yyNComb [2558],
& yyNComb [-88],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-56],
& yyNComb [2673],
& yyNComb [-49],
& yyNComb [29],
& yyNComb [-136],
& yyNComb [2743],
& yyNComb [-136],
& yyNComb [2],
& yyNComb [15],
& yyNComb [-136],
& yyNComb [-13],
& yyNComb [-9],
& yyNComb [-136],
& yyNComb [253],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [26],
& yyNComb [-136],
& yyNComb [134],
& yyNComb [2148],
& yyNComb [2656],
& yyNComb [2690],
& yyNComb [-22],
& yyNComb [116],
& yyNComb [44],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [2711],
& yyNComb [2724],
& yyNComb [-136],
& yyNComb [116],
& yyNComb [-22],
& yyNComb [2828],
& yyNComb [-136],
& yyNComb [747],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [39],
& yyNComb [-136],
& yyNComb [-72],
& yyNComb [-94],
& yyNComb [-136],
& yyNComb [2763],
& yyNComb [71],
& yyNComb [2986],
& yyNComb [3027],
& yyNComb [-136],
& yyNComb [3068],
& yyNComb [-136],
& yyNComb [2766],
& yyNComb [73],
& yyNComb [-111],
& yyNComb [-124],
& yyNComb [309],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [113],
& yyNComb [163],
& yyNComb [-136],
& yyNComb [320],
& yyNComb [-136],
& yyNComb [131],
& yyNComb [117],
& yyNComb [-136],
& yyNComb [127],
& yyNComb [-136],
& yyNComb [151],
& yyNComb [169],
& yyNComb [-136],
& yyNComb [2909],
& yyNComb [-136],
& yyNComb [233],
& yyNComb [-136],
& yyNComb [411],
& yyNComb [177],
& yyNComb [3087],
& yyNComb [-136],
& yyNComb [217],
& yyNComb [-136],
& yyNComb [407],
& yyNComb [3147],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3166],
& yyNComb [-136],
& yyNComb [3226],
& yyNComb [-136],
& yyNComb [3245],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [113],
& yyNComb [115],
& yyNComb [-136],
& yyNComb [381],
& yyNComb [-136],
& yyNComb [3305],
& yyNComb [-136],
& yyNComb [142],
& yyNComb [451],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3323],
& yyNComb [3305],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3383],
& yyNComb [-136],
& yyNComb [3446],
& yyNComb [-136],
& yyNComb [3487],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3541],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3582],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3623],
& yyNComb [-136],
& yyNComb [3642],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3702],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [3762],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [234],
& yyNComb [3918],
& yyNComb [3964],
& yyNComb [4010],
& yyNComb [-125],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [4166],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [4207],
& yyNComb [-136],
& yyNComb [4248],
& yyNComb [-136],
& yyNComb [4289],
& yyNComb [221],
& yyNComb [4378],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [4534],
& yyNComb [3804],
& yyNComb [-136],
& yyNComb [4580],
& yyNComb [-136],
& yyNComb [4335],
& yyNComb [-136],
& yyNComb [4626],
& yyNComb [-136],
& yyNComb [4782],
& yyNComb [-136],
& yyNComb [4823],
& yyNComb [-136],
& yyNComb [4869],
& yyNComb [-136],
& yyNComb [4910],
& yyNComb [4991],
& yyNComb [-136],
& yyNComb [5066],
& yyNComb [-136],
& yyNComb [5147],
& yyNComb [-136],
& yyNComb [5188],
& yyNComb [-136],
& yyNComb [5229],
& yyNComb [173],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [5275],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [4689],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [5338],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-129],
& yyNComb [5398],
& yyNComb [-103],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [5444],
& yyNComb [-136],
& yyNComb [5490],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [5318],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [-136],
& yyNComb [5646],
& yyNComb [5593],
& yyNComb [149],
& yyNComb [4968],
& yyNComb [153],
& yyNComb [2770],
& yyNComb [154],
& yyNComb [2964],
& yyNComb [166],
& yyNComb [5802],
& yyNComb [5958],
& yyNComb [5958],
& yyNComb [6047],
& yyNComb [6203],
& yyNComb [-136],
& yyNComb [6203],
& yyNComb [-136],
& yyNComb [191],
& yyNComb [493],
& yyNComb [194],
& yyNComb [247],
& yyNComb [202],
& yyNComb [276],
& yyNComb [206],
& yyNComb [117],
& yyNComb [269],
& yyNComb [-136],
& yyNComb [5613],
& yyNComb [149],
& yyNComb [287],
& yyNComb [306],
& yyNComb [6203],
& yyNComb [5802],
& yyNComb [5771],
& yyNComb [153],
& yyNComb [344],
& yyNComb [348],
& yyNComb [6311],
& yyNComb [6047],
& yyNComb [3236],
& yyNComb [154],
& yyNComb [374],
& yyNComb [383],
& yyNComb [6331],
& yyNComb [6433],
& yyNComb [3627],
& yyNComb [166],
& yyNComb [405],
& yyNComb [419],
& yyNComb [6411],
& yyNComb [6513],
& yyNComb [299],
& yyNComb [421],
& yyNComb [432],
& yyNComb [6533],
& yyNComb [6596],
& yyNComb [-136],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
562,
478,
0,
504,
431,
114,
17,
0,
19,
0,
0,
350,
437,
314,
491,
0,
0,
0,
22,
0,
0,
0,
437,
0,
378,
504,
149,
437,
0,
378,
0,
504,
504,
149,
504,
149,
114,
504,
114,
378,
378,
47,
107,
126,
504,
378,
0,
504,
308,
504,
0,
55,
44,
0,
504,
0,
114,
504,
67,
504,
504,
504,
72,
504,
67,
504,
0,
77,
504,
72,
504,
0,
86,
504,
77,
504,
0,
91,
504,
86,
504,
86,
504,
86,
504,
0,
94,
504,
91,
504,
0,
97,
504,
0,
100,
504,
0,
103,
504,
0,
106,
504,
0,
0,
504,
0,
504,
0,
504,
504,
0,
504,
0,
504,
504,
0,
0,
504,
0,
504,
0,
0,
107,
0,
504,
0,
0,
505,
300,
478,
478,
285,
491,
149,
300,
301,
0,
491,
504,
149,
300,
301,
0,
326,
300,
491,
491,
504,
38,
300,
301,
0,
247,
237,
213,
0,
491,
504,
167,
491,
491,
491,
172,
491,
167,
491,
0,
177,
491,
172,
491,
0,
186,
491,
177,
491,
0,
191,
491,
186,
491,
186,
491,
186,
491,
0,
194,
491,
191,
491,
0,
197,
491,
0,
200,
491,
0,
203,
491,
0,
206,
491,
0,
0,
491,
0,
491,
0,
491,
223,
0,
213,
153,
213,
0,
0,
300,
276,
276,
535,
146,
0,
0,
0,
478,
0,
0,
154,
249,
0,
0,
515,
515,
238,
238,
247,
0,
326,
238,
244,
0,
247,
247,
0,
0,
247,
0,
249,
274,
249,
0,
0,
247,
0,
0,
478,
300,
300,
491,
0,
268,
326,
326,
300,
0,
268,
0,
515,
0,
300,
300,
220,
274,
553,
276,
326,
275,
276,
301,
217,
301,
0,
288,
478,
0,
0,
478,
0,
301,
0,
300,
301,
0,
308,
0,
0,
0,
0,
0,
0,
0,
0,
0,
504,
0,
478,
478,
0,
336,
0,
0,
433,
0,
0,
478,
353,
433,
553,
326,
326,
330,
237,
215,
0,
0,
553,
326,
0,
247,
243,
1,
0,
350,
0,
0,
0,
0,
326,
338,
0,
515,
516,
344,
504,
0,
344,
0,
515,
516,
478,
22,
433,
0,
0,
478,
17,
0,
478,
0,
358,
532,
0,
478,
0,
533,
478,
0,
491,
0,
478,
0,
526,
17,
401,
0,
393,
0,
0,
491,
492,
0,
0,
491,
492,
491,
0,
491,
492,
394,
391,
0,
0,
391,
0,
401,
0,
0,
478,
0,
0,
491,
401,
0,
0,
491,
0,
421,
0,
504,
417,
0,
504,
417,
0,
504,
417,
0,
0,
0,
0,
504,
0,
405,
0,
0,
491,
492,
0,
0,
508,
0,
451,
0,
508,
508,
508,
22,
0,
378,
0,
149,
128,
0,
483,
0,
475,
0,
508,
560,
430,
0,
0,
508,
491,
0,
508,
0,
504,
505,
508,
0,
504,
505,
508,
0,
504,
505,
508,
508,
0,
483,
0,
483,
0,
504,
0,
508,
0,
0,
0,
0,
0,
504,
0,
0,
0,
491,
492,
0,
0,
46,
0,
0,
378,
508,
378,
0,
0,
508,
0,
508,
0,
0,
46,
0,
0,
0,
483,
535,
516,
509,
516,
515,
516,
553,
0,
450,
508,
508,
430,
508,
0,
508,
0,
531,
530,
531,
530,
531,
531,
0,
0,
0,
0,
217,
516,
560,
561,
562,
563,
535,
516,
560,
561,
562,
563,
553,
516,
560,
561,
562,
563,
0,
516,
560,
561,
562,
563,
0,
0,
0,
217,
562,
0,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
1,
1,
1,
1,
1,
1,
1,
2,
1,
1,
1,
3,
1,
2,
2,
4,
1,
2,
4,
7,
3,
4,
3,
3,
2,
2,
2,
4,
4,
1,
5,
8,
0,
1,
1,
3,
1,
2,
2,
2,
2,
2,
2,
6,
6,
3,
3,
5,
5,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
8,
1,
3,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
3,
3,
1,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
5,
0,
1,
7,
7,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
0,
1,
1,
2,
2,
2,
6,
6,
5,
5,
1,
1,
1,
1,
1,
6,
1,
3,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
1,
3,
3,
3,
3,
1,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
5,
0,
1,
1,
0,
1,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
1,
3,
2,
1,
2,
2,
1,
2,
2,
5,
7,
10,
0,
1,
1,
3,
1,
2,
2,
1,
2,
2,
3,
2,
3,
3,
4,
2,
3,
3,
4,
3,
4,
4,
5,
3,
1,
3,
3,
5,
1,
2,
4,
4,
1,
2,
2,
1,
2,
0,
1,
1,
1,
1,
3,
1,
1,
3,
3,
5,
7,
1,
2,
4,
4,
1,
2,
3,
7,
7,
3,
3,
5,
1,
3,
2,
3,
1,
3,
2,
5,
5,
2,
3,
3,
1,
1,
1,
1,
1,
1,
3,
3,
4,
3,
3,
4,
1,
1,
1,
1,
1,
1,
1,
2,
2,
1,
2,
1,
1,
1,
1,
1,
2,
2,
2,
2,
1,
2,
2,
2,
2,
2,
2,
1,
2,
2,
2,
2,
2,
1,
2,
2,
1,
1,
1,
1,
1,
1,
2,
0,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
4,
5,
2,
1,
1,
1,
2,
2,
2,
2,
3,
2,
3,
2,
1,
0,
1,
2,
4,
5,
2,
2,
4,
0,
2,
3,
5,
1,
3,
1,
2,
2,
1,
2,
2,
1,
2,
2,
1,
2,
2,
1,
3,
1,
2,
1,
2,
0,
2,
3,
4,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
4,
3,
3,
3,
3,
4,
4,
5,
1,
2,
1,
2,
2,
5,
7,
5,
5,
7,
9,
3,
2,
2,
3,
3,
2,
3,
1,
2,
1,
1,
2,
1,
2,
2,
2,
2,
1,
2,
2,
2,
2,
5,
6,
6,
6,
6,
1,
1,
1,
2,
3,
3,
4,
2,
4,
5,
6,
2,
2,
1,
3,
3,
1,
1,
3,
3,
4,
1,
1,
1,
1,
2,
3,
3,
4,
5,
3,
4,
1,
1,
1,
1,
4,
5,
1,
2,
3,
3,
4,
4,
5,
1,
2,
2,
3,
2,
3,
3,
4,
3,
3,
3,
4,
2,
0,
2,
0,
0,
0,
0,
0,
0,
0,
1,
5,
6,
1,
2,
1,
1,
2,
9,
6,
10,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
306,
137,
138,
138,
138,
138,
138,
139,
139,
140,
140,
140,
140,
142,
142,
142,
142,
145,
145,
145,
145,
145,
145,
145,
145,
145,
145,
145,
145,
145,
149,
151,
151,
152,
152,
148,
148,
154,
154,
154,
154,
154,
154,
154,
154,
154,
154,
154,
154,
154,
155,
155,
155,
155,
155,
155,
155,
150,
150,
150,
150,
150,
150,
150,
150,
150,
156,
156,
165,
165,
165,
165,
166,
166,
166,
167,
167,
167,
168,
168,
168,
169,
169,
169,
169,
169,
170,
170,
170,
171,
171,
172,
172,
173,
173,
174,
174,
175,
175,
176,
176,
177,
177,
178,
178,
153,
153,
153,
179,
179,
179,
179,
179,
179,
179,
179,
179,
179,
179,
141,
141,
146,
146,
180,
180,
180,
180,
180,
180,
180,
180,
181,
181,
181,
181,
182,
182,
183,
183,
183,
183,
184,
184,
184,
185,
185,
185,
186,
186,
186,
187,
187,
187,
187,
187,
188,
188,
188,
189,
189,
190,
190,
191,
191,
192,
192,
193,
193,
194,
194,
196,
196,
197,
195,
195,
199,
199,
199,
199,
199,
199,
199,
199,
199,
199,
198,
198,
162,
207,
207,
207,
208,
208,
211,
211,
202,
202,
213,
213,
215,
215,
216,
216,
216,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
214,
219,
224,
224,
225,
221,
226,
226,
227,
227,
228,
228,
228,
228,
228,
229,
229,
229,
229,
230,
230,
230,
231,
231,
232,
222,
222,
233,
233,
235,
235,
236,
236,
236,
237,
237,
234,
238,
220,
239,
239,
200,
200,
240,
240,
241,
143,
143,
201,
201,
242,
243,
243,
243,
243,
243,
243,
206,
206,
206,
205,
205,
205,
248,
248,
248,
249,
249,
249,
244,
244,
244,
247,
247,
254,
254,
255,
255,
255,
250,
250,
250,
250,
252,
252,
252,
252,
203,
203,
203,
204,
204,
204,
251,
251,
251,
253,
253,
253,
212,
212,
212,
212,
212,
212,
217,
257,
217,
217,
217,
217,
217,
217,
217,
217,
256,
256,
258,
258,
258,
260,
260,
261,
261,
262,
262,
264,
264,
263,
263,
265,
265,
266,
266,
267,
259,
259,
259,
268,
268,
269,
269,
271,
271,
270,
270,
272,
272,
272,
272,
272,
272,
272,
272,
272,
272,
272,
272,
274,
274,
158,
158,
158,
158,
246,
246,
275,
275,
275,
276,
276,
278,
278,
278,
278,
278,
278,
278,
278,
278,
277,
277,
277,
277,
277,
279,
279,
279,
279,
287,
287,
288,
288,
280,
281,
281,
281,
282,
282,
282,
283,
283,
283,
283,
283,
284,
285,
136,
136,
289,
289,
290,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
291,
245,
245,
293,
293,
293,
293,
293,
295,
295,
295,
295,
294,
294,
294,
294,
210,
210,
210,
144,
144,
144,
209,
209,
209,
292,
292,
292,
292,
292,
299,
299,
299,
273,
273,
273,
297,
297,
297,
218,
218,
218,
218,
218,
218,
218,
300,
300,
300,
300,
300,
300,
300,
300,
301,
301,
301,
301,
296,
147,
147,
160,
302,
298,
157,
159,
163,
164,
161,
223,
223,
303,
303,
286,
286,
286,
286,
304,
305,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
10,
1,
1,
1,
1,
1,
39,
39,
22,
41,
41,
41,
18,
37,
1,
37,
39,
39,
22,
41,
41,
22,
2,
37,
1,
1,
1,
2,
37,
1,
1,
41,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
37,
1,
1,
1,
41,
41,
1,
21,
120,
37,
120,
120,
120,
1,
1,
21,
1,
1,
1,
21,
1,
21,
1,
21,
21,
1,
21,
1,
21,
21,
1,
21,
1,
21,
21,
1,
21,
1,
21,
1,
21,
1,
21,
21,
1,
21,
1,
21,
21,
1,
21,
21,
1,
21,
21,
1,
21,
21,
1,
21,
21,
1,
21,
42,
42,
21,
121,
121,
119,
119,
1,
1,
1,
1,
1,
106,
1,
108,
42,
37,
37,
1,
37,
37,
41,
49,
1,
1,
40,
1,
1,
49,
41,
41,
1,
1,
1,
49,
41,
41,
1,
49,
37,
1,
1,
1,
49,
41,
41,
41,
3,
41,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
42,
42,
28,
37,
37,
41,
41,
41,
3,
41,
69,
1,
1,
40,
37,
37,
37,
37,
37,
37,
37,
3,
40,
1,
1,
1,
1,
1,
1,
40,
3,
1,
1,
41,
41,
40,
41,
41,
41,
68,
68,
40,
40,
40,
41,
41,
40,
41,
49,
1,
49,
49,
1,
40,
1,
1,
1,
64,
63,
1,
63,
1,
1,
49,
64,
69,
40,
40,
1,
1,
1,
1,
41,
69,
41,
41,
64,
1,
40,
1,
1,
64,
41,
41,
49,
41,
41,
41,
41,
2,
37,
41,
3,
49,
41,
41,
41,
1,
37,
1,
1,
41,
2,
85,
2,
36,
2,
42,
1,
63,
36,
1,
1,
1,
40,
1,
3,
41,
1,
1,
1,
41,
3,
41,
0,
63,
1,
63,
63,
2,
63,
1,
63,
63,
1,
40,
1,
1,
64,
1,
63,
1,
40,
1,
1,
36,
63,
23,
1,
39,
62,
1,
41,
1,
40,
40,
1,
62,
13,
1,
66,
1,
63,
1,
64,
64,
62,
1,
42,
36,
67,
1,
1,
37,
94,
36,
1,
37,
1,
36,
1,
37,
63,
36,
36,
42,
36,
63,
64,
63,
39,
1,
41,
62,
1,
64,
63,
62,
1,
42,
21,
67,
1,
21,
21,
1,
21,
21,
1,
21,
21,
63,
63,
42,
21,
63,
64,
63,
36,
1,
37,
63,
62,
63,
36,
42,
36,
63,
63,
63,
2,
37,
1,
1,
1,
41,
63,
63,
63,
41,
41,
63,
1,
64,
1,
42,
63,
1,
42,
63,
39,
1,
41,
63,
39,
1,
41,
63,
39,
1,
41,
63,
63,
39,
63,
63,
63,
63,
41,
41,
63,
1,
63,
63,
63,
63,
63,
63,
63,
36,
1,
37,
63,
36,
1,
37,
63,
1,
63,
1,
63,
42,
63,
42,
63,
128,
39,
1,
41,
63,
1,
63,
49,
40,
60,
40,
1,
40,
1,
40,
64,
64,
64,
63,
64,
63,
64,
63,
64,
64,
64,
64,
64,
64,
64,
40,
13,
64,
49,
40,
62,
3,
10,
62,
60,
40,
62,
3,
10,
62,
1,
40,
62,
3,
10,
62,
1,
40,
62,
3,
10,
62,
62,
62,
3,
10,
62,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
1409,
1265,
1133,
1134,
1273,
1417,
1418,
1419,
997,
952,
953,
954,
955,
956,
957,
1268,
1269,
1270,
1271,
1272,
998,
999,
1414,
959,
1216,
1079,
1080,
1007,
981,
958,
1002,
1003,
1004,
1005,
1001,
1000,
1008,
1009,
1010,
1011,
1012,
1013,
1014,
1015,
969,
971,
1058,
1059,
1060,
1061,
1062,
1063,
1064,
1065,
1066,
1067,
1068,
972,
968,
973,
974,
975,
976,
978,
979,
970,
962,
1247,
1245,
1246,
1289,
1290,
1081,
1082,
1083,
1084,
1077,
1266,
1435,
1078,
1434,
1439,
1440,
1432,
1263,
1411,
1437,
1438,
1415,
1416,
1436,
1412,
1408,
1407,
1410,
1451,
1450,
1274,
1276,
1277,
1278,
1279,
1280,
1281,
1282,
1283,
1286,
1293,
1294,
1287,
1433,
1304,
1305,
995,
994,
982,
1215,
1144,
1224,
1222,
1225,
1223,
1220,
1221,
1219,
1327,
1328,
1425,
1125,
1126,
1127,
1128,
1129,
1130,
1336,
1335,
1131,
1132,
1170,
1146,
1203,
1204,
1199,
1198,
1194,
1205,
1195,
1179,
1178,
1180,
1181,
1183,
1177,
1174,
1207,
1354,
1369,
1370,
1371,
1372,
1373,
1472,
1473,
1362,
1367,
1355,
1357,
1356,
1465,
1464,
1145,
1141,
1142,
960,
966,
963,
967,
964,
965,
1006,
986,
1053,
1016,
991,
1069,
1018,
1019,
1020,
1021,
1052,
1050,
1055,
1057,
1054,
1056,
985,
977,
980,
1070,
990,
989,
1261,
1252,
1073,
1085,
1074,
1087,
1088,
1089,
1090,
1122,
1121,
1119,
1124,
1242,
1447,
1430,
1428,
1429,
1241,
1445,
1448,
1446,
1244,
1258,
1243,
1256,
1238,
1413,
1399,
1401,
1396,
1403,
1398,
1400,
1402,
1405,
1406,
1452,
1249,
1320,
1240,
1257,
1284,
1285,
1303,
1253,
1299,
1302,
1260,
1295,
1300,
1297,
1255,
1254,
1267,
1259,
1292,
1298,
1296,
1291,
1319,
1239,
1326,
1325,
1317,
1316,
1323,
1322,
1251,
1250,
1264,
1248,
1262,
1312,
1314,
1311,
1313,
1330,
1076,
1453,
1332,
1075,
1086,
1310,
1307,
1308,
993,
992,
1017,
1140,
1137,
1138,
1139,
996,
1217,
1214,
1213,
1212,
1423,
1420,
1421,
1424,
1422,
1427,
1135,
1136,
1379,
1218,
1337,
1338,
1339,
1334,
1231,
1228,
1151,
1152,
1173,
1172,
1171,
1206,
1208,
1209,
1202,
1200,
1201,
1197,
1196,
1185,
1186,
1187,
1176,
1175,
1340,
1352,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1468,
1469,
1349,
1353,
1368,
1366,
1365,
1364,
1350,
1351,
1358,
1226,
1227,
1229,
1230,
1360,
1359,
1361,
1471,
1470,
1374,
1375,
1466,
1467,
1163,
1165,
1169,
1168,
1164,
1167,
1166,
1162,
1394,
1381,
1395,
1392,
1393,
1377,
1378,
1380,
1391,
1376,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginmpcPars		();

int mpcPars ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   
/* line 384 "mpcPars.lalr" */



#define  ErrorMessage	Make_ErrorMessage
#define  ErrorMessageI	Make_ErrorMessageI
#define  Message	Make_Message
#define  MessageI	Make_MessageI

#define EVAL_CONST_SUBEXPR(Tree,Value)  { if( EVAL_CONST ) Tree=Make_IntConst(Value); }

extern tPosition CurrentPosition;
static bool 	 Opened_PrototypeScope;
static bool 	 Is_PrototypeScope=false;
static bool	 Opened_ParameterScope=false;
static bool	 Inside_topo_param_list=false;
static int	 DynArray_Possible = 0;




      BeginmpcPars ();
      yyState		= yyStartState;
      yyTerminal	= mpcScan_GetToken ();
      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register short * yyTCombPtr;

	    yyTCombPtr = (short *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  mpcScan_tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadTermState) { /* read or read terminal reduce ? */
		     mpcScan_ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, mpcScan_Attribute.Position,
			xxString, mpcPars_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadTermState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, mpcScan_Attribute);
	       yyTerminal = mpcScan_GetToken ();
	       yyIsRepairing = false;
	       yyState = yyFinalToProd [yyState - yyFirstReadTermState];
	    }

	    for (;;) {
	       /* register long yyNonterminal;		/* left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 950: /* _0000_ : prog_start _EndOfFile .*/
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 951: /* prog_start : translation_unit .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 137; {
/* line 739 "mpcPars.lalr" */

			  ;
{ 
			    IgnoreAll = false;
			    TreeRoot->MPC_Root.Decls =
					ReverseTree(yyAttrStackPtr [1-1].translation_unit.Tree);
			  ; }
			;

} break;
case 952: /* constant : FLOATINGconstant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 748 "mpcPars.lalr" */

			    yySynAttribute.constant.Tree = mMPC_FloatConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, DoubleType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.FLOATINGconstant.SymForm, yyAttrStackPtr [1-1].Scan.FLOATINGconstant.FloatConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.FLOATINGconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_FloatConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.FLOATINGconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = false;

			  yySynAttribute.constant.Value = 0;

			;

} break;
case 953: /* constant : INTEGERconstant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 768 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.INTEGERconstant.SymForm, yyAttrStackPtr [1-1].Scan.INTEGERconstant.IntConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.INTEGERconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.INTEGERconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.INTEGERconstant.IntConst;

			;

} break;
case 954: /* constant : OCTALconstant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 789 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.OCTALconstant.SymForm, yyAttrStackPtr [1-1].Scan.OCTALconstant.OctConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.OCTALconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.OCTALconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.OCTALconstant.OctConst;

			;

} break;
case 955: /* constant : HEXconstant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 808 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.HEXconstant.SymForm, yyAttrStackPtr [1-1].Scan.HEXconstant.HexConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.HEXconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.HEXconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.HEXconstant.HexConst;

			;

} break;
case 956: /* constant : CHARACTERconstant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 827 "mpcPars.lalr" */
  
			    yySynAttribute.constant.Tree = mMPC_IntConst(
					yySynAttribute.constant.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.CHARACTERconstant.SymForm, yyAttrStackPtr [1-1].Scan.CHARACTERconstant.CharConst
				   );
			    (void)Clean_OutAttributes(yySynAttribute.constant.Tree);
			    yySynAttribute.constant.Tree->MPC_Expr.BegPos = yySynAttribute.constant.EndPos = yySynAttribute.constant.Position;  
			    yySynAttribute.constant.EndPos.Column += yyAttrStackPtr [1-1].Scan.CHARACTERconstant.Length - 1 ;  
			    yySynAttribute.constant.Tree->MPC_Expr.EndPos = yySynAttribute.constant.EndPos;  
			    yySynAttribute.constant.Ignore = yySynAttribute.constant.Tree->MPC_IntConst.Flag.Ignore = yyAttrStackPtr [1-1].Scan.CHARACTERconstant.Ignore;
			  ;

			  yySynAttribute.constant.IsIntConst = true;

			  yySynAttribute.constant.Value  =  yyAttrStackPtr [1-1].Scan.CHARACTERconstant.CharConst;

			;

} break;
case 957: /* string_literal_list : STRINGliteral .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 847 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.string_literal_list.Tree = mMPC_StringLiteral(
					yySynAttribute.string_literal_list.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree ,
					NoTree , NoTree ,
					yyAttrStackPtr [1-1].Scan.STRINGliteral.SymForm, yySynAttribute.string_literal_list.Length=yyAttrStackPtr [1-1].Scan.STRINGliteral.Length,
					tmp , tmp 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.string_literal_list.Tree);
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.BegPos = yySynAttribute.string_literal_list.EndPos = yySynAttribute.string_literal_list.Position;  
			    yySynAttribute.string_literal_list.EndPos.Column += yySynAttribute.string_literal_list.Length - 1 ;  
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.EndPos = yySynAttribute.string_literal_list.EndPos;  
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.Flag.Const = YES;
			  ;

			  yySynAttribute.string_literal_list.Ignore  =  yyAttrStackPtr [1-1].Scan.STRINGliteral.Ignore;

			  yySynAttribute.string_literal_list.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 958: /* string_literal_list : string_literal_list STRINGliteral .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 139; {
/* line 870 "mpcPars.lalr" */
  
			    yySynAttribute.string_literal_list.Tree = mMPC_StringLiteral(
					yySynAttribute.string_literal_list.EndPos = yySynAttribute.string_literal_list.Position = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree ,
					NoTree , NoTree ,
					yyAttrStackPtr [2-1].Scan.STRINGliteral.SymForm, yyAttrStackPtr [2-1].Scan.STRINGliteral.Length,
					yyAttrStackPtr [1-1].string_literal_list.Tree ,
					yyAttrStackPtr [1-1].string_literal_list.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.string_literal_list.Tree);
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.BegPos = yyAttrStackPtr [1-1].string_literal_list.BegPos;  
			    yySynAttribute.string_literal_list.EndPos.Column += yyAttrStackPtr [2-1].Scan.STRINGliteral.Length - 1 ;  
			    yySynAttribute.string_literal_list.Tree->MPC_Expr.EndPos = yySynAttribute.string_literal_list.EndPos;  
			    yySynAttribute.string_literal_list.Tree->MPC_StringLiteral.Flag.Const = YES;
			    yySynAttribute.string_literal_list.Length = yyAttrStackPtr [1-1].string_literal_list.Length+yyAttrStackPtr [2-1].Scan.STRINGliteral.Length;
			  ;

			    yySynAttribute.string_literal_list.Ignore = yyAttrStackPtr [1-1].string_literal_list.Ignore && yyAttrStackPtr [2-1].Scan.STRINGliteral.Ignore;
			  ;

			  yySynAttribute.string_literal_list.BegPos  =  yyAttrStackPtr [1-1].string_literal_list.BegPos;
  
			;

} break;
case 959: /* primary_expression : IDENTIFIER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 140; {
/* line 894 "mpcPars.lalr" */
  
			    yySynAttribute.primary_expression.Tree = mMPC_Ident(yySynAttribute.primary_expression.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, Find_Ident(yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, IDENT)
				   );
			    (void)Clean_OutAttributes(yySynAttribute.primary_expression.Tree);
			    yySynAttribute.primary_expression.Tree->MPC_Ident.BegPos = yySynAttribute.primary_expression.EndPos = yySynAttribute.primary_expression.Position;  
			    yySynAttribute.primary_expression.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.primary_expression.Tree->MPC_Ident.EndPos = yySynAttribute.primary_expression.EndPos ;  
			    yySynAttribute.primary_expression.Tree->MPC_Ident.Flag.Ignore = yySynAttribute.primary_expression.Ignore = yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.primary_expression.IsIntConst = false;

			  yySynAttribute.primary_expression.Value = 0;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.BegPos  =  yySynAttribute.primary_expression.Position;
  
			;

} break;
case 960: /* primary_expression : constant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 140; {
/* line 919 "mpcPars.lalr" */

			    yySynAttribute.primary_expression.Tree = yyAttrStackPtr [1-1].constant.Tree;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.EvalNet = CONST_NET_LIST;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.StoreNet = CONST_NET;
			  ;

			  yySynAttribute.primary_expression.IsIntConst  =  yyAttrStackPtr [1-1].constant.IsIntConst;

			  yySynAttribute.primary_expression.Value  =  yyAttrStackPtr [1-1].constant.Value;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [1-1].constant.Ignore;

			  yySynAttribute.primary_expression.Position  =  yyAttrStackPtr [1-1].constant.Position;

			  yySynAttribute.primary_expression.BegPos  =  yyAttrStackPtr [1-1].constant.Position;
  
			  yySynAttribute.primary_expression.EndPos  =  yyAttrStackPtr [1-1].constant.EndPos;
  
			;

} break;
case 961: /* primary_expression : string_literal_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 140; {
/* line 943 "mpcPars.lalr" */

			      yySynAttribute.primary_expression.Tree = ReverseTree(yyAttrStackPtr [1-1].string_literal_list.Tree);
			      NestedType_ON();
			      Push_Pattern(
				mMPC_ArrayType(
				  NoPosition, NoTree, NoTree,
				  Make_TypeFlag(YES,NO,NO,NO,NO,NO,NO,NO,NO,NO),
				  yyAttrStackPtr [1-1].string_literal_list.Length, 1, CharType
				)
			      );
			      TopType()->MPC_ArrayType.ArraySize =
				mMPC_IntConst(
					NoPosition, NoExprFlag, EmptyString, IntType,
					CONST_NET_LIST, CONST_NET, EmptyString,
					yyAttrStackPtr [1-1].string_literal_list.Length
				);
			      TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			      yySynAttribute.primary_expression.Tree->MPC_Expr.Type = Make_Type();
			      NestedType_OFF();
			      yySynAttribute.primary_expression.Tree->MPC_Expr.EvalNet = CONST_NET_LIST;
			      yySynAttribute.primary_expression.Tree->MPC_Expr.StoreNet = CONST_NET;
			    ;

			  yySynAttribute.primary_expression.IsIntConst = false;

			  yySynAttribute.primary_expression.Value = 0;

			  yySynAttribute.primary_expression.Sizeof = false;

			  yySynAttribute.primary_expression.Scope = false;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [1-1].string_literal_list.Ignore;

			  yySynAttribute.primary_expression.Position  =  yyAttrStackPtr [1-1].string_literal_list.Position;

			  yySynAttribute.primary_expression.BegPos  =  yyAttrStackPtr [1-1].string_literal_list.BegPos;
  
			  yySynAttribute.primary_expression.EndPos  =  yyAttrStackPtr [1-1].string_literal_list.EndPos;
  
			;

} break;
case 962: /* primary_expression : '(' expression ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 140; {
/* line 984 "mpcPars.lalr" */
yySynAttribute.primary_expression.EndPos = yyAttrStackPtr [2-1].expression.EndPos;

			  yySynAttribute.primary_expression.Scope  =  yyAttrStackPtr [2-1].expression.Scope;
  
			    if(yyAttrStackPtr [2-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.primary_expression.Tree = yyAttrStackPtr [2-1].expression.Tree;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.Flag.InParentheses = YES;
			    yySynAttribute.primary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.primary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.primary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.primary_expression.Position = CurrentPosition = yySynAttribute.primary_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			  yySynAttribute.primary_expression.IsIntConst  =  yyAttrStackPtr [2-1].expression.IsIntConst;

			  yySynAttribute.primary_expression.Value  =  yyAttrStackPtr [2-1].expression.Value;

			  yySynAttribute.primary_expression.Sizeof  =  yyAttrStackPtr [2-1].expression.Sizeof;

			  yySynAttribute.primary_expression.Ignore  =  yyAttrStackPtr [2-1].expression.Ignore;

			;

} break;
case 963: /* net_cast_expression : primary_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 142; {
/* line 1006 "mpcPars.lalr" */

			  yySynAttribute.net_cast_expression.Tree  =  yyAttrStackPtr [1-1].primary_expression.Tree;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [1-1].primary_expression.Value;

			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [1-1].primary_expression.Sizeof;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [1-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.Ignore  =  yyAttrStackPtr [1-1].primary_expression.Ignore;

			  yySynAttribute.net_cast_expression.Position  =  yyAttrStackPtr [1-1].primary_expression.Position;

			  yySynAttribute.net_cast_expression.BegPos  =  yyAttrStackPtr [1-1].primary_expression.BegPos;
  
			  yySynAttribute.net_cast_expression.EndPos  =  yyAttrStackPtr [1-1].primary_expression.EndPos;
  
			;

} break;
case 964: /* net_cast_expression : subnet_specifier primary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 142; {
/* line 1027 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [2-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [1-1].subnet_specifier.Position, 
					NoExprFlag, EmptyString, NoTree, NoTree,
					yyAttrStackPtr [1-1].subnet_specifier.Tree,
					false, yyAttrStackPtr [2-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore ||
								   yyAttrStackPtr [2-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [2-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [2-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [2-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [2-1].primary_expression.Value;

			;

} break;
case 965: /* net_cast_expression : net_name_specifier primary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 142; {
/* line 1059 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_name_specifier.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [2-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [1-1].net_name_specifier.Position, 
					NoExprFlag, EmptyString, NoTree,NoTree,
					yyAttrStackPtr [1-1].net_name_specifier.Tree,
					false, yyAttrStackPtr [2-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [1-1].net_name_specifier.Ignore ||
								   yyAttrStackPtr [2-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].net_name_specifier.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [2-1].primary_expression.EndPos;  
			    if(!yyAttrStackPtr [1-1].net_name_specifier.Simple) {
			      Make_Message(
				100, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position, yySynAttribute.net_cast_expression.Tree
			      );
		
			      yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = YES;
			    }
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [2-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [2-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [2-1].primary_expression.Value;

			;

} break;
case 966: /* net_cast_expression : '[' host ']' primary_expression .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 142; {
/* line 1098 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [1-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.net_cast_expression.Sizeof  =  yyAttrStackPtr [4-1].primary_expression.Sizeof;
  
			    yySynAttribute.net_cast_expression.Tree = mMPC_NetCastExpr(yySynAttribute.net_cast_expression.Position=yyAttrStackPtr [3-1].Scan.Position, 
					NoExprFlag, EmptyString, NoTree,
					NoTree, HOST,
					false, yyAttrStackPtr [4-1].primary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.net_cast_expression.Tree);
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.net_cast_expression.Ignore = yyAttrStackPtr [4-1].primary_expression.Ignore;
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.net_cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.net_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.net_cast_expression.EndPos = yyAttrStackPtr [4-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.net_cast_expression.Scope  =  yyAttrStackPtr [4-1].primary_expression.Scope;

			  yySynAttribute.net_cast_expression.IsIntConst  =  yyAttrStackPtr [4-1].primary_expression.IsIntConst;

			  yySynAttribute.net_cast_expression.Value  =  yyAttrStackPtr [4-1].primary_expression.Value;

			;

} break;
case 967: /* postfix_expression : net_cast_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 145; {
/* line 1128 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Tree  =  yyAttrStackPtr [1-1].net_cast_expression.Tree;

			  yySynAttribute.postfix_expression.IsIntConst  =  yyAttrStackPtr [1-1].net_cast_expression.IsIntConst;

			  yySynAttribute.postfix_expression.Value  =  yyAttrStackPtr [1-1].net_cast_expression.Value;

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].net_cast_expression.Sizeof;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].net_cast_expression.Scope;

			  yySynAttribute.postfix_expression.Ignore  =  yyAttrStackPtr [1-1].net_cast_expression.Ignore;

			  yySynAttribute.postfix_expression.Position  =  yyAttrStackPtr [1-1].net_cast_expression.Position;

			  yySynAttribute.postfix_expression.BegPos  =  yyAttrStackPtr [1-1].net_cast_expression.BegPos;
  
			  yySynAttribute.postfix_expression.EndPos  =  yyAttrStackPtr [1-1].net_cast_expression.EndPos;
  
			;

} break;
case 968: /* postfix_expression : postfix_expression '[]' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 145; {
/* line 1149 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					BRACKETS, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column++;  yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos.Column++;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 969: /* postfix_expression : postfix_expression '[' expression ']' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 145; {
/* line 1172 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    if(yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [4-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					INDEX, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 970: /* postfix_expression : postfix_expression '[' expression_opt ':' expression_opt grid_step ']' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 145; {
/* line 1198 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof = false;
  
			    yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
					yyAttrStackPtr [3-1].expression_opt.Ignore || yyAttrStackPtr [5-1].expression_opt.Ignore ||
						   yyAttrStackPtr [6-1].grid_step.Ignore;
			    if(yyAttrStackPtr [3-1].expression_opt.Tree!=NoTree && yyAttrStackPtr [3-1].expression_opt.IsIntConst && yyAttrStackPtr [3-1].expression_opt.Value<0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(280, xxError, yyAttrStackPtr [3-1].expression_opt.Position,
					   yyAttrStackPtr [3-1].expression_opt.Tree);
		
			    }
			    if(yyAttrStackPtr [5-1].expression_opt.Tree!=NoTree && yyAttrStackPtr [5-1].expression_opt.IsIntConst && yyAttrStackPtr [5-1].expression_opt.Value<=0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(281, xxError, yyAttrStackPtr [5-1].expression_opt.Position,
					   yyAttrStackPtr [5-1].expression_opt.Tree);
		
			    }
			    if(yyAttrStackPtr [6-1].grid_step.Tree!=NoTree && yyAttrStackPtr [6-1].grid_step.IsIntConst && yyAttrStackPtr [6-1].grid_step.Value<=0) {
			      yySynAttribute.postfix_expression.Ignore = true;
			      yySynAttribute.postfix_expression.Value = UNDEFINED;
			      Make_Message(282, xxError, yyAttrStackPtr [6-1].grid_step.Position,
					   yyAttrStackPtr [6-1].grid_step.Tree);
		
			    }
			    if(yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [6-1].grid_step.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_QuaternaryExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					GRID, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression_opt.Tree, yyAttrStackPtr [5-1].expression_opt.Tree,
					yyAttrStackPtr [6-1].grid_step.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand2 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand2 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand3 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand3 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    if(yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand4 == NoTree)
				yySynAttribute.postfix_expression.Tree->MPC_QuaternaryExpr.Operand4 = mMPC_FreeNode(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value=0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope ||
					       yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [6-1].grid_step.Scope;

			;

} break;
case 971: /* postfix_expression : postfix_expression '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 145; {
/* line 1255 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_CallExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [3-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].postfix_expression.Tree,
					NoTree, NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 972: /* postfix_expression : postfix_expression '(' argument_expression_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 145; {
/* line 1278 "mpcPars.lalr" */
yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [1-1].postfix_expression.EndPos;

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_CallExpr(yySynAttribute.postfix_expression.Position=CurrentPosition=yyAttrStackPtr [4-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					yyAttrStackPtr [1-1].postfix_expression.Tree,
					ReverseTree(yyAttrStackPtr [3-1].argument_expression_list.Tree),
					NoTree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree ->
			      MPC_CallExpr.ArgList ->
				MPC_Exprs.Prev -> MPC_FreeNode.Parent = yySynAttribute.postfix_expression.Tree;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								yyAttrStackPtr [3-1].argument_expression_list.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 973: /* postfix_expression : postfix_expression '.' IDENTIFIER .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 145; {
/* line 1307 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DOT, yyAttrStackPtr [1-1].postfix_expression.Tree,
					mMPC_Ident(yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString,
						NoTree, NoTree, NoTree, yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident,
						NoTree
					)
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.BegPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.Flag.Ignore =
									yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 974: /* postfix_expression : postfix_expression '->' IDENTIFIER .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 145; {
/* line 1338 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					ARROW, yyAttrStackPtr [1-1].postfix_expression.Tree,
					mMPC_Ident(yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString,
						NoTree, NoTree, NoTree, yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident,
						NoTree
					)
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.BegPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.postfix_expression.Tree->MPC_BinaryExpr.Roperand->MPC_Ident.Flag.Ignore =
									yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 975: /* postfix_expression : postfix_expression '++' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 145; {
/* line 1369 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					POST_INC, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;   
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 976: /* postfix_expression : postfix_expression '--' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 145; {
/* line 1391 "mpcPars.lalr" */

			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					POST_DEC, yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;   
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 977: /* postfix_expression : postfix_expression postfix_linear_operator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 145; {
/* line 1413 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].postfix_linear_operator.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].postfix_linear_operator.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;
  
			    yySynAttribute.postfix_expression.Tree = mMPC_UnaryExpr(yySynAttribute.postfix_expression.Position=yyAttrStackPtr [2-1].postfix_linear_operator.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, yyAttrStackPtr [2-1].postfix_linear_operator.OpCode,
					yyAttrStackPtr [1-1].postfix_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [2-1].postfix_linear_operator.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			;

} break;
case 978: /* postfix_expression : postfix_expression '[<' expression '>]' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 145; {
/* line 1444 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof = yyAttrStackPtr [1-1].postfix_expression.Sizeof || yyAttrStackPtr [3-1].expression.Sizeof;
  
			    if(yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					DISTR_COMM_CALL, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 979: /* postfix_expression : postfix_expression '[>' expression '<]' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 145; {
/* line 1478 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.postfix_expression.Sizeof = yyAttrStackPtr [1-1].postfix_expression.Sizeof || yyAttrStackPtr [3-1].expression.Sizeof;
  
			    if(yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope)
			      Restore_ExprScope();
			    yySynAttribute.postfix_expression.Tree = mMPC_BinaryExpr(yySynAttribute.postfix_expression.Position = CurrentPosition = yySynAttribute.postfix_expression.EndPos = yyAttrStackPtr [4-1].Scan.Position,  
					NoExprFlag, EmptyString, NoTree,
					NoTree, NoTree,
					DISTR_ASS_CALL, yyAttrStackPtr [1-1].postfix_expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.postfix_expression.Tree);
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.postfix_expression.Ignore = yyAttrStackPtr [1-1].postfix_expression.Ignore ||
								   yyAttrStackPtr [3-1].expression.Ignore;
			    yySynAttribute.postfix_expression.Tree->MPC_Expr.BegPos = yySynAttribute.postfix_expression.BegPos = yyAttrStackPtr [1-1].postfix_expression.BegPos;  
			    yySynAttribute.postfix_expression.EndPos.Column++; yySynAttribute.postfix_expression.Tree->MPC_Expr.EndPos = yySynAttribute.postfix_expression.EndPos;  
			  ;

			  yySynAttribute.postfix_expression.IsIntConst = false;

			  yySynAttribute.postfix_expression.Value = 0;

			  yySynAttribute.postfix_expression.Scope = yyAttrStackPtr [1-1].postfix_expression.Scope || yyAttrStackPtr [3-1].expression.Scope;

			;

} break;
case 980: /* postfix_linear_operator : linear_operator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 149; {
/* line 1512 "mpcPars.lalr" */

			    yySynAttribute.postfix_linear_operator.OpCode = yyAttrStackPtr [1-1].linear_operator.OpCode + POSTFIX;
			  ;
yySynAttribute.postfix_linear_operator.Position = CurrentPosition = yySynAttribute.postfix_linear_operator.EndPos = yyAttrStackPtr [1-1].linear_operator.Position;  
			     yySynAttribute.postfix_linear_operator.EndPos.Column += yyAttrStackPtr [1-1].linear_operator.Length; ;
  
			;

} break;
case 981: /* special_arguments : '(' '[' host ']' ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 151; {
/* line 1520 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }
			  yySynAttribute.special_arguments.NetArgument = HOST;

			  yySynAttribute.special_arguments.NetworkArgList = NoTree;

			  yySynAttribute.special_arguments.Ignore = false;

			  yySynAttribute.special_arguments.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 982: /* special_arguments : '(' '[' '(' argument_expression_list_opt ')' NETorSUBNETname ']' ')' .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 151; {
/* line 1539 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
		
#endif
			  ; }  
			    CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;
			    yySynAttribute.special_arguments.Ignore = yyAttrStackPtr [4-1].argument_expression_list_opt.Ignore ||
				     yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ignore;

			    yySynAttribute.special_arguments.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.special_arguments.NetworkArgList = yyAttrStackPtr [4-1].argument_expression_list_opt.Tree;
			    yySynAttribute.special_arguments.NetArgument = Find_Ident(yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ident,IDENT);
			    if(!yySynAttribute.special_arguments.NetArgument) {
			      yySynAttribute.special_arguments.Ignore = true;
			      Make_MessageI(283, xxError,
				yyAttrStackPtr [6-1].Scan.Position, xxIdent,
				(char*)&yyAttrStackPtr [6-1].Scan.NETorSUBNETname.Ident, NoTree);
		
			    }
			  ;

			;

} break;
case 983: /* argument_expression_list_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 152; {
/* line 1566 "mpcPars.lalr" */

			  yySynAttribute.argument_expression_list_opt.Tree = NoTree;

			  yySynAttribute.argument_expression_list_opt.Ignore = false;

			;

} break;
case 984: /* argument_expression_list_opt : argument_expression_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 152; {
/* line 1573 "mpcPars.lalr" */

			    yySynAttribute.argument_expression_list_opt.Tree = ReverseTree(yyAttrStackPtr [1-1].argument_expression_list.Tree);
			  ;

			  yySynAttribute.argument_expression_list_opt.Ignore  =  yyAttrStackPtr [1-1].argument_expression_list.Ignore;

			;

} break;
case 985: /* argument_expression_list : assignment_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 148; {
/* line 1581 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.argument_expression_list.Tree = mMPC_Exprs(yySynAttribute.argument_expression_list.Position=yyAttrStackPtr [1-1].assignment_expression.Position,
					tmp, tmp, yyAttrStackPtr [1-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.argument_expression_list.Tree);
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.BegPos = yySynAttribute.argument_expression_list.BegPos = yyAttrStackPtr [1-1].assignment_expression.BegPos;
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [1-1].assignment_expression.EndPos;  
			  ;

			  yySynAttribute.argument_expression_list.Ignore  =  yyAttrStackPtr [1-1].assignment_expression.Ignore;

			;

} break;
case 986: /* argument_expression_list : argument_expression_list ',' assignment_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 148; {
/* line 1596 "mpcPars.lalr" */
  
			    yySynAttribute.argument_expression_list.Tree = mMPC_Exprs(yySynAttribute.argument_expression_list.Position=yyAttrStackPtr [3-1].assignment_expression.Position,
					yyAttrStackPtr [1-1].argument_expression_list.Tree,
					yyAttrStackPtr [1-1].argument_expression_list.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.argument_expression_list.Tree);
			    yySynAttribute.argument_expression_list.Ignore = yyAttrStackPtr [1-1].argument_expression_list.Ignore ||
						yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.BegPos = yySynAttribute.argument_expression_list.BegPos = yyAttrStackPtr [1-1].argument_expression_list.BegPos; 
			    yySynAttribute.argument_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos; 
			  ;

			;

} break;
case 987: /* unary_expression : postfix_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 154; {
/* line 1611 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [1-1].postfix_expression.Sizeof;

			  yySynAttribute.unary_expression.Tree  =  yyAttrStackPtr [1-1].postfix_expression.Tree;

			  yySynAttribute.unary_expression.IsIntConst  =  yyAttrStackPtr [1-1].postfix_expression.IsIntConst;

			  yySynAttribute.unary_expression.Value  =  yyAttrStackPtr [1-1].postfix_expression.Value;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [1-1].postfix_expression.Scope;

			  yySynAttribute.unary_expression.Ignore  =  yyAttrStackPtr [1-1].postfix_expression.Ignore;

			  yySynAttribute.unary_expression.Position  =  yyAttrStackPtr [1-1].postfix_expression.Position;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].postfix_expression.BegPos;
  
			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [1-1].postfix_expression.EndPos;
  
			;

} break;
case 988: /* unary_expression : special_arguments postfix_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1632 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].postfix_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [1-1].special_arguments.Ignore || yyAttrStackPtr [2-1].postfix_expression.Ignore;
			    yySynAttribute.unary_expression.Tree = yyAttrStackPtr [2-1].postfix_expression.Tree;
			    if(Tree_IsType(yySynAttribute.unary_expression.Tree, kMPC_CallExpr)) {
			      yySynAttribute.unary_expression.Tree->MPC_CallExpr.StoreNet = yyAttrStackPtr [1-1].special_arguments.NetArgument;
			      yySynAttribute.unary_expression.Tree->MPC_CallExpr.NetworkArgList =
							yyAttrStackPtr [1-1].special_arguments.NetworkArgList;
			    }
			    else {
			      yySynAttribute.unary_expression.Ignore = true;
			      Make_Message( 284, xxError,
					 yyAttrStackPtr [2-1].postfix_expression.Position, yySynAttribute.unary_expression.Tree);
		
			    }
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].special_arguments.BegPos;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].postfix_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].postfix_expression.Scope;

			  yySynAttribute.unary_expression.Position  =  yyAttrStackPtr [2-1].postfix_expression.Position;

			;

} break;
case 989: /* unary_expression : '++' unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1663 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].unary_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PRE_INC, yyAttrStackPtr [2-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;   
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.Position;   
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 990: /* unary_expression : '--' unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1684 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].unary_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PRE_DEC, yyAttrStackPtr [2-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;   
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.Position;   
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 991: /* unary_expression : unary_operator cast_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1705 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof  =  yyAttrStackPtr [2-1].cast_expression.Sizeof;
  
			    yySynAttribute.unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].unary_operator.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].unary_operator.OpCode, yyAttrStackPtr [2-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].cast_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].unary_operator.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].cast_expression.EndPos;  
			    if(yySynAttribute.unary_expression.IsIntConst=yyAttrStackPtr [2-1].cast_expression.IsIntConst) {
			      yySynAttribute.unary_expression.Value = Eval_UnaryExpr(yyAttrStackPtr [1-1].unary_operator.OpCode,
						     yyAttrStackPtr [2-1].cast_expression.Value,
						     yyAttrStackPtr [1-1].unary_operator.Position
				      );
			      if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			    }
			  ;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].cast_expression.Scope;

			;

} break;
case 992: /* unary_expression : sizeof unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1729 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = true;
  
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = true;

			  yySynAttribute.unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 993: /* unary_expression : mpc_sizeof unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 154; {
/* line 1751 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;
  
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			    yySynAttribute.unary_expression.IsIntConst = true;
			    yySynAttribute.unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			  ;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [2-1].unary_expression.Scope;

			;

} break;
case 994: /* unary_expression : sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 154; {
/* line 1772 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = true;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Type(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = true;

			  yySynAttribute.unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);

			  yySynAttribute.unary_expression.Scope = true;

			;

} break;
case 995: /* unary_expression : mpc_sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 154; {
/* line 1796 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			    yySynAttribute.unary_expression.IsIntConst = true;
			    yySynAttribute.unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.unary_expression.Tree,yySynAttribute.unary_expression.Value);
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			;

} break;
case 996: /* unary_expression : IDENTIFIER coordof unary_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 154; {
/* line 1818 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].Scan.Position, NoTree);
		
#endif
			  ; }
			  yySynAttribute.unary_expression.Sizeof = false;
  
			    yySynAttribute.unary_expression.Tree = mMPC_CoordExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident,
					yyAttrStackPtr [3-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [3-1].unary_expression.Ignore ||
								   yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [3-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope  =  yyAttrStackPtr [3-1].unary_expression.Scope;

			;

} break;
case 997: /* unary_expression : IDENTIFIER coordof NETorSUBNETname .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 154; {
/* line 1850 "mpcPars.lalr" */
  
			    tTree Network, Dummy, NetList;
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [2-1].Scan.Position, NoTree);
		
#endif
			    Network = Find_Ident(yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident,IDENT);
			    if(!Network) {
			      yySynAttribute.unary_expression.Ignore = true;
			      Make_MessageI(283, xxError,
				yyAttrStackPtr [3-1].Scan.Position, xxIdent,
				(char*)&yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident, NoTree);
		
			    }
			    NetList = Clean_OutAttributes(mMPC_NetList(NoTree, NoTree, Network));
			    DummyVar = mMPC_Var(
					  yyAttrStackPtr [3-1].Scan.Position, DummyIdent, NoDeclFlag, NoTree, NoTree,
					  VoidType, Network, NoTree
				       );
				        
			    Dummy = mMPC_Ident(
					yyAttrStackPtr [3-1].Scan.Position, NoExprFlag, EmptyString, VoidType,
					NetList, Network, DummyIdent, DummyVar
				    );
			    yySynAttribute.unary_expression.Tree = mMPC_CoordExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, Dummy
				   );
			    (void)Clean_OutAttributes(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.unary_expression.Ignore = yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ignore ||
								   yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			    yySynAttribute.unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.unary_expression.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.unary_expression.EndPos.Column += yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Length - 1 ;  
			    yySynAttribute.unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.unary_expression.EndPos ;  
			  ;

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;

			  yySynAttribute.unary_expression.Scope = false;

			;

} break;
case 998: /* unary_expression : timeof new_scope '(' empty_net_declaring_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 154; {
/* line 1899 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].empty_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Ignore = yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].empty_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;
 
			;

} break;
case 999: /* unary_expression : timeof new_scope '(' single_net_declaring_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 154; {
/* line 1924 "mpcPars.lalr" */

			  yySynAttribute.unary_expression.Sizeof = false;

			  yySynAttribute.unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].single_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.unary_expression.Tree);
			    yySynAttribute.unary_expression.Ignore = yySynAttribute.unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].single_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.unary_expression.Scope = true;

			  yySynAttribute.unary_expression.IsIntConst = false;

			  yySynAttribute.unary_expression.Value = 0;
 
			;

} break;
case 1000: /* unary_operator : '&' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1949 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=ADDRESS;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1001: /* unary_operator : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1953 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=STAR;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1002: /* unary_operator : '+' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1957 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=PLUS;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1003: /* unary_operator : '-' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1961 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=NEG;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1004: /* unary_operator : '~' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1965 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=NOT;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1005: /* unary_operator : '!' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1969 "mpcPars.lalr" */
 yySynAttribute.unary_operator.OpCode=LOG_NOT;
yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1006: /* unary_operator : linear_operator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 1973 "mpcPars.lalr" */

			  yySynAttribute.unary_operator.OpCode  =  yyAttrStackPtr [1-1].linear_operator.OpCode;
 yySynAttribute.unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].linear_operator.Position; ;

			;

} break;
case 1007: /* linear_operator : '[*]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1979 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MULT;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1008: /* linear_operator : '[?<]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1983 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MIN;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1009: /* linear_operator : '[?>]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1987 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_MAX;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1010: /* linear_operator : '[+]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1991 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_PLUS;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1011: /* linear_operator : '[&]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1995 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_AND;
	  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1012: /* linear_operator : '[^]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 1999 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_EXCL_OR;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1013: /* linear_operator : '[|]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 2003 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_INCL_OR;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  yySynAttribute.linear_operator.Length = 3 ;

} break;
case 1014: /* linear_operator : '[&&]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 2007 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_LOG_AND;
 yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1015: /* linear_operator : '[||]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 150; {
/* line 2011 "mpcPars.lalr" */
 yySynAttribute.linear_operator.OpCode = LIN_LOG_OR;
  yySynAttribute.linear_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 yySynAttribute.linear_operator.Length = 4 ;

} break;
case 1016: /* cast_expression : unary_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 156; {
/* line 2015 "mpcPars.lalr" */

			  yySynAttribute.cast_expression.Tree  =  yyAttrStackPtr [1-1].unary_expression.Tree;

			  yySynAttribute.cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].unary_expression.IsIntConst;

			  yySynAttribute.cast_expression.Value  =  yyAttrStackPtr [1-1].unary_expression.Value;

			  yySynAttribute.cast_expression.Sizeof  =  yyAttrStackPtr [1-1].unary_expression.Sizeof;

			  yySynAttribute.cast_expression.Ignore  =  yyAttrStackPtr [1-1].unary_expression.Ignore;

			  yySynAttribute.cast_expression.Position  =  yyAttrStackPtr [1-1].unary_expression.Position;

			  yySynAttribute.cast_expression.BegPos  =  yyAttrStackPtr [1-1].unary_expression.BegPos;
  
			  yySynAttribute.cast_expression.EndPos  =  yyAttrStackPtr [1-1].unary_expression.EndPos;
  
			  yySynAttribute.cast_expression.Scope  =  yyAttrStackPtr [1-1].unary_expression.Scope;

			;

} break;
case 1017: /* cast_expression : '(' nested_type_on enable_dyn_array type_name nested_type_off disable_dyn_array ')' cast_expression .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 156; {
/* line 2036 "mpcPars.lalr" */

			  yySynAttribute.cast_expression.Sizeof  =  yyAttrStackPtr [8-1].cast_expression.Sizeof;
  
			    yySynAttribute.cast_expression.Tree = mMPC_CastExpr(yySynAttribute.cast_expression.Position=yyAttrStackPtr [7-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [8-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.cast_expression.Tree);
			    yySynAttribute.cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.cast_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore ||
								   yyAttrStackPtr [8-1].cast_expression.Ignore;
			    yySynAttribute.cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.cast_expression.EndPos = yyAttrStackPtr [8-1].cast_expression.EndPos;  
			  ;

			  yySynAttribute.cast_expression.IsIntConst = yyAttrStackPtr [8-1].cast_expression.IsIntConst && yyAttrStackPtr [4-1].type_name.Type!=NoTree &&
					yyAttrStackPtr [4-1].type_name.Type->Kind==kMPC_BasicType &&
					yyAttrStackPtr [4-1].type_name.Type->MPC_BasicType.TypeConstructor<VOID &&
					yyAttrStackPtr [4-1].type_name.Type->MPC_BasicType.TypeConstructor>FLOAT;

			  yySynAttribute.cast_expression.Value  =  yyAttrStackPtr [8-1].cast_expression.Value;

			  yySynAttribute.cast_expression.Scope = true;

			;

} break;
case 1018: /* multiplicative_expression : cast_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 2061 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Tree  =  yyAttrStackPtr [1-1].cast_expression.Tree;

			  yySynAttribute.multiplicative_expression.IsIntConst  =  yyAttrStackPtr [1-1].cast_expression.IsIntConst;

			  yySynAttribute.multiplicative_expression.Value  =  yyAttrStackPtr [1-1].cast_expression.Value;

			  yySynAttribute.multiplicative_expression.Sizeof  =  yyAttrStackPtr [1-1].cast_expression.Sizeof;

			  yySynAttribute.multiplicative_expression.Scope  =  yyAttrStackPtr [1-1].cast_expression.Scope;

			  yySynAttribute.multiplicative_expression.Ignore  =  yyAttrStackPtr [1-1].cast_expression.Ignore;

			  yySynAttribute.multiplicative_expression.Position  =  yyAttrStackPtr [1-1].cast_expression.Position;

			  yySynAttribute.multiplicative_expression.BegPos  =  yyAttrStackPtr [1-1].cast_expression.BegPos;
  
			  yySynAttribute.multiplicative_expression.EndPos  =  yyAttrStackPtr [1-1].cast_expression.EndPos;
  
			;

} break;
case 1019: /* multiplicative_expression : multiplicative_expression '*' cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 165; {
/* line 2082 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MULT, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(MULT,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1020: /* multiplicative_expression : multiplicative_expression '/' cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 165; {
/* line 2116 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DIV, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(DIV,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1021: /* multiplicative_expression : multiplicative_expression '%' cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 165; {
/* line 2150 "mpcPars.lalr" */

			  yySynAttribute.multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].multiplicative_expression.Sizeof || yyAttrStackPtr [3-1].cast_expression.Sizeof;
  
			    yySynAttribute.multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MOD, yyAttrStackPtr [1-1].multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.multiplicative_expression.Tree);
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.multiplicative_expression.Ignore =
							  yyAttrStackPtr [1-1].multiplicative_expression.Ignore ||
							  yyAttrStackPtr [3-1].cast_expression.Ignore;
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.multiplicative_expression.BegPos = yyAttrStackPtr [1-1].multiplicative_expression.BegPos;  
			    yySynAttribute.multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.multiplicative_expression.EndPos = yyAttrStackPtr [3-1].cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst &&
			      yyAttrStackPtr [3-1].cast_expression.IsIntConst) {
			      yySynAttribute.multiplicative_expression.IsIntConst = true;
			      yySynAttribute.multiplicative_expression.Value = Eval_BinaryExpr(MOD,
					yyAttrStackPtr [1-1].multiplicative_expression.Value,
					yyAttrStackPtr [3-1].cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.multiplicative_expression.Tree,yySynAttribute.multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.multiplicative_expression.IsIntConst = false;
			      yySynAttribute.multiplicative_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.multiplicative_expression.Scope = yyAttrStackPtr [1-1].multiplicative_expression.Scope || yyAttrStackPtr [3-1].cast_expression.Scope;

			;

} break;
case 1022: /* max_or_min_expression : multiplicative_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 166; {
/* line 2184 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Tree  =  yyAttrStackPtr [1-1].multiplicative_expression.Tree;

			  yySynAttribute.max_or_min_expression.IsIntConst  =  yyAttrStackPtr [1-1].multiplicative_expression.IsIntConst;

			  yySynAttribute.max_or_min_expression.Value  =  yyAttrStackPtr [1-1].multiplicative_expression.Value;

			  yySynAttribute.max_or_min_expression.Sizeof  =  yyAttrStackPtr [1-1].multiplicative_expression.Sizeof;

			  yySynAttribute.max_or_min_expression.Scope  =  yyAttrStackPtr [1-1].multiplicative_expression.Scope;

			  yySynAttribute.max_or_min_expression.Ignore  =  yyAttrStackPtr [1-1].multiplicative_expression.Ignore;

			  yySynAttribute.max_or_min_expression.Position  =  yyAttrStackPtr [1-1].multiplicative_expression.Position;

			  yySynAttribute.max_or_min_expression.BegPos  =  yyAttrStackPtr [1-1].multiplicative_expression.BegPos;
  
			  yySynAttribute.max_or_min_expression.EndPos  =  yyAttrStackPtr [1-1].multiplicative_expression.EndPos;
  
			;

} break;
case 1023: /* max_or_min_expression : max_or_min_expression '?<' multiplicative_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 166; {
/* line 2205 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].max_or_min_expression.Sizeof || yyAttrStackPtr [3-1].multiplicative_expression.Sizeof;
  
			    yySynAttribute.max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MIN, yyAttrStackPtr [1-1].max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.max_or_min_expression.Tree);
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].multiplicative_expression.Ignore;
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.max_or_min_expression.BegPos = yyAttrStackPtr [1-1].max_or_min_expression.BegPos;  
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.max_or_min_expression.EndPos = yyAttrStackPtr [3-1].multiplicative_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].multiplicative_expression.IsIntConst) {
			      yySynAttribute.max_or_min_expression.IsIntConst = true;
			      yySynAttribute.max_or_min_expression.Value = Eval_BinaryExpr(MIN,
					yyAttrStackPtr [1-1].max_or_min_expression.Value,
					yyAttrStackPtr [3-1].multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.max_or_min_expression.Tree,yySynAttribute.max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.max_or_min_expression.IsIntConst = false;
			      yySynAttribute.max_or_min_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.max_or_min_expression.Scope = yyAttrStackPtr [1-1].max_or_min_expression.Scope || yyAttrStackPtr [3-1].multiplicative_expression.Scope;

			;

} break;
case 1024: /* max_or_min_expression : max_or_min_expression '?>' multiplicative_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 166; {
/* line 2239 "mpcPars.lalr" */

			  yySynAttribute.max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].max_or_min_expression.Sizeof || yyAttrStackPtr [3-1].multiplicative_expression.Sizeof;
  
			    yySynAttribute.max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MAX, yyAttrStackPtr [1-1].max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.max_or_min_expression.Tree);
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].multiplicative_expression.Ignore;
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.max_or_min_expression.BegPos = yyAttrStackPtr [1-1].max_or_min_expression.BegPos;  
			    yySynAttribute.max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.max_or_min_expression.EndPos = yyAttrStackPtr [3-1].multiplicative_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].multiplicative_expression.IsIntConst) {
			      yySynAttribute.max_or_min_expression.IsIntConst = true;
			      yySynAttribute.max_or_min_expression.Value = Eval_BinaryExpr(MAX,
					yyAttrStackPtr [1-1].max_or_min_expression.Value,
					yyAttrStackPtr [3-1].multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.max_or_min_expression.Tree,yySynAttribute.max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.max_or_min_expression.IsIntConst = false;
			      yySynAttribute.max_or_min_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.max_or_min_expression.Scope = yyAttrStackPtr [1-1].max_or_min_expression.Scope || yyAttrStackPtr [3-1].multiplicative_expression.Scope;

			;

} break;
case 1025: /* additive_expression : max_or_min_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 167; {
/* line 2273 "mpcPars.lalr" */

			  yySynAttribute.additive_expression.Tree  =  yyAttrStackPtr [1-1].max_or_min_expression.Tree;

			  yySynAttribute.additive_expression.IsIntConst  =  yyAttrStackPtr [1-1].max_or_min_expression.IsIntConst;

			  yySynAttribute.additive_expression.Value  =  yyAttrStackPtr [1-1].max_or_min_expression.Value;

			  yySynAttribute.additive_expression.Sizeof  =  yyAttrStackPtr [1-1].max_or_min_expression.Sizeof;

			  yySynAttribute.additive_expression.Scope  =  yyAttrStackPtr [1-1].max_or_min_expression.Scope;

			  yySynAttribute.additive_expression.Ignore  =  yyAttrStackPtr [1-1].max_or_min_expression.Ignore;

			  yySynAttribute.additive_expression.Position  =  yyAttrStackPtr [1-1].max_or_min_expression.Position;

			  yySynAttribute.additive_expression.BegPos  =  yyAttrStackPtr [1-1].max_or_min_expression.BegPos;
  
			  yySynAttribute.additive_expression.EndPos  =  yyAttrStackPtr [1-1].max_or_min_expression.EndPos;
  
			;

} break;
case 1026: /* additive_expression : additive_expression '+' max_or_min_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 167; {
/* line 2294 "mpcPars.lalr" */
yySynAttribute.additive_expression.Value = yyAttrStackPtr [3-1].max_or_min_expression.Value;

			  yySynAttribute.additive_expression.Sizeof = yyAttrStackPtr [1-1].additive_expression.Sizeof || yyAttrStackPtr [3-1].max_or_min_expression.Sizeof;
  
			    yySynAttribute.additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PLUS, yyAttrStackPtr [1-1].additive_expression.Tree,
					yyAttrStackPtr [3-1].max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.additive_expression.Tree);
			    yySynAttribute.additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.additive_expression.Ignore =
							  yyAttrStackPtr [1-1].additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].max_or_min_expression.Ignore;
			    yySynAttribute.additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.additive_expression.BegPos = yyAttrStackPtr [1-1].additive_expression.BegPos;  
			    yySynAttribute.additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.additive_expression.EndPos = yyAttrStackPtr [3-1].max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].max_or_min_expression.IsIntConst) {
			      yySynAttribute.additive_expression.IsIntConst = true;
			      yySynAttribute.additive_expression.Value = Eval_BinaryExpr(PLUS,
					yyAttrStackPtr [1-1].additive_expression.Value,
					yyAttrStackPtr [3-1].max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.additive_expression.Tree,yySynAttribute.additive_expression.Value);
			    }
			    else {
			      yySynAttribute.additive_expression.IsIntConst = false;
			      yySynAttribute.additive_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.additive_expression.Scope = yyAttrStackPtr [1-1].additive_expression.Scope || yyAttrStackPtr [3-1].max_or_min_expression.Scope;

			;

} break;
case 1027: /* additive_expression : additive_expression '-' max_or_min_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 167; {
/* line 2329 "mpcPars.lalr" */

			  yySynAttribute.additive_expression.Sizeof = yyAttrStackPtr [1-1].additive_expression.Sizeof || yyAttrStackPtr [3-1].max_or_min_expression.Sizeof;
  
			    yySynAttribute.additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MINUS, yyAttrStackPtr [1-1].additive_expression.Tree,
					yyAttrStackPtr [3-1].max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.additive_expression.Tree);
			    yySynAttribute.additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.additive_expression.Ignore =
							  yyAttrStackPtr [1-1].additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].max_or_min_expression.Ignore;
			    yySynAttribute.additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.additive_expression.BegPos = yyAttrStackPtr [1-1].additive_expression.BegPos;  
			    yySynAttribute.additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.additive_expression.EndPos = yyAttrStackPtr [3-1].max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].max_or_min_expression.IsIntConst) {
			      yySynAttribute.additive_expression.IsIntConst = true;
			      yySynAttribute.additive_expression.Value = Eval_BinaryExpr(MINUS,
					yyAttrStackPtr [1-1].additive_expression.Value,
					yyAttrStackPtr [3-1].max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.additive_expression.Tree,yySynAttribute.additive_expression.Value);
			    }
			    else {
			      yySynAttribute.additive_expression.IsIntConst = false;
			      yySynAttribute.additive_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.additive_expression.Scope = yyAttrStackPtr [1-1].additive_expression.Scope || yyAttrStackPtr [3-1].max_or_min_expression.Scope;

			;

} break;
case 1028: /* shift_expression : additive_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 2363 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Tree  =  yyAttrStackPtr [1-1].additive_expression.Tree;

			  yySynAttribute.shift_expression.IsIntConst  =  yyAttrStackPtr [1-1].additive_expression.IsIntConst;

			  yySynAttribute.shift_expression.Value  =  yyAttrStackPtr [1-1].additive_expression.Value;

			  yySynAttribute.shift_expression.Sizeof  =  yyAttrStackPtr [1-1].additive_expression.Sizeof;

			  yySynAttribute.shift_expression.Scope  =  yyAttrStackPtr [1-1].additive_expression.Scope;

			  yySynAttribute.shift_expression.Ignore  =  yyAttrStackPtr [1-1].additive_expression.Ignore;

			  yySynAttribute.shift_expression.Position  =  yyAttrStackPtr [1-1].additive_expression.Position;

			  yySynAttribute.shift_expression.BegPos  =  yyAttrStackPtr [1-1].additive_expression.BegPos;
  
			  yySynAttribute.shift_expression.EndPos  =  yyAttrStackPtr [1-1].additive_expression.EndPos;
  
			;

} break;
case 1029: /* shift_expression : shift_expression '<<' additive_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 168; {
/* line 2384 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Sizeof = yyAttrStackPtr [1-1].shift_expression.Sizeof || yyAttrStackPtr [3-1].additive_expression.Sizeof;
  
			    yySynAttribute.shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LEFT_SHIFT, yyAttrStackPtr [1-1].shift_expression.Tree,
					yyAttrStackPtr [3-1].additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.shift_expression.Tree);
			    yySynAttribute.shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.shift_expression.Ignore =
							  yyAttrStackPtr [1-1].shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].additive_expression.Ignore;
			    yySynAttribute.shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.shift_expression.BegPos = yyAttrStackPtr [1-1].shift_expression.BegPos;  
			    yySynAttribute.shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.shift_expression.EndPos = yyAttrStackPtr [3-1].additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].additive_expression.IsIntConst) {
			      yySynAttribute.shift_expression.IsIntConst = true;
			      yySynAttribute.shift_expression.Value = Eval_BinaryExpr(LEFT_SHIFT,
					yyAttrStackPtr [1-1].shift_expression.Value,
					yyAttrStackPtr [3-1].additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.shift_expression.Tree,yySynAttribute.shift_expression.Value);
			    }
			    else {
			      yySynAttribute.shift_expression.IsIntConst = false;
			      yySynAttribute.shift_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.shift_expression.Scope = yyAttrStackPtr [1-1].shift_expression.Scope || yyAttrStackPtr [3-1].additive_expression.Scope;

			;

} break;
case 1030: /* shift_expression : shift_expression '>>' additive_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 168; {
/* line 2418 "mpcPars.lalr" */

			  yySynAttribute.shift_expression.Sizeof = yyAttrStackPtr [1-1].shift_expression.Sizeof || yyAttrStackPtr [3-1].additive_expression.Sizeof;
  
			    yySynAttribute.shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					RIGHT_SHIFT, yyAttrStackPtr [1-1].shift_expression.Tree,
					yyAttrStackPtr [3-1].additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.shift_expression.Tree);
			    yySynAttribute.shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.shift_expression.Ignore =
							  yyAttrStackPtr [1-1].shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].additive_expression.Ignore;
			    yySynAttribute.shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.shift_expression.BegPos = yyAttrStackPtr [1-1].shift_expression.BegPos;  
			    yySynAttribute.shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.shift_expression.EndPos = yyAttrStackPtr [3-1].additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].additive_expression.IsIntConst) {
			      yySynAttribute.shift_expression.IsIntConst = true;
			      yySynAttribute.shift_expression.Value = Eval_BinaryExpr(RIGHT_SHIFT,
					yyAttrStackPtr [1-1].shift_expression.Value,
					yyAttrStackPtr [3-1].additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.shift_expression.Tree,yySynAttribute.shift_expression.Value);
			    }
			    else {
			      yySynAttribute.shift_expression.IsIntConst = false;
			      yySynAttribute.shift_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.shift_expression.Scope = yyAttrStackPtr [1-1].shift_expression.Scope || yyAttrStackPtr [3-1].additive_expression.Scope;

			;

} break;
case 1031: /* relational_expression : shift_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 169; {
/* line 2452 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Tree  =  yyAttrStackPtr [1-1].shift_expression.Tree;

			  yySynAttribute.relational_expression.IsIntConst  =  yyAttrStackPtr [1-1].shift_expression.IsIntConst;

			  yySynAttribute.relational_expression.Value  =  yyAttrStackPtr [1-1].shift_expression.Value;

			  yySynAttribute.relational_expression.Sizeof  =  yyAttrStackPtr [1-1].shift_expression.Sizeof;

			  yySynAttribute.relational_expression.Scope  =  yyAttrStackPtr [1-1].shift_expression.Scope;

			  yySynAttribute.relational_expression.Ignore  =  yyAttrStackPtr [1-1].shift_expression.Ignore;

			  yySynAttribute.relational_expression.Position  =  yyAttrStackPtr [1-1].shift_expression.Position;

			  yySynAttribute.relational_expression.BegPos  =  yyAttrStackPtr [1-1].shift_expression.BegPos;
  
			  yySynAttribute.relational_expression.EndPos  =  yyAttrStackPtr [1-1].shift_expression.EndPos;
  
			;

} break;
case 1032: /* relational_expression : relational_expression '<' shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 169; {
/* line 2473 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_THEN, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(LESS_THEN,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1033: /* relational_expression : relational_expression '>' shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 169; {
/* line 2507 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_THEN, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(GREAT_THEN,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1034: /* relational_expression : relational_expression '<=' shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 169; {
/* line 2541 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_OR_EQ, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(LESS_OR_EQ,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1035: /* relational_expression : relational_expression '>=' shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 169; {
/* line 2575 "mpcPars.lalr" */

			  yySynAttribute.relational_expression.Sizeof = yyAttrStackPtr [1-1].relational_expression.Sizeof || yyAttrStackPtr [3-1].shift_expression.Sizeof;
  
			    yySynAttribute.relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_OR_EQ, yyAttrStackPtr [1-1].relational_expression.Tree,
					yyAttrStackPtr [3-1].shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.relational_expression.Tree);
			    yySynAttribute.relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.relational_expression.Ignore =
							  yyAttrStackPtr [1-1].relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].shift_expression.Ignore;
			    yySynAttribute.relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.relational_expression.BegPos = yyAttrStackPtr [1-1].relational_expression.BegPos;  
			    yySynAttribute.relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.relational_expression.EndPos = yyAttrStackPtr [3-1].shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].shift_expression.IsIntConst) {
			      yySynAttribute.relational_expression.IsIntConst = true;
			      yySynAttribute.relational_expression.Value = Eval_BinaryExpr(GREAT_OR_EQ,
					yyAttrStackPtr [1-1].relational_expression.Value,
					yyAttrStackPtr [3-1].shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.relational_expression.Tree,yySynAttribute.relational_expression.Value);
			    }
			    else {
			      yySynAttribute.relational_expression.IsIntConst = false;
			      yySynAttribute.relational_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.relational_expression.Scope = yyAttrStackPtr [1-1].relational_expression.Scope || yyAttrStackPtr [3-1].shift_expression.Scope;

			;

} break;
case 1036: /* equality_expression : relational_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 170; {
/* line 2609 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Tree  =  yyAttrStackPtr [1-1].relational_expression.Tree;

			  yySynAttribute.equality_expression.IsIntConst  =  yyAttrStackPtr [1-1].relational_expression.IsIntConst;

			  yySynAttribute.equality_expression.Value  =  yyAttrStackPtr [1-1].relational_expression.Value;

			  yySynAttribute.equality_expression.Sizeof  =  yyAttrStackPtr [1-1].relational_expression.Sizeof;

			  yySynAttribute.equality_expression.Scope  =  yyAttrStackPtr [1-1].relational_expression.Scope;

			  yySynAttribute.equality_expression.Ignore  =  yyAttrStackPtr [1-1].relational_expression.Ignore;

			  yySynAttribute.equality_expression.Position  =  yyAttrStackPtr [1-1].relational_expression.Position;

			  yySynAttribute.equality_expression.BegPos  =  yyAttrStackPtr [1-1].relational_expression.BegPos;
  
			  yySynAttribute.equality_expression.EndPos  =  yyAttrStackPtr [1-1].relational_expression.EndPos;
  
			;

} break;
case 1037: /* equality_expression : equality_expression '==' relational_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 170; {
/* line 2630 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Sizeof = yyAttrStackPtr [1-1].equality_expression.Sizeof || yyAttrStackPtr [3-1].relational_expression.Sizeof;
  
			    yySynAttribute.equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EQUAL, yyAttrStackPtr [1-1].equality_expression.Tree,
					yyAttrStackPtr [3-1].relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.equality_expression.Tree);
			    yySynAttribute.equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.equality_expression.Ignore =
							  yyAttrStackPtr [1-1].equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].relational_expression.Ignore;
			    yySynAttribute.equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.equality_expression.BegPos = yyAttrStackPtr [1-1].equality_expression.BegPos;  
			    yySynAttribute.equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.equality_expression.EndPos = yyAttrStackPtr [3-1].relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].relational_expression.IsIntConst) {
			      yySynAttribute.equality_expression.IsIntConst = true;
			      yySynAttribute.equality_expression.Value = Eval_BinaryExpr(EQUAL,
					yyAttrStackPtr [1-1].equality_expression.Value,
					yyAttrStackPtr [3-1].relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.equality_expression.Tree,yySynAttribute.equality_expression.Value);
			    }
			    else {
			      yySynAttribute.equality_expression.IsIntConst = false;
			      yySynAttribute.equality_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.equality_expression.Scope = yyAttrStackPtr [1-1].equality_expression.Scope || yyAttrStackPtr [3-1].relational_expression.Scope;

			;

} break;
case 1038: /* equality_expression : equality_expression '!=' relational_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 170; {
/* line 2664 "mpcPars.lalr" */

			  yySynAttribute.equality_expression.Sizeof = yyAttrStackPtr [1-1].equality_expression.Sizeof || yyAttrStackPtr [3-1].relational_expression.Sizeof;
  
			    yySynAttribute.equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					NOT_EQUAL, yyAttrStackPtr [1-1].equality_expression.Tree,
					yyAttrStackPtr [3-1].relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.equality_expression.Tree);
			    yySynAttribute.equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.equality_expression.Ignore =
							  yyAttrStackPtr [1-1].equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].relational_expression.Ignore;
			    yySynAttribute.equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.equality_expression.BegPos = yyAttrStackPtr [1-1].equality_expression.BegPos;  
			    yySynAttribute.equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.equality_expression.EndPos = yyAttrStackPtr [3-1].relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].relational_expression.IsIntConst) {
			      yySynAttribute.equality_expression.IsIntConst = true;
			      yySynAttribute.equality_expression.Value = Eval_BinaryExpr(NOT_EQUAL,
					yyAttrStackPtr [1-1].equality_expression.Value,
					yyAttrStackPtr [3-1].relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.equality_expression.Tree,yySynAttribute.equality_expression.Value);
			    }
			    else {
			      yySynAttribute.equality_expression.IsIntConst = false;
			      yySynAttribute.equality_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.equality_expression.Scope = yyAttrStackPtr [1-1].equality_expression.Scope || yyAttrStackPtr [3-1].relational_expression.Scope;

			;

} break;
case 1039: /* AND_expression : equality_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 171; {
/* line 2698 "mpcPars.lalr" */

			  yySynAttribute.AND_expression.Tree  =  yyAttrStackPtr [1-1].equality_expression.Tree;

			  yySynAttribute.AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].equality_expression.IsIntConst;

			  yySynAttribute.AND_expression.Value  =  yyAttrStackPtr [1-1].equality_expression.Value;

			  yySynAttribute.AND_expression.Sizeof  =  yyAttrStackPtr [1-1].equality_expression.Sizeof;

			  yySynAttribute.AND_expression.Scope  =  yyAttrStackPtr [1-1].equality_expression.Scope;

			  yySynAttribute.AND_expression.Ignore  =  yyAttrStackPtr [1-1].equality_expression.Ignore;

			  yySynAttribute.AND_expression.Position  =  yyAttrStackPtr [1-1].equality_expression.Position;

			  yySynAttribute.AND_expression.BegPos  =  yyAttrStackPtr [1-1].equality_expression.BegPos;
  
			  yySynAttribute.AND_expression.EndPos  =  yyAttrStackPtr [1-1].equality_expression.EndPos;
  
			;

} break;
case 1040: /* AND_expression : AND_expression '&' equality_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 171; {
/* line 2719 "mpcPars.lalr" */

			  yySynAttribute.AND_expression.Sizeof = yyAttrStackPtr [1-1].AND_expression.Sizeof || yyAttrStackPtr [3-1].equality_expression.Sizeof;
  
			    yySynAttribute.AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					AND, yyAttrStackPtr [1-1].AND_expression.Tree,
					yyAttrStackPtr [3-1].equality_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.AND_expression.Tree);
			    yySynAttribute.AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.AND_expression.Ignore =
							  yyAttrStackPtr [1-1].AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].equality_expression.Ignore;
			    yySynAttribute.AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.AND_expression.BegPos = yyAttrStackPtr [1-1].AND_expression.BegPos;  
			    yySynAttribute.AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.AND_expression.EndPos = yyAttrStackPtr [3-1].equality_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].equality_expression.IsIntConst) {
			      yySynAttribute.AND_expression.IsIntConst = true;
			      yySynAttribute.AND_expression.Value = Eval_BinaryExpr(AND,
					yyAttrStackPtr [1-1].AND_expression.Value,
					yyAttrStackPtr [3-1].equality_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.AND_expression.Tree,yySynAttribute.AND_expression.Value);
			    }
			    else {
			      yySynAttribute.AND_expression.IsIntConst = false;
			      yySynAttribute.AND_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.AND_expression.Scope = yyAttrStackPtr [1-1].AND_expression.Scope || yyAttrStackPtr [3-1].equality_expression.Scope;

			;

} break;
case 1041: /* exclusive_OR_expression : AND_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 172; {
/* line 2753 "mpcPars.lalr" */

			  yySynAttribute.exclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].AND_expression.Tree;

			  yySynAttribute.exclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].AND_expression.IsIntConst;

			  yySynAttribute.exclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].AND_expression.Value;

			  yySynAttribute.exclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].AND_expression.Sizeof;

			  yySynAttribute.exclusive_OR_expression.Scope  =  yyAttrStackPtr [1-1].AND_expression.Scope;

			  yySynAttribute.exclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].AND_expression.Ignore;

			  yySynAttribute.exclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].AND_expression.Position;

			  yySynAttribute.exclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].AND_expression.BegPos;
  
			  yySynAttribute.exclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].AND_expression.EndPos;
  
			;

} break;
case 1042: /* exclusive_OR_expression : exclusive_OR_expression '^' AND_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 172; {
/* line 2774 "mpcPars.lalr" */

			  yySynAttribute.exclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].exclusive_OR_expression.Sizeof || yyAttrStackPtr [3-1].AND_expression.Sizeof;
  
			    yySynAttribute.exclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.exclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EXCL_OR, yyAttrStackPtr [1-1].exclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.exclusive_OR_expression.Tree);
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.exclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].exclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].AND_expression.Ignore;
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.exclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].exclusive_OR_expression.BegPos;  
			    yySynAttribute.exclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.exclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].exclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].AND_expression.IsIntConst) {
			      yySynAttribute.exclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.exclusive_OR_expression.Value = Eval_BinaryExpr(EXCL_OR,
					yyAttrStackPtr [1-1].exclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.exclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.exclusive_OR_expression.Tree,yySynAttribute.exclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.exclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.exclusive_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.exclusive_OR_expression.Scope = yyAttrStackPtr [1-1].exclusive_OR_expression.Scope || yyAttrStackPtr [3-1].AND_expression.Scope;

			;

} break;
case 1043: /* inclusive_OR_expression : exclusive_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 173; {
/* line 2808 "mpcPars.lalr" */

			  yySynAttribute.inclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Tree;

			  yySynAttribute.inclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].exclusive_OR_expression.IsIntConst;

			  yySynAttribute.inclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Value;

			  yySynAttribute.inclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Sizeof;

			  yySynAttribute.inclusive_OR_expression.Scope  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Scope;

			  yySynAttribute.inclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Ignore;

			  yySynAttribute.inclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].exclusive_OR_expression.Position;

			  yySynAttribute.inclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].exclusive_OR_expression.BegPos;
  
			  yySynAttribute.inclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].exclusive_OR_expression.EndPos;
  
			;

} break;
case 1044: /* inclusive_OR_expression : inclusive_OR_expression '|' exclusive_OR_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 173; {
/* line 2829 "mpcPars.lalr" */

			  yySynAttribute.inclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].inclusive_OR_expression.Sizeof || yyAttrStackPtr [3-1].exclusive_OR_expression.Sizeof;
  
			    yySynAttribute.inclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.inclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					INCL_OR, yyAttrStackPtr [1-1].inclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].exclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.inclusive_OR_expression.Tree);
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.inclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].inclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].exclusive_OR_expression.Ignore;
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.inclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].inclusive_OR_expression.BegPos;  
			    yySynAttribute.inclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.inclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].exclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].inclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].exclusive_OR_expression.IsIntConst) {
			      yySynAttribute.inclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.inclusive_OR_expression.Value = Eval_BinaryExpr(INCL_OR,
					yyAttrStackPtr [1-1].inclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].exclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.inclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.inclusive_OR_expression.Tree,yySynAttribute.inclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.inclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.inclusive_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.inclusive_OR_expression.Scope = yyAttrStackPtr [1-1].inclusive_OR_expression.Scope || yyAttrStackPtr [3-1].exclusive_OR_expression.Scope;

			;

} break;
case 1045: /* logical_AND_expression : inclusive_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 174; {
/* line 2863 "mpcPars.lalr" */

			  yySynAttribute.logical_AND_expression.Tree  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Tree;

			  yySynAttribute.logical_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].inclusive_OR_expression.IsIntConst;

			  yySynAttribute.logical_AND_expression.Value  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Value;

			  yySynAttribute.logical_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Sizeof;

			  yySynAttribute.logical_AND_expression.Scope  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Scope;

			  yySynAttribute.logical_AND_expression.Ignore  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Ignore;

			  yySynAttribute.logical_AND_expression.Position  =  yyAttrStackPtr [1-1].inclusive_OR_expression.Position;

			  yySynAttribute.logical_AND_expression.BegPos  =  yyAttrStackPtr [1-1].inclusive_OR_expression.BegPos;
  
			  yySynAttribute.logical_AND_expression.EndPos  =  yyAttrStackPtr [1-1].inclusive_OR_expression.EndPos;
  
			;

} break;
case 1046: /* logical_AND_expression : logical_AND_expression '&&' inclusive_OR_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 174; {
/* line 2884 "mpcPars.lalr" */

			  yySynAttribute.logical_AND_expression.Sizeof = yyAttrStackPtr [1-1].logical_AND_expression.Sizeof || yyAttrStackPtr [3-1].inclusive_OR_expression.Sizeof;
  
			    yySynAttribute.logical_AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.logical_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_AND, yyAttrStackPtr [1-1].logical_AND_expression.Tree,
					yyAttrStackPtr [3-1].inclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.logical_AND_expression.Tree);
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.logical_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].logical_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].inclusive_OR_expression.Ignore;
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.logical_AND_expression.BegPos =yyAttrStackPtr [1-1].logical_AND_expression.BegPos;  
			    yySynAttribute.logical_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.logical_AND_expression.EndPos =yyAttrStackPtr [3-1].inclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].inclusive_OR_expression.IsIntConst) {
			      yySynAttribute.logical_AND_expression.IsIntConst = true;
			      yySynAttribute.logical_AND_expression.Value = Eval_BinaryExpr(LOG_AND,
					yyAttrStackPtr [1-1].logical_AND_expression.Value,
					yyAttrStackPtr [3-1].inclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.logical_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.logical_AND_expression.Tree,yySynAttribute.logical_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.logical_AND_expression.IsIntConst = false;
			      yySynAttribute.logical_AND_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.logical_AND_expression.Scope = yyAttrStackPtr [1-1].logical_AND_expression.Scope || yyAttrStackPtr [3-1].inclusive_OR_expression.Scope;

			;

} break;
case 1047: /* logical_OR_expression : logical_AND_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 175; {
/* line 2918 "mpcPars.lalr" */

			  yySynAttribute.logical_OR_expression.Tree  =  yyAttrStackPtr [1-1].logical_AND_expression.Tree;

			  yySynAttribute.logical_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].logical_AND_expression.IsIntConst;

			  yySynAttribute.logical_OR_expression.Value  =  yyAttrStackPtr [1-1].logical_AND_expression.Value;

			  yySynAttribute.logical_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].logical_AND_expression.Sizeof;

			  yySynAttribute.logical_OR_expression.Scope  =  yyAttrStackPtr [1-1].logical_AND_expression.Scope;

			  yySynAttribute.logical_OR_expression.Ignore  =  yyAttrStackPtr [1-1].logical_AND_expression.Ignore;

			  yySynAttribute.logical_OR_expression.Position  =  yyAttrStackPtr [1-1].logical_AND_expression.Position;

			  yySynAttribute.logical_OR_expression.BegPos  =  yyAttrStackPtr [1-1].logical_AND_expression.BegPos;
  
			  yySynAttribute.logical_OR_expression.EndPos  =  yyAttrStackPtr [1-1].logical_AND_expression.EndPos;
  
			;

} break;
case 1048: /* logical_OR_expression : logical_OR_expression '||' logical_AND_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 175; {
/* line 2939 "mpcPars.lalr" */

			  yySynAttribute.logical_OR_expression.Sizeof = yyAttrStackPtr [1-1].logical_OR_expression.Sizeof || yyAttrStackPtr [3-1].logical_AND_expression.Sizeof;
  
			    yySynAttribute.logical_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.logical_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_OR, yyAttrStackPtr [1-1].logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].logical_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.logical_OR_expression.Tree);
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.logical_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].logical_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].logical_AND_expression.Ignore;
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.logical_OR_expression.BegPos = yyAttrStackPtr [1-1].logical_OR_expression.BegPos;  
			    yySynAttribute.logical_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.logical_OR_expression.EndPos = yyAttrStackPtr [3-1].logical_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].logical_AND_expression.IsIntConst) {
			      yySynAttribute.logical_OR_expression.IsIntConst = true;
			      yySynAttribute.logical_OR_expression.Value = Eval_BinaryExpr(LOG_OR,
					yyAttrStackPtr [1-1].logical_OR_expression.Value,
					yyAttrStackPtr [3-1].logical_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.logical_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.logical_OR_expression.Tree,yySynAttribute.logical_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.logical_OR_expression.IsIntConst = false;
			      yySynAttribute.logical_OR_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.logical_OR_expression.Scope = yyAttrStackPtr [1-1].logical_OR_expression.Scope || yyAttrStackPtr [3-1].logical_AND_expression.Scope;

			;

} break;
case 1049: /* conditional_expression : logical_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 176; {
/* line 2973 "mpcPars.lalr" */

			  yySynAttribute.conditional_expression.Tree  =  yyAttrStackPtr [1-1].logical_OR_expression.Tree;

			  yySynAttribute.conditional_expression.IsIntConst  =  yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst;

			  yySynAttribute.conditional_expression.Value  =  yyAttrStackPtr [1-1].logical_OR_expression.Value;

			  yySynAttribute.conditional_expression.Sizeof  =  yyAttrStackPtr [1-1].logical_OR_expression.Sizeof;

			  yySynAttribute.conditional_expression.Scope  =  yyAttrStackPtr [1-1].logical_OR_expression.Scope;

			  yySynAttribute.conditional_expression.Ignore  =  yyAttrStackPtr [1-1].logical_OR_expression.Ignore;

			  yySynAttribute.conditional_expression.Position  =  yyAttrStackPtr [1-1].logical_OR_expression.Position;

			  yySynAttribute.conditional_expression.BegPos  =  yyAttrStackPtr [1-1].logical_OR_expression.BegPos;
  
			  yySynAttribute.conditional_expression.EndPos  =  yyAttrStackPtr [1-1].logical_OR_expression.EndPos;
  
			;

} break;
case 1050: /* conditional_expression : logical_OR_expression '?' expression_opt ':' conditional_expression_opt .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 176; {
/* line 2994 "mpcPars.lalr" */

			  yySynAttribute.conditional_expression.Sizeof = yyAttrStackPtr [1-1].logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].expression_opt.Sizeof || yyAttrStackPtr [5-1].conditional_expression_opt.Sizeof;
  
			    if(yyAttrStackPtr [5-1].conditional_expression_opt.Tree==NoTree)
				CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			    yySynAttribute.conditional_expression.Tree = mMPC_TernaryExpr(yySynAttribute.conditional_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					CONDITION, yyAttrStackPtr [1-1].logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].expression_opt.Tree, yyAttrStackPtr [5-1].conditional_expression_opt.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.conditional_expression.Tree);
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.conditional_expression.Ignore =
							yyAttrStackPtr [1-1].logical_OR_expression.Ignore ||
							yyAttrStackPtr [3-1].expression_opt.Ignore        ||
							yyAttrStackPtr [5-1].conditional_expression_opt.Ignore;
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.BegPos = yySynAttribute.conditional_expression.BegPos = yyAttrStackPtr [1-1].logical_OR_expression.BegPos;  
			    yySynAttribute.conditional_expression.Tree->MPC_Expr.EndPos = yySynAttribute.conditional_expression.EndPos =   
				(yyAttrStackPtr [5-1].conditional_expression_opt.Tree==NoTree)?yyAttrStackPtr [4-1].Scan.Position :  
							yyAttrStackPtr [5-1].conditional_expression_opt.EndPos;  
			    if(yyAttrStackPtr [1-1].logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].expression_opt.IsIntConst        &&
			       yyAttrStackPtr [5-1].conditional_expression_opt.IsIntConst) {
			      if(yyAttrStackPtr [1-1].logical_OR_expression.Value)
				yySynAttribute.conditional_expression.Value = yyAttrStackPtr [3-1].expression_opt.Value;
			      else
				yySynAttribute.conditional_expression.Value = yyAttrStackPtr [5-1].conditional_expression_opt.Value;
			      if(!yySynAttribute.conditional_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.conditional_expression.Tree,yySynAttribute.conditional_expression.Value);
			    }
			    else {
			      yySynAttribute.conditional_expression.IsIntConst = false;
			      yySynAttribute.conditional_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.conditional_expression.Scope = yyAttrStackPtr [1-1].logical_OR_expression.Scope ||
						yyAttrStackPtr [3-1].expression_opt.Scope ||
							yyAttrStackPtr [5-1].conditional_expression_opt.Scope;

			;

} break;
case 1051: /* conditional_expression_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 177; {
/* line 3035 "mpcPars.lalr" */
 yySynAttribute.conditional_expression_opt.Tree = NoTree;
 yySynAttribute.conditional_expression_opt.IsIntConst = false;
 yySynAttribute.conditional_expression_opt.Value = 0;

		    yySynAttribute.conditional_expression_opt.Sizeof = false;
 yySynAttribute.conditional_expression_opt.Scope = false;
 yySynAttribute.conditional_expression_opt.Ignore = false;
 yySynAttribute.conditional_expression_opt.EndPos = NoPosition;
 ;

} break;
case 1052: /* conditional_expression_opt : conditional_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 177; {
/* line 3045 "mpcPars.lalr" */

			  yySynAttribute.conditional_expression_opt.Tree  =  yyAttrStackPtr [1-1].conditional_expression.Tree;

			  yySynAttribute.conditional_expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].conditional_expression.IsIntConst;

			  yySynAttribute.conditional_expression_opt.Value  =  yyAttrStackPtr [1-1].conditional_expression.Value;

			  yySynAttribute.conditional_expression_opt.Sizeof  =  yyAttrStackPtr [1-1].conditional_expression.Sizeof;

			  yySynAttribute.conditional_expression_opt.Scope  =  yyAttrStackPtr [1-1].conditional_expression.Scope;

			  yySynAttribute.conditional_expression_opt.Ignore  =  yyAttrStackPtr [1-1].conditional_expression.Ignore;

			  yySynAttribute.conditional_expression_opt.EndPos  =  yyAttrStackPtr [1-1].conditional_expression.EndPos;
  
			;

} break;
case 1053: /* quaternary_assignment : unary_expression '<-' expression_opt '@' expression_opt '@' unary_expression .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 178; {
/* line 3062 "mpcPars.lalr" */

			  yySynAttribute.quaternary_assignment.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].expression_opt.Sizeof || yyAttrStackPtr [5-1].expression_opt.Sizeof || yyAttrStackPtr [7-1].unary_expression.Sizeof;

			    yySynAttribute.quaternary_assignment.Tree = mMPC_QuaternaryExpr(yySynAttribute.quaternary_assignment.Position=yyAttrStackPtr [2-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, SCAT_ASSIGN,
					yyAttrStackPtr [1-1].unary_expression.Tree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand2 =
                                  yyAttrStackPtr [3-1].expression_opt.Tree ? yyAttrStackPtr [3-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand3 =
                                  yyAttrStackPtr [5-1].expression_opt.Tree ? yyAttrStackPtr [5-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.quaternary_assignment.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore ||
							  yyAttrStackPtr [5-1].expression_opt.Ignore  || yyAttrStackPtr [7-1].unary_expression.Ignore;
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.BegPos = yySynAttribute.quaternary_assignment.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.EndPos = yySynAttribute.quaternary_assignment.EndPos = yyAttrStackPtr [7-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.quaternary_assignment.IsIntConst = false;
 yySynAttribute.quaternary_assignment.Value = 0;

			  yySynAttribute.quaternary_assignment.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [7-1].unary_expression.Scope;

			;

} break;
case 1054: /* quaternary_assignment : unary_expression '@@' expression_opt '@@' expression_opt '<-' unary_expression .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 178; {
/* line 3091 "mpcPars.lalr" */

			  yySynAttribute.quaternary_assignment.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].expression_opt.Sizeof || yyAttrStackPtr [5-1].expression_opt.Sizeof || yyAttrStackPtr [7-1].unary_expression.Sizeof;
  
			    yySynAttribute.quaternary_assignment.Tree = mMPC_QuaternaryExpr(yySynAttribute.quaternary_assignment.Position=yyAttrStackPtr [6-1].Scan.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, SCAT_ASSIGN,
					yyAttrStackPtr [1-1].unary_expression.Tree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].unary_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand2 =
                                  yyAttrStackPtr [3-1].expression_opt.Tree ? yyAttrStackPtr [3-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
                            yySynAttribute.quaternary_assignment.Tree->MPC_QuaternaryExpr.Operand3 =
                                  yyAttrStackPtr [5-1].expression_opt.Tree ? yyAttrStackPtr [5-1].expression_opt.Tree : mMPC_FreeNode(yySynAttribute.quaternary_assignment.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.quaternary_assignment.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore ||
							  yyAttrStackPtr [5-1].expression_opt.Ignore  || yyAttrStackPtr [7-1].unary_expression.Ignore;
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.BegPos = yySynAttribute.quaternary_assignment.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.quaternary_assignment.Tree->MPC_Expr.EndPos = yySynAttribute.quaternary_assignment.EndPos = yyAttrStackPtr [7-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.quaternary_assignment.IsIntConst = false;
 yySynAttribute.quaternary_assignment.Value = 0;

			  yySynAttribute.quaternary_assignment.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].expression_opt.Scope || yyAttrStackPtr [5-1].expression_opt.Scope || yyAttrStackPtr [7-1].unary_expression.Scope;

			;

} break;
case 1055: /* assignment_expression : conditional_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 153; {
/* line 3120 "mpcPars.lalr" */

			    yySynAttribute.assignment_expression.Tree = yyAttrStackPtr [1-1].conditional_expression.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.assignment_expression.IsIntConst  =  yyAttrStackPtr [1-1].conditional_expression.IsIntConst;

			  yySynAttribute.assignment_expression.Value  =  yyAttrStackPtr [1-1].conditional_expression.Value;

			  yySynAttribute.assignment_expression.Sizeof  =  yyAttrStackPtr [1-1].conditional_expression.Sizeof;

			  yySynAttribute.assignment_expression.Scope  =  yyAttrStackPtr [1-1].conditional_expression.Scope;

			  yySynAttribute.assignment_expression.Ignore  =  yyAttrStackPtr [1-1].conditional_expression.Ignore;

			  yySynAttribute.assignment_expression.Position  =  yyAttrStackPtr [1-1].conditional_expression.Position;

			  yySynAttribute.assignment_expression.BegPos  =  yyAttrStackPtr [1-1].conditional_expression.BegPos;
  
			  yySynAttribute.assignment_expression.EndPos  =  yyAttrStackPtr [1-1].conditional_expression.EndPos;
  
			;

} break;
case 1056: /* assignment_expression : unary_expression assignment_operator assignment_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 153; {
/* line 3143 "mpcPars.lalr" */
yySynAttribute.assignment_expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;

			  yySynAttribute.assignment_expression.Sizeof = yyAttrStackPtr [1-1].unary_expression.Sizeof || yyAttrStackPtr [3-1].assignment_expression.Sizeof;
  
			    yySynAttribute.assignment_expression.Tree = mMPC_BinaryExpr(yySynAttribute.assignment_expression.Position=yyAttrStackPtr [2-1].assignment_operator.Position,
					NoExprFlag, EmptyString, NoTree, NoTree,
					NoTree, yyAttrStackPtr [2-1].assignment_operator.OpCode,
					yyAttrStackPtr [1-1].unary_expression.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.assignment_expression.Tree);
			    ExprScopeEnd();    
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.assignment_expression.Ignore =
							  yyAttrStackPtr [1-1].unary_expression.Ignore ||
							  yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.BegPos = yySynAttribute.assignment_expression.BegPos = yyAttrStackPtr [1-1].unary_expression.BegPos;  
			    yySynAttribute.assignment_expression.Tree->MPC_Expr.EndPos = yySynAttribute.assignment_expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;  
			  ;

			    if(yyAttrStackPtr [1-1].unary_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].assignment_expression.IsIntConst) {
			      yySynAttribute.assignment_expression.IsIntConst = true;
			      yySynAttribute.assignment_expression.Value = Eval_BinaryExpr(yyAttrStackPtr [2-1].assignment_operator.OpCode,
					yyAttrStackPtr [1-1].unary_expression.Value,
					yyAttrStackPtr [3-1].assignment_expression.Value,
					yyAttrStackPtr [2-1].assignment_operator.Position
				      );
			    }
			    else {
			      yySynAttribute.assignment_expression.IsIntConst = false;
			      yySynAttribute.assignment_expression.Value = 0;
			    }
			  ;

			  yySynAttribute.assignment_expression.Scope = yyAttrStackPtr [1-1].unary_expression.Scope || yyAttrStackPtr [3-1].assignment_expression.Scope;

			;

} break;
case 1057: /* assignment_expression : quaternary_assignment .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 153; {
/* line 3181 "mpcPars.lalr" */

			    yySynAttribute.assignment_expression.Tree = yyAttrStackPtr [1-1].quaternary_assignment.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.assignment_expression.IsIntConst  =  yyAttrStackPtr [1-1].quaternary_assignment.IsIntConst;

			  yySynAttribute.assignment_expression.Value  =  yyAttrStackPtr [1-1].quaternary_assignment.Value;

			  yySynAttribute.assignment_expression.Sizeof  =  yyAttrStackPtr [1-1].quaternary_assignment.Sizeof;

			  yySynAttribute.assignment_expression.Scope  =  yyAttrStackPtr [1-1].quaternary_assignment.Scope;

			  yySynAttribute.assignment_expression.Ignore  =  yyAttrStackPtr [1-1].quaternary_assignment.Ignore;

			  yySynAttribute.assignment_expression.Position  =  yyAttrStackPtr [1-1].quaternary_assignment.Position;

			  yySynAttribute.assignment_expression.BegPos  =  yyAttrStackPtr [1-1].quaternary_assignment.BegPos;
  
			  yySynAttribute.assignment_expression.EndPos  =  yyAttrStackPtr [1-1].quaternary_assignment.EndPos;

			    
			;

} break;
case 1058: /* assignment_operator : '=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3205 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1059: /* assignment_operator : '*=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3209 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MULT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1060: /* assignment_operator : '/=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3213 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=DIV_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1061: /* assignment_operator : '%=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3217 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MOD_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1062: /* assignment_operator : '+=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3221 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=PLUS_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1063: /* assignment_operator : '-=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3225 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=MINUS_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1064: /* assignment_operator : '<<=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3229 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=LSHIFT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1065: /* assignment_operator : '>>=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3233 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=RSHIFT_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1066: /* assignment_operator : '&=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3237 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=AND_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1067: /* assignment_operator : '^=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3241 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=EXCL_OR_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1068: /* assignment_operator : '|=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 3245 "mpcPars.lalr" */
 yySynAttribute.assignment_operator.OpCode=INCL_OR_ASSIGN;
yySynAttribute.assignment_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1069: /* expression : assignment_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 141; {
/* line 3249 "mpcPars.lalr" */

			  yySynAttribute.expression.Tree  =  yyAttrStackPtr [1-1].assignment_expression.Tree;

			  yySynAttribute.expression.IsIntConst  =  yyAttrStackPtr [1-1].assignment_expression.IsIntConst;

			  yySynAttribute.expression.Value  =  yyAttrStackPtr [1-1].assignment_expression.Value;

			  yySynAttribute.expression.Sizeof  =  yyAttrStackPtr [1-1].assignment_expression.Sizeof;

			  yySynAttribute.expression.Scope  =  yyAttrStackPtr [1-1].assignment_expression.Scope;

			  yySynAttribute.expression.Ignore  =  yyAttrStackPtr [1-1].assignment_expression.Ignore;

			  yySynAttribute.expression.Position  =  yyAttrStackPtr [1-1].assignment_expression.Position;

			  yySynAttribute.expression.BegPos  =  yyAttrStackPtr [1-1].assignment_expression.BegPos;
  
			  yySynAttribute.expression.EndPos  =  yyAttrStackPtr [1-1].assignment_expression.EndPos;
  
			;

} break;
case 1070: /* expression : expression ',' assignment_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 141; {
/* line 3270 "mpcPars.lalr" */

			  yySynAttribute.expression.Sizeof = yyAttrStackPtr [1-1].expression.Sizeof || yyAttrStackPtr [3-1].assignment_expression.Sizeof;
  
			    yySynAttribute.expression.Tree = mMPC_BinaryExpr(yySynAttribute.expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					COMMA, yyAttrStackPtr [1-1].expression.Tree,
					yyAttrStackPtr [3-1].assignment_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.expression.Tree);
			    yySynAttribute.expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.expression.Ignore =
							  yyAttrStackPtr [1-1].expression.Ignore ||
							  yyAttrStackPtr [3-1].assignment_expression.Ignore;
			    yySynAttribute.expression.Tree->MPC_Expr.BegPos = yySynAttribute.expression.BegPos = yyAttrStackPtr [1-1].expression.BegPos;  
			    yySynAttribute.expression.Tree->MPC_Expr.EndPos = yySynAttribute.expression.EndPos = yyAttrStackPtr [3-1].assignment_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].expression.IsIntConst && yyAttrStackPtr [3-1].assignment_expression.IsIntConst) {
			      yySynAttribute.expression.IsIntConst = true;
			      yySynAttribute.expression.Value = Eval_BinaryExpr(COMMA,
					yyAttrStackPtr [1-1].expression.Value,
					yyAttrStackPtr [3-1].assignment_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.expression.Tree,yySynAttribute.expression.Value);
			    }
			    else {
			      yySynAttribute.expression.IsIntConst = false;
			      yySynAttribute.expression.Value = 0;
			    }
			  ;

			  yySynAttribute.expression.Scope = yyAttrStackPtr [1-1].expression.Scope || yyAttrStackPtr [3-1].assignment_expression.Scope;

			;

} break;
case 1071: /* expression_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 146; {
/* line 3303 "mpcPars.lalr" */

			  yySynAttribute.expression_opt.Tree = NoTree;

			  yySynAttribute.expression_opt.IsIntConst = false;

			  yySynAttribute.expression_opt.Value = 0;

			  yySynAttribute.expression_opt.Sizeof = false;

			  yySynAttribute.expression_opt.Scope = false;

			  yySynAttribute.expression_opt.Ignore = false;

			  yySynAttribute.expression_opt.Position = NoPosition;

			  yySynAttribute.expression_opt.BegPos = NoPosition;

			;

} break;
case 1072: /* expression_opt : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 146; {
/* line 3322 "mpcPars.lalr" */

			  yySynAttribute.expression_opt.Tree  =  yyAttrStackPtr [1-1].expression.Tree;

			  yySynAttribute.expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].expression.IsIntConst;

			  yySynAttribute.expression_opt.Value  =  yyAttrStackPtr [1-1].expression.Value;

			  yySynAttribute.expression_opt.Sizeof  =  yyAttrStackPtr [1-1].expression.Sizeof;

			  yySynAttribute.expression_opt.Scope  =  yyAttrStackPtr [1-1].expression.Scope;

			  yySynAttribute.expression_opt.Ignore  =  yyAttrStackPtr [1-1].expression.Ignore;

			  yySynAttribute.expression_opt.Position  =  yyAttrStackPtr [1-1].expression.Position;

			  yySynAttribute.expression_opt.BegPos  =  yyAttrStackPtr [1-1].expression.BegPos;
  
			;

} break;
case 1073: /* const_unary_expression : net_cast_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 180; {
/* line 3341 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Tree  =  yyAttrStackPtr [1-1].net_cast_expression.Tree;

			  yySynAttribute.const_unary_expression.IsIntConst  =  yyAttrStackPtr [1-1].net_cast_expression.IsIntConst;

			  yySynAttribute.const_unary_expression.Value  =  yyAttrStackPtr [1-1].net_cast_expression.Value;

			  yySynAttribute.const_unary_expression.Sizeof  =  yyAttrStackPtr [1-1].net_cast_expression.Sizeof;

			  yySynAttribute.const_unary_expression.Ignore  =  yyAttrStackPtr [1-1].net_cast_expression.Ignore;

			  yySynAttribute.const_unary_expression.Position  =  yyAttrStackPtr [1-1].net_cast_expression.Position;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].net_cast_expression.BegPos;
  
			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [1-1].net_cast_expression.EndPos;
  
			;

} break;
case 1074: /* const_unary_expression : const_unary_operator cast_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 180; {
/* line 3360 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof  =  yyAttrStackPtr [2-1].cast_expression.Sizeof;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_UnaryExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].const_unary_operator.Position,
					NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [1-1].const_unary_operator.OpCode, yyAttrStackPtr [2-1].cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].cast_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].const_unary_operator.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].cast_expression.EndPos;  
			    yySynAttribute.const_unary_expression.IsIntConst = yyAttrStackPtr [2-1].cast_expression.IsIntConst;
			    if(yySynAttribute.const_unary_expression.IsIntConst) {
			      yySynAttribute.const_unary_expression.Value = Eval_UnaryExpr(
					yyAttrStackPtr [1-1].const_unary_operator.OpCode,
					yyAttrStackPtr [2-1].cast_expression.Value, yyAttrStackPtr [1-1].const_unary_operator.Position
				      );
			      if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			    }
			    else
			      yySynAttribute.const_unary_expression.Value = UNDEFINED;
			  ;

			;

} break;
case 1075: /* const_unary_expression : sizeof unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 180; {
/* line 3386 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = true;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yySynAttribute.const_unary_expression.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = true;

			  yySynAttribute.const_unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);

			;

} break;
case 1076: /* const_unary_expression : mpc_sizeof unary_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 180; {
/* line 3406 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;
  
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [2-1].unary_expression.Tree 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [2-1].unary_expression.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [2-1].unary_expression.EndPos;  
			    yySynAttribute.const_unary_expression.IsIntConst = true;
			    yySynAttribute.const_unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [2-1].unary_expression.Tree, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			  ;

			;

} break;
case 1077: /* const_unary_expression : sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 180; {
/* line 3425 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = true;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Type(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position,
					NoExprFlag, EmptyString, IntType,
					NoTree, NoTree,
					false, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = true;

			  yySynAttribute.const_unary_expression.Value=Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);

			;

} break;
case 1078: /* const_unary_expression : mpc_sizeof '(' nested_type_on type_name nested_type_off ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 180; {
/* line 3447 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;
  
			    CurrentPosition = yyAttrStackPtr [6-1].Scan.Position;
			    yySynAttribute.const_unary_expression.Tree = mMPC_Size_Of_Value(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
					IntType, NoTree, NoTree,
					true, 0,
					yyAttrStackPtr [4-1].type_name.Type 
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_unary_expression.Ignore = yyAttrStackPtr [4-1].type_name.Ignore;
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_unary_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_unary_expression.EndPos = yyAttrStackPtr [6-1].Scan.Position;  
			    yySynAttribute.const_unary_expression.IsIntConst = true;
			    yySynAttribute.const_unary_expression.Value = Eval_SizeofExpr(yyAttrStackPtr [4-1].type_name.Type, yyAttrStackPtr [1-1].Scan.Position);
			    if(!yySynAttribute.const_unary_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_unary_expression.Tree,yySynAttribute.const_unary_expression.Value);
			  ;

			;

} break;
case 1079: /* const_unary_expression : timeof new_scope '(' empty_net_declaring_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 180; {
/* line 3467 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.const_unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].empty_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].empty_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Ignore = yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].empty_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = false;

			  yySynAttribute.const_unary_expression.Value = 0;
 
			;

} break;
case 1080: /* const_unary_expression : timeof new_scope '(' single_net_declaring_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 180; {
/* line 3490 "mpcPars.lalr" */

			  yySynAttribute.const_unary_expression.Sizeof = false;

			  yySynAttribute.const_unary_expression.BegPos  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.const_unary_expression.EndPos  =  yyAttrStackPtr [5-1].Scan.Position;

			    yySynAttribute.const_unary_expression.Tree = mMPC_TimeofExpr(yySynAttribute.const_unary_expression.Position=yyAttrStackPtr [1-1].Scan.Position, NoExprFlag, EmptyString,
						   DoubleType, CONST_NET_LIST, CONST_NET,
						   yyAttrStackPtr [4-1].single_net_declaring_list.Tree
				   );
			    yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Next =
				yyAttrStackPtr [4-1].single_net_declaring_list.Tree->MPC_NetDecl.Prev = mMPC_FreeNode(yySynAttribute.const_unary_expression.Tree);
			    yySynAttribute.const_unary_expression.Ignore = yySynAttribute.const_unary_expression.Tree->MPC_Expr.Flag.Ignore = yyAttrStackPtr [4-1].single_net_declaring_list.Ignore;
			    Close_Scope(), Scope_Depth--;
			  ;

			  yySynAttribute.const_unary_expression.IsIntConst = false;

			  yySynAttribute.const_unary_expression.Value = 0;
 
			;

} break;
case 1081: /* const_unary_operator : '+' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 3513 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=PLUS;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1082: /* const_unary_operator : '-' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 3517 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=NEG;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1083: /* const_unary_operator : '~' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 3521 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=NOT;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1084: /* const_unary_operator : '!' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 3525 "mpcPars.lalr" */
 yySynAttribute.const_unary_operator.OpCode=LOG_NOT;
yySynAttribute.const_unary_operator.Position=CurrentPosition=yyAttrStackPtr [1-1].Scan.Position;;
 ;

} break;
case 1085: /* const_cast_expression : const_unary_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 3529 "mpcPars.lalr" */

			  yySynAttribute.const_cast_expression.Tree  =  yyAttrStackPtr [1-1].const_unary_expression.Tree;

			  yySynAttribute.const_cast_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_unary_expression.IsIntConst;

			  yySynAttribute.const_cast_expression.Value  =  yyAttrStackPtr [1-1].const_unary_expression.Value;

			  yySynAttribute.const_cast_expression.Sizeof  =  yyAttrStackPtr [1-1].const_unary_expression.Sizeof;

			  yySynAttribute.const_cast_expression.Ignore  =  yyAttrStackPtr [1-1].const_unary_expression.Ignore;

			  yySynAttribute.const_cast_expression.Position  =  yyAttrStackPtr [1-1].const_unary_expression.Position;

			  yySynAttribute.const_cast_expression.BegPos  =  yyAttrStackPtr [1-1].const_unary_expression.BegPos;
  
			  yySynAttribute.const_cast_expression.EndPos  =  yyAttrStackPtr [1-1].const_unary_expression.EndPos;
  
			;

} break;
case 1086: /* const_cast_expression : '(' nested_type_on type_name nested_type_off ')' const_cast_expression .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 182; {
/* line 3548 "mpcPars.lalr" */

			  yySynAttribute.const_cast_expression.Sizeof  =  yyAttrStackPtr [6-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_cast_expression.Tree = mMPC_CastExpr(yySynAttribute.const_cast_expression.Position=yyAttrStackPtr [5-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					yyAttrStackPtr [3-1].type_name.Type, yyAttrStackPtr [6-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_cast_expression.Tree);
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_cast_expression.Ignore = yyAttrStackPtr [3-1].type_name.Ignore ||
								   yyAttrStackPtr [6-1].const_cast_expression.Ignore;
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_cast_expression.BegPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.const_cast_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_cast_expression.EndPos = yyAttrStackPtr [6-1].const_cast_expression.EndPos;  
			  ;

			  yySynAttribute.const_cast_expression.IsIntConst = yyAttrStackPtr [6-1].const_cast_expression.IsIntConst &&
					yyAttrStackPtr [3-1].type_name.Type!=NoTree &&
					yyAttrStackPtr [3-1].type_name.Type->Kind==kMPC_BasicType &&
					yyAttrStackPtr [3-1].type_name.Type->MPC_BasicType.TypeConstructor<VOID &&
					yyAttrStackPtr [3-1].type_name.Type->MPC_BasicType.TypeConstructor>FLOAT;

			  yySynAttribute.const_cast_expression.Value  =  yyAttrStackPtr [6-1].const_cast_expression.Value;

			;

} break;
case 1087: /* const_multiplicative_expression : const_cast_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 183; {
/* line 3572 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Tree  =  yyAttrStackPtr [1-1].const_cast_expression.Tree;

			  yySynAttribute.const_multiplicative_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_cast_expression.IsIntConst;

			  yySynAttribute.const_multiplicative_expression.Value  =  yyAttrStackPtr [1-1].const_cast_expression.Value;

			  yySynAttribute.const_multiplicative_expression.Sizeof  =  yyAttrStackPtr [1-1].const_cast_expression.Sizeof;

			  yySynAttribute.const_multiplicative_expression.Ignore  =  yyAttrStackPtr [1-1].const_cast_expression.Ignore;

			  yySynAttribute.const_multiplicative_expression.Position  =  yyAttrStackPtr [1-1].const_cast_expression.Position;

			  yySynAttribute.const_multiplicative_expression.BegPos  =  yyAttrStackPtr [1-1].const_cast_expression.BegPos;
  
			  yySynAttribute.const_multiplicative_expression.EndPos  =  yyAttrStackPtr [1-1].const_cast_expression.EndPos;
  
			;

} break;
case 1088: /* const_multiplicative_expression : const_multiplicative_expression '*' const_cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 183; {
/* line 3591 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MULT, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(MULT,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1089: /* const_multiplicative_expression : const_multiplicative_expression '/' const_cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 183; {
/* line 3624 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					DIV, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(DIV,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1090: /* const_multiplicative_expression : const_multiplicative_expression '%' const_cast_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 183; {
/* line 3657 "mpcPars.lalr" */

			  yySynAttribute.const_multiplicative_expression.Sizeof = yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_cast_expression.Sizeof;
  
			    yySynAttribute.const_multiplicative_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_multiplicative_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MOD, yyAttrStackPtr [1-1].const_multiplicative_expression.Tree,
					yyAttrStackPtr [3-1].const_cast_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_multiplicative_expression.Tree);
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.Flag.Ignore =
				  yySynAttribute.const_multiplicative_expression.Ignore = yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore ||
					   yyAttrStackPtr [3-1].const_cast_expression.Ignore;
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_multiplicative_expression.BegPos = yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;  
			    yySynAttribute.const_multiplicative_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_multiplicative_expression.EndPos = yyAttrStackPtr [3-1].const_cast_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst &&
			      yyAttrStackPtr [3-1].const_cast_expression.IsIntConst) {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = true;
			      yySynAttribute.const_multiplicative_expression.Value = Eval_BinaryExpr(MOD,
					yyAttrStackPtr [1-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [3-1].const_cast_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_multiplicative_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_multiplicative_expression.Tree,yySynAttribute.const_multiplicative_expression.Value);
			    }
			    else {
			      yySynAttribute.const_multiplicative_expression.IsIntConst = false;
			      yySynAttribute.const_multiplicative_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1091: /* const_max_or_min_expression : const_multiplicative_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 184; {
/* line 3690 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Tree  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Tree;

			  yySynAttribute.const_max_or_min_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_multiplicative_expression.IsIntConst;

			  yySynAttribute.const_max_or_min_expression.Value  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Value;

			  yySynAttribute.const_max_or_min_expression.Sizeof  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Sizeof;

			  yySynAttribute.const_max_or_min_expression.Ignore  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Ignore;

			  yySynAttribute.const_max_or_min_expression.Position  =  yyAttrStackPtr [1-1].const_multiplicative_expression.Position;

			  yySynAttribute.const_max_or_min_expression.BegPos  =  yyAttrStackPtr [1-1].const_multiplicative_expression.BegPos;
  
			  yySynAttribute.const_max_or_min_expression.EndPos  =  yyAttrStackPtr [1-1].const_multiplicative_expression.EndPos;
  
			;

} break;
case 1092: /* const_max_or_min_expression : const_max_or_min_expression '?<' const_multiplicative_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 184; {
/* line 3709 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_multiplicative_expression.Sizeof;
  
			    yySynAttribute.const_max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MIN, yyAttrStackPtr [1-1].const_max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_max_or_min_expression.Tree);
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_multiplicative_expression.Ignore;
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_max_or_min_expression.BegPos = yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;   
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_max_or_min_expression.EndPos = yyAttrStackPtr [3-1].const_multiplicative_expression.EndPos;   
			    if(yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_multiplicative_expression.IsIntConst) {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = true;
			      yySynAttribute.const_max_or_min_expression.Value = Eval_BinaryExpr(MIN,
					yyAttrStackPtr [1-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_max_or_min_expression.Tree,yySynAttribute.const_max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = false;
			      yySynAttribute.const_max_or_min_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1093: /* const_max_or_min_expression : const_max_or_min_expression '?>' const_multiplicative_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 184; {
/* line 3742 "mpcPars.lalr" */

			  yySynAttribute.const_max_or_min_expression.Sizeof = yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_multiplicative_expression.Sizeof;
  
			    yySynAttribute.const_max_or_min_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_max_or_min_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MAX, yyAttrStackPtr [1-1].const_max_or_min_expression.Tree,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_max_or_min_expression.Tree);
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_max_or_min_expression.Ignore =
							  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_multiplicative_expression.Ignore;
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_max_or_min_expression.BegPos = yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;   
			    yySynAttribute.const_max_or_min_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_max_or_min_expression.EndPos = yyAttrStackPtr [3-1].const_multiplicative_expression.EndPos;   
			    if(yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_multiplicative_expression.IsIntConst) {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = true;
			      yySynAttribute.const_max_or_min_expression.Value = Eval_BinaryExpr(MAX,
					yyAttrStackPtr [1-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [3-1].const_multiplicative_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_max_or_min_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_max_or_min_expression.Tree,yySynAttribute.const_max_or_min_expression.Value);
			    }
			    else {
			      yySynAttribute.const_max_or_min_expression.IsIntConst = false;
			      yySynAttribute.const_max_or_min_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1094: /* const_additive_expression : const_max_or_min_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 3775 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Tree  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Tree;

			  yySynAttribute.const_additive_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_max_or_min_expression.IsIntConst;

			  yySynAttribute.const_additive_expression.Value  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Value;

			  yySynAttribute.const_additive_expression.Sizeof  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Sizeof;

			  yySynAttribute.const_additive_expression.Ignore  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Ignore;

			  yySynAttribute.const_additive_expression.Position  =  yyAttrStackPtr [1-1].const_max_or_min_expression.Position;

			  yySynAttribute.const_additive_expression.BegPos  =  yyAttrStackPtr [1-1].const_max_or_min_expression.BegPos;
  
			  yySynAttribute.const_additive_expression.EndPos  =  yyAttrStackPtr [1-1].const_max_or_min_expression.EndPos;
  
			;

} break;
case 1095: /* const_additive_expression : const_additive_expression '+' const_max_or_min_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 185; {
/* line 3794 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Sizeof = yyAttrStackPtr [1-1].const_additive_expression.Sizeof || yyAttrStackPtr [3-1].const_max_or_min_expression.Sizeof;
  
			    yySynAttribute.const_additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					PLUS, yyAttrStackPtr [1-1].const_additive_expression.Tree,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_additive_expression.Tree);
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_additive_expression.Ignore =
							  yyAttrStackPtr [1-1].const_additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_max_or_min_expression.Ignore;
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_additive_expression.BegPos = yyAttrStackPtr [1-1].const_additive_expression.BegPos;  
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_additive_expression.EndPos = yyAttrStackPtr [3-1].const_max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_max_or_min_expression.IsIntConst) {
			      yySynAttribute.const_additive_expression.IsIntConst = true;
			      yySynAttribute.const_additive_expression.Value = Eval_BinaryExpr(PLUS,
					yyAttrStackPtr [1-1].const_additive_expression.Value,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_additive_expression.Tree,yySynAttribute.const_additive_expression.Value);
			    }
			    else {
			      yySynAttribute.const_additive_expression.IsIntConst = false;
			      yySynAttribute.const_additive_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1096: /* const_additive_expression : const_additive_expression '-' const_max_or_min_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 185; {
/* line 3826 "mpcPars.lalr" */

			  yySynAttribute.const_additive_expression.Sizeof = yyAttrStackPtr [1-1].const_additive_expression.Sizeof || yyAttrStackPtr [3-1].const_max_or_min_expression.Sizeof;
  
			    yySynAttribute.const_additive_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_additive_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					MINUS, yyAttrStackPtr [1-1].const_additive_expression.Tree,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_additive_expression.Tree);
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_additive_expression.Ignore =
							  yyAttrStackPtr [1-1].const_additive_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_max_or_min_expression.Ignore;
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_additive_expression.BegPos = yyAttrStackPtr [1-1].const_additive_expression.BegPos;  
			    yySynAttribute.const_additive_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_additive_expression.EndPos = yyAttrStackPtr [3-1].const_max_or_min_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_additive_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_max_or_min_expression.IsIntConst) {
			      yySynAttribute.const_additive_expression.IsIntConst = true;
			      yySynAttribute.const_additive_expression.Value = Eval_BinaryExpr(MINUS,
					yyAttrStackPtr [1-1].const_additive_expression.Value,
					yyAttrStackPtr [3-1].const_max_or_min_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_additive_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_additive_expression.Tree,yySynAttribute.const_additive_expression.Value);
			    }
			    else {
			      yySynAttribute.const_additive_expression.IsIntConst = false;
			      yySynAttribute.const_additive_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1097: /* const_shift_expression : const_additive_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 186; {
/* line 3858 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Tree  =  yyAttrStackPtr [1-1].const_additive_expression.Tree;

			  yySynAttribute.const_shift_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_additive_expression.IsIntConst;

			  yySynAttribute.const_shift_expression.Value  =  yyAttrStackPtr [1-1].const_additive_expression.Value;

			  yySynAttribute.const_shift_expression.Sizeof  =  yyAttrStackPtr [1-1].const_additive_expression.Sizeof;

			  yySynAttribute.const_shift_expression.Ignore  =  yyAttrStackPtr [1-1].const_additive_expression.Ignore;

			  yySynAttribute.const_shift_expression.Position  =  yyAttrStackPtr [1-1].const_additive_expression.Position;

			  yySynAttribute.const_shift_expression.BegPos  =  yyAttrStackPtr [1-1].const_additive_expression.BegPos;
  
			  yySynAttribute.const_shift_expression.EndPos  =  yyAttrStackPtr [1-1].const_additive_expression.EndPos;
  
			;

} break;
case 1098: /* const_shift_expression : const_shift_expression '<<' const_additive_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 186; {
/* line 3877 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Sizeof = yyAttrStackPtr [1-1].const_shift_expression.Sizeof || yyAttrStackPtr [3-1].const_additive_expression.Sizeof;
  
			    yySynAttribute.const_shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LEFT_SHIFT, yyAttrStackPtr [1-1].const_shift_expression.Tree,
					yyAttrStackPtr [3-1].const_additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_shift_expression.Tree);
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_shift_expression.Ignore =
							  yyAttrStackPtr [1-1].const_shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_additive_expression.Ignore;
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_shift_expression.BegPos = yyAttrStackPtr [1-1].const_shift_expression.BegPos;  
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_shift_expression.EndPos = yyAttrStackPtr [3-1].const_additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_additive_expression.IsIntConst) {
			      yySynAttribute.const_shift_expression.IsIntConst = true;
			      yySynAttribute.const_shift_expression.Value = Eval_BinaryExpr(LEFT_SHIFT,
					yyAttrStackPtr [1-1].const_shift_expression.Value,
					yyAttrStackPtr [3-1].const_additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_shift_expression.Tree,yySynAttribute.const_shift_expression.Value);
			    }
			    else {
			      yySynAttribute.const_shift_expression.IsIntConst = false;
			      yySynAttribute.const_shift_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1099: /* const_shift_expression : const_shift_expression '>>' const_additive_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 186; {
/* line 3909 "mpcPars.lalr" */

			  yySynAttribute.const_shift_expression.Sizeof = yyAttrStackPtr [1-1].const_shift_expression.Sizeof || yyAttrStackPtr [3-1].const_additive_expression.Sizeof;
  
			    yySynAttribute.const_shift_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_shift_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					RIGHT_SHIFT, yyAttrStackPtr [1-1].const_shift_expression.Tree,
					yyAttrStackPtr [3-1].const_additive_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_shift_expression.Tree);
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_shift_expression.Ignore =
							  yyAttrStackPtr [1-1].const_shift_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_additive_expression.Ignore;
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_shift_expression.BegPos = yyAttrStackPtr [1-1].const_shift_expression.BegPos;  
			    yySynAttribute.const_shift_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_shift_expression.EndPos = yyAttrStackPtr [3-1].const_additive_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_shift_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_additive_expression.IsIntConst) {
			      yySynAttribute.const_shift_expression.IsIntConst = true;
			      yySynAttribute.const_shift_expression.Value = Eval_BinaryExpr(RIGHT_SHIFT,
					yyAttrStackPtr [1-1].const_shift_expression.Value,
					yyAttrStackPtr [3-1].const_additive_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_shift_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_shift_expression.Tree,yySynAttribute.const_shift_expression.Value);
			    }
			    else {
			      yySynAttribute.const_shift_expression.IsIntConst = false;
			      yySynAttribute.const_shift_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1100: /* const_relational_expression : const_shift_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 187; {
/* line 3941 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Tree  =  yyAttrStackPtr [1-1].const_shift_expression.Tree;

			  yySynAttribute.const_relational_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_shift_expression.IsIntConst;

			  yySynAttribute.const_relational_expression.Value  =  yyAttrStackPtr [1-1].const_shift_expression.Value;

			  yySynAttribute.const_relational_expression.Sizeof  =  yyAttrStackPtr [1-1].const_shift_expression.Sizeof;

			  yySynAttribute.const_relational_expression.Ignore  =  yyAttrStackPtr [1-1].const_shift_expression.Ignore;

			  yySynAttribute.const_relational_expression.Position  =  yyAttrStackPtr [1-1].const_shift_expression.Position;

			  yySynAttribute.const_relational_expression.BegPos  =  yyAttrStackPtr [1-1].const_shift_expression.BegPos;
  
			  yySynAttribute.const_relational_expression.EndPos  =  yyAttrStackPtr [1-1].const_shift_expression.EndPos;
  
			;

} break;
case 1101: /* const_relational_expression : const_relational_expression '<' const_shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 187; {
/* line 3960 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_THEN, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(LESS_THEN,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1102: /* const_relational_expression : const_relational_expression '>' const_shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 187; {
/* line 3992 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_THEN, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(GREAT_THEN,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1103: /* const_relational_expression : const_relational_expression '<=' const_shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 187; {
/* line 4024 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof || yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LESS_OR_EQ, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(LESS_OR_EQ,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1104: /* const_relational_expression : const_relational_expression '>=' const_shift_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 187; {
/* line 4056 "mpcPars.lalr" */

			  yySynAttribute.const_relational_expression.Sizeof = yyAttrStackPtr [1-1].const_relational_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_shift_expression.Sizeof;
  
			    yySynAttribute.const_relational_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_relational_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					GREAT_OR_EQ, yyAttrStackPtr [1-1].const_relational_expression.Tree,
					yyAttrStackPtr [3-1].const_shift_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_relational_expression.Tree);
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_relational_expression.Ignore =
							  yyAttrStackPtr [1-1].const_relational_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_shift_expression.Ignore;
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_relational_expression.BegPos = yyAttrStackPtr [1-1].const_relational_expression.BegPos;  
			    yySynAttribute.const_relational_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_relational_expression.EndPos = yyAttrStackPtr [3-1].const_shift_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_relational_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_shift_expression.IsIntConst) {
			      yySynAttribute.const_relational_expression.IsIntConst = true;
			      yySynAttribute.const_relational_expression.Value = Eval_BinaryExpr(GREAT_OR_EQ,
					yyAttrStackPtr [1-1].const_relational_expression.Value,
					yyAttrStackPtr [3-1].const_shift_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_relational_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_relational_expression.Tree,yySynAttribute.const_relational_expression.Value);
			    }
			    else {
			      yySynAttribute.const_relational_expression.IsIntConst = false;
			      yySynAttribute.const_relational_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1105: /* const_equality_expression : const_relational_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 188; {
/* line 4089 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Tree  =  yyAttrStackPtr [1-1].const_relational_expression.Tree;

			  yySynAttribute.const_equality_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_relational_expression.IsIntConst;

			  yySynAttribute.const_equality_expression.Value  =  yyAttrStackPtr [1-1].const_relational_expression.Value;

			  yySynAttribute.const_equality_expression.Sizeof  =  yyAttrStackPtr [1-1].const_relational_expression.Sizeof;

			  yySynAttribute.const_equality_expression.Ignore  =  yyAttrStackPtr [1-1].const_relational_expression.Ignore;

			  yySynAttribute.const_equality_expression.Position  =  yyAttrStackPtr [1-1].const_relational_expression.Position;

			  yySynAttribute.const_equality_expression.BegPos  =  yyAttrStackPtr [1-1].const_relational_expression.BegPos;
  
			  yySynAttribute.const_equality_expression.EndPos  =  yyAttrStackPtr [1-1].const_relational_expression.EndPos;
  
			;

} break;
case 1106: /* const_equality_expression : const_equality_expression '==' const_relational_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 188; {
/* line 4108 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Sizeof = yyAttrStackPtr [1-1].const_equality_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_relational_expression.Sizeof;
  
			    yySynAttribute.const_equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EQUAL, yyAttrStackPtr [1-1].const_equality_expression.Tree,
					yyAttrStackPtr [3-1].const_relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_equality_expression.Tree);
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_equality_expression.Ignore =
							  yyAttrStackPtr [1-1].const_equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_relational_expression.Ignore;
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_equality_expression.BegPos = yyAttrStackPtr [1-1].const_equality_expression.BegPos;  
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_equality_expression.EndPos = yyAttrStackPtr [3-1].const_relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_relational_expression.IsIntConst) {
			      yySynAttribute.const_equality_expression.IsIntConst = true;
			      yySynAttribute.const_equality_expression.Value = Eval_BinaryExpr(EQUAL,
					yyAttrStackPtr [1-1].const_equality_expression.Value,
					yyAttrStackPtr [3-1].const_relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_equality_expression.Tree,yySynAttribute.const_equality_expression.Value);
			    }
			    else {
			      yySynAttribute.const_equality_expression.IsIntConst = false;
			      yySynAttribute.const_equality_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1107: /* const_equality_expression : const_equality_expression '!=' const_relational_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 188; {
/* line 4141 "mpcPars.lalr" */

			  yySynAttribute.const_equality_expression.Sizeof = yyAttrStackPtr [1-1].const_equality_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_relational_expression.Sizeof;
  
			    yySynAttribute.const_equality_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_equality_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					NOT_EQUAL, yyAttrStackPtr [1-1].const_equality_expression.Tree,
					yyAttrStackPtr [3-1].const_relational_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_equality_expression.Tree);
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_equality_expression.Ignore =
							  yyAttrStackPtr [1-1].const_equality_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_relational_expression.Ignore;
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_equality_expression.BegPos = yyAttrStackPtr [1-1].const_equality_expression.BegPos;  
			    yySynAttribute.const_equality_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_equality_expression.EndPos = yyAttrStackPtr [3-1].const_relational_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_equality_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_relational_expression.IsIntConst) {
			      yySynAttribute.const_equality_expression.IsIntConst = true;
			      yySynAttribute.const_equality_expression.Value = Eval_BinaryExpr(NOT_EQUAL,
					yyAttrStackPtr [1-1].const_equality_expression.Value,
					yyAttrStackPtr [3-1].const_relational_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_equality_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_equality_expression.Tree,yySynAttribute.const_equality_expression.Value);
			    }
			    else {
			      yySynAttribute.const_equality_expression.IsIntConst = false;
			      yySynAttribute.const_equality_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1108: /* const_AND_expression : const_equality_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 4174 "mpcPars.lalr" */

			  yySynAttribute.const_AND_expression.Tree  =  yyAttrStackPtr [1-1].const_equality_expression.Tree;

			  yySynAttribute.const_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_equality_expression.IsIntConst;

			  yySynAttribute.const_AND_expression.Value  =  yyAttrStackPtr [1-1].const_equality_expression.Value;

			  yySynAttribute.const_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].const_equality_expression.Sizeof;

			  yySynAttribute.const_AND_expression.Ignore  =  yyAttrStackPtr [1-1].const_equality_expression.Ignore;

			  yySynAttribute.const_AND_expression.Position  =  yyAttrStackPtr [1-1].const_equality_expression.Position;

			  yySynAttribute.const_AND_expression.BegPos  =  yyAttrStackPtr [1-1].const_equality_expression.BegPos;
  
			  yySynAttribute.const_AND_expression.EndPos  =  yyAttrStackPtr [1-1].const_equality_expression.EndPos;
  
			;

} break;
case 1109: /* const_AND_expression : const_AND_expression '&' const_equality_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 189; {
/* line 4193 "mpcPars.lalr" */

			  yySynAttribute.const_AND_expression.Sizeof = yyAttrStackPtr [1-1].const_AND_expression.Sizeof || yyAttrStackPtr [3-1].const_equality_expression.Sizeof;
  
			    yySynAttribute.const_AND_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					AND, yyAttrStackPtr [1-1].const_AND_expression.Tree,
					yyAttrStackPtr [3-1].const_equality_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_AND_expression.Tree);
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].const_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_equality_expression.Ignore;
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_AND_expression.BegPos = yyAttrStackPtr [1-1].const_AND_expression.BegPos;  
			    yySynAttribute.const_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_AND_expression.EndPos = yyAttrStackPtr [3-1].const_equality_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_equality_expression.IsIntConst) {
			      yySynAttribute.const_AND_expression.IsIntConst = true;
			      yySynAttribute.const_AND_expression.Value = Eval_BinaryExpr(AND,
					yyAttrStackPtr [1-1].const_AND_expression.Value,
					yyAttrStackPtr [3-1].const_equality_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_AND_expression.Tree,yySynAttribute.const_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.const_AND_expression.IsIntConst = false;
			      yySynAttribute.const_AND_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1110: /* const_exclusive_OR_expression : const_AND_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 190; {
/* line 4225 "mpcPars.lalr" */

			  yySynAttribute.const_exclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_AND_expression.Tree;

			  yySynAttribute.const_exclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_AND_expression.IsIntConst;

			  yySynAttribute.const_exclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].const_AND_expression.Value;

			  yySynAttribute.const_exclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_AND_expression.Sizeof;

			  yySynAttribute.const_exclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_AND_expression.Ignore;

			  yySynAttribute.const_exclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].const_AND_expression.Position;

			  yySynAttribute.const_exclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_AND_expression.BegPos;
  
			  yySynAttribute.const_exclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_AND_expression.EndPos;
  
			;

} break;
case 1111: /* const_exclusive_OR_expression : const_exclusive_OR_expression '^' const_AND_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 190; {
/* line 4244 "mpcPars.lalr" */

			  yySynAttribute.const_exclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_exclusive_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_AND_expression.Sizeof;
  
			    yySynAttribute.const_exclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_exclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					EXCL_OR, yyAttrStackPtr [1-1].const_exclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_exclusive_OR_expression.Tree);
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_exclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_AND_expression.Ignore;
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_exclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].const_exclusive_OR_expression.BegPos;  
			    yySynAttribute.const_exclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_exclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].const_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_exclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_AND_expression.IsIntConst) {
			      yySynAttribute.const_exclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.const_exclusive_OR_expression.Value = Eval_BinaryExpr(EXCL_OR,
					yyAttrStackPtr [1-1].const_exclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].const_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_exclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_exclusive_OR_expression.Tree,yySynAttribute.const_exclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_exclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.const_exclusive_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1112: /* const_inclusive_OR_expression : const_exclusive_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 4277 "mpcPars.lalr" */

			  yySynAttribute.const_inclusive_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Tree;

			  yySynAttribute.const_inclusive_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.IsIntConst;

			  yySynAttribute.const_inclusive_OR_expression.Value  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Value;

			  yySynAttribute.const_inclusive_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Sizeof;

			  yySynAttribute.const_inclusive_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Ignore;

			  yySynAttribute.const_inclusive_OR_expression.Position  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.Position;

			  yySynAttribute.const_inclusive_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.BegPos;
  
			  yySynAttribute.const_inclusive_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_exclusive_OR_expression.EndPos;
  
			;

} break;
case 1113: /* const_inclusive_OR_expression : const_inclusive_OR_expression '|' const_exclusive_OR_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 191; {
/* line 4296 "mpcPars.lalr" */

			  yySynAttribute.const_inclusive_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_inclusive_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_exclusive_OR_expression.Sizeof;
  
			    yySynAttribute.const_inclusive_OR_expression.Tree = mMPC_BinaryExpr(yySynAttribute.const_inclusive_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					INCL_OR, yyAttrStackPtr [1-1].const_inclusive_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_exclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_inclusive_OR_expression.Tree);
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_inclusive_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_exclusive_OR_expression.Ignore;
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_inclusive_OR_expression.BegPos = yyAttrStackPtr [1-1].const_inclusive_OR_expression.BegPos;  
			    yySynAttribute.const_inclusive_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_inclusive_OR_expression.EndPos = yyAttrStackPtr [3-1].const_exclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_inclusive_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_exclusive_OR_expression.IsIntConst) {
			      yySynAttribute.const_inclusive_OR_expression.IsIntConst = true;
			      yySynAttribute.const_inclusive_OR_expression.Value = Eval_BinaryExpr(INCL_OR,
					yyAttrStackPtr [1-1].const_inclusive_OR_expression.Value,
					yyAttrStackPtr [3-1].const_exclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_inclusive_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_inclusive_OR_expression.Tree,yySynAttribute.const_inclusive_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_inclusive_OR_expression.IsIntConst = false;
			      yySynAttribute.const_inclusive_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1114: /* const_logical_AND_expression : const_inclusive_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 192; {
/* line 4329 "mpcPars.lalr" */

			  yySynAttribute.const_logical_AND_expression.Tree  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Tree;

			  yySynAttribute.const_logical_AND_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.IsIntConst;

			  yySynAttribute.const_logical_AND_expression.Value  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Value;

			  yySynAttribute.const_logical_AND_expression.Sizeof  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Sizeof;

			  yySynAttribute.const_logical_AND_expression.Ignore  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Ignore;

			  yySynAttribute.const_logical_AND_expression.Position  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.Position;

			  yySynAttribute.const_logical_AND_expression.BegPos  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.BegPos;
  
			  yySynAttribute.const_logical_AND_expression.EndPos  =  yyAttrStackPtr [1-1].const_inclusive_OR_expression.EndPos;
  
			;

} break;
case 1115: /* const_logical_AND_expression : const_logical_AND_expression '&&' const_inclusive_OR_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 192; {
/* line 4348 "mpcPars.lalr" */

			  yySynAttribute.const_logical_AND_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_AND_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_inclusive_OR_expression.Sizeof;
  
			    yySynAttribute.const_logical_AND_expression.Tree = mMPC_BinaryExpr(
					yySynAttribute.const_logical_AND_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_AND, yyAttrStackPtr [1-1].const_logical_AND_expression.Tree,
					yyAttrStackPtr [3-1].const_inclusive_OR_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_logical_AND_expression.Tree);
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_logical_AND_expression.Ignore =
							  yyAttrStackPtr [1-1].const_logical_AND_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_inclusive_OR_expression.Ignore;
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_logical_AND_expression.BegPos = yyAttrStackPtr [1-1].const_logical_AND_expression.BegPos;  
			    yySynAttribute.const_logical_AND_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_logical_AND_expression.EndPos = yyAttrStackPtr [3-1].const_inclusive_OR_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_AND_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_inclusive_OR_expression.IsIntConst) {
			      yySynAttribute.const_logical_AND_expression.IsIntConst = true;
			      yySynAttribute.const_logical_AND_expression.Value = Eval_BinaryExpr(LOG_AND,
					yyAttrStackPtr [1-1].const_logical_AND_expression.Value,
					yyAttrStackPtr [3-1].const_inclusive_OR_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_logical_AND_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_logical_AND_expression.Tree,yySynAttribute.const_logical_AND_expression.Value);
			    }
			    else {
			      yySynAttribute.const_logical_AND_expression.IsIntConst = false;
			      yySynAttribute.const_logical_AND_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1116: /* const_logical_OR_expression : const_logical_AND_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 193; {
/* line 4382 "mpcPars.lalr" */

			  yySynAttribute.const_logical_OR_expression.Tree  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Tree;

			  yySynAttribute.const_logical_OR_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_logical_AND_expression.IsIntConst;

			  yySynAttribute.const_logical_OR_expression.Value  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Value;

			  yySynAttribute.const_logical_OR_expression.Sizeof  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Sizeof;

			  yySynAttribute.const_logical_OR_expression.Ignore  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Ignore;

			  yySynAttribute.const_logical_OR_expression.Position  =  yyAttrStackPtr [1-1].const_logical_AND_expression.Position;

			  yySynAttribute.const_logical_OR_expression.BegPos  =  yyAttrStackPtr [1-1].const_logical_AND_expression.BegPos;
  
			  yySynAttribute.const_logical_OR_expression.EndPos  =  yyAttrStackPtr [1-1].const_logical_AND_expression.EndPos;
  
			;

} break;
case 1117: /* const_logical_OR_expression : const_logical_OR_expression '||' const_logical_AND_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 193; {
/* line 4401 "mpcPars.lalr" */

			  yySynAttribute.const_logical_OR_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_logical_AND_expression.Sizeof;
  
			    yySynAttribute.const_logical_OR_expression.Tree = mMPC_BinaryExpr(
					yySynAttribute.const_logical_OR_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					LOG_OR, yyAttrStackPtr [1-1].const_logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_logical_AND_expression.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_logical_OR_expression.Tree);
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_logical_OR_expression.Ignore =
							  yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore ||
							  yyAttrStackPtr [3-1].const_logical_AND_expression.Ignore;
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_logical_OR_expression.BegPos = yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;  
			    yySynAttribute.const_logical_OR_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_logical_OR_expression.EndPos = yyAttrStackPtr [3-1].const_logical_AND_expression.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_logical_AND_expression.IsIntConst) {
			      yySynAttribute.const_logical_OR_expression.IsIntConst = true;
			      yySynAttribute.const_logical_OR_expression.Value = Eval_BinaryExpr(LOG_OR,
					yyAttrStackPtr [1-1].const_logical_OR_expression.Value,
					yyAttrStackPtr [3-1].const_logical_AND_expression.Value,
					yyAttrStackPtr [2-1].Scan.Position
				      );
			      if(!yySynAttribute.const_logical_OR_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_logical_OR_expression.Tree,yySynAttribute.const_logical_OR_expression.Value);
			    }
			    else {
			      yySynAttribute.const_logical_OR_expression.IsIntConst = false;
			      yySynAttribute.const_logical_OR_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1118: /* const_conditional_expression : const_logical_OR_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 4435 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression.Tree  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Tree;

			  yySynAttribute.const_conditional_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst;

			  yySynAttribute.const_conditional_expression.Value  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Value;

			  yySynAttribute.const_conditional_expression.Sizeof  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof;

			  yySynAttribute.const_conditional_expression.Ignore  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore;

			  yySynAttribute.const_conditional_expression.Position  =  yyAttrStackPtr [1-1].const_logical_OR_expression.Position;

			  yySynAttribute.const_conditional_expression.BegPos  =  yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;
  
			  yySynAttribute.const_conditional_expression.EndPos  =  yyAttrStackPtr [1-1].const_logical_OR_expression.EndPos;
  
			;

} break;
case 1119: /* const_conditional_expression : const_logical_OR_expression '?' const_expression_opt ':' const_conditional_expression_opt .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 194; {
/* line 4454 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression.Sizeof = yyAttrStackPtr [1-1].const_logical_OR_expression.Sizeof ||
				    yyAttrStackPtr [3-1].const_expression_opt.Sizeof ||
				    yyAttrStackPtr [5-1].const_conditional_expression_opt.Sizeof;
  
			    if(yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree==NoTree)
				CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			    yySynAttribute.const_conditional_expression.Tree = mMPC_TernaryExpr(yySynAttribute.const_conditional_expression.Position=yyAttrStackPtr [2-1].Scan.Position, NoExprFlag, EmptyString,
					NoTree, NoTree, NoTree,
					CONDITION, yyAttrStackPtr [1-1].const_logical_OR_expression.Tree,
					yyAttrStackPtr [3-1].const_expression_opt.Tree,
					yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree
				   );
			    (void)Clean_OutAttributes(yySynAttribute.const_conditional_expression.Tree);
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.Flag.Ignore = yySynAttribute.const_conditional_expression.Ignore =
							yyAttrStackPtr [1-1].const_logical_OR_expression.Ignore ||
							yyAttrStackPtr [3-1].const_expression_opt.Ignore        ||
							yyAttrStackPtr [5-1].const_conditional_expression_opt.Ignore;
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.BegPos = yySynAttribute.const_conditional_expression.BegPos = yyAttrStackPtr [1-1].const_logical_OR_expression.BegPos;  
			    yySynAttribute.const_conditional_expression.Tree->MPC_Expr.EndPos = yySynAttribute.const_conditional_expression.EndPos =   
			    		(yyAttrStackPtr [5-1].const_conditional_expression_opt.Tree==NoTree)?  
						yyAttrStackPtr [4-1].Scan.Position:  
						yyAttrStackPtr [5-1].const_conditional_expression_opt.EndPos;  
			    if(yyAttrStackPtr [1-1].const_logical_OR_expression.IsIntConst &&
			       yyAttrStackPtr [3-1].const_expression_opt.IsIntConst        &&
			       yyAttrStackPtr [5-1].const_conditional_expression_opt.IsIntConst) {
			      if(yyAttrStackPtr [1-1].const_logical_OR_expression.Value)
				yySynAttribute.const_conditional_expression.Value = yyAttrStackPtr [3-1].const_expression_opt.Value;
			      else
				yySynAttribute.const_conditional_expression.Value = yyAttrStackPtr [5-1].const_conditional_expression_opt.Value;
			      if(!yySynAttribute.const_conditional_expression.Sizeof) EVAL_CONST_SUBEXPR(yySynAttribute.const_conditional_expression.Tree,yySynAttribute.const_conditional_expression.Value);
			    }
			    else {
			      yySynAttribute.const_conditional_expression.IsIntConst = false;
			      yySynAttribute.const_conditional_expression.Value = 0;
			    }
			  ;

			;

} break;
case 1120: /* const_conditional_expression_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 196; {
/* line 4494 "mpcPars.lalr" */
 yySynAttribute.const_conditional_expression_opt.Tree = NoTree;
 yySynAttribute.const_conditional_expression_opt.IsIntConst = false;
 yySynAttribute.const_conditional_expression_opt.Value = 0;
 yySynAttribute.const_conditional_expression_opt.Sizeof = false;

		    	      yySynAttribute.const_conditional_expression_opt.Ignore = false;
 yySynAttribute.const_conditional_expression_opt.EndPos = NoPosition;
 ;

} break;
case 1121: /* const_conditional_expression_opt : const_conditional_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 196; {
/* line 4503 "mpcPars.lalr" */

			  yySynAttribute.const_conditional_expression_opt.Tree  =  yyAttrStackPtr [1-1].const_conditional_expression.Tree;

			  yySynAttribute.const_conditional_expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].const_conditional_expression.IsIntConst;

			  yySynAttribute.const_conditional_expression_opt.Value  =  yyAttrStackPtr [1-1].const_conditional_expression.Value;

			  yySynAttribute.const_conditional_expression_opt.Sizeof  =  yyAttrStackPtr [1-1].const_conditional_expression.Sizeof;

			  yySynAttribute.const_conditional_expression_opt.Ignore  =  yyAttrStackPtr [1-1].const_conditional_expression.Ignore;

			  yySynAttribute.const_conditional_expression_opt.EndPos  =  yyAttrStackPtr [1-1].const_conditional_expression.EndPos;
  
			;

} break;
case 1122: /* constant_expression : const_conditional_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 197; {
/* line 4518 "mpcPars.lalr" */

			    yySynAttribute.constant_expression.Tree = yyAttrStackPtr [1-1].const_conditional_expression.Tree;
			    ExprScopeEnd();    
			  ;

			  yySynAttribute.constant_expression.IsIntConst  =  yyAttrStackPtr [1-1].const_conditional_expression.IsIntConst;

			  yySynAttribute.constant_expression.Value  =  yyAttrStackPtr [1-1].const_conditional_expression.Value;

			  yySynAttribute.constant_expression.Sizeof  =  yyAttrStackPtr [1-1].const_conditional_expression.Sizeof;

			  yySynAttribute.constant_expression.Ignore  =  yyAttrStackPtr [1-1].const_conditional_expression.Ignore;

			  yySynAttribute.constant_expression.Position  =  yyAttrStackPtr [1-1].const_conditional_expression.Position;

			  yySynAttribute.constant_expression.BegPos  =  yyAttrStackPtr [1-1].const_conditional_expression.BegPos;
  
			  yySynAttribute.constant_expression.EndPos  =  yyAttrStackPtr [1-1].const_conditional_expression.EndPos;
  
			;

} break;
case 1123: /* const_expression_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 195; {
/* line 4539 "mpcPars.lalr" */

			  yySynAttribute.const_expression_opt.Tree = NoTree;

			  yySynAttribute.const_expression_opt.IsIntConst = false;

			  yySynAttribute.const_expression_opt.Value = 0;

			  yySynAttribute.const_expression_opt.Sizeof = false;

			  yySynAttribute.const_expression_opt.Ignore = false;

			;

} break;
case 1124: /* const_expression_opt : constant_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 195; {
/* line 4552 "mpcPars.lalr" */

			  yySynAttribute.const_expression_opt.Tree  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.const_expression_opt.IsIntConst  =  yyAttrStackPtr [1-1].constant_expression.IsIntConst;

			  yySynAttribute.const_expression_opt.Value  =  yyAttrStackPtr [1-1].constant_expression.Value;

			  yySynAttribute.const_expression_opt.Sizeof  =  yyAttrStackPtr [1-1].constant_expression.Sizeof;

			  yySynAttribute.const_expression_opt.Ignore  =  yyAttrStackPtr [1-1].constant_expression.Ignore;

			;

} break;
case 1125: /* declaration : net_declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4565 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].net_declaring_list.Tree;
			    yySynAttribute.declaration.Tree->MPC_NetDecl.Flag.Ignore |= yyAttrStackPtr [1-1].net_declaring_list.Ignore;
			    yySynAttribute.declaration.Tree->MPC_NetDecl.Net = ReverseTree(yySynAttribute.declaration.Tree->MPC_NetDecl.Net);
			    yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].net_declaring_list.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].net_declaring_list.Ignore;

			;

} break;
case 1126: /* declaration : subnet_declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4577 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].subnet_declaring_list.Tree;
 yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
						yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].subnet_declaring_list.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].subnet_declaring_list.Ignore;

			;

} break;
case 1127: /* declaration : relation_declaration ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4586 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = mMPC_RelDecl(
					yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].relation_declaration.Position,  
					NoTree, NoTree, ReverseTree(yyAttrStackPtr [1-1].relation_declaration.Tree)
				   );
			    yySynAttribute.declaration.Tree->MPC_RelDecl.Relation->MPC_Relation.Prev->
				  MPC_FreeNode.Parent = yySynAttribute.declaration.Tree;
			    yySynAttribute.declaration.Tree->MPC_RelDecl.EndPos = yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].relation_declaration.Ignore;

			;

} break;
case 1128: /* declaration : net_type_declaration ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4600 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].net_type_declaration.Tree;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].net_type_declaration.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].net_type_declaration.Ignore;

			;

} break;
case 1129: /* declaration : sue_declaration_specifier ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4609 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].sue_declaration_specifier.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;

			;

} break;
case 1130: /* declaration : sue_type_specifier ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4618 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree  =  yyAttrStackPtr [1-1].sue_type_specifier.Type;
 yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].sue_type_specifier.Position;  
						yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position; ;
  
			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].sue_type_specifier.Ignore;

			;

} break;
case 1131: /* declaration : declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4627 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].declaring_list.Tree;
			    if(yySynAttribute.declaration.Tree->Kind==kMPC_Typedef)
			       yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].declaring_list.Position;  
			    else {  
			      if(yyAttrStackPtr [1-1].declaring_list.Ignore)
				yySynAttribute.declaration.Tree->MPC_VarDecl.Flag.Ignore = true;
			      yySynAttribute.declaration.Tree->MPC_VarDecl.Var = ReverseTree(yySynAttribute.declaration.Tree->MPC_VarDecl.Var);
			      yySynAttribute.declaration.Position = yySynAttribute.declaration.Tree->MPC_VarDecl.Pos = yyAttrStackPtr [1-1].declaring_list.Position;  
			      yySynAttribute.declaration.Tree->MPC_Decls.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    }
			    yySynAttribute.declaration.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].declaring_list.Ignore;

			;

} break;
case 1132: /* declaration : default_declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 199; {
/* line 4645 "mpcPars.lalr" */
  
			    yySynAttribute.declaration.Tree = yyAttrStackPtr [1-1].default_declaring_list.Tree;
			    if(yySynAttribute.declaration.Tree->Kind==kMPC_Typedef)
			      yySynAttribute.declaration.Position = yyAttrStackPtr [1-1].default_declaring_list.Position;
			    else {  
			      if(yyAttrStackPtr [1-1].default_declaring_list.Ignore)
				yySynAttribute.declaration.Tree->MPC_VarDecl.Flag.Ignore = true;
			      yySynAttribute.declaration.Tree->MPC_VarDecl.Var = ReverseTree(yySynAttribute.declaration.Tree->MPC_VarDecl.Var);
			      yySynAttribute.declaration.Position = yySynAttribute.declaration.Tree->MPC_VarDecl.Pos = yyAttrStackPtr [1-1].default_declaring_list.Position;  
			    }
			    yySynAttribute.declaration.EndPos = yySynAttribute.declaration.Tree->MPC_Decls.EndPos =  
				     CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			  yySynAttribute.declaration.Ignore  =  yyAttrStackPtr [1-1].default_declaring_list.Ignore;

			;

} break;
case 1133: /* declaration : HEADER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 199; {
/* line 4663 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree = mMPC_UncompString(NoPosition, NoTree, NoTree, yyAttrStackPtr [1-1].Scan.HEADER.SymForm);

			  yySynAttribute.declaration.Position = NoPosition;
 
			  yySynAttribute.declaration.EndPos = NoPosition;

			  yySynAttribute.declaration.Ignore = false;

			;

} break;
case 1134: /* declaration : SOURCE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 199; {
/* line 4674 "mpcPars.lalr" */

			  yySynAttribute.declaration.Tree = mMPC_UncompString(NoPosition, NoTree, NoTree, END_OF_HEADER_STRING);

			  yySynAttribute.declaration.Position = NoPosition;
 
			  yySynAttribute.declaration.EndPos = NoPosition;

			  yySynAttribute.declaration.Ignore = false;

			;

} break;
case 1135: /* net_declaring_list : single_net_declaring_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 198; {
/* line 4685 "mpcPars.lalr" */

			  yySynAttribute.net_declaring_list.Tree  =  yyAttrStackPtr [1-1].single_net_declaring_list.Tree;

			  yySynAttribute.net_declaring_list.NetType  =  yyAttrStackPtr [1-1].single_net_declaring_list.NetType;

			  yySynAttribute.net_declaring_list.Class  =  yyAttrStackPtr [1-1].single_net_declaring_list.Class;

			  yySynAttribute.net_declaring_list.Ignore  =  yyAttrStackPtr [1-1].single_net_declaring_list.Ignore;

			  yySynAttribute.net_declaring_list.Position  =  yyAttrStackPtr [1-1].single_net_declaring_list.Position;
  
			;

} break;
case 1136: /* net_declaring_list : net_declaring_list ',' net_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 198; {
/* line 4698 "mpcPars.lalr" */

			    yySynAttribute.net_declaring_list.Tree = yyAttrStackPtr [1-1].net_declaring_list.Tree;
			    yySynAttribute.net_declaring_list.NetType = yyAttrStackPtr [1-1].net_declaring_list.NetType;
			    yySynAttribute.net_declaring_list.Class = yyAttrStackPtr [1-1].net_declaring_list.Class;
			    yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net =
				   mMPC_Net(yySynAttribute.net_declaring_list.Position = yyAttrStackPtr [1-1].net_declaring_list.Position,  
					yyAttrStackPtr [3-1].net_declarator.Ident, PRAGMA_BIG,
					yyAttrStackPtr [3-1].net_declarator.Distribution,
					yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net,
					yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net,
					UNDEFINED, yySynAttribute.net_declaring_list.NetType
				   );
			    Clean_OutAttributes(yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    if(!yyAttrStackPtr [3-1].net_declarator.Ignore &&
			       yyAttrStackPtr [3-1].net_declarator.Distribution->Kind==kMPC_Subnet &&
			       yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Flexible)
			      yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Next =
				yyAttrStackPtr [3-1].net_declarator.Distribution->MPC_Subnet.Prev =
						mMPC_FreeNode(yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.net_declaring_list.Class==TYPEDEF ? Add_Ident(yyAttrStackPtr [3-1].net_declarator.Ident,NSUE_TAG,yySynAttribute.net_declaring_list.NetType)
					   : Add_Ident(yyAttrStackPtr [3-1].net_declarator.Ident,IDENT,
						yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.net_declaring_list.Ignore = yyAttrStackPtr [3-1].net_declarator.Ignore || yyAttrStackPtr [1-1].net_declaring_list.Ignore;
			    yySynAttribute.net_declaring_list.Tree->MPC_NetDecl.EndPos = yyAttrStackPtr [3-1].net_declarator.EndPos;  
			  ;

			;

} break;
case 1137: /* single_net_declaring_list : net_declaration_specifier net_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 162; {
/* line 4726 "mpcPars.lalr" */
  
			    tTree tmp;
			    yySynAttribute.single_net_declaring_list.Tree = mMPC_NetDecl(yySynAttribute.single_net_declaring_list.Position = yyAttrStackPtr [1-1].net_declaration_specifier.Position,  
					NoTree, NoTree,
					yySynAttribute.single_net_declaring_list.Class=yyAttrStackPtr [1-1].net_declaration_specifier.Class, NoDeclFlag,
					yyAttrStackPtr [1-1].net_declaration_specifier.Tree,
					NoTree
				   );
			    tmp = mMPC_FreeNode(yySynAttribute.single_net_declaring_list.Tree);
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net =
				   mMPC_Net(yyAttrStackPtr [2-1].net_declarator.Position,
					yyAttrStackPtr [2-1].net_declarator.Ident, PRAGMA_BIG,
					yyAttrStackPtr [2-1].net_declarator.Distribution, tmp, tmp,
					UNDEFINED,
					yySynAttribute.single_net_declaring_list.NetType=yyAttrStackPtr [1-1].net_declaration_specifier.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    if(!yyAttrStackPtr [2-1].net_declarator.Ignore &&
			       yyAttrStackPtr [2-1].net_declarator.Distribution->Kind==kMPC_Subnet &&
			       yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Flexible)
			      yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Next =
				yyAttrStackPtr [2-1].net_declarator.Distribution->MPC_Subnet.Prev =
						mMPC_FreeNode(yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.single_net_declaring_list.Class==TYPEDEF ? Add_Ident(yyAttrStackPtr [2-1].net_declarator.Ident,NSUE_TAG,yySynAttribute.single_net_declaring_list.NetType)
					   : Add_Ident(yyAttrStackPtr [2-1].net_declarator.Ident,IDENT,
						yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net);
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Flag.Exported = yyAttrStackPtr [1-1].net_declaration_specifier.Exported;
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Flag.Ignore = yyAttrStackPtr [1-1].net_declaration_specifier.Ignore;
			    yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.EndPos = yySynAttribute.single_net_declaring_list.Tree->MPC_NetDecl.Net->
			    		MPC_Net.EndPos = yyAttrStackPtr [2-1].net_declarator.EndPos;  
			    yySynAttribute.single_net_declaring_list.Ignore = yyAttrStackPtr [2-1].net_declarator.Ignore;
			  ;

			;

} break;
case 1138: /* net_declarator : general_identifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 4761 "mpcPars.lalr" */

			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution = HOST;

			  yySynAttribute.net_declarator.Ignore  =  yyAttrStackPtr [1-1].general_identifier.Ignore;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].general_identifier.Position;  
				   yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [1-1].general_identifier.EndPos ;
  
			;

} break;
case 1139: /* net_declarator : net_specifier general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 4772 "mpcPars.lalr" */
 
			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution  =  yyAttrStackPtr [1-1].net_specifier.Tree;

			    yySynAttribute.net_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			  ;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].net_specifier.Position;  
				   yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  ;
  
			;

} break;
case 1140: /* net_declarator : subnet_specifier general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 4784 "mpcPars.lalr" */

			  yySynAttribute.net_declarator.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			  yySynAttribute.net_declarator.Distribution  =  yyAttrStackPtr [1-1].subnet_specifier.Tree;

			    yySynAttribute.net_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			  ;
 yySynAttribute.net_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
				  yySynAttribute.net_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos; ;
  
			;

} break;
case 1141: /* net_declaration_specifier : net_type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 4796 "mpcPars.lalr" */

			  yySynAttribute.net_declaration_specifier.Tree  =  yyAttrStackPtr [1-1].net_type_specifier.Tree;

			    yySynAttribute.net_declaration_specifier.Class = Default_Class==AUTO ? AUTO : GLOBAL_STATIC ;
			  ;

			  yySynAttribute.net_declaration_specifier.Exported = yySynAttribute.net_declaration_specifier.Class==GLOBAL_STATIC ? true : false ;

			  yySynAttribute.net_declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].net_type_specifier.Ignore;

			  yySynAttribute.net_declaration_specifier.Position  =  yyAttrStackPtr [1-1].net_type_specifier.Position;

			  
			;

} break;
case 1142: /* net_declaration_specifier : storage_class net_type_specifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 208; {
/* line 4811 "mpcPars.lalr" */
 
			  yySynAttribute.net_declaration_specifier.Tree  =  yyAttrStackPtr [2-1].net_type_specifier.Tree;
  
			    yySynAttribute.net_declaration_specifier.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(yySynAttribute.net_declaration_specifier.Class==FLEXIBLE || yySynAttribute.net_declaration_specifier.Class==REGISTER ||
			       yySynAttribute.net_declaration_specifier.Class==AUTO && Default_Class!=AUTO)
			      Make_Message(
				456, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree);
		
			    else if(yySynAttribute.net_declaration_specifier.Class==STATIC)
			      yySynAttribute.net_declaration_specifier.Class = Default_Class==AUTO ? LOCAL_STATIC : GLOBAL_STATIC;
			     yySynAttribute.net_declaration_specifier.Tree->MPC_NetTypeSpecifier.Pos = yySynAttribute.net_declaration_specifier.Position = yyAttrStackPtr [1-1].storage_class.Position;  
 			  ;

			  yySynAttribute.net_declaration_specifier.Exported = false;

			  yySynAttribute.net_declaration_specifier.Ignore  =  yyAttrStackPtr [2-1].net_type_specifier.Ignore;

			  
			;

} break;
case 1143: /* net_type_specifier : net general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 211; {
/* line 4832 "mpcPars.lalr" */
  
			    tTree tmp=NoTree;
			    if(yyAttrStackPtr [2-1].general_identifier.Ident!=NoIdent &&
			       !(tmp=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG))) {
			      Make_MessageI(489 , xxError,
				yyAttrStackPtr [2-1].general_identifier.Position, xxIdent,
				(char*)&yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
			      ); 
			
			      yySynAttribute.net_type_specifier.Ignore = true;
			    }
			    yySynAttribute.net_type_specifier.Ignore = !tmp || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.net_type_specifier.Tree = mMPC_NetTypeSpecifier(
					yySynAttribute.net_type_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident, tmp, NoTree
				   );
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.ArgList = mMPC_FreeNode(yySynAttribute.net_type_specifier.Tree);
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.EndPos = yySynAttribute.net_type_specifier.EndPos =
				 CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			;

} break;
case 1144: /* net_type_specifier : net general_identifier '(' argument_expression_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 211; {
/* line 4855 "mpcPars.lalr" */
  
			    tTree tmp=NoTree;
			    if(yyAttrStackPtr [2-1].general_identifier.Ident!=NoIdent &&
			       !(tmp=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG)))
			      Make_MessageI(489 , xxError,
				yyAttrStackPtr [2-1].general_identifier.Position, xxIdent,
				(char*)&yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
			      );
			
			    yySynAttribute.net_type_specifier.Ignore = !tmp || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.net_type_specifier.Tree = mMPC_NetTypeSpecifier(yySynAttribute.net_type_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident, tmp,
					ReverseTree(yyAttrStackPtr [4-1].argument_expression_list.Tree)
				   );
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.ArgList->
					MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_type_specifier.Tree;
			    yySynAttribute.net_type_specifier.Tree->MPC_NetTypeSpecifier.EndPos = yySynAttribute.net_type_specifier.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1145: /* net_type_declaration : storage_class_opt nettype general_identifier new_scope '{' net_declaration '}' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 202; {
/* line 4876 "mpcPars.lalr" */
  
			    Close_Scope();
			    Scope_Depth--;
			    Default_Class = EXTERN;  
			    if(!(yyAttrStackPtr [1-1].storage_class_opt.Class==EXTERN ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==STATIC ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==UNDEFINED)) {
				Make_Message(457, xxError,
					     yyAttrStackPtr [1-1].storage_class_opt.Position, NoTree);
		
				yySynAttribute.net_type_declaration.Ignore = true;
			    }
			    yySynAttribute.net_type_declaration.Tree = yyAttrStackPtr [6-1].net_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Ident = yyAttrStackPtr [3-1].general_identifier.Ident;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Class = yyAttrStackPtr [1-1].storage_class_opt.Class;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Pos = yySynAttribute.net_type_declaration.Position =  
				(!Compare(yyAttrStackPtr [1-1].storage_class_opt.Position,NoPosition) )?  
				 yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].storage_class_opt.Position;  
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.EndPos = yySynAttribute.net_type_declaration.EndPos = CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.net_type_declaration.Tree);
			    yySynAttribute.net_type_declaration.Ignore = yySynAttribute.net_type_declaration.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore || yyAttrStackPtr [6-1].net_declaration.Ignore;
			  ;

			;

} break;
case 1146: /* net_type_declaration : storage_class_opt nettype general_identifier new_scope '(' topo_parameter_list ')' '{' net_declaration '}' .*/
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 202; {
/* line 4901 "mpcPars.lalr" */
  
			    Close_Scope();
			    Scope_Depth--;
			    Default_Class = EXTERN;  
			    Inside_topo_param_list = false;
			    if(!(yyAttrStackPtr [1-1].storage_class_opt.Class==EXTERN ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==STATIC ||
				yyAttrStackPtr [1-1].storage_class_opt.Class==UNDEFINED)) {
				Make_Message(457, xxError,
					     yyAttrStackPtr [1-1].storage_class_opt.Position, NoTree);
		
				yySynAttribute.net_type_declaration.Ignore = true;
			    }
			    yySynAttribute.net_type_declaration.Tree = yyAttrStackPtr [9-1].net_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Ident = yyAttrStackPtr [3-1].general_identifier.Ident;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Class = yyAttrStackPtr [1-1].storage_class_opt.Class;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.ParamList = ReverseTree(yyAttrStackPtr [6-1].topo_parameter_list.Tree);
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.ParamList->MPC_Var.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_type_declaration.Tree;
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.Pos = yySynAttribute.net_type_declaration.Position =  
				(!Compare(yyAttrStackPtr [1-1].storage_class_opt.Position,NoPosition) )?  
				yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].storage_class_opt.Position;  
			    yySynAttribute.net_type_declaration.Tree->MPC_NetType.EndPos = yySynAttribute.net_type_declaration.EndPos = CurrentPosition = yyAttrStackPtr [10-1].Scan.Position;  
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.net_type_declaration.Tree);
			    yySynAttribute.net_type_declaration.Ignore = yySynAttribute.net_type_declaration.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore ||
				     yyAttrStackPtr [6-1].topo_parameter_list.Ignore  || yyAttrStackPtr [9-1].net_declaration.Ignore;
			  ;

			;

} break;
case 1147: /* storage_class_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 213; {
/* line 4931 "mpcPars.lalr" */
 yySynAttribute.storage_class_opt.Class = UNDEFINED;
 yySynAttribute.storage_class_opt.Position = NoPosition;
  ;

} break;
case 1148: /* storage_class_opt : storage_class .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 213; {
/* line 4935 "mpcPars.lalr" */

			  yySynAttribute.storage_class_opt.Class  =  yyAttrStackPtr [1-1].storage_class.Class;

			  yySynAttribute.storage_class_opt.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  
		        ;

} break;
case 1149: /* topo_parameter_list : topo_parameter .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 215; {
/* line 4943 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    Push_Pattern(yyAttrStackPtr [1-1].topo_parameter.Type);
			    yySynAttribute.topo_parameter_list.Tree = mMPC_Var(yySynAttribute.topo_parameter_list.Position=yyAttrStackPtr [1-1].topo_parameter.Position,
					yyAttrStackPtr [1-1].topo_parameter.Ident, NoDeclFlag,
					tmp, tmp, Make_Type(),
					NO_NET, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [1-1].topo_parameter.Ident, IDENT, yySynAttribute.topo_parameter_list.Tree);
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Ignore = yySynAttribute.topo_parameter_list.Ignore = yyAttrStackPtr [1-1].topo_parameter.Ignore;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.EndPos = yySynAttribute.topo_parameter_list.EndPos = yyAttrStackPtr [1-1].topo_parameter.EndPos;  
			  ;

			;

} break;
case 1150: /* topo_parameter_list : topo_parameter_list ',' topo_parameter .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 215; {
/* line 4960 "mpcPars.lalr" */
  
			    Push_Pattern(yyAttrStackPtr [3-1].topo_parameter.Type);
			    yySynAttribute.topo_parameter_list.Tree = mMPC_Var(yySynAttribute.topo_parameter_list.Position=yyAttrStackPtr [1-1].topo_parameter_list.Position,  
					yyAttrStackPtr [3-1].topo_parameter.Ident, NoDeclFlag,
					yyAttrStackPtr [1-1].topo_parameter_list.Tree,
					yyAttrStackPtr [1-1].topo_parameter_list.Tree, Make_Type(),
					NO_NET, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [3-1].topo_parameter.Ident, IDENT, yySynAttribute.topo_parameter_list.Tree);
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.Flag.Ignore = yySynAttribute.topo_parameter_list.Ignore =
					yyAttrStackPtr [1-1].topo_parameter_list.Ignore && yyAttrStackPtr [3-1].topo_parameter.Ignore;
			    yySynAttribute.topo_parameter_list.Tree->MPC_Var.EndPos = yySynAttribute.topo_parameter_list.EndPos = yyAttrStackPtr [3-1].topo_parameter.EndPos;  
			  ;

			;

} break;
case 1151: /* topo_parameter : general_identifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 4977 "mpcPars.lalr" */

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.topo_parameter.Type = ReplConstIntType;

			  yySynAttribute.topo_parameter.Ignore  =  yyAttrStackPtr [1-1].general_identifier.Ignore;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].general_identifier.Position;

			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [1-1].general_identifier.EndPos;
  
			  ;
{  Inside_topo_param_list = true; ; }
			;

} break;
case 1152: /* topo_parameter : basic_type_name general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 216; {
/* line 4992 "mpcPars.lalr" */

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [2-1].general_identifier.Ident;

			    yySynAttribute.topo_parameter.Ignore = yyAttrStackPtr [1-1].basic_type_name.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    if(yyAttrStackPtr [1-1].basic_type_name.TypeName==INT)
			      yySynAttribute.topo_parameter.Type = ReplConstIntType;
			    else if(yyAttrStackPtr [1-1].basic_type_name.TypeName==DOUBLE || yyAttrStackPtr [1-1].basic_type_name.TypeName==FLOAT)
			      yySynAttribute.topo_parameter.Type = ReplConstDoubleType;
			    else {
			      yySynAttribute.topo_parameter.Type = ErrorType;
			      yySynAttribute.topo_parameter.Ignore = true;
			      Make_Message(458, xxError,
					   yyAttrStackPtr [1-1].basic_type_name.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].basic_type_name.Position;
  
			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [2-1].general_identifier.EndPos;
  
			  ;
{  Inside_topo_param_list = true; ; }
			;

} break;
case 1153: /* topo_parameter : topo_parameter array_abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 216; {
/* line 5017 "mpcPars.lalr" */
yySynAttribute.topo_parameter.Type = yyAttrStackPtr [1-1].topo_parameter.Type;

			  yySynAttribute.topo_parameter.Ident  =  yyAttrStackPtr [1-1].topo_parameter.Ident;

			  yySynAttribute.topo_parameter.Ignore = yyAttrStackPtr [1-1].topo_parameter.Ignore || yyAttrStackPtr [2-1].array_abstract_declarator.Ignore;

			  yySynAttribute.topo_parameter.Position  =  yyAttrStackPtr [1-1].topo_parameter.Position;
  
			  yySynAttribute.topo_parameter.EndPos  =  yyAttrStackPtr [2-1].array_abstract_declarator.EndPos;
  
			;

} break;
case 1154: /* net_declaration : coord_declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 214; {
/* line 5029 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore;
			  ;

			;

} break;
case 1155: /* net_declaration : coord_declaration parent_node_declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 214; {
/* line 5039 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [2-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1156: /* net_declaration : coord_declaration node_declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 214; {
/* line 5053 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore;
			  ;

			;

} break;
case 1157: /* net_declaration : coord_declaration node_declaration parent_node_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5067 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1158: /* net_declaration : coord_declaration link_declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 214; {
/* line 5086 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore;
			  ;

			;

} break;
case 1159: /* net_declaration : coord_declaration link_declaration parent_node_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5098 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1160: /* net_declaration : coord_declaration node_declaration link_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5115 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore;
			  ;

			;

} break;
case 1161: /* net_declaration : coord_declaration node_declaration link_declaration parent_node_declaration .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 214; {
/* line 5131 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl = 
						ReverseTree(yyAttrStackPtr [4-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].parent_node_declaration.Ignore;
			  ;

			;

} break;
case 1162: /* net_declaration : coord_declaration scheme_declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 214; {
/* line 5152 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [2-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1163: /* net_declaration : coord_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5163 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [2-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore || yyAttrStackPtr [2-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1164: /* net_declaration : coord_declaration node_declaration scheme_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5179 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore  || yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1165: /* net_declaration : coord_declaration node_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 214; {
/* line 5194 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1166: /* net_declaration : coord_declaration link_declaration scheme_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 5215 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [3-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1167: /* net_declaration : coord_declaration link_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 214; {
/* line 5229 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [2-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl =
						ReverseTree(yyAttrStackPtr [3-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].link_declaration.Ignore ||
				     yyAttrStackPtr [3-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1168: /* net_declaration : coord_declaration node_declaration link_declaration scheme_declaration .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 214; {
/* line 5248 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [4-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1169: /* net_declaration : coord_declaration node_declaration link_declaration parent_node_declaration scheme_declaration .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 214; {
/* line 5266 "mpcPars.lalr" */

			    yySynAttribute.net_declaration.Tree = nMPC_NetType();
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl = ReverseTree(yyAttrStackPtr [1-1].coord_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.CoordDecl->MPC_CoordDecl.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl  = ReverseTree(yyAttrStackPtr [2-1].node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.NodeDecl->MPC_Node.Prev->
							MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.LinkDecl  = yyAttrStackPtr [3-1].link_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl = 
						ReverseTree(yyAttrStackPtr [4-1].parent_node_declaration.Tree);
			    yySynAttribute.net_declaration.Tree->MPC_NetType.StartDecl->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.net_declaration.Tree;
			    yySynAttribute.net_declaration.Tree->MPC_NetType.SchemeDecl = yyAttrStackPtr [5-1].scheme_declaration.Tree;
			    yySynAttribute.net_declaration.Ignore = yyAttrStackPtr [1-1].coord_declaration.Ignore ||
				     yyAttrStackPtr [2-1].node_declaration.Ignore ||
				     yyAttrStackPtr [3-1].link_declaration.Ignore ||
				     yyAttrStackPtr [4-1].parent_node_declaration.Ignore ||
				     yyAttrStackPtr [5-1].scheme_declaration.Ignore;
			  ;

			;

} break;
case 1170: /* coord_declaration : coord coord_list ';' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 219; {
/* line 5289 "mpcPars.lalr" */

			    yySynAttribute.coord_declaration.Tree = yyAttrStackPtr [2-1].coord_list.Tree;
			    CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;
			  ;

			  yySynAttribute.coord_declaration.Ignore  =  yyAttrStackPtr [2-1].coord_list.Ignore;

			;

} break;
case 1171: /* coord_list : coord_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 224; {
/* line 5298 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.coord_list.Tree = mMPC_CoordDecl(yySynAttribute.coord_list.Position = yyAttrStackPtr [1-1].coord_declarator.Position,  
					yyAttrStackPtr [1-1].coord_declarator.Ident, tmp, tmp,
					yyAttrStackPtr [1-1].coord_declarator.Range
				   );
			    Add_Ident(yyAttrStackPtr [1-1].coord_declarator.Ident, IDENT, yySynAttribute.coord_list.Tree);
			    yySynAttribute.coord_list.Ignore = yyAttrStackPtr [1-1].coord_declarator.Ignore;
			    yySynAttribute.coord_list.Tree->MPC_CoordDecl.EndPos = yyAttrStackPtr [1-1].coord_declarator.EndPos;  
			  ;

			;

} break;
case 1172: /* coord_list : coord_list ',' coord_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 224; {
/* line 5312 "mpcPars.lalr" */
yySynAttribute.coord_list.Position = yyAttrStackPtr [3-1].coord_declarator.Position;

			    yySynAttribute.coord_list.Position = yyAttrStackPtr [1-1].coord_list.Position,  
			    yySynAttribute.coord_list.Tree = mMPC_CoordDecl(yyAttrStackPtr [3-1].coord_declarator.Position,  
					yyAttrStackPtr [3-1].coord_declarator.Ident, yyAttrStackPtr [1-1].coord_list.Tree,
					yyAttrStackPtr [1-1].coord_list.Tree, yyAttrStackPtr [3-1].coord_declarator.Range
				   );
			    Add_Ident(yyAttrStackPtr [3-1].coord_declarator.Ident, IDENT, yySynAttribute.coord_list.Tree);
			    yySynAttribute.coord_list.Ignore = yyAttrStackPtr [1-1].coord_list.Ignore || yyAttrStackPtr [3-1].coord_declarator.Ignore;
			    yySynAttribute.coord_list.Tree->MPC_CoordDecl.EndPos = yyAttrStackPtr [3-1].coord_declarator.EndPos;  
			  ;

			;

} break;
case 1173: /* coord_declarator : general_identifier '=' constant_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 225; {
/* line 5326 "mpcPars.lalr" */

			  yySynAttribute.coord_declarator.Ident  =  yyAttrStackPtr [1-1].general_identifier.Ident;

			  yySynAttribute.coord_declarator.Range  =  yyAttrStackPtr [3-1].constant_expression.Tree;

			    yySynAttribute.coord_declarator.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [3-1].constant_expression.Ignore;
			  ;

			  yySynAttribute.coord_declarator.Position  =  yyAttrStackPtr [1-1].general_identifier.Position;
  
			  yySynAttribute.coord_declarator.EndPos  =  yyAttrStackPtr [3-1].constant_expression.EndPos;
  
			;

} break;
case 1174: /* node_declaration : node '{' node_declaring_list '}' ';' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 221; {
/* line 5340 "mpcPars.lalr" */

			    yySynAttribute.node_declaration.Tree = yyAttrStackPtr [3-1].node_declaring_list.Tree;
			    CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;
			  ;

			  yySynAttribute.node_declaration.Ignore  =  yyAttrStackPtr [3-1].node_declaring_list.Ignore;

			;

} break;
case 1175: /* node_declaring_list : node_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 5349 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.node_declaring_list.Tree = mMPC_Node( yySynAttribute.node_declaring_list.Position = yyAttrStackPtr [1-1].node_declarator.Position, yyAttrStackPtr [1-1].node_declarator.NodeType,  
					yyAttrStackPtr [1-1].node_declarator.Dynamic ,
					tmp, tmp, yyAttrStackPtr [1-1].node_declarator.Predicate,
					yyAttrStackPtr [1-1].node_declarator.NodeQual
				   );
			    yySynAttribute.node_declaring_list.Ignore = yyAttrStackPtr [1-1].node_declarator.Ignore;
			    yySynAttribute.node_declaring_list.Tree->MPC_Node.EndPos = yyAttrStackPtr [1-1].node_declarator.EndPos;   
			  ;

			;

} break;
case 1176: /* node_declaring_list : node_declaring_list node_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 226; {
/* line 5363 "mpcPars.lalr" */
  
			    yySynAttribute.node_declaring_list.Position = yyAttrStackPtr [1-1].node_declaring_list.Position,  
			    yySynAttribute.node_declaring_list.Tree = mMPC_Node( yyAttrStackPtr [2-1].node_declarator.Position,  
					yyAttrStackPtr [2-1].node_declarator.NodeType,
					yyAttrStackPtr [2-1].node_declarator.Dynamic ,
					yyAttrStackPtr [1-1].node_declaring_list.Tree,
					yyAttrStackPtr [1-1].node_declaring_list.Tree,
					yyAttrStackPtr [2-1].node_declarator.Predicate,
					yyAttrStackPtr [2-1].node_declarator.NodeQual
				   );
			    yySynAttribute.node_declaring_list.Ignore = yyAttrStackPtr [1-1].node_declaring_list.Ignore || yyAttrStackPtr [2-1].node_declarator.Ignore;
			    yySynAttribute.node_declaring_list.Tree->MPC_Node.EndPos = yyAttrStackPtr [2-1].node_declarator.EndPos;   
			  ;

			;

} break;
case 1177: /* node_declarator : constant_expression ':' node_type_specifier ';' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 227; {
/* line 5379 "mpcPars.lalr" */

			  yySynAttribute.node_declarator.Predicate  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.node_declarator.NodeQual  =  yyAttrStackPtr [3-1].node_type_specifier.NodeQual;

			  yySynAttribute.node_declarator.NodeType  =  yyAttrStackPtr [3-1].node_type_specifier.NodeType;

			  yySynAttribute.node_declarator.Dynamic  =  yyAttrStackPtr [3-1].node_type_specifier.Dynamic;

			  yySynAttribute.node_declarator.Ignore  =  yyAttrStackPtr [1-1].constant_expression.Ignore;
 yySynAttribute.node_declarator.Position = yyAttrStackPtr [1-1].constant_expression.Position;  
						yySynAttribute.node_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1178: /* node_declarator : default ':' node_type_specifier ';' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 227; {
/* line 5394 "mpcPars.lalr" */

			  yySynAttribute.node_declarator.Predicate = NoTree;

			  yySynAttribute.node_declarator.NodeQual  =  yyAttrStackPtr [3-1].node_type_specifier.NodeQual;

			  yySynAttribute.node_declarator.NodeType  =  yyAttrStackPtr [3-1].node_type_specifier.NodeType;

			  yySynAttribute.node_declarator.Dynamic  =  yyAttrStackPtr [3-1].node_type_specifier.Dynamic;

			  yySynAttribute.node_declarator.Ignore = false;
 yySynAttribute.node_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
						yySynAttribute.node_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1179: /* node_type_specifier : void .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 5409 "mpcPars.lalr" */

			  yySynAttribute.node_type_specifier.NodeQual = NoTree;

			    yySynAttribute.node_type_specifier.NodeType = VOID_NODE;
			    CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic = false;

			;

} break;
case 1180: /* node_type_specifier : speed_specifier memory .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 228; {
/* line 5420 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = MEMORY_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1181: /* node_type_specifier : speed_specifier scalar .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 228; {
/* line 5430 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = SCALAR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1182: /* node_type_specifier : speed_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 5440 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = SCALAR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [1-1].speed_specifier.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1183: /* node_type_specifier : speed_specifier vector .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 228; {
/* line 5450 "mpcPars.lalr" */

			    yySynAttribute.node_type_specifier.NodeQual = yyAttrStackPtr [1-1].speed_specifier.Tree;
			    yySynAttribute.node_type_specifier.NodeType = VECTOR_NODE + yyAttrStackPtr [1-1].speed_specifier.NodeQual;
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;
			  ;

			  yySynAttribute.node_type_specifier.Dynamic  =  yyAttrStackPtr [1-1].speed_specifier.Dynamic;

			;

} break;
case 1184: /* speed_specifier : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 229; {
/* line 5460 "mpcPars.lalr" */
 yySynAttribute.speed_specifier.Tree = NoTree;
 yySynAttribute.speed_specifier.NodeQual = 0;
 yySynAttribute.speed_specifier.Dynamic = false;

			      yySynAttribute.speed_specifier.Position = NoPosition;

			       ;

} break;
case 1185: /* speed_specifier : fast_node_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 229; {
/* line 5468 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].fast_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual  =  yyAttrStackPtr [1-1].fast_node_specifier.NodeQual;

			  yySynAttribute.speed_specifier.Dynamic = yyAttrStackPtr [1-1].fast_node_specifier.NodeQual ? false : true;

			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].fast_node_specifier.Position;

			  
			;

} break;
case 1186: /* speed_specifier : slow_node_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 229; {
/* line 5480 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].slow_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual  =  yyAttrStackPtr [1-1].slow_node_specifier.NodeQual;

			  yySynAttribute.speed_specifier.Dynamic = yyAttrStackPtr [1-1].slow_node_specifier.NodeQual ? false : true;

			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].slow_node_specifier.Position;

			  
			;

} break;
case 1187: /* speed_specifier : bench_node_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 229; {
/* line 5492 "mpcPars.lalr" */

			  yySynAttribute.speed_specifier.Tree  =  yyAttrStackPtr [1-1].bench_node_specifier.Tree;

			  yySynAttribute.speed_specifier.NodeQual = 0;
    
			  yySynAttribute.speed_specifier.Dynamic = true;
  
			  yySynAttribute.speed_specifier.Position  =  yyAttrStackPtr [1-1].bench_node_specifier.Position;

			  
			;

} break;
case 1188: /* fast_node_specifier : fast .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 230; {
/* line 5504 "mpcPars.lalr" */
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual( 
				yySynAttribute.fast_node_specifier.Position = yySynAttribute.fast_node_specifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position,  
				 NoTree, true, 1);
			    yySynAttribute.fast_node_specifier.NodeQual = FAST;
			    yySynAttribute.fast_node_specifier.EndPos.Column += 3;  
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos;  
			  ;

			;

} break;
case 1189: /* fast_node_specifier : fast '*' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 230; {
/* line 5515 "mpcPars.lalr" */
yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [3-1].expression.Position;
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual(yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,
					yyAttrStackPtr [3-1].expression.Tree, true,
					yyAttrStackPtr [3-1].expression.Value
				   );
			    yySynAttribute.fast_node_specifier.NodeQual = FAST * yyAttrStackPtr [3-1].expression.Value;
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1190: /* fast_node_specifier : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 230; {
/* line 5527 "mpcPars.lalr" */
yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].expression.Position;
  
			    yySynAttribute.fast_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.fast_node_specifier.Position = yyAttrStackPtr [1-1].expression.BegPos,  
					yyAttrStackPtr [1-1].expression.Tree, true,
					yyAttrStackPtr [1-1].expression.Value
				   );
			    yySynAttribute.fast_node_specifier.NodeQual = FAST * yyAttrStackPtr [1-1].expression.Value;
			    yySynAttribute.fast_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.fast_node_specifier.EndPos = yyAttrStackPtr [1-1].expression.EndPos;  
			  ;

			;

} break;
case 1191: /* slow_node_specifier : slow .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 231; {
/* line 5539 "mpcPars.lalr" */
  
			    yySynAttribute.slow_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.slow_node_specifier.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position,  
					 NoTree, false, 1);
			    yySynAttribute.slow_node_specifier.NodeQual = SLOW;
			    yySynAttribute.slow_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.slow_node_specifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.slow_node_specifier.EndPos.Column += 3;  
			  ;

			;

} break;
case 1192: /* slow_node_specifier : slow '*' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 231; {
/* line 5549 "mpcPars.lalr" */
  
			    yySynAttribute.slow_node_specifier.Tree = mMPC_NodeTypeQual( yySynAttribute.slow_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					yyAttrStackPtr [3-1].expression.Tree, false,
					yyAttrStackPtr [3-1].expression.Value
				   );
			    yySynAttribute.slow_node_specifier.NodeQual = SLOW * yyAttrStackPtr [3-1].expression.Value;
			    yySynAttribute.slow_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.slow_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1193: /* bench_node_specifier : bench '*' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 232; {
/* line 5560 "mpcPars.lalr" */
  
			    yySynAttribute.bench_node_specifier.Tree = mMPC_BenchQual( yySynAttribute.bench_node_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					yyAttrStackPtr [3-1].expression.Tree,
					yyAttrStackPtr [3-1].expression.Tree->Kind==kMPC_FloatConst ?
						yyAttrStackPtr [3-1].expression.Tree->MPC_FloatConst.Value : 0.0 
				   );
			    yySynAttribute.bench_node_specifier.Tree->MPC_NodeTypeQual.EndPos = yySynAttribute.bench_node_specifier.EndPos = yyAttrStackPtr [3-1].expression.EndPos;  
			  ;

			;

} break;
case 1194: /* link_declaration : link '{' link_declaring_list '}' ';' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 222; {
/* line 5571 "mpcPars.lalr" */

			    yySynAttribute.link_declaration.Tree = mMPC_LinkDecl(yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					ReverseTree(yyAttrStackPtr [3-1].link_declaring_list.Tree)
				   );
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.LinkDeclaringList->
				  MPC_LinkDeclaringList.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    yySynAttribute.link_declaration.Ignore = yyAttrStackPtr [3-1].link_declaring_list.Ignore;
			  ;

			;

} break;
case 1195: /* link_declaration : link new_scope free_coord_list '{' link_declaring_list '}' ';' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 222; {
/* line 5583 "mpcPars.lalr" */

			    yySynAttribute.link_declaration.Tree = mMPC_LinkDecl(yyAttrStackPtr [1-1].Scan.Position, ReverseTree(yyAttrStackPtr [3-1].free_coord_list.Tree),  
					ReverseTree(yyAttrStackPtr [5-1].link_declaring_list.Tree)
				   );
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.FreeCoord->MPC_CoordDecl.Prev->
							  MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.LinkDeclaringList->
				  MPC_LinkDeclaringList.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaration.Tree;
			    yySynAttribute.link_declaration.Ignore = yyAttrStackPtr [3-1].free_coord_list.Ignore || yyAttrStackPtr [5-1].link_declaring_list.Ignore;
			    Close_Scope();
			    Scope_Depth--;
			    yySynAttribute.link_declaration.Tree->MPC_LinkDecl.EndPos = CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			;

} break;
case 1196: /* link_declaring_list : link_declaration_member .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 233; {
/* line 5599 "mpcPars.lalr" */
  
			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declaring_list.Tree = mMPC_LinkDeclaringList( yySynAttribute.link_declaring_list.Position = yyAttrStackPtr [1-1].link_declaration_member.Position,  
					yyAttrStackPtr [1-1].link_declaration_member.LinkType,
					yyAttrStackPtr [1-1].link_declaration_member.Dynamic,
					tmp, tmp,
					yyAttrStackPtr [1-1].link_declaration_member.Predicate,
					yyAttrStackPtr [1-1].link_declaration_member.LinkTypeSpec,
					ReverseTree(yyAttrStackPtr [1-1].link_declaration_member.LinkList)
				   );
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.LinkDeclarator->
				  MPC_LinkDeclarator.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaring_list.Tree;
			    yySynAttribute.link_declaring_list.Ignore = yyAttrStackPtr [1-1].link_declaration_member.Ignore;
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.EndPos = yyAttrStackPtr [1-1].link_declaration_member.EndPos;  
			  ;

			;

} break;
case 1197: /* link_declaring_list : link_declaring_list link_declaration_member .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 233; {
/* line 5618 "mpcPars.lalr" */
  
			    yySynAttribute.link_declaring_list.Position = yyAttrStackPtr [1-1].link_declaring_list.Position,  
			    yySynAttribute.link_declaring_list.Tree = mMPC_LinkDeclaringList( yyAttrStackPtr [2-1].link_declaration_member.Position,  
					yyAttrStackPtr [2-1].link_declaration_member.LinkType,
					yyAttrStackPtr [2-1].link_declaration_member.Dynamic,
					yyAttrStackPtr [1-1].link_declaring_list.Tree,
					yyAttrStackPtr [1-1].link_declaring_list.Tree,
					yyAttrStackPtr [2-1].link_declaration_member.Predicate,
					yyAttrStackPtr [2-1].link_declaration_member.LinkTypeSpec,
					ReverseTree(yyAttrStackPtr [2-1].link_declaration_member.LinkList)
				   );
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.LinkDeclarator->
				  MPC_LinkDeclarator.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declaring_list.Tree;
			    yySynAttribute.link_declaring_list.Ignore = yyAttrStackPtr [1-1].link_declaring_list.Ignore || yyAttrStackPtr [2-1].link_declaration_member.Ignore;
			    yySynAttribute.link_declaring_list.Tree->MPC_LinkDeclaringList.EndPos = yyAttrStackPtr [2-1].link_declaration_member.EndPos;  
			  ;

			;

} break;
case 1198: /* link_declaration_member : constant_expression ':' link_declarator_list ';' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 235; {
/* line 5637 "mpcPars.lalr" */

			  yySynAttribute.link_declaration_member.Predicate  =  yyAttrStackPtr [1-1].constant_expression.Tree;

			  yySynAttribute.link_declaration_member.LinkTypeSpec  =  yyAttrStackPtr [3-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declaration_member.LinkType  =  yyAttrStackPtr [3-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declaration_member.Dynamic  =  yyAttrStackPtr [3-1].link_declarator_list.Dynamic;

			  yySynAttribute.link_declaration_member.LinkList  =  yyAttrStackPtr [3-1].link_declarator_list.LinkList;
  
			    yySynAttribute.link_declaration_member.Ignore = yyAttrStackPtr [1-1].constant_expression.Ignore || yyAttrStackPtr [3-1].link_declarator_list.Ignore;
			    yySynAttribute.link_declaration_member.Position = yyAttrStackPtr [1-1].constant_expression.BegPos;  
			    yySynAttribute.link_declaration_member.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;
			  ;

			;

} break;
case 1199: /* link_declaration_member : default ':' link_declarator_list ';' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 235; {
/* line 5655 "mpcPars.lalr" */

			  yySynAttribute.link_declaration_member.Predicate = NoTree;

			  yySynAttribute.link_declaration_member.LinkTypeSpec  =  yyAttrStackPtr [3-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declaration_member.LinkType  =  yyAttrStackPtr [3-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declaration_member.Dynamic  =  yyAttrStackPtr [3-1].link_declarator_list.Dynamic;

			  yySynAttribute.link_declaration_member.LinkList  =  yyAttrStackPtr [3-1].link_declarator_list.LinkList;

			  yySynAttribute.link_declaration_member.Ignore  =  yyAttrStackPtr [3-1].link_declarator_list.Ignore;
 yySynAttribute.link_declaration_member.Position = yyAttrStackPtr [1-1].Scan.Position;  
						yySynAttribute.link_declaration_member.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position; ;
  
			;

} break;
case 1200: /* link_declarator_list : link_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 236; {
/* line 5672 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [1-1].link_declarator.Tree;
			    if(yyAttrStackPtr [1-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = tmp;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = tmp;
			  ;

			  yySynAttribute.link_declarator_list.LinkTypeSpec = NoTree;

			  yySynAttribute.link_declarator_list.LinkType = NORMAL_LINK;

			  yySynAttribute.link_declarator_list.Dynamic = false;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [1-1].link_declarator.Ignore;

			;

} break;
case 1201: /* link_declarator_list : link_type_specifier link_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 236; {
/* line 5694 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [2-1].link_declarator.Tree;
			    if(yyAttrStackPtr [2-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = tmp;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = tmp;
			  ;

			  yySynAttribute.link_declarator_list.LinkTypeSpec  = yyAttrStackPtr [1-1].link_type_specifier.Tree;

			  yySynAttribute.link_declarator_list.LinkType  =  yyAttrStackPtr [1-1].link_type_specifier.LinkType;

			  yySynAttribute.link_declarator_list.Dynamic  =  yyAttrStackPtr [1-1].link_type_specifier.Dynamic;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [1-1].link_type_specifier.Ignore || yyAttrStackPtr [2-1].link_declarator.Ignore;

			;

} break;
case 1202: /* link_declarator_list : link_declarator_list ',' link_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 236; {
/* line 5716 "mpcPars.lalr" */

			  yySynAttribute.link_declarator_list.LinkTypeSpec  =  yyAttrStackPtr [1-1].link_declarator_list.LinkTypeSpec;

			  yySynAttribute.link_declarator_list.LinkType  =  yyAttrStackPtr [1-1].link_declarator_list.LinkType;

			  yySynAttribute.link_declarator_list.Dynamic  =  yyAttrStackPtr [1-1].link_declarator_list.Dynamic;

			    yySynAttribute.link_declarator_list.LinkList = yyAttrStackPtr [3-1].link_declarator.Tree;
			    if(yyAttrStackPtr [3-1].link_declarator.Pair)
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev->MPC_LinkDeclarator.Prev = 
								yyAttrStackPtr [1-1].link_declarator_list.LinkList;
			    else
			      yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Next =
				yySynAttribute.link_declarator_list.LinkList->MPC_LinkDeclarator.Prev = yyAttrStackPtr [1-1].link_declarator_list.LinkList;
			  ;

			  yySynAttribute.link_declarator_list.Ignore  =  yyAttrStackPtr [3-1].link_declarator.Ignore;

			;

} break;
case 1203: /* link_declarator : '[' constant_expression_list ']' '->' '[' constant_expression_list ']' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 237; {
/* line 5737 "mpcPars.lalr" */

			    yySynAttribute.link_declarator.Tree = mMPC_LinkDeclarator(CurrentPosition=yyAttrStackPtr [7-1].Scan.Position,  
					NoTree, NoTree,
					ReverseTree(yyAttrStackPtr [2-1].constant_expression_list.Tree), ReverseTree(yyAttrStackPtr [6-1].constant_expression_list.Tree)
				   );
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.LeftNode->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.link_declarator.Tree;
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.link_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression_list.Ignore || yyAttrStackPtr [6-1].constant_expression_list.Ignore;
			  ;

			  yySynAttribute.link_declarator.Pair = false;

			;

} break;
case 1204: /* link_declarator : '[' constant_expression_list ']' '<->' '[' constant_expression_list ']' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 237; {
/* line 5753 "mpcPars.lalr" */

			    tTree tmp, lexp, rexp;
			    tmp  =mMPC_LinkDeclarator(CurrentPosition=yyAttrStackPtr [7-1].Scan.Position,
					NoTree, NoTree,
					lexp=ReverseTree(yyAttrStackPtr [2-1].constant_expression_list.Tree),
					rexp=ReverseTree(yyAttrStackPtr [6-1].constant_expression_list.Tree)
				   ); 
			    tmp->MPC_LinkDeclarator.LeftNode->
				  MPC_Exprs.Prev->MPC_FreeNode.Parent = tmp;
			    tmp->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    tmp->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  

			    yySynAttribute.link_declarator.Tree = mMPC_LinkDeclarator(yyAttrStackPtr [4-1].Scan.Position, tmp,
					tmp, yyAttrStackPtr [6-1].constant_expression_list.Tree, yyAttrStackPtr [2-1].constant_expression_list.Tree
				   ); 
			    yySynAttribute.link_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression_list.Ignore || yyAttrStackPtr [6-1].constant_expression_list.Ignore;
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.EndPos = yyAttrStackPtr [7-1].Scan.Position;  
			    yySynAttribute.link_declarator.Tree->MPC_LinkDeclarator.Pos = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			  yySynAttribute.link_declarator.Pair = true;

			;

} break;
case 1205: /* free_coord_list : '(' coord_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 234; {
/* line 5777 "mpcPars.lalr" */

			    yySynAttribute.free_coord_list.Tree = yyAttrStackPtr [2-1].coord_list.Tree;
			    CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;
			  ;

			  yySynAttribute.free_coord_list.Ignore  =  yyAttrStackPtr [2-1].coord_list.Ignore;

			;

} break;
case 1206: /* link_type_specifier : length '*' primary_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 238; {
/* line 5786 "mpcPars.lalr" */

			    yySynAttribute.link_type_specifier.Tree = mMPC_LinkLengthSpecifier(
					yyAttrStackPtr [1-1].Scan.Position,
					yySynAttribute.link_type_specifier.LinkType=NORMAL_LINK+yyAttrStackPtr [3-1].primary_expression.Value*LONG_LINK,
					yyAttrStackPtr [3-1].primary_expression.Tree
				   );
			    yySynAttribute.link_type_specifier.Dynamic = (yyAttrStackPtr [3-1].primary_expression.IsIntConst ? false : true);
			    yySynAttribute.link_type_specifier.Tree->MPC_LinkLengthSpecifier.EndPos = yyAttrStackPtr [3-1].primary_expression.EndPos;  
			  ;

			  yySynAttribute.link_type_specifier.Ignore  =  yyAttrStackPtr [3-1].primary_expression.Ignore;

			;

} break;
case 1207: /* parent_node_declaration : parent '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 220; {
/* line 5800 "mpcPars.lalr" */

			    yySynAttribute.parent_node_declaration.Tree = yyAttrStackPtr [3-1].constant_expression_list.Tree;
			    CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;
			  ;

			  yySynAttribute.parent_node_declaration.Ignore  =  yyAttrStackPtr [3-1].constant_expression_list.Ignore;

			;

} break;
case 1208: /* constant_expression_list : constant_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 239; {
/* line 5809 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.constant_expression_list.Tree = mMPC_Exprs(yyAttrStackPtr [1-1].constant_expression.Position,
					tmp, tmp, yyAttrStackPtr [1-1].constant_expression.Tree
				   );
			    yySynAttribute.constant_expression_list.Ignore = yyAttrStackPtr [1-1].constant_expression.Ignore;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.BegPos = yyAttrStackPtr [1-1].constant_expression.BegPos;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [1-1].constant_expression.EndPos; 
			  ;

			;

} break;
case 1209: /* constant_expression_list : constant_expression_list ',' constant_expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 239; {
/* line 5822 "mpcPars.lalr" */

			    yySynAttribute.constant_expression_list.Tree = mMPC_Exprs(yyAttrStackPtr [3-1].constant_expression.Position,
					yyAttrStackPtr [1-1].constant_expression_list.Tree,
					yyAttrStackPtr [1-1].constant_expression_list.Tree,
					yyAttrStackPtr [3-1].constant_expression.Tree
				   );
			    yySynAttribute.constant_expression_list.Ignore = yyAttrStackPtr [1-1].constant_expression_list.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.BegPos = yyAttrStackPtr [3-1].constant_expression.BegPos;
			    yySynAttribute.constant_expression_list.Tree->MPC_Exprs.EndPos = yyAttrStackPtr [3-1].constant_expression.EndPos; 
			  ;

			;

} break;
case 1210: /* subnet_declaring_list : subnet subnet_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 200; {
/* line 5836 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_declaring_list.Tree = mMPC_SubnetDecl(yySynAttribute.subnet_declaring_list.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree,
					Default_Class==AUTO ? AUTO : GLOBAL_STATIC,
					NoDeclFlag, ReverseTree(yyAttrStackPtr [2-1].subnet_list.Tree)
				   );
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Exported = Default_Class==EXTERN ;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Ignore = yySynAttribute.subnet_declaring_list.Ignore = yyAttrStackPtr [2-1].subnet_list.Ignore;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.EndPos = yyAttrStackPtr [2-1].subnet_list.EndPos;  
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Subnet->
				  MPC_Subnet.Prev->MPC_FreeNode.Parent = yySynAttribute.subnet_declaring_list.Tree;
			  ;

			;

} break;
case 1211: /* subnet_declaring_list : storage_class subnet subnet_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 200; {
/* line 5851 "mpcPars.lalr" */
  
			    tClass Class;
			    Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(Class==REGISTER || Class==TYPEDEF ||
			       Class==AUTO && Default_Class!=AUTO)
			      Make_Message(
				459, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree), yySynAttribute.subnet_declaring_list.Ignore = true;
		
			    else if(Class==STATIC)
			      Class = Default_Class==AUTO ? LOCAL_STATIC : GLOBAL_STATIC;
			    yySynAttribute.subnet_declaring_list.Tree = mMPC_SubnetDecl(yySynAttribute.subnet_declaring_list.Position = yyAttrStackPtr [1-1].storage_class.Position,    
					NoTree, NoTree, Class,
					NoDeclFlag, ReverseTree(yyAttrStackPtr [3-1].subnet_list.Tree)
				   );
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Flag.Ignore = (yySynAttribute.subnet_declaring_list.Ignore |= yyAttrStackPtr [3-1].subnet_list.Ignore);
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.Subnet->
				  MPC_Subnet.Prev->MPC_FreeNode.Parent = yySynAttribute.subnet_declaring_list.Tree;
			    yySynAttribute.subnet_declaring_list.Tree->MPC_SubnetDecl.EndPos = yyAttrStackPtr [3-1].subnet_list.EndPos;  
			  ;

			;

} break;
case 1212: /* subnet_list : subnet_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 240; {
/* line 5873 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.subnet_list.Tree = yyAttrStackPtr [1-1].subnet_declarator.Tree;
			    yySynAttribute.subnet_list.Tree->MPC_Subnet.Next = yySynAttribute.subnet_list.Tree->MPC_Subnet.Prev = tmp;
			  ;

			  yySynAttribute.subnet_list.Ignore  =  yyAttrStackPtr [1-1].subnet_declarator.Ignore;

			  yySynAttribute.subnet_list.Position  =  yyAttrStackPtr [1-1].subnet_declarator.Position;

			  yySynAttribute.subnet_list.EndPos  =  yyAttrStackPtr [1-1].subnet_declarator.EndPos;
  
			;

} break;
case 1213: /* subnet_list : subnet_list ',' subnet_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 240; {
/* line 5888 "mpcPars.lalr" */

			    yySynAttribute.subnet_list.Tree = yyAttrStackPtr [3-1].subnet_declarator.Tree;
			    yySynAttribute.subnet_list.Tree->MPC_Subnet.Next = yySynAttribute.subnet_list.Tree->MPC_Subnet.Prev = yyAttrStackPtr [1-1].subnet_list.Tree;
			    yySynAttribute.subnet_list.Ignore = yyAttrStackPtr [1-1].subnet_list.Ignore && yyAttrStackPtr [3-1].subnet_declarator.Ignore;
			  ;

			  yySynAttribute.subnet_list.Position  =  yyAttrStackPtr [1-1].subnet_list.Position;
  
			  yySynAttribute.subnet_list.EndPos  =  yyAttrStackPtr [3-1].subnet_declarator.EndPos;
  
			;

} break;
case 1214: /* subnet_declarator : subnet_specifier general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 241; {
/* line 5900 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_declarator.Tree = Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, IDENT, yyAttrStackPtr [1-1].subnet_specifier.Tree);
			    if(yyAttrStackPtr [1-1].subnet_specifier.WithPredicate) {
			      yySynAttribute.subnet_declarator.Tree->MPC_Subnet.Ident = yyAttrStackPtr [2-1].general_identifier.Ident;
			      yySynAttribute.subnet_declarator.Tree->MPC_Subnet.Flexible = false;
			    }
			    yySynAttribute.subnet_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.subnet_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    yySynAttribute.subnet_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			;

} break;
case 1215: /* subnet_specifier : '[' NETorSUBNETname ':' constant_expression ']' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 143; {
/* line 5913 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_specifier.Tree = mMPC_Subnet(
			    		yySynAttribute.subnet_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoIdent, false,
					Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT), 
					NoTree, NoTree, yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,
					yySynAttribute.subnet_specifier.Flexible=true, yyAttrStackPtr [4-1].constant_expression.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.subnet_specifier.Tree);
			    yySynAttribute.subnet_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore || yyAttrStackPtr [4-1].constant_expression.Ignore;
			    yySynAttribute.subnet_specifier.EndPos = yySynAttribute.subnet_specifier.Tree->MPC_Subnet.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			  yySynAttribute.subnet_specifier.WithPredicate = true;

			;

} break;
case 1216: /* subnet_specifier : '[' NETorSUBNETname ':' parent ']' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 143; {
/* line 5931 "mpcPars.lalr" */
  
			    yySynAttribute.subnet_specifier.Tree = Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT);
			    yySynAttribute.subnet_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.subnet_specifier.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    yySynAttribute.subnet_specifier.WithPredicate = false;
			    if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Net &&
			       yySynAttribute.subnet_specifier.Tree->MPC_Net.Topology!=PARAMETER)
			      yySynAttribute.subnet_specifier.Tree = yySynAttribute.subnet_specifier.Tree->MPC_Net.Distribution;  
			    else if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Net &&
				    yySynAttribute.subnet_specifier.Tree->MPC_Net.Topology==PARAMETER)
			      yySynAttribute.subnet_specifier.WithPredicate = true,
			      yySynAttribute.subnet_specifier.Tree = Make_ParentSubnet(yySynAttribute.subnet_specifier.Tree, yySynAttribute.subnet_specifier.Position, yySynAttribute.subnet_specifier.EndPos);  
			    else if(yySynAttribute.subnet_specifier.Tree!=NoTree && yySynAttribute.subnet_specifier.Tree->Kind==kMPC_Subnet) {
			      yySynAttribute.subnet_specifier.Ignore = true;
			      Make_Message(101, xxError, yyAttrStackPtr [2-1].Scan.Position, yySynAttribute.subnet_specifier.Tree);
					   
			    }
			    else {
			      yySynAttribute.subnet_specifier.Ignore = true;
			      Make_MessageI(102, xxError, yyAttrStackPtr [2-1].Scan.Position, xxIdent,
					    (char*)&yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident, NoTree);
					    
			    }
			    yySynAttribute.subnet_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore;
			  ;

			;

} break;
case 1217: /* relation_declaration : relation relation_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 201; {
/* line 5959 "mpcPars.lalr" */

			    yySynAttribute.relation_declaration.Tree = yyAttrStackPtr [2-1].relation_declarator.Tree;
			    yySynAttribute.relation_declaration.Tree->MPC_Relation.Next = yySynAttribute.relation_declaration.Tree->MPC_Relation.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.relation_declaration.Ignore  =  yyAttrStackPtr [2-1].relation_declarator.Ignore;

			  yySynAttribute.relation_declaration.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1218: /* relation_declaration : relation_declaration ',' relation_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 201; {
/* line 5970 "mpcPars.lalr" */

			    yySynAttribute.relation_declaration.Tree = yyAttrStackPtr [3-1].relation_declarator.Tree;
			    yySynAttribute.relation_declaration.Tree->MPC_Relation.Next =
				  yySynAttribute.relation_declaration.Tree->MPC_Relation.Prev = yyAttrStackPtr [1-1].relation_declaration.Tree;
			  ;

			  yySynAttribute.relation_declaration.Ignore  =  yyAttrStackPtr [3-1].relation_declarator.Ignore;

			  yySynAttribute.relation_declaration.Position  =  yyAttrStackPtr [1-1].relation_declaration.Position;
  
			;

} break;
case 1219: /* relation_declarator : NETorSUBNETname relational_operator NETorSUBNETname .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 242; {
/* line 5982 "mpcPars.lalr" */
  
				yySynAttribute.relation_declarator.Tree = mMPC_Relation(yyAttrStackPtr [2-1].relational_operator.Position,
					yyAttrStackPtr [2-1].relational_operator.OpCode, NoTree, NoTree,
					Find_Ident(yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ident, IDENT),
					Find_Ident(yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ident, IDENT)
				  );
			  	
				;

			  yySynAttribute.relation_declarator.Ignore = yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ignore || yyAttrStackPtr [3-1].Scan.NETorSUBNETname.Ignore ;

			;

} break;
case 1220: /* relational_operator : '==' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 5995 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = EQUAL;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1221: /* relational_operator : '!=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 5999 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = NOT_EQUAL;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1222: /* relational_operator : '>' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 6003 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = GREAT_THEN;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  ;

} break;
case 1223: /* relational_operator : '>=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 6007 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = GREAT_OR_EQ;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1224: /* relational_operator : '<' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 6011 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = LESS_THEN;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  ;

} break;
case 1225: /* relational_operator : '<=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 243; {
/* line 6015 "mpcPars.lalr" */
 yySynAttribute.relational_operator.OpCode = LESS_OR_EQ;
	yySynAttribute.relational_operator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
 ;

} break;
case 1226: /* default_declaring_list : declaration_qualifier_list declarator initializer_opt .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 206; {
/* line 6019 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
									 true : false;
			    yySynAttribute.default_declaring_list.Class =  yySynAttribute.default_declaring_list.NoClass ?
					Default_Class : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree )?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(
				mMPC_BasicType(NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const,
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile,
					  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , NO 
					), INT 
				)
			    );
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF)
			      yySynAttribute.default_declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.default_declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.default_declaring_list.Position, NoTree, NoTree, yySynAttribute.default_declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore
						), yySynAttribute.default_declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree, NoTree, NoTypeFlag,  
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [2-1].declarator.Ignore ||
							       yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1227: /* default_declaring_list : type_qualifier_list declarator initializer_opt .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 206; {
/* line 6157 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ? true : false;
			    yySynAttribute.default_declaring_list.Class =  yySynAttribute.default_declaring_list.NoClass ?
					Default_Class : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(
				mMPC_BasicType(NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
					  yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , NO 
					), INT 
				)
			    );
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF)
			      yySynAttribute.default_declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.default_declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.default_declaring_list.Position, NoTree, NoTree, yySynAttribute.default_declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].type_qualifier_list.Ignore
						), yySynAttribute.default_declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree, NoTypeFlag,  
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1228: /* default_declaring_list : default_declaring_list ',' declarator initializer_opt .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 206; {
/* line 6294 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    yySynAttribute.default_declaring_list.Tree = yyAttrStackPtr [1-1].default_declaring_list.Tree;
			    yySynAttribute.default_declaring_list.Type = yyAttrStackPtr [1-1].default_declaring_list.Type;
			    yySynAttribute.default_declaring_list.Class =  yyAttrStackPtr [1-1].default_declaring_list.Class;
			    yySynAttribute.default_declaring_list.NoClass = yyAttrStackPtr [1-1].default_declaring_list.NoClass;
			    yySynAttribute.default_declaring_list.Ignore = yyAttrStackPtr [1-1].default_declaring_list.Ignore && yyAttrStackPtr [3-1].declarator.Ignore;
			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    if(!yySynAttribute.default_declaring_list.NoClass && yySynAttribute.default_declaring_list.Class==EXTERN && yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [4-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [3-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.default_declaring_list.Position = yyAttrStackPtr [1-1].default_declaring_list.Position;  
			    yySynAttribute.default_declaring_list.EndPos = (yyAttrStackPtr [4-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [3-1].declarator.EndPos:yyAttrStackPtr [4-1].initializer_opt.EndPos;  

			    tmp = yyAttrStackPtr [1-1].default_declaring_list.Tree->MPC_VarDecl.Var;

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.default_declaring_list.Type);
			    if(yySynAttribute.default_declaring_list.Class==TYPEDEF) {
			      yySynAttribute.default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].default_declaring_list.Position, yyAttrStackPtr [1-1].default_declaring_list.Tree,  
					 yyAttrStackPtr [1-1].default_declaring_list.Tree, NoTypeFlag,
					 yyAttrStackPtr [3-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.TypedefList = YES;
					
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].default_declaring_list.Ignore ||
							       yyAttrStackPtr [3-1].declarator.Ignore;
			      if(yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [4-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [3-1].declarator.Ident),yySynAttribute.default_declaring_list.Tree);  
		
				 yySynAttribute.default_declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.default_declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.default_declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [3-1].declarator.Position, yyAttrStackPtr [3-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.default_declaring_list.Class==AUTO, yySynAttribute.default_declaring_list.Class==STATIC, yySynAttribute.default_declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN ,
						  yySynAttribute.default_declaring_list.NoClass&&yySynAttribute.default_declaring_list.Class==EXTERN || yySynAttribute.default_declaring_list.Class==EXTERN &&
							yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [3-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [3-1].declarator.Distribution,
						yyAttrStackPtr [4-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [3-1].declarator.Distribution!=NO_NET)
				yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;

			      yySynAttribute.default_declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.default_declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1229: /* declaring_list : declaration_specifier declarator initializer_opt .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 205; {
/* line 6406 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ? true : false;
			    yySynAttribute.declaring_list.Class =  yySynAttribute.declaring_list.NoClass ? Default_Class : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].declaration_specifier.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF)
			      yySynAttribute.declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.declaring_list.Position, NoTree, NoTree, yySynAttribute.declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), yySynAttribute.declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree, NoTree, NoTypeFlag,
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1230: /* declaring_list : type_specifier declarator initializer_opt .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 205; {
/* line 6531 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ? true : false;
			    yySynAttribute.declaring_list.Class =  yySynAttribute.declaring_list.NoClass ? Default_Class : yyAttrStackPtr [1-1].type_specifier.Class;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [2-1].declarator.Ignore;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [3-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [2-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].type_specifier.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [3-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [2-1].declarator.EndPos:yyAttrStackPtr [3-1].initializer_opt.EndPos;  

			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF)
			      yySynAttribute.declaring_list.Type = Make_Type();  
			    else
			      tmp = mMPC_FreeNode(
				      yySynAttribute.declaring_list.Tree = mMPC_VarDecl(
						yySynAttribute.declaring_list.Position, NoTree, NoTree, yySynAttribute.declaring_list.Class,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].type_specifier.Ignore
						), yySynAttribute.declaring_list.Type=Make_Type() , NoTree
					     )
				    );
			    NestedType_OFF(); 

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].type_specifier.Position, NoTree, NoTree, NoTypeFlag,
					 yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
							       yyAttrStackPtr [2-1].declarator.Ignore;
			      if(yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [3-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [2-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [3-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						yyAttrStackPtr [3-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1231: /* declaring_list : declaring_list ',' declarator initializer_opt .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 205; {
/* line 6656 "mpcPars.lalr" */
  
			    tTree ftype, tmp=NoTree;

			    yySynAttribute.declaring_list.Tree = yyAttrStackPtr [1-1].declaring_list.Tree;
			    yySynAttribute.declaring_list.Type = yyAttrStackPtr [1-1].declaring_list.Type;
			    yySynAttribute.declaring_list.Class =  yyAttrStackPtr [1-1].declaring_list.Class;
			    yySynAttribute.declaring_list.NoClass = yyAttrStackPtr [1-1].declaring_list.NoClass;
			    yySynAttribute.declaring_list.Ignore = yyAttrStackPtr [1-1].declaring_list.Ignore && yyAttrStackPtr [3-1].declarator.Ignore;
			    if(Opened_PrototypeScope && Scope_Depth==1)
				Default_Class = EXTERN;
			    if(!yySynAttribute.declaring_list.NoClass && yySynAttribute.declaring_list.Class==EXTERN && yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree) {
			      INIT_WarningI((476, xxWarning, yyAttrStackPtr [4-1].initializer_opt.Position,
					    xxIdent, (char *)&yyAttrStackPtr [3-1].declarator.Ident, NoTree));
		
			      
			    }
			    yySynAttribute.declaring_list.Position = yyAttrStackPtr [1-1].declaring_list.Position;  
			    yySynAttribute.declaring_list.EndPos = (yyAttrStackPtr [4-1].initializer_opt.Tree==NoTree)?  
				yyAttrStackPtr [3-1].declarator.EndPos:yyAttrStackPtr [4-1].initializer_opt.EndPos;  
			    tmp = yyAttrStackPtr [1-1].declaring_list.Tree->MPC_VarDecl.Var;

			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].declarator.Position 
				    );
			      }
			    }
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;
			    }

			    Push_Pattern(yySynAttribute.declaring_list.Type);
			    if(yySynAttribute.declaring_list.Class==TYPEDEF) {
			      yySynAttribute.declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
				       mMPC_Typedef(
					 yyAttrStackPtr [1-1].declaring_list.Position, yyAttrStackPtr [1-1].declaring_list.Tree,
					 yyAttrStackPtr [1-1].declaring_list.Tree, NoTypeFlag,
					 yyAttrStackPtr [3-1].declarator.Ident, Make_Type()
				       )
				     );
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag = yySynAttribute.declaring_list.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.TypedefList = YES;
					
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yyAttrStackPtr [1-1].declaring_list.Ignore ||
							       yyAttrStackPtr [3-1].declarator.Ignore;
			      if(yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree)  
				{Make_MessageI(460,xxError,  
					yyAttrStackPtr [4-1].initializer_opt.Position,xxIdent,  
					(char*)&(yyAttrStackPtr [3-1].declarator.Ident),yySynAttribute.declaring_list.Tree);  
		
				 yySynAttribute.declaring_list.Tree->MPC_Typedef.Flag.Ignore = yySynAttribute.declaring_list.Ignore = YES ;  
				}
			      yySynAttribute.declaring_list.Tree->MPC_Typedef.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			    else {
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [3-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [3-1].declarator.Position, yyAttrStackPtr [3-1].declarator.Ident,
						Make_DeclFlag(
						  yySynAttribute.declaring_list.Class==AUTO, yySynAttribute.declaring_list.Class==STATIC, yySynAttribute.declaring_list.Class==REGISTER,
						  NO ,
						  !yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN ,
						  yySynAttribute.declaring_list.NoClass&&yySynAttribute.declaring_list.Class==EXTERN || yySynAttribute.declaring_list.Class==EXTERN &&
							yyAttrStackPtr [4-1].initializer_opt.Tree!=NoTree ,
						  NO ,
						  NO , YES ,
						  yyAttrStackPtr [3-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [3-1].declarator.Distribution,
						yyAttrStackPtr [4-1].initializer_opt.Tree
					   )
				 );
			      if(yyAttrStackPtr [3-1].declarator.Distribution!=NO_NET)
				yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.declaring_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yySynAttribute.declaring_list.EndPos;  
			    }
			  ;

			;

} break;
case 1232: /* declaration_specifier : basic_declaration_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 248; {
/* line 6766 "mpcPars.lalr" */

			    switch(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName) {
			      case LONG_LONG:
			      case SIGNED_LONG_LONG:
			      case SIGNED_LONG_LONG_INT:
				yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.declaration_specifier.Type) = *LongLongType;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl;
				break;
			      case UNSIGNED_LONG_LONG:
			      case UNSIGNED_LONG_LONG_INT:
				yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.declaration_specifier.Type) = *UnsignedLongLongType;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile;
				yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl;
				break;
			      default:
			        yySynAttribute.declaration_specifier.Type = mMPC_BasicType(
					NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Const,
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Volatile,
					  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore
					),
					BasicTypeConstructor(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName)
				       );
			        
			    }
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].basic_declaration_specifier.EndPos;
  
			;

} break;
case 1233: /* declaration_specifier : sue_declaration_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 248; {
/* line 6812 "mpcPars.lalr" */

			    yySynAttribute.declaration_specifier.Type = yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Const;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].sue_declaration_specifier.EndPos;
  
			;

} break;
case 1234: /* declaration_specifier : typedef_declaration_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 248; {
/* line 6829 "mpcPars.lalr" */

			    yySynAttribute.declaration_specifier.Type = MakeTree(kMPC_Typedef);  
							    
			    *(yySynAttribute.declaration_specifier.Type) =  *(yyAttrStackPtr [1-1].typedef_declaration_specifier.Type);
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Const)
			      DECL_WarningI((477, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Volatile)
			      DECL_WarningI((478, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    if(yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl && yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Repl)
			      DECL_WarningI((479, xxWarning, yyAttrStackPtr [1-1].typedef_declaration_specifier.Position, xxIdent, (char*)&(yySynAttribute.declaration_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.declaration_specifier.Type));
		
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Const;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Volatile;
			    yySynAttribute.declaration_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.declaration_specifier.Class  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Class;

			  yySynAttribute.declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Ignore;

			  yySynAttribute.declaration_specifier.Position  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Position;

			  yySynAttribute.declaration_specifier.EndPos  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.EndPos;
  
			;

} break;
case 1235: /* type_specifier : basic_type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 249; {
/* line 6857 "mpcPars.lalr" */
  
			    switch(yyAttrStackPtr [1-1].basic_type_specifier.TypeName) {
			      case LONG_LONG:
			      case SIGNED_LONG_LONG:
			      case SIGNED_LONG_LONG_INT:
				yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.type_specifier.Type) = *LongLongType;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl;
				break;
			      case UNSIGNED_LONG_LONG:
			      case UNSIGNED_LONG_LONG_INT:
				yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);
				*(yySynAttribute.type_specifier.Type) = *UnsignedLongLongType;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile;
				yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl;
				break;
			      default:
			        yySynAttribute.type_specifier.Type = mMPC_BasicType(
					NoPosition, NoTree, NoTree,
					Make_TypeFlag(
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Const,
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Volatile,
					  yyAttrStackPtr [1-1].basic_type_specifier.Qual.Repl,
					  NO , NO ,
					  NO , NO , NO ,
					  YES , yyAttrStackPtr [1-1].basic_type_specifier.Ignore
					),
					BasicTypeConstructor(yyAttrStackPtr [1-1].basic_type_specifier.TypeName)
				       );
				   yySynAttribute.type_specifier.EndPos = yyAttrStackPtr [1-1].basic_type_specifier.EndPos;  
			    }
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].basic_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].basic_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;

			;

} break;
case 1236: /* type_specifier : sue_type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 249; {
/* line 6901 "mpcPars.lalr" */

			    yySynAttribute.type_specifier.Type = yyAttrStackPtr [1-1].sue_type_specifier.Type;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Const;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Volatile;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].sue_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].sue_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].sue_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;

			  yySynAttribute.type_specifier.EndPos  =  yyAttrStackPtr [1-1].sue_type_specifier.EndPos;
  
			;

} break;
case 1237: /* type_specifier : typedef_type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 249; {
/* line 6918 "mpcPars.lalr" */

			    yySynAttribute.type_specifier.Type = MakeTree(kMPC_Typedef);  
							    
			    *(yySynAttribute.type_specifier.Type) =  *(yyAttrStackPtr [1-1].typedef_type_specifier.Type);
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Const)
			      DECL_WarningI((477, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Volatile)
			      DECL_WarningI((478, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    if(yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl && yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Repl)
			      DECL_WarningI((479, xxWarning, yyAttrStackPtr [1-1].typedef_type_specifier.Position, xxIdent, (char*)&(yySynAttribute.type_specifier.Type->MPC_Typedef.TypedefName), yySynAttribute.type_specifier.Type));
		
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Const |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Const;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Volatile |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Volatile;
			    yySynAttribute.type_specifier.Type->MPC_Type.Flag.Repl |= yyAttrStackPtr [1-1].typedef_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.type_specifier.Class  =  yyAttrStackPtr [1-1].typedef_type_specifier.Class;

			  yySynAttribute.type_specifier.Ignore  =  yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;

			  yySynAttribute.type_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;

			  yySynAttribute.type_specifier.EndPos  =  yyAttrStackPtr [1-1].typedef_type_specifier.EndPos;
  
			;

} break;
case 1238: /* declaration_qualifier_list : storage_class .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 244; {
/* line 6946 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    yySynAttribute.declaration_qualifier_list.Ignore = false;
			    if(yySynAttribute.declaration_qualifier_list.Class==FLEXIBLE) {
			      yySynAttribute.declaration_qualifier_list.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [1-1].storage_class.Position,
					   NoTree);
		
			    }
			  ;

			  yySynAttribute.declaration_qualifier_list.Qual = NoQual;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [1-1].storage_class.EndPos;
  
			;

} break;
case 1239: /* declaration_qualifier_list : type_qualifier_list storage_class .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 244; {
/* line 6965 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.declaration_qualifier_list.Ignore = false;
			    if(yySynAttribute.declaration_qualifier_list.Class==FLEXIBLE) {
			      yySynAttribute.declaration_qualifier_list.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position,
					   NoTree);
		
			    }
			  ;

			  yySynAttribute.declaration_qualifier_list.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1240: /* declaration_qualifier_list : declaration_qualifier_list declaration_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 244; {
/* line 6984 "mpcPars.lalr" */

			    yySynAttribute.declaration_qualifier_list.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
				yySynAttribute.declaration_qualifier_list.Class = yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    else {
				yySynAttribute.declaration_qualifier_list.Ignore = true;
				Make_Message(462, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
					     
			    }
			    yySynAttribute.declaration_qualifier_list.Qual = JoinQualifiers(yyAttrStackPtr [1-1].declaration_qualifier_list.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.declaration_qualifier_list.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			  ;

			  yySynAttribute.declaration_qualifier_list.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.declaration_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1241: /* type_qualifier_list : type_qualifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 247; {
/* line 7004 "mpcPars.lalr" */

			  yySynAttribute.type_qualifier_list.Class = UNDEFINED;

			  yySynAttribute.type_qualifier_list.Qual  =  yyAttrStackPtr [1-1].type_qualifier.Qual;

			  yySynAttribute.type_qualifier_list.Ignore = false;

			  yySynAttribute.type_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier.Position;

			  yySynAttribute.type_qualifier_list.EndPos  =  yyAttrStackPtr [1-1].type_qualifier.EndPos;
  
			;

} break;
case 1242: /* type_qualifier_list : type_qualifier_list type_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 247; {
/* line 7017 "mpcPars.lalr" */

			  yySynAttribute.type_qualifier_list.Class = UNDEFINED;

			    yySynAttribute.type_qualifier_list.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    yySynAttribute.type_qualifier_list.Qual = JoinQualifiers(yyAttrStackPtr [1-1].type_qualifier_list.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.type_qualifier_list.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.type_qualifier_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.type_qualifier_list.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1243: /* declaration_qualifier : type_qualifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 254; {
/* line 7032 "mpcPars.lalr" */

			  yySynAttribute.declaration_qualifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier.Qual;

			  yySynAttribute.declaration_qualifier.Class = UNDEFINED;

			  yySynAttribute.declaration_qualifier.Position  =  yyAttrStackPtr [1-1].type_qualifier.Position;

			  yySynAttribute.declaration_qualifier.EndPos  =  yyAttrStackPtr [1-1].type_qualifier.EndPos;
  
			;

} break;
case 1244: /* declaration_qualifier : storage_class .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 254; {
/* line 7043 "mpcPars.lalr" */

			  yySynAttribute.declaration_qualifier.Qual = NoQual;

			    yySynAttribute.declaration_qualifier.Class = yyAttrStackPtr [1-1].storage_class.Class;
			    if(yySynAttribute.declaration_qualifier.Class==FLEXIBLE)
			      Make_Message(461, xxError, yyAttrStackPtr [1-1].storage_class.Position, NoTree);
					   
			  ;

			  yySynAttribute.declaration_qualifier.Position  =  yyAttrStackPtr [1-1].storage_class.Position;

			  yySynAttribute.declaration_qualifier.EndPos  =  yyAttrStackPtr [1-1].storage_class.EndPos;
  
			;

} break;
case 1245: /* type_qualifier : const .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 255; {
/* line 7058 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Const = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 4;  
			  ;

			;

} break;
case 1246: /* type_qualifier : volatile .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 255; {
/* line 7067 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Volatile = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 7;  
			  ;

			;

} break;
case 1247: /* type_qualifier : repl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 255; {
/* line 7076 "mpcPars.lalr" */
  
			    yySynAttribute.type_qualifier.Qual = NoQual;
			    yySynAttribute.type_qualifier.Qual.Repl = true;
			    yySynAttribute.type_qualifier.Position = yySynAttribute.type_qualifier.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.type_qualifier.EndPos.Column += 3;  
			  ;

			;

} break;
case 1248: /* basic_declaration_specifier : basic_type_specifier storage_class .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 250; {
/* line 7085 "mpcPars.lalr" */

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_specifier.TypeName;

			    yySynAttribute.basic_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    if(yySynAttribute.basic_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.basic_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].basic_type_specifier.Qual;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1249: /* basic_declaration_specifier : declaration_qualifier_list basic_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 250; {
/* line 7105 "mpcPars.lalr" */

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [2-1].basic_type_name.TypeName;

			  yySynAttribute.basic_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;

			  yySynAttribute.basic_declaration_specifier.Ignore  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1250: /* basic_declaration_specifier : basic_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 250; {
/* line 7120 "mpcPars.lalr" */

			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;
			    yySynAttribute.basic_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].basic_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.basic_declaration_specifier.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    if(yyAttrStackPtr [1-1].basic_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.basic_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else {
			      yySynAttribute.basic_declaration_specifier.Ignore = true;
			      Make_Message(
				463, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1251: /* basic_declaration_specifier : basic_declaration_specifier basic_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 250; {
/* line 7143 "mpcPars.lalr" */

			    yySynAttribute.basic_declaration_specifier.Ignore = yyAttrStackPtr [1-1].basic_declaration_specifier.Ignore;
			    if( !( yySynAttribute.basic_declaration_specifier.TypeName=BasicTypeName(yyAttrStackPtr [1-1].basic_declaration_specifier.TypeName,
							  yyAttrStackPtr [2-1].basic_type_name.TypeName) ) ) {
				yySynAttribute.basic_declaration_specifier.Ignore = true;
				Make_Message(464, xxError, yyAttrStackPtr [2-1].basic_type_name.Position, NoTree);
		
			    }
			  ;

			  yySynAttribute.basic_declaration_specifier.Class  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Class;

			  yySynAttribute.basic_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Qual;

			  yySynAttribute.basic_declaration_specifier.Position  =  yyAttrStackPtr [1-1].basic_declaration_specifier.Position;
  
			  yySynAttribute.basic_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1252: /* basic_type_specifier : basic_type_name .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 252; {
/* line 7163 "mpcPars.lalr" */

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_name.TypeName;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual = NoQual;

			  yySynAttribute.basic_type_specifier.Ignore = false;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_name.Position;

			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [1-1].basic_type_name.EndPos;
  
			;

} break;
case 1253: /* basic_type_specifier : type_qualifier_list basic_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 252; {
/* line 7178 "mpcPars.lalr" */

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [2-1].basic_type_name.TypeName;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;

			  yySynAttribute.basic_type_specifier.Ignore  =  yyAttrStackPtr [1-1].type_qualifier_list.Ignore;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1254: /* basic_type_specifier : basic_type_specifier type_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 252; {
/* line 7193 "mpcPars.lalr" */

			    yySynAttribute.basic_type_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    yySynAttribute.basic_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].basic_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.basic_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.basic_type_specifier.TypeName  =  yyAttrStackPtr [1-1].basic_type_specifier.TypeName;

			  yySynAttribute.basic_type_specifier.Class  =  yyAttrStackPtr [1-1].basic_type_specifier.Class;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
   
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
   
			;

} break;
case 1255: /* basic_type_specifier : basic_type_specifier basic_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 252; {
/* line 7210 "mpcPars.lalr" */

			    yySynAttribute.basic_type_specifier.Ignore = yyAttrStackPtr [1-1].basic_type_specifier.Ignore;
			    if( !( yySynAttribute.basic_type_specifier.TypeName=BasicTypeName(yyAttrStackPtr [1-1].basic_type_specifier.TypeName,
							  yyAttrStackPtr [2-1].basic_type_name.TypeName) ) ) {
				yySynAttribute.basic_type_specifier.Ignore = true;
				Make_Message(464, xxError, yyAttrStackPtr [2-1].basic_type_name.Position, NoTree);
					     
			    }
			  ;

			  yySynAttribute.basic_type_specifier.Class = UNDEFINED;

			  yySynAttribute.basic_type_specifier.Qual  =  yyAttrStackPtr [1-1].basic_type_specifier.Qual;

			  yySynAttribute.basic_type_specifier.Position  =  yyAttrStackPtr [1-1].basic_type_specifier.Position;
  
			  yySynAttribute.basic_type_specifier.EndPos  =  yyAttrStackPtr [2-1].basic_type_name.EndPos;
  
			;

} break;
case 1256: /* sue_declaration_specifier : sue_type_specifier storage_class .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 203; {
/* line 7230 "mpcPars.lalr" */

			  yySynAttribute.sue_declaration_specifier.Type  =  yyAttrStackPtr [1-1].sue_type_specifier.Type;

			    yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].sue_type_specifier.Ignore;
			    if(yySynAttribute.sue_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.sue_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
					   
			    }
			  ;

			  yySynAttribute.sue_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].sue_type_specifier.Qual;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1257: /* sue_declaration_specifier : declaration_qualifier_list elaborated_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 203; {
/* line 7250 "mpcPars.lalr" */

			    yySynAttribute.sue_declaration_specifier.Type = yyAttrStackPtr [2-1].elaborated_type_name.Type;
			    yySynAttribute.sue_declaration_specifier.Qual = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Const = yySynAttribute.sue_declaration_specifier.Qual.Const;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Volatile = yySynAttribute.sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Repl = yySynAttribute.sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].elaborated_type_name.Ignore;
			  ;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1258: /* sue_declaration_specifier : sue_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 203; {
/* line 7270 "mpcPars.lalr" */

			    yySynAttribute.sue_declaration_specifier.Type = yyAttrStackPtr [1-1].sue_declaration_specifier.Type;
			    yySynAttribute.sue_declaration_specifier.Ignore = yyAttrStackPtr [1-1].sue_declaration_specifier.Ignore;
			    if(yyAttrStackPtr [1-1].sue_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
			      yySynAttribute.sue_declaration_specifier.Class = yyAttrStackPtr [1-1].sue_declaration_specifier.Class;
			    else {
			      yySynAttribute.sue_declaration_specifier.Ignore = true;
			      Make_Message(
				463, xxError, yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
				
			    }
			    yySynAttribute.sue_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].sue_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual,
						  &yySynAttribute.sue_declaration_specifier.Ignore, yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Const |= yySynAttribute.sue_declaration_specifier.Qual.Const;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Volatile |= yySynAttribute.sue_declaration_specifier.Qual.Volatile;
			    yySynAttribute.sue_declaration_specifier.Type->MPC_Type.Flag.Repl |= yySynAttribute.sue_declaration_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_declaration_specifier.Position  =  yyAttrStackPtr [1-1].sue_declaration_specifier.Position;
  
			  yySynAttribute.sue_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].declaration_qualifier.EndPos;
  
			;

} break;
case 1259: /* sue_type_specifier : elaborated_type_name .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 204; {
/* line 7297 "mpcPars.lalr" */

			  yySynAttribute.sue_type_specifier.Type  =  yyAttrStackPtr [1-1].elaborated_type_name.Type;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Qual = NoQual;

			  yySynAttribute.sue_type_specifier.Ignore  =  yyAttrStackPtr [1-1].elaborated_type_name.Ignore;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].elaborated_type_name.Position;

			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [1-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1260: /* sue_type_specifier : type_qualifier_list elaborated_type_name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 204; {
/* line 7312 "mpcPars.lalr" */

			    yySynAttribute.sue_type_specifier.Type = yyAttrStackPtr [2-1].elaborated_type_name.Type;
			    yySynAttribute.sue_type_specifier.Qual = yyAttrStackPtr [1-1].type_qualifier_list.Qual;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Const = yySynAttribute.sue_type_specifier.Qual.Const;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Volatile = yySynAttribute.sue_type_specifier.Qual.Volatile;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Repl = yySynAttribute.sue_type_specifier.Qual.Repl;
			  ;

			    yySynAttribute.sue_type_specifier.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].elaborated_type_name.Ignore;
			  ;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [2-1].elaborated_type_name.EndPos;
  
			;

} break;
case 1261: /* sue_type_specifier : sue_type_specifier type_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 204; {
/* line 7331 "mpcPars.lalr" */

			    yySynAttribute.sue_type_specifier.Type = yyAttrStackPtr [1-1].sue_type_specifier.Type;
			    yySynAttribute.sue_type_specifier.Ignore = yyAttrStackPtr [1-1].sue_type_specifier.Ignore;
			    yySynAttribute.sue_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].sue_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.sue_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Const |= yySynAttribute.sue_type_specifier.Qual.Const;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Volatile |= yySynAttribute.sue_type_specifier.Qual.Volatile;
			    yySynAttribute.sue_type_specifier.Type->MPC_Type.Flag.Repl |= yySynAttribute.sue_type_specifier.Qual.Repl;
			  ;

			  yySynAttribute.sue_type_specifier.Class = UNDEFINED;

			  yySynAttribute.sue_type_specifier.Position  =  yyAttrStackPtr [1-1].sue_type_specifier.Position;
  
			  yySynAttribute.sue_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1262: /* typedef_declaration_specifier : typedef_type_specifier storage_class .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 251; {
/* line 7350 "mpcPars.lalr" */

			  yySynAttribute.typedef_declaration_specifier.Type  =  yyAttrStackPtr [1-1].typedef_type_specifier.Type;

			    yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [2-1].storage_class.Class;
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;
			    if(yySynAttribute.typedef_declaration_specifier.Class==FLEXIBLE) {
			      yySynAttribute.typedef_declaration_specifier.Ignore = true;
			      Make_Message(461, xxError, yyAttrStackPtr [2-1].storage_class.Position, NoTree);
					   
			    }
			  ;

			  yySynAttribute.typedef_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].typedef_type_specifier.Qual;

			  yySynAttribute.typedef_declaration_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;
  
			  yySynAttribute.typedef_declaration_specifier.EndPos  =  yyAttrStackPtr [2-1].storage_class.EndPos;
  
			;

} break;
case 1263: /* typedef_declaration_specifier : declaration_qualifier_list TYPEDEFname .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 251; {
/* line 7370 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ignore || yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_declaration_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_declaration_specifier.Ignore = true;
			      Make_MessageI(465,xxError, yyAttrStackPtr [2-1].Scan.Position,
					 xxIdent, (char *)&yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, NoTree);
					 
			    }
			  ;

			  yySynAttribute.typedef_declaration_specifier.Class  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class;

			  yySynAttribute.typedef_declaration_specifier.Qual  =  yyAttrStackPtr [1-1].declaration_qualifier_list.Qual;
  
			    yySynAttribute.typedef_declaration_specifier.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position;  
			    CurrentPosition = yySynAttribute.typedef_declaration_specifier.EndPos = yyAttrStackPtr [2-1].Scan.Position; 
			    yySynAttribute.typedef_declaration_specifier.EndPos.Column += yyAttrStackPtr [2-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1264: /* typedef_declaration_specifier : typedef_declaration_specifier declaration_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 251; {
/* line 7395 "mpcPars.lalr" */

			  yySynAttribute.typedef_declaration_specifier.Type  =  yyAttrStackPtr [1-1].typedef_declaration_specifier.Type;

			    if(yyAttrStackPtr [1-1].typedef_declaration_specifier.Class==UNDEFINED)
			      yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [2-1].declaration_qualifier.Class;
			    else if(yyAttrStackPtr [2-1].declaration_qualifier.Class==UNDEFINED)
			      yySynAttribute.typedef_declaration_specifier.Class = yyAttrStackPtr [1-1].typedef_declaration_specifier.Class;
			    else
			      Make_Message(466, xxError,
					   yyAttrStackPtr [2-1].declaration_qualifier.Position, NoTree);
					   
			  ;
  
			    yySynAttribute.typedef_declaration_specifier.Ignore = yyAttrStackPtr [1-1].typedef_declaration_specifier.Ignore;
			    yySynAttribute.typedef_declaration_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].typedef_declaration_specifier.Qual,
						  yyAttrStackPtr [2-1].declaration_qualifier.Qual, &yySynAttribute.typedef_declaration_specifier.Ignore,
						  yyAttrStackPtr [2-1].declaration_qualifier.Position);
			    CurrentPosition = yySynAttribute.typedef_declaration_specifier.Position = yyAttrStackPtr [1-1].typedef_declaration_specifier.Position;  
			    yySynAttribute.typedef_declaration_specifier.EndPos = yyAttrStackPtr [2-1].declaration_qualifier.EndPos;  
			  ;

			;

} break;
case 1265: /* typedef_type_specifier : TYPEDEFname .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 253; {
/* line 7418 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_type_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_type_specifier.Ignore = true;
			      Make_MessageI(467,xxError, yyAttrStackPtr [1-1].Scan.Position,
				 xxIdent, (char *)&yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident, NoTree);
				 
			    }
			  ;

			  yySynAttribute.typedef_type_specifier.Class = UNDEFINED;

			  yySynAttribute.typedef_type_specifier.Qual = NoQual;
  
			    yySynAttribute.typedef_type_specifier.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.typedef_type_specifier.EndPos = yySynAttribute.typedef_type_specifier.Position;  
			    yySynAttribute.typedef_type_specifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1266: /* typedef_type_specifier : type_qualifier_list TYPEDEFname .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 253; {
/* line 7443 "mpcPars.lalr" */

			  tTree decl;
			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ignore || yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    decl = Find_Ident(yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, IDENT);
			    if(decl!=NoTree && decl->Kind==kMPC_Typedef)
			      yySynAttribute.typedef_type_specifier.Type = decl;
			    else {
			      yySynAttribute.typedef_type_specifier.Ignore = true;
			      Make_MessageI(467,xxError, yyAttrStackPtr [2-1].Scan.Position,
				 xxIdent, (char *)&yyAttrStackPtr [2-1].Scan.TYPEDEFname.Ident, NoTree);
				 
			    }
			  ;

			  yySynAttribute.typedef_type_specifier.Class = UNDEFINED;

			  yySynAttribute.typedef_type_specifier.Qual  =  yyAttrStackPtr [1-1].type_qualifier_list.Qual;
  
			    yySynAttribute.typedef_type_specifier.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position;  
			    CurrentPosition = yySynAttribute.typedef_type_specifier.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.typedef_type_specifier.EndPos.Column += yyAttrStackPtr [2-1].Scan.TYPEDEFname.Length - 1 ;  
			  ;

			;

} break;
case 1267: /* typedef_type_specifier : typedef_type_specifier type_qualifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 253; {
/* line 7468 "mpcPars.lalr" */

			  yySynAttribute.typedef_type_specifier.Type  =  yyAttrStackPtr [1-1].typedef_type_specifier.Type;

			  yySynAttribute.typedef_type_specifier.Class  =  yyAttrStackPtr [1-1].typedef_type_specifier.Class;

			    yySynAttribute.typedef_type_specifier.Ignore = yyAttrStackPtr [1-1].typedef_type_specifier.Ignore;
			    yySynAttribute.typedef_type_specifier.Qual = JoinQualifiers(yyAttrStackPtr [1-1].typedef_type_specifier.Qual,
						  yyAttrStackPtr [2-1].type_qualifier.Qual, &yySynAttribute.typedef_type_specifier.Ignore,
						  yyAttrStackPtr [2-1].type_qualifier.Position);
			  ;

			  yySynAttribute.typedef_type_specifier.Position  =  yyAttrStackPtr [1-1].typedef_type_specifier.Position;
  
			  yySynAttribute.typedef_type_specifier.EndPos  =  yyAttrStackPtr [2-1].type_qualifier.EndPos;
  
			;

} break;
case 1268: /* storage_class : typedef .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7485 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = TYPEDEF;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 6;  
			  ;
 
			;

} break;
case 1269: /* storage_class : extern .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7494 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = EXTERN;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 5;  
			  ;

			;

} break;
case 1270: /* storage_class : static .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7503 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = STATIC;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 5;  
			  ;

			;

} break;
case 1271: /* storage_class : auto .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7512 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = AUTO;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 3;  
			  ;

			;

} break;
case 1272: /* storage_class : register .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7521 "mpcPars.lalr" */

			  yySynAttribute.storage_class.Class = REGISTER;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.storage_class.EndPos.Column += 7;  
			  ;

			;

} break;
case 1273: /* storage_class : flex .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 7530 "mpcPars.lalr" */
  
			  yySynAttribute.storage_class.Class = FLEXIBLE;
  
			    CurrentPosition = yySynAttribute.storage_class.Position = yySynAttribute.storage_class.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.storage_class.EndPos.Column += 3;  
			  ;

			;

} break;
case 1274: /* basic_type_name : xx324 void .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7539 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = VOID;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1275: /* xx324 : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 257; {
/* line 7549 "mpcPars.lalr" */
 yySynAttribute.basic_type_name.Ignore = false;
 ;

} break;
case 1276: /* basic_type_name : xx324 char .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7552 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = CHAR;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1277: /* basic_type_name : xx324 short .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7562 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = SHORT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 4;  
			  ;

			;

} break;
case 1278: /* basic_type_name : xx324 int .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7572 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = INT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 2;  
			  ;

			;

} break;
case 1279: /* basic_type_name : xx324 long .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7582 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = LONG;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 3;  
			  ;

			;

} break;
case 1280: /* basic_type_name : xx324 float .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7592 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = FLOAT;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 4;  
			  ;

			;

} break;
case 1281: /* basic_type_name : xx324 double .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7602 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = DOUBLE;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 5;  
			  ;

			;

} break;
case 1282: /* basic_type_name : xx324 signed .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7612 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = SIGNED;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 5;  
			  ;

			;

} break;
case 1283: /* basic_type_name : xx324 unsigned .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 7622 "mpcPars.lalr" */
 yySynAttribute.basic_type_name = yyAttrStackPtr [1-1].basic_type_name;

			  yySynAttribute.basic_type_name.TypeName = UNSIGNED;
  
			    CurrentPosition = yySynAttribute.basic_type_name.Position = yySynAttribute.basic_type_name.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.basic_type_name.EndPos.Column += 7;  
			  ;

			;

} break;
case 1284: /* elaborated_type_name : struct_or_union_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 256; {
/* line 7632 "mpcPars.lalr" */

			    yySynAttribute.elaborated_type_name.Type = yyAttrStackPtr [1-1].struct_or_union_specifier.Type;
			    if(Is_PrototypeScope &&
			       yySynAttribute.elaborated_type_name.Type->MPC_Type.EquivType==NoTree )
			      DECL_Warning((480, xxWarning, yyAttrStackPtr [1-1].struct_or_union_specifier.Position, NoTree));
				
			  ;

			  yySynAttribute.elaborated_type_name.Ignore  =  yyAttrStackPtr [1-1].struct_or_union_specifier.Ignore;

			  yySynAttribute.elaborated_type_name.Position  =  yyAttrStackPtr [1-1].struct_or_union_specifier.Position;

			  yySynAttribute.elaborated_type_name.EndPos  =  yyAttrStackPtr [1-1].struct_or_union_specifier.EndPos;
  
			;

} break;
case 1285: /* elaborated_type_name : enum_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 256; {
/* line 7648 "mpcPars.lalr" */

			    yySynAttribute.elaborated_type_name.Type = yyAttrStackPtr [1-1].enum_specifier.Type;
			    if(Is_PrototypeScope &&
			       yySynAttribute.elaborated_type_name.Type->MPC_Type.EquivType==NoTree )
			      DECL_Warning((481, xxWarning, yyAttrStackPtr [1-1].enum_specifier.Position, NoTree));
				
			  ;

			  yySynAttribute.elaborated_type_name.Ignore  =  yyAttrStackPtr [1-1].enum_specifier.Ignore;

			  yySynAttribute.elaborated_type_name.Position  =  yyAttrStackPtr [1-1].enum_specifier.Position;

			  yySynAttribute.elaborated_type_name.EndPos  =  yyAttrStackPtr [1-1].enum_specifier.EndPos;
  
			;

} break;
case 1286: /* struct_or_union_specifier : struct_or_union '{' struct_declaration_list '}' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 258; {
/* line 7664 "mpcPars.lalr" */
  
			    Save_SUE_Tags();
			    Close_Scope(), Scope_Depth--;
			    if(!Scope_Depth) Default_Class = EXTERN;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = NoIdent;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls =
				  ReverseTree(yyAttrStackPtr [3-1].struct_declaration_list.Tree);
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls->
				  MPC_SU_MemberDecl.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_or_union_specifier.Type;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			  yySynAttribute.struct_or_union_specifier.Ignore  =  yyAttrStackPtr [3-1].struct_declaration_list.Ignore;

			;

} break;
case 1287: /* struct_or_union_specifier : struct_or_union general_identifier '{' struct_declaration_list '}' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 258; {
/* line 7684 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ignore = yyAttrStackPtr [4-1].struct_declaration_list.Ignore;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = yyAttrStackPtr [2-1].general_identifier.Ident;
			    if((decl=Find_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.struct_or_union_specifier.Type->Kind) {
			      
			      Add_EquivType(yySynAttribute.struct_or_union_specifier.Type,decl);
			    }
			    Save_SUE_Tags();
			    Close_Scope(), Scope_Depth--;
			    Add_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG, yySynAttribute.struct_or_union_specifier.Type);
			    if(!Scope_Depth) Default_Class = EXTERN;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls = 
					ReverseTree(yyAttrStackPtr [4-1].struct_declaration_list.Tree);
			    yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.MemberDecls->
				  MPC_SU_MemberDecl.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_or_union_specifier.Type;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1288: /* struct_or_union_specifier : struct_or_union general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 258; {
/* line 7710 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.struct_or_union_specifier.Type = yyAttrStackPtr [1-1].struct_or_union.Tree;
			    yySynAttribute.struct_or_union_specifier.Ident = yySynAttribute.struct_or_union_specifier.Type->MPC_StructType.SU_Tag = yyAttrStackPtr [2-1].general_identifier.Ident;
			    if((decl=Find_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.struct_or_union_specifier.Type->Kind) {
			      Add_EquivType(yySynAttribute.struct_or_union_specifier.Type,decl);
			      Close_Scope(), Scope_Depth--;
			    }
			    else {
			      Close_Scope(), Scope_Depth--;
			      Add_Ident(yySynAttribute.struct_or_union_specifier.Ident, NSUE_TAG, yySynAttribute.struct_or_union_specifier.Type);  
			    }
			    if(!Scope_Depth) Default_Class = EXTERN;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_Type.Flag = NoTypeFlag;
			    yySynAttribute.struct_or_union_specifier.Type->MPC_DerivedType.NumberOfComponents = UNDEFINED;
			    yySynAttribute.struct_or_union_specifier.Position = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.Pos = yyAttrStackPtr [1-1].struct_or_union.Position;  
			    yySynAttribute.struct_or_union_specifier.EndPos = yySynAttribute.struct_or_union_specifier.Type->MPC_Decls.EndPos = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			  ;

			  yySynAttribute.struct_or_union_specifier.Ignore  =  yyAttrStackPtr [2-1].general_identifier.Ignore;

			;

} break;
case 1289: /* struct_or_union : struct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 7734 "mpcPars.lalr" */
 yySynAttribute.struct_or_union.Tree=nMPC_StructType(); Open_Scope(); Scope_Depth++; ;

			  yySynAttribute.struct_or_union.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1290: /* struct_or_union : union .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 7740 "mpcPars.lalr" */
 yySynAttribute.struct_or_union.Tree=nMPC_UnionType(); Open_Scope(); Scope_Depth++; ;

			  yySynAttribute.struct_or_union.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1291: /* struct_declaration_list : struct_declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 261; {
/* line 7746 "mpcPars.lalr" */

			    yySynAttribute.struct_declaration_list.Tree = mMPC_SU_MemberDecl(
					yyAttrStackPtr [1-1].struct_declaration.Position, NoTree, NoTree,
					yyAttrStackPtr [1-1].struct_declaration.Tree
				   );
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Member->
				  MPC_SU_Member.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_declaration_list.Tree;
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Next =
				  yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.EndPos = yyAttrStackPtr [1-1].struct_declaration.EndPos;  
			  ;

			  yySynAttribute.struct_declaration_list.Ignore  =  yyAttrStackPtr [1-1].struct_declaration.Ignore;

			;

} break;
case 1292: /* struct_declaration_list : struct_declaration_list struct_declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 261; {
/* line 7762 "mpcPars.lalr" */

			    yySynAttribute.struct_declaration_list.Tree = mMPC_SU_MemberDecl(
					yyAttrStackPtr [2-1].struct_declaration.Position,
					yyAttrStackPtr [1-1].struct_declaration_list.Tree,
					yyAttrStackPtr [1-1].struct_declaration_list.Tree,
					yyAttrStackPtr [2-1].struct_declaration.Tree
				   );
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.Member->
				  MPC_SU_Member.Prev->MPC_FreeNode.Parent = yySynAttribute.struct_declaration_list.Tree;
			    yySynAttribute.struct_declaration_list.Tree->MPC_SU_MemberDecl.EndPos = yyAttrStackPtr [2-1].struct_declaration.EndPos;  
			  ;

			  yySynAttribute.struct_declaration_list.Ignore = yyAttrStackPtr [1-1].struct_declaration_list.Ignore || yyAttrStackPtr [2-1].struct_declaration.Ignore;

			;

} break;
case 1293: /* struct_declaration : struct_declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 262; {
/* line 7778 "mpcPars.lalr" */

			  yySynAttribute.struct_declaration.Tree = ReverseTree(yyAttrStackPtr [1-1].struct_declaring_list.Tree);

			  yySynAttribute.struct_declaration.Ignore  =  yyAttrStackPtr [1-1].struct_declaring_list.Ignore;

			  yySynAttribute.struct_declaration.Position  =  yyAttrStackPtr [1-1].struct_declaring_list.Position;
  
			  yySynAttribute.struct_declaration.EndPos  =  yyAttrStackPtr [2-1].Scan.Position;
  
			;

} break;
case 1294: /* struct_declaration : struct_default_declaring_list ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 262; {
/* line 7789 "mpcPars.lalr" */

			  yySynAttribute.struct_declaration.Tree = ReverseTree(yyAttrStackPtr [1-1].struct_default_declaring_list.Tree);

			  yySynAttribute.struct_declaration.Ignore  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Ignore;

			  yySynAttribute.struct_declaration.Position  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Position;
  
			  yySynAttribute.struct_declaration.EndPos  =  yyAttrStackPtr [2-1].Scan.Position;
  
			;

} break;
case 1295: /* struct_default_declaring_list : type_qualifier_list struct_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 264; {
/* line 7800 "mpcPars.lalr" */

			    tTree ftype;
			    yySynAttribute.struct_default_declaring_list.Type = mMPC_BasicType(NoPosition, NoTree, NoTree, NoTypeFlag, INT);
			    yySynAttribute.struct_default_declaring_list.Type->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    yySynAttribute.struct_default_declaring_list.Type->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    NestedType_ON();
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Type = Make_Type();
			    NestedType_OFF();
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [2-1].struct_declarator.Position, yyAttrStackPtr [2-1].struct_declarator.Ident,
					yyAttrStackPtr [2-1].struct_declarator.BitFieldLength, NoTree, NoTree,
					Make_Type(), yyAttrStackPtr [2-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.Next =
				  yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [2-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_default_declaring_list.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].struct_declarator.Ignore;

			  yySynAttribute.struct_default_declaring_list.Position  =  yyAttrStackPtr [1-1].type_qualifier_list.Position;
  
			;

} break;
case 1296: /* struct_default_declaring_list : struct_default_declaring_list ',' struct_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 264; {
/* line 7862 "mpcPars.lalr" */

			    tTree ftype;
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_default_declaring_list.Type=yyAttrStackPtr [1-1].struct_default_declaring_list.Type);
			    yySynAttribute.struct_default_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [3-1].struct_declarator.Position, yyAttrStackPtr [3-1].struct_declarator.Ident,
					yyAttrStackPtr [3-1].struct_declarator.BitFieldLength,
					yyAttrStackPtr [1-1].struct_default_declaring_list.Tree,
					yyAttrStackPtr [1-1].struct_default_declaring_list.Tree,
					Make_Type(), yyAttrStackPtr [3-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_default_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [3-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_default_declaring_list.Ignore = yyAttrStackPtr [1-1].struct_default_declaring_list.Ignore ||
						yyAttrStackPtr [3-1].struct_declarator.Ignore;

			  yySynAttribute.struct_default_declaring_list.Position  =  yyAttrStackPtr [1-1].struct_default_declaring_list.Position;
  
			;

} break;
case 1297: /* struct_declaring_list : type_specifier struct_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 263; {
/* line 7917 "mpcPars.lalr" */

			    tTree ftype;
			    yySynAttribute.struct_declaring_list.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].struct_declarator.Ignore;
			    if(yyAttrStackPtr [1-1].type_specifier.Class!=UNDEFINED)
			      yySynAttribute.struct_declaring_list.Ignore = true,
			      Make_Message(468, xxError, yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
					   
			    NestedType_ON();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    yySynAttribute.struct_declaring_list.Type = Make_Type();
			    NestedType_OFF();
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [2-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_declaring_list.Type);
			    yySynAttribute.struct_declaring_list.Tree = Add_Ident(yyAttrStackPtr [2-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [2-1].struct_declarator.Position, yyAttrStackPtr [2-1].struct_declarator.Ident,
					yyAttrStackPtr [2-1].struct_declarator.BitFieldLength, NoTree, NoTree,
					Make_Type(), yyAttrStackPtr [2-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.Next =
				  yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.Prev = nMPC_FreeNode();
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [2-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_declaring_list.Position  =  yyAttrStackPtr [1-1].type_specifier.Position;
  
			;

} break;
case 1298: /* struct_declaring_list : struct_declaring_list ',' struct_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 263; {
/* line 7978 "mpcPars.lalr" */

			    tTree ftype;
			    ftype = Find_FunctionType(); 
			    if(ftype!=NoTree && ftype->Kind==kMPC_FunctionType) {
			      if(ftype->MPC_FunctionType.Kind==UNDEFINED) {
				if(ftype->MPC_FunctionType.NetParam!=NoTree &&
				   Tree_IsType(ftype->MPC_FunctionType.NetParam, kMPC_NetOrSubnet)) {
				  if(ftype->MPC_FunctionType.NetParam==COMPUTING_SPACE)
				    ftype->MPC_FunctionType.Kind = BASIC;
				  else
				    ftype->MPC_FunctionType.Kind = NETWORK;
				}
				else
				  ftype->MPC_FunctionType.Kind = NODAL;
			      }
			      if(ftype->MPC_FunctionType.NetParamType!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList!=NoTree &&
			         ftype->MPC_FunctionType.NetParamType->
					MPC_NetTypeSpecifier.ArgList->Kind==kMPC_Exprs) {
			        ftype->MPC_FunctionType.NetworkParamList =
				  Rebuild_NetworkParamList(
					ftype->MPC_FunctionType.NetParamType->
							MPC_NetTypeSpecifier.ArgList,
					ftype->MPC_FunctionType.NetParam
				  );
			        ftype->MPC_FunctionType.Flag.Ignore |=
				    CheckAndReset_NetworkParamTypes(
					ftype->MPC_FunctionType.NetworkParamList,
					ftype->MPC_FunctionType.NetParamType->
					  MPC_NetTypeSpecifier.NetType->MPC_NetType.ParamList,
					yyAttrStackPtr [3-1].struct_declarator.Position 
				    );
			      }
			    }
			    Push_Pattern(yySynAttribute.struct_declaring_list.Type=yyAttrStackPtr [1-1].struct_declaring_list.Type);
			    yySynAttribute.struct_declaring_list.Tree = Add_Ident(yyAttrStackPtr [3-1].struct_declarator.Ident, NSUE_MEMBER,
				     mMPC_SU_Member(
					yyAttrStackPtr [3-1].struct_declarator.Position, yyAttrStackPtr [3-1].struct_declarator.Ident,
					yyAttrStackPtr [3-1].struct_declarator.BitFieldLength,
					yyAttrStackPtr [1-1].struct_declaring_list.Tree, yyAttrStackPtr [1-1].struct_declaring_list.Tree,
					Make_Type(), yyAttrStackPtr [3-1].struct_declarator.BitFieldSize_Expr
				     )
				   );
			    yySynAttribute.struct_declaring_list.Tree->MPC_SU_Member.EndPos = yyAttrStackPtr [3-1].struct_declarator.EndPos;  
			  ;

			  yySynAttribute.struct_declaring_list.Ignore = yyAttrStackPtr [1-1].struct_declaring_list.Ignore ||
					yyAttrStackPtr [3-1].struct_declarator.Ignore;

			  yySynAttribute.struct_declaring_list.Position  =  yyAttrStackPtr [1-1].struct_declaring_list.Position;
  
			;

} break;
case 1299: /* struct_declarator : declarator bit_field_size_opt .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 265; {
/* line 8032 "mpcPars.lalr" */

			    yySynAttribute.struct_declarator.Ident = yyAttrStackPtr [1-1].declarator.Ident;
			    if(Opened_PrototypeScope) {
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      if(!--Scope_Depth) Default_Class = EXTERN;  
			    }
			    yySynAttribute.struct_declarator.EndPos = (yyAttrStackPtr [2-1].bit_field_size_opt.Tree==NoTree)?  
				yyAttrStackPtr [1-1].declarator.EndPos:yyAttrStackPtr [2-1].bit_field_size_opt.EndPos;  
			  ;

			  yySynAttribute.struct_declarator.BitFieldLength  =  yyAttrStackPtr [2-1].bit_field_size_opt.Length;

			  yySynAttribute.struct_declarator.BitFieldSize_Expr  =  yyAttrStackPtr [2-1].bit_field_size_opt.Tree;

			  yySynAttribute.struct_declarator.Ignore = yyAttrStackPtr [1-1].declarator.Ignore || yyAttrStackPtr [2-1].bit_field_size_opt.Ignore;

			  yySynAttribute.struct_declarator.Position  =  yyAttrStackPtr [1-1].declarator.Position;
  
			;

} break;
case 1300: /* struct_declarator : bit_field_size .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 265; {
/* line 8053 "mpcPars.lalr" */

			  yySynAttribute.struct_declarator.Ident = NoIdent;

			  yySynAttribute.struct_declarator.BitFieldLength  =  yyAttrStackPtr [1-1].bit_field_size.Length;

			  yySynAttribute.struct_declarator.BitFieldSize_Expr  =  yyAttrStackPtr [1-1].bit_field_size.Tree;

			  yySynAttribute.struct_declarator.Ignore  =  yyAttrStackPtr [1-1].bit_field_size.Ignore;

			  yySynAttribute.struct_declarator.Position  =  yyAttrStackPtr [1-1].bit_field_size.Position;

			  yySynAttribute.struct_declarator.EndPos  =  yyAttrStackPtr [1-1].bit_field_size.EndPos;
  
			;

} break;
case 1301: /* bit_field_size_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 266; {
/* line 8068 "mpcPars.lalr" */

			    
			  yySynAttribute.bit_field_size_opt.Length = UNDEFINED;

			  yySynAttribute.bit_field_size_opt.Tree = NoTree;

			  yySynAttribute.bit_field_size_opt.Ignore = false;

			    
			  yySynAttribute.bit_field_size_opt.EndPos = NoPosition;
  
			;

} break;
case 1302: /* bit_field_size_opt : bit_field_size .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 8081 "mpcPars.lalr" */

			    
			  yySynAttribute.bit_field_size_opt.Length  =  yyAttrStackPtr [1-1].bit_field_size.Length;

			  yySynAttribute.bit_field_size_opt.Tree  =  yyAttrStackPtr [1-1].bit_field_size.Tree;

			  yySynAttribute.bit_field_size_opt.Ignore  =  yyAttrStackPtr [1-1].bit_field_size.Ignore;

			    	
			  yySynAttribute.bit_field_size_opt.EndPos  =  yyAttrStackPtr [1-1].bit_field_size.EndPos;
  
			;

} break;
case 1303: /* bit_field_size : ':' constant_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 267; {
/* line 8094 "mpcPars.lalr" */

			    yySynAttribute.bit_field_size.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    yySynAttribute.bit_field_size.Tree = yyAttrStackPtr [2-1].constant_expression.Tree;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      yySynAttribute.bit_field_size.Length = yyAttrStackPtr [2-1].constant_expression.Value;
			    else
			      yySynAttribute.bit_field_size.Ignore = true,
			      Make_Message(469, xxError, yyAttrStackPtr [2-1].constant_expression.Position, yySynAttribute.bit_field_size.Tree);
					   
			  ;

			  yySynAttribute.bit_field_size.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.bit_field_size.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1304: /* enum_specifier : enum '{' enumerator_list '}' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 259; {
/* line 8111 "mpcPars.lalr" */
  
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoTypeFlag,  
					NoIdent, ReverseTree(yyAttrStackPtr [3-1].enumerator_list.Tree)
				   );
			    yySynAttribute.enum_specifier.Type->MPC_EnumType.EnumList->MPC_EnumConst.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.enum_specifier.Type;
			    yySynAttribute.enum_specifier.Type->MPC_Type.Flag.Ignore = yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [3-1].enumerator_list.Ignore;
			     yySynAttribute.enum_specifier.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1305: /* enum_specifier : enum general_identifier '{' enumerator_list '}' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 259; {
/* line 8125 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoTypeFlag,  
					yyAttrStackPtr [2-1].general_identifier.Ident, ReverseTree(yyAttrStackPtr [4-1].enumerator_list.Tree)
				   );
			    yySynAttribute.enum_specifier.Type->MPC_EnumType.EnumList->MPC_EnumConst.Prev->
							 MPC_FreeNode.Parent = yySynAttribute.enum_specifier.Type;
			    yySynAttribute.enum_specifier.Type->MPC_Type.Flag.Ignore = yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [4-1].enumerator_list.Ignore ||
									yyAttrStackPtr [2-1].general_identifier.Ignore;
			     yySynAttribute.enum_specifier.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    if((decl=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident,NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.enum_specifier.Type->Kind) {
			      
			      Add_EquivType(yySynAttribute.enum_specifier.Type,decl);
			    }
			    Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.enum_specifier.Type);
			  ;

			;

} break;
case 1306: /* enum_specifier : enum general_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 259; {
/* line 8147 "mpcPars.lalr" */
  
			    tTree decl;
			    yySynAttribute.enum_specifier.Type = mMPC_EnumType(
					yySynAttribute.enum_specifier.Position=yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, NoTypeFlag,
					yyAttrStackPtr [2-1].general_identifier.Ident, NoTree
				   );
			    yySynAttribute.enum_specifier.EndPos = yyAttrStackPtr [2-1].general_identifier.EndPos;  
			    if((decl=Find_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG))!=NoTree &&
				decl->Kind==yySynAttribute.enum_specifier.Type->Kind) {
			      Add_EquivType(yySynAttribute.enum_specifier.Type,decl);
			    }
			    else
			      Add_Ident(yyAttrStackPtr [2-1].general_identifier.Ident, NSUE_TAG, yySynAttribute.enum_specifier.Type);
			    yySynAttribute.enum_specifier.Ignore = yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.enum_specifier.Position = yyAttrStackPtr [2-1].general_identifier.Position;
			  ;

			;

} break;
case 1307: /* enumerator_list : general_identifier enumerator_value_opt .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 268; {
/* line 8167 "mpcPars.lalr" */

			    yySynAttribute.enumerator_list.Tree = mMPC_EnumConst(
					yyAttrStackPtr [1-1].general_identifier.Position, yyAttrStackPtr [1-1].general_identifier.Ident,
					yyAttrStackPtr [2-1].enumerator_value_opt.Present,
					yyAttrStackPtr [2-1].enumerator_value_opt.Value, NoTree, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [1-1].general_identifier.Ident, IDENT, yySynAttribute.enumerator_list.Tree);
			    yySynAttribute.enumerator_list.Tree->MPC_EnumConst.Next =
				  yySynAttribute.enumerator_list.Tree->MPC_EnumConst.Prev = nMPC_FreeNode();
			    yySynAttribute.enumerator_list.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [2-1].enumerator_value_opt.Ignore;
			    yySynAttribute.enumerator_list.Tree->MPC_EnumConst.EndPos =  
				 (!Compare(yyAttrStackPtr [2-1].enumerator_value_opt.EndPos,NoPosition) )?  
					yyAttrStackPtr [1-1].general_identifier.EndPos:  
					yyAttrStackPtr [2-1].enumerator_value_opt.EndPos;  
			  ;

			;

} break;
case 1308: /* enumerator_list : enumerator_list ',' general_identifier enumerator_value_opt .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 268; {
/* line 8185 "mpcPars.lalr" */
  
			    yySynAttribute.enumerator_list.Tree = mMPC_EnumConst(
					yyAttrStackPtr [3-1].general_identifier.Position, yyAttrStackPtr [3-1].general_identifier.Ident,
					yyAttrStackPtr [4-1].enumerator_value_opt.Present,
					yyAttrStackPtr [4-1].enumerator_value_opt.Value,
					yyAttrStackPtr [1-1].enumerator_list.Tree, yyAttrStackPtr [1-1].enumerator_list.Tree
				   );
			    Add_Ident(yyAttrStackPtr [3-1].general_identifier.Ident, IDENT, yySynAttribute.enumerator_list.Tree);
			    yySynAttribute.enumerator_list.Ignore = yyAttrStackPtr [1-1].enumerator_list.Ignore ||
				     yyAttrStackPtr [3-1].general_identifier.Ignore || yyAttrStackPtr [4-1].enumerator_value_opt.Ignore;
			    
			  ;

			;

} break;
case 1309: /* enumerator_value_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 269; {
/* line 8200 "mpcPars.lalr" */
 yySynAttribute.enumerator_value_opt.Present = NO;
 yySynAttribute.enumerator_value_opt.Value = UNDEFINED;
 yySynAttribute.enumerator_value_opt.Ignore = false;

		    yySynAttribute.enumerator_value_opt.EndPos = NoPosition;
  ;

} break;
case 1310: /* enumerator_value_opt : '=' constant_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 269; {
/* line 8207 "mpcPars.lalr" */

			  yySynAttribute.enumerator_value_opt.Present = YES;

			    yySynAttribute.enumerator_value_opt.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      yySynAttribute.enumerator_value_opt.Value = yyAttrStackPtr [2-1].constant_expression.Value;
			    else {
			      yySynAttribute.enumerator_value_opt.Ignore = YES;
			      Make_Message(470, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			  ;

		          yySynAttribute.enumerator_value_opt.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1311: /* parameter_type_list : nested_type_on parameter_list nested_type_off .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 271; {
/* line 8225 "mpcPars.lalr" */
 yySynAttribute.parameter_type_list.Tree = ReverseTree(yyAttrStackPtr [2-1].parameter_list.Tree); ;

			  yySynAttribute.parameter_type_list.Length  =  yyAttrStackPtr [2-1].parameter_list.Length;

			  yySynAttribute.parameter_type_list.Ignore  =  yyAttrStackPtr [2-1].parameter_list.Ignore;

			;

} break;
case 1312: /* parameter_type_list : nested_type_on parameter_list ',' '...' nested_type_off .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 271; {
/* line 8233 "mpcPars.lalr" */

			    yySynAttribute.parameter_type_list.Tree = mMPC_Ellipsis(yyAttrStackPtr [4-1].Scan.Position,
					yyAttrStackPtr [2-1].parameter_list.Tree, yyAttrStackPtr [2-1].parameter_list.Tree
				   );
			    yySynAttribute.parameter_type_list.Tree = ReverseTree(yySynAttribute.parameter_type_list.Tree);
			    yySynAttribute.parameter_type_list.Tree->MPC_Ellipsis.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			    yySynAttribute.parameter_type_list.Tree->MPC_Ellipsis.EndPos.Column += 2;  
			  ;

			  yySynAttribute.parameter_type_list.Length = yyAttrStackPtr [2-1].parameter_list.Length + 1;

			  yySynAttribute.parameter_type_list.Ignore  =  yyAttrStackPtr [2-1].parameter_list.Ignore;

			;

} break;
case 1313: /* parameter_list : parameter_declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 270; {
/* line 8248 "mpcPars.lalr" */

			    yySynAttribute.parameter_list.Tree = yyAttrStackPtr [1-1].parameter_declaration.Tree;
			    yySynAttribute.parameter_list.Tree->MPC_Decls.Next =
				yySynAttribute.parameter_list.Tree->MPC_Decls.Prev = mMPC_FreeNode(NoTree);
			    if(Opened_PrototypeScope) {  
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      Scope_Depth--;
			      if(yyAttrStackPtr [1-1].parameter_declaration.WithIdent && !IgnoreAll)
				
				Add_Ident(yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var->MPC_Var.Ident,
					  IDENT, yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var);
			      IgnoreAll = false;
			    }
			  ;

			  yySynAttribute.parameter_list.Length = 1;

			  yySynAttribute.parameter_list.Ignore  =  yyAttrStackPtr [1-1].parameter_declaration.Ignore;

			;

} break;
case 1314: /* parameter_list : parameter_list ',' parameter_declaration .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 270; {
/* line 8270 "mpcPars.lalr" */

			    yySynAttribute.parameter_list.Tree = yyAttrStackPtr [3-1].parameter_declaration.Tree;
			    yySynAttribute.parameter_list.Tree->MPC_Decls.Next =
				yySynAttribute.parameter_list.Tree->MPC_Decls.Prev = yyAttrStackPtr [1-1].parameter_list.Tree;
			    if(Opened_PrototypeScope) {  
			      Close_Scope();
			      Opened_PrototypeScope = false;
			      Scope_Depth--;
			      if(yyAttrStackPtr [3-1].parameter_declaration.WithIdent && !IgnoreAll)
				
				Add_Ident(yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var->MPC_Var.Ident,
					  IDENT, yySynAttribute.parameter_list.Tree->MPC_VarDecl.Var);
			      IgnoreAll = false;
			    }
			  ;

			  yySynAttribute.parameter_list.Length = yyAttrStackPtr [1-1].parameter_list.Length + 1;

			  yySynAttribute.parameter_list.Ignore = yyAttrStackPtr [1-1].parameter_list.Ignore && yyAttrStackPtr [3-1].parameter_declaration.Ignore;

			;

} break;
case 1315: /* parameter_declaration : declaration_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 272; {
/* line 8292 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].declaration_specifier.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1316: /* parameter_declaration : declaration_specifier abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8325 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1317: /* parameter_declaration : declaration_specifier declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8359 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [1-1].declaration_specifier.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      NestedType_OFF(); 
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  

			      Push_Pattern(yyAttrStackPtr [1-1].declaration_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			    } 
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1318: /* parameter_declaration : declaration_qualifier_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 272; {
/* line 8426 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile =yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].declaration_qualifier_list.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1319: /* parameter_declaration : declaration_qualifier_list abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8462 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile =yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1320: /* parameter_declaration : declaration_qualifier_list declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8499 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].declaration_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].declaration_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile =
					yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree, NoTree,
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile =
					yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].declaration_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.DeclSpecifier);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1321: /* parameter_declaration : type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 272; {
/* line 8573 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].type_specifier.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1322: /* parameter_declaration : type_specifier abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8606 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1323: /* parameter_declaration : type_specifier declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8639 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_specifier.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_specifier.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_specifier.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].type_specifier.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_specifier.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1324: /* parameter_declaration : type_qualifier_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 272; {
/* line 8705 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type(), NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].type_qualifier_list.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1325: /* parameter_declaration : type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8741 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
				     yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    Push_Pattern(tmp = CopyTree(IntType));
			    tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var = tmp;
			    yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = false;

			;

} break;
case 1326: /* parameter_declaration : type_qualifier_list declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 272; {
/* line 8778 "mpcPars.lalr" */

			    tTree tmp;
			    tClass Class;
			    yySynAttribute.parameter_declaration.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    Class =  yyAttrStackPtr [1-1].type_qualifier_list.Class==UNDEFINED ?
				     AUTO : yyAttrStackPtr [1-1].type_qualifier_list.Class;
			    if(Class!=AUTO && Class!=REGISTER && Class!=TYPEDEF) {
			      yySynAttribute.parameter_declaration.Ignore = true;
			      Make_Message(471, xxError,
				 yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree);
				 
			    }
			    if(Class==TYPEDEF) {
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			      yySynAttribute.parameter_declaration.Tree = mMPC_Typedef(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,  
					NoTypeFlag, yyAttrStackPtr [2-1].declarator.Ident, Make_Type()
				     );
			      Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT, yySynAttribute.parameter_declaration.Tree);
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag = yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Type->MPC_Type.Flag;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.Flag.Ignore |= yySynAttribute.parameter_declaration.Ignore;
			      yySynAttribute.parameter_declaration.Tree->MPC_Typedef.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			    else {
			      NestedType_ON();
			      Push_Pattern(tmp = CopyTree(IntType));
			      tmp->MPC_Type.Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			      tmp->MPC_Type.Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			      tmp->MPC_Type.Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			      tmp = mMPC_FreeNode(
				    yySynAttribute.parameter_declaration.Tree = mMPC_VarDecl(
						yyAttrStackPtr [1-1].type_qualifier_list.Position,
						NoTree, NoTree, Class,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES , yySynAttribute.parameter_declaration.Ignore
						), Make_Type() , NoTree
					   )
				  );
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			      NestedType_OFF(); 

			      Push_Pattern(yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.DeclSpecifier);
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var =
				 Add_Ident(yyAttrStackPtr [2-1].declarator.Ident, IDENT,
					   mMPC_Var(
						yyAttrStackPtr [2-1].declarator.Position, yyAttrStackPtr [2-1].declarator.Ident,
						Make_DeclFlag(
						  Class==AUTO, NO , Class==REGISTER,
						  YES , NO ,
						  NO , NO ,
						  NO , YES ,
						  yyAttrStackPtr [2-1].declarator.Ignore
						), tmp , tmp ,
						Make_Type(), yyAttrStackPtr [2-1].declarator.Distribution,
						NoTree 
					   )
				 );
			      if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
				yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.Var->MPC_Var.Flag.ExplDistr = YES;
			      yySynAttribute.parameter_declaration.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			    }
			  ;

			  yySynAttribute.parameter_declaration.WithIdent = true;

			;

} break;
case 1327: /* identifier_list : IDENTIFIER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 274; {
/* line 8850 "mpcPars.lalr" */

			    tTree tmp;
			    tmp = mMPC_FreeNode(NoTree);
			    yySynAttribute.identifier_list.Tree = mMPC_VarDecl(yySynAttribute.identifier_list.Position=yyAttrStackPtr [1-1].Scan.Position,
					tmp, tmp, AUTO, NoDeclFlag, IntType, NoTree
				   );
			    tmp = mMPC_FreeNode(yySynAttribute.identifier_list.Tree);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var =
				   mMPC_Var(yySynAttribute.identifier_list.Position,
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, NoDeclFlag,
					tmp, tmp, IntType,
					NO_NET, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident, IDENT, yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Ignore = yySynAttribute.identifier_list.Ignore =
					yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.identifier_list.Length = 1;

			;

} break;
case 1328: /* identifier_list : identifier_list ',' IDENTIFIER .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 274; {
/* line 8877 "mpcPars.lalr" */

			    tTree tmp;
			    yySynAttribute.identifier_list.Tree = mMPC_VarDecl(yyAttrStackPtr [1-1].identifier_list.Position,
					yyAttrStackPtr [1-1].identifier_list.Tree,
					yyAttrStackPtr [1-1].identifier_list.Tree,
					AUTO, NoDeclFlag, IntType, NoTree
				   );
			    yySynAttribute.identifier_list.Position=yyAttrStackPtr [3-1].Scan.Position;
			    tmp = mMPC_FreeNode(yySynAttribute.identifier_list.Tree);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var =
				   mMPC_Var(yySynAttribute.identifier_list.Position,
					yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident, NoDeclFlag,
					tmp, tmp, IntType,
					NO_NET, NoTree
				   );
			    Add_Ident(yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ident, IDENT, yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var);
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Parameter = YES;
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.EndPos.Column += yyAttrStackPtr [3-1].Scan.IDENTIFIER.Length - 1 ;  
			    yySynAttribute.identifier_list.Tree->MPC_VarDecl.Var->MPC_Var.Flag.Ignore = yySynAttribute.identifier_list.Ignore =
					yyAttrStackPtr [1-1].identifier_list.Ignore && yyAttrStackPtr [3-1].Scan.IDENTIFIER.Ignore;
			  ;

			  yySynAttribute.identifier_list.Length = yyAttrStackPtr [1-1].identifier_list.Length + 1;

			;

} break;
case 1329: /* type_name : type_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 158; {
/* line 8906 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			 
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			  yySynAttribute.type_name.Ignore  =  yyAttrStackPtr [1-1].type_specifier.Ignore;

			;

} break;
case 1330: /* type_name : type_specifier abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 158; {
/* line 8917 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(yyAttrStackPtr [1-1].type_specifier.Type);
			 
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			    yySynAttribute.type_name.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
					yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			  ;

			;

} break;
case 1331: /* type_name : type_qualifier_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 158; {
/* line 8930 "mpcPars.lalr" */

			    Push_Pattern(
				mMPC_BasicType(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,
					Make_TypeFlag(yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl, NO,
						NO, NO, NO,
						NO, YES, NO
					), INT
				)
			    );
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			  yySynAttribute.type_name.Ignore  =  yyAttrStackPtr [1-1].type_qualifier_list.Ignore;

			;

} break;
case 1332: /* type_name : type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 158; {
/* line 8948 "mpcPars.lalr" */

			    Try_ExprScopeBegin();
			    Push_Pattern(
				mMPC_BasicType(yyAttrStackPtr [1-1].type_qualifier_list.Position, NoTree, NoTree,
					Make_TypeFlag(yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl, NO,
						NO, NO, NO,
						NO, YES, NO
					), INT
				)
			    );
			    yySynAttribute.type_name.Type = Make_Type();
			  ;

			    yySynAttribute.type_name.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
					yyAttrStackPtr [2-1].abstract_declarator.Ignore;
			  ;

			;

} break;
case 1333: /* initializer_opt : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 246; {
/* line 8969 "mpcPars.lalr" */

			  yySynAttribute.initializer_opt.Tree = NoTree;

			  yySynAttribute.initializer_opt.Position = NoPosition;

			  yySynAttribute.initializer_opt.EndPos = NoPosition;
  
			;

} break;
case 1334: /* initializer_opt : '=' initializer .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 246; {
/* line 8978 "mpcPars.lalr" */

			  yySynAttribute.initializer_opt.Tree  =  yyAttrStackPtr [2-1].initializer.Tree;

			  yySynAttribute.initializer_opt.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.initializer_opt.EndPos  =  yyAttrStackPtr [2-1].initializer.EndPos;
  
			;

} break;
case 1335: /* initializer : '{' initializer_list '}' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 275; {
/* line 8987 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_InitList(
					yySynAttribute.initializer.Position = yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					NoTree, yyAttrStackPtr [2-1].initializer_list.Length,
					ReverseTree(yyAttrStackPtr [2-1].initializer_list.Tree)
				   );
			    yySynAttribute.initializer.Tree->MPC_InitList.List->MPC_Initializer.Prev->
						     MPC_FreeNode.Parent = yySynAttribute.initializer.Tree;
			    yySynAttribute.initializer.Tree->MPC_InitList.EndPos = yySynAttribute.initializer.EndPos =  
					 CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1336: /* initializer : '{' initializer_list ',' '}' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 275; {
/* line 9001 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_InitList(
					yySynAttribute.initializer.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree, NoTree, yyAttrStackPtr [2-1].initializer_list.Length,
					ReverseTree(yyAttrStackPtr [2-1].initializer_list.Tree)
				   );
			    yySynAttribute.initializer.Tree->MPC_InitList.List->MPC_Initializer.Prev->
						     MPC_FreeNode.Parent = yySynAttribute.initializer.Tree;
			    yySynAttribute.initializer.Tree->MPC_InitList.EndPos = yySynAttribute.initializer.EndPos =  
					 CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1337: /* initializer : assignment_expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 275; {
/* line 9015 "mpcPars.lalr" */
  
			    yySynAttribute.initializer.Tree = mMPC_SimpleInit(yyAttrStackPtr [1-1].assignment_expression.Position,
					NoTree, NoTree, yyAttrStackPtr [1-1].assignment_expression.Tree
				   );
			    yySynAttribute.initializer.Tree->MPC_SimpleInit.EndPos = yySynAttribute.initializer.EndPos = yyAttrStackPtr [1-1].assignment_expression.EndPos;  
			  ;

			  yySynAttribute.initializer.Position  =  yyAttrStackPtr [1-1].assignment_expression.Position;

			;

} break;
case 1338: /* initializer_list : initializer .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 276; {
/* line 9026 "mpcPars.lalr" */

			    yySynAttribute.initializer_list.Tree = yyAttrStackPtr [1-1].initializer.Tree;
			    yySynAttribute.initializer_list.Tree->MPC_Initializer.Next =
				  yySynAttribute.initializer_list.Tree->MPC_Initializer.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.initializer_list.Length = 1;

			;

} break;
case 1339: /* initializer_list : initializer_list ',' initializer .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 276; {
/* line 9036 "mpcPars.lalr" */

			    yySynAttribute.initializer_list.Tree = yyAttrStackPtr [3-1].initializer.Tree;
			    yySynAttribute.initializer_list.Tree->MPC_Initializer.Next =
				  yySynAttribute.initializer_list.Tree->MPC_Initializer.Prev = yyAttrStackPtr [1-1].initializer_list.Tree;
			  ;

			  yySynAttribute.initializer_list.Length = yyAttrStackPtr [1-1].initializer_list.Length + 1;

			;

} break;
case 1340: /* statement : labeled_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9046 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].labeled_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].labeled_statement.Chain;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].labeled_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].labeled_statement.EndPos;
  
			;

} break;
case 1341: /* statement : compound_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9057 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].compound_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].compound_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].compound_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].compound_statement.EndPos;
  
			;

} break;
case 1342: /* statement : expression_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9068 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].expression_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].expression_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].expression_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].expression_statement.EndPos;
  
			;

} break;
case 1343: /* statement : selection_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9079 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].selection_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].selection_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].selection_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].selection_statement.EndPos;
  
			;

} break;
case 1344: /* statement : iteration_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9090 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].iteration_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].iteration_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].iteration_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].iteration_statement.EndPos;
  
			;

} break;
case 1345: /* statement : jump_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9101 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].jump_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].jump_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].jump_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].jump_statement.EndPos;
  
			;

} break;
case 1346: /* statement : recon_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9112 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].recon_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].recon_statement.Chain;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].recon_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].recon_statement.EndPos;
  
			;

} break;
case 1347: /* statement : fan_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9123 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].fan_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].fan_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].fan_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].fan_statement.EndPos;
  
			;

} break;
case 1348: /* statement : scheme_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 9134 "mpcPars.lalr" */

			  yySynAttribute.statement.Tree    =  yyAttrStackPtr [1-1].scheme_statement.Tree;

			  yySynAttribute.statement.Chain   =  yyAttrStackPtr [1-1].scheme_statement.Tree;

			  yySynAttribute.statement.Ignore  =  yyAttrStackPtr [1-1].scheme_statement.Ignore;

			  yySynAttribute.statement.EndPos  =  yyAttrStackPtr [1-1].scheme_statement.EndPos;

			;

} break;
case 1349: /* labeled_statement : general_identifier ':' statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 277; {
/* line 9145 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_IdentLabel(yyAttrStackPtr [1-1].general_identifier.Position, NoTree, NoTree,
						yyAttrStackPtr [1-1].general_identifier.Ident
					  );
			    yySynAttribute.labeled_statement.Chain->MPC_IdentLabel.EndPos = yyAttrStackPtr [2-1].Scan.Position;   
			    yySynAttribute.labeled_statement.Chain->MPC_Label.PrevLabel = LabelList;
			    LabelList = yySynAttribute.labeled_statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].general_identifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1350: /* labeled_statement : case constant_expression ':' statement .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 277; {
/* line 9162 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [4-1].statement.Tree;
			    yyAttrStackPtr [4-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [4-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_CaseLabel(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,
						yyAttrStackPtr [2-1].constant_expression.Value,
						yyAttrStackPtr [2-1].constant_expression.Tree
					  );
			    yySynAttribute.labeled_statement.Chain->MPC_CaseLabel.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore || yyAttrStackPtr [4-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [4-1].statement.EndPos;
  
			;

} break;
case 1351: /* labeled_statement : default ':' statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 277; {
/* line 9178 "mpcPars.lalr" */

			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev =
				  yySynAttribute.labeled_statement.Chain = mMPC_Default(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree);
			    yySynAttribute.labeled_statement.Chain->MPC_Default.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [3-1].statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1352: /* labeled_statement : net_specifier ':' statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 277; {
/* line 9191 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yySynAttribute.labeled_statement.Chain = yyAttrStackPtr [3-1].statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			    if(yySynAttribute.labeled_statement.Tree!=yySynAttribute.labeled_statement.Chain) { 
			      STATS_Warning((624, xxError, yyAttrStackPtr [2-1].Scan.Position, yySynAttribute.labeled_statement.Tree));
					    
			    }
			    if(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Fan) {
			      
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(621, xxError, yyAttrStackPtr [1-1].net_specifier.Position,
					   yySynAttribute.labeled_statement.Tree);
					   
			    }
			    if(!yyAttrStackPtr [1-1].net_specifier.Simple || yyAttrStackPtr [1-1].net_specifier.Tree==COMPUTING_SPACE &&
				!(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Goto ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Continue ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Break ||
				  yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Return)) {
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(622, xxError, yyAttrStackPtr [1-1].net_specifier.Position,
					   yySynAttribute.labeled_statement.Tree);
					   
			    }
			    
			    yySynAttribute.labeled_statement.Ignore |= Recurse_DistrLabel(yySynAttribute.labeled_statement.Tree,yyAttrStackPtr [1-1].net_specifier.Tree,
							 yyAttrStackPtr [1-1].net_specifier.Position);
			    
			    yySynAttribute.labeled_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.labeled_statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1353: /* labeled_statement : subnet_specifier ':' statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 277; {
/* line 9236 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
					 
#endif
			  ; }
			    yySynAttribute.labeled_statement.Tree = yyAttrStackPtr [3-1].statement.Tree;
			    yySynAttribute.labeled_statement.Chain = yyAttrStackPtr [3-1].statement.Chain;
			    yySynAttribute.labeled_statement.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [3-1].statement.Ignore;
			    if(yySynAttribute.labeled_statement.Tree!=yySynAttribute.labeled_statement.Chain) { 
			      STATS_Warning((625, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position, yySynAttribute.labeled_statement.Tree));
					    
			    }
			    if(yyAttrStackPtr [3-1].statement.Tree->Kind==kMPC_Fan) {
			      
			      yySynAttribute.labeled_statement.Ignore = true;
			      Make_Message(623, xxError,
					   yyAttrStackPtr [1-1].subnet_specifier.Position, yySynAttribute.labeled_statement.Tree);
					   
			    }
			    
			    yySynAttribute.labeled_statement.Ignore |= Recurse_DistrLabel(yySynAttribute.labeled_statement.Tree,yyAttrStackPtr [1-1].subnet_specifier.Tree,
							 yyAttrStackPtr [1-1].subnet_specifier.Position);
			    
			    yySynAttribute.labeled_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.labeled_statement.Ignore;
			  ;

			  yySynAttribute.labeled_statement.EndPos  =  yyAttrStackPtr [3-1].statement.EndPos;
  
			;

} break;
case 1354: /* compound_statement : '{' new_scope '}' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 279; {
/* line 9271 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			    yySynAttribute.compound_statement.Ignore = false;
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1355: /* compound_statement : '{' new_scope declaration_list '}' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 279; {
/* line 9288 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls->MPC_Decls.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].declaration_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1356: /* compound_statement : '{' new_scope statement_list '}' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 279; {
/* line 9307 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = ReverseTree(yyAttrStackPtr [3-1].statement_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats->MPC_Stats.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].statement_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1357: /* compound_statement : '{' new_scope declaration_list statement_list '}' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 279; {
/* line 9326 "mpcPars.lalr" */
  
			    yySynAttribute.compound_statement.Tree = mMPC_Compound(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,
					NoStatFlag, NoTree,
					NO, NoTree, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.compound_statement.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls = ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Decls->MPC_Decls.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats = ReverseTree(yyAttrStackPtr [4-1].statement_list.Tree);
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Stats->MPC_Stats.Prev->
							MPC_FreeNode.Parent = yySynAttribute.compound_statement.Tree;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.Flag.Ignore = yySynAttribute.compound_statement.Ignore = yyAttrStackPtr [3-1].declaration_list.Ignore ||
								       yyAttrStackPtr [4-1].statement_list.Ignore;
			    yySynAttribute.compound_statement.Tree->MPC_Compound.EndPos = yySynAttribute.compound_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    Close_Scope();
			    Scope_Depth--;
			  ;

			;

} break;
case 1358: /* declaration_list : declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 287; {
/* line 9348 "mpcPars.lalr" */
  
			    tTree last;
			    yySynAttribute.declaration_list.Tree = last = yyAttrStackPtr [1-1].declaration.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.declaration_list.Ignore = yyAttrStackPtr [1-1].declaration.Ignore;
			    yySynAttribute.declaration_list.EndPos = yyAttrStackPtr [1-1].declaration.EndPos;  
			  ;

			;

} break;
case 1359: /* declaration_list : declaration_list declaration .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 287; {
/* line 9360 "mpcPars.lalr" */

			    tTree last;
			    yySynAttribute.declaration_list.Tree = last = yyAttrStackPtr [2-1].declaration.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev = yyAttrStackPtr [1-1].declaration_list.Tree;
			    yySynAttribute.declaration_list.Ignore = yyAttrStackPtr [1-1].declaration_list.Ignore && yyAttrStackPtr [2-1].declaration.Ignore;
			  ;

			  yySynAttribute.declaration_list.EndPos  =  yyAttrStackPtr [2-1].declaration.EndPos;
  
			;

} break;
case 1360: /* statement_list : statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 288; {
/* line 9373 "mpcPars.lalr" */

			    yySynAttribute.statement_list.Tree = yyAttrStackPtr [1-1].statement.Tree;
			    yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.statement_list.Ignore = yyAttrStackPtr [1-1].statement.Ignore;
			  ;

			;

} break;
case 1361: /* statement_list : statement_list statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 288; {
/* line 9382 "mpcPars.lalr" */

			    yySynAttribute.statement_list.Tree = yyAttrStackPtr [2-1].statement.Tree;
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = yyAttrStackPtr [1-1].statement_list.Tree;
			    yySynAttribute.statement_list.Ignore = yyAttrStackPtr [1-1].statement_list.Ignore && yyAttrStackPtr [2-1].statement.Ignore;
			  ;

			;

} break;
case 1362: /* expression_statement : expression_opt ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 280; {
/* line 9391 "mpcPars.lalr" */
  
			    yySynAttribute.expression_statement.Tree = mMPC_ExprStat( (yyAttrStackPtr [1-1].expression_opt.Tree==NoTree )?  
			    		yyAttrStackPtr [2-1].Scan.Position:yyAttrStackPtr [1-1].expression_opt.BegPos ,  
					NoTree, NoTree,
					NoStatFlag, NoTree, yyAttrStackPtr [1-1].expression_opt.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.expression_statement.Tree);
			    yySynAttribute.expression_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.expression_statement.Ignore = yyAttrStackPtr [1-1].expression_opt.Ignore;
			    yySynAttribute.expression_statement.Tree->MPC_ExprStat.EndPos = yySynAttribute.expression_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1363: /* selection_statement : if '(' expression ')' statement .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 281; {
/* line 9405 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_If(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_If.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1364: /* selection_statement : if '(' expression ')' statement else statement .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 281; {
/* line 9421 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yyAttrStackPtr [7-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [7-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_IfElse(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree),
					ReverseTree(yyAttrStackPtr [7-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_IfElse.Then->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_IfElse.Else->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
							  yyAttrStackPtr [5-1].statement.Ignore || yyAttrStackPtr [7-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [7-1].statement.EndPos;  
			  ;

			;

} break;
case 1365: /* selection_statement : switch '(' expression ')' statement .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 281; {
/* line 9441 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.selection_statement.Tree = mMPC_Switch(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.selection_statement.Tree);
			    yySynAttribute.selection_statement.Tree->MPC_Switch.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.selection_statement.Tree;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.selection_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.selection_statement.Tree->MPC_Stat.EndPos = yySynAttribute.selection_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1366: /* iteration_statement : while '(' expression ')' statement .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 282; {
/* line 9457 "mpcPars.lalr" */
  
			    yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [5-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_While(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression.Tree,
					ReverseTree(yyAttrStackPtr [5-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_While.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [3-1].expression.Ignore ||
								   yyAttrStackPtr [5-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos = yyAttrStackPtr [5-1].statement.EndPos;  
			  ;

			;

} break;
case 1367: /* iteration_statement : do statement while '(' expression ')' ';' .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 282; {
/* line 9473 "mpcPars.lalr" */
  
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_DoWhile(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree,
					ReverseTree(yyAttrStackPtr [2-1].statement.Tree), yyAttrStackPtr [5-1].expression.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_DoWhile.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [5-1].expression.Ignore ||
								   yyAttrStackPtr [2-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos =   
			    		CurrentPosition = yyAttrStackPtr [7-1].Scan.Position;  
			  ;

			;

} break;
case 1368: /* iteration_statement : for '(' expression_opt ';' expression_opt ';' expression_opt ')' statement .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 282; {
/* line 9490 "mpcPars.lalr" */
  
			    yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.iteration_statement.Tree = mMPC_For(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [3-1].expression_opt.Tree,
					yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].expression_opt.Tree,
					ReverseTree(yyAttrStackPtr [9-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.iteration_statement.Tree);
			    yySynAttribute.iteration_statement.Tree->MPC_For.Stats->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.iteration_statement.Tree;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.iteration_statement.Ignore = yyAttrStackPtr [3-1].expression_opt.Ignore ||
				  yyAttrStackPtr [5-1].expression_opt.Ignore || yyAttrStackPtr [7-1].expression_opt.Ignore || yyAttrStackPtr [9-1].statement.Ignore;
			    yySynAttribute.iteration_statement.Tree->MPC_Stat.EndPos = yySynAttribute.iteration_statement.EndPos = yyAttrStackPtr [9-1].statement.EndPos;  
			  ;

			;

} break;
case 1369: /* jump_statement : goto general_identifier ';' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 283; {
/* line 9507 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Goto(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [2-1].general_identifier.Ident
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.jump_statement.Ignore = yyAttrStackPtr [2-1].general_identifier.Ignore;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			   		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1370: /* jump_statement : continue ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 283; {
/* line 9519 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Continue(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1371: /* jump_statement : break ';' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 283; {
/* line 9531 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Break(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1372: /* jump_statement : break '?' ';' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 283; {
/* line 9543 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [2-1].Scan.Position);
			    Make_Message(23,xxInformation,yyAttrStackPtr [2-1].Scan.Position,NoTree);
					 
#endif
			  ; }  
			    yySynAttribute.jump_statement.Tree = mMPC_BreakFan(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = false;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1373: /* jump_statement : return expression_opt ';' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 283; {
/* line 9563 "mpcPars.lalr" */
  
			    yySynAttribute.jump_statement.Tree = mMPC_Return(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree,  
					NoStatFlag, NoTree, yyAttrStackPtr [2-1].expression_opt.Tree
				   );
			    Clean_OutAttributes(yySynAttribute.jump_statement.Tree);
			    yySynAttribute.jump_statement.Ignore = yyAttrStackPtr [2-1].expression_opt.Ignore;
			    yySynAttribute.jump_statement.Tree->MPC_Stat.EndPos = yySynAttribute.jump_statement.EndPos =  
			    		CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1374: /* recon_statement : recon statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 284; {
/* line 9575 "mpcPars.lalr" */

			    yySynAttribute.recon_statement.Tree = Make_Epilogue(yyAttrStackPtr [1-1].Scan.Position);
			    yySynAttribute.recon_statement.Tree->MPC_Stat.Next = yySynAttribute.recon_statement.Tree->MPC_Stat.Prev = yyAttrStackPtr [2-1].statement.Tree;
			    yySynAttribute.recon_statement.Chain = yyAttrStackPtr [2-1].statement.Chain;
			    yyAttrStackPtr [2-1].statement.Tree->MPC_Stat.Benchmark = true;
			
			    yySynAttribute.recon_statement.Ignore = yyAttrStackPtr [2-1].statement.Ignore;
			    yySynAttribute.recon_statement.Ignore |= Recurse_DistrLabel(yyAttrStackPtr [2-1].statement.Tree, RECON_NET, yyAttrStackPtr [1-1].Scan.Position);
			  ;

			  yySynAttribute.recon_statement.EndPos  =  yyAttrStackPtr [2-1].statement.EndPos;
  
			;

} break;
case 1375: /* fan_statement : fan subnet_specifier statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 285; {
/* line 9589 "mpcPars.lalr" */
  
			    yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [3-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(NoTree);
			    yySynAttribute.fan_statement.Tree = mMPC_Fan(yyAttrStackPtr [1-1].Scan.Position, NoTree,  
					NoTree, NoStatFlag, yyAttrStackPtr [2-1].subnet_specifier.Tree,
					ReverseTree(yyAttrStackPtr [3-1].statement.Tree)
				   );
			    Clean_OutAttributes(yySynAttribute.fan_statement.Tree);
			    yySynAttribute.fan_statement.Tree->MPC_Fan.Body->MPC_Stats.Prev->MPC_FreeNode.Parent = yySynAttribute.fan_statement.Tree;
			    yySynAttribute.fan_statement.Tree->MPC_Stat.Flag.Ignore = yySynAttribute.fan_statement.Ignore = yyAttrStackPtr [2-1].subnet_specifier.Ignore ||
								   yyAttrStackPtr [3-1].statement.Ignore;
			    yySynAttribute.fan_statement.Tree->MPC_Stat.EndPos = yySynAttribute.fan_statement.EndPos = yyAttrStackPtr [3-1].statement.EndPos;  
			  ;

			;

} break;
case 1376: /* translation_unit : external_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 136; {
/* line 9605 "mpcPars.lalr" */

			    {
			      tTree last;
			      yySynAttribute.translation_unit.Tree = last = yyAttrStackPtr [1-1].external_definition.Tree;
			      while(last->MPC_Decls.Next)
			        last = last->MPC_Decls.Next; 
			      last->MPC_Decls.Next = last->MPC_Decls.Prev =
							mMPC_FreeNode(TreeRoot);
			    }
			  ;

			  yySynAttribute.translation_unit.Ignore  =  yyAttrStackPtr [1-1].external_definition.Ignore;

			;

} break;
case 1377: /* translation_unit : translation_unit external_definition .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 136; {
/* line 9620 "mpcPars.lalr" */

			    tTree last;
			    yySynAttribute.translation_unit.Tree = last = yyAttrStackPtr [2-1].external_definition.Tree;
			    while(last->MPC_Decls.Next)
			      last = last->MPC_Decls.Next; 
			    last->MPC_Decls.Next = last->MPC_Decls.Prev =
							yyAttrStackPtr [1-1].translation_unit.Tree;
			    yySynAttribute.translation_unit.Ignore = yyAttrStackPtr [1-1].translation_unit.Ignore && yyAttrStackPtr [2-1].external_definition.Ignore;
			  ;

			;

} break;
case 1378: /* external_definition : function_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 289; {
/* line 9632 "mpcPars.lalr" */

			  yySynAttribute.external_definition.Tree  =  yyAttrStackPtr [1-1].function_definition.Tree;

			  yySynAttribute.external_definition.Ignore  =  yyAttrStackPtr [1-1].function_definition.Ignore;

			   
			;

} break;
case 1379: /* external_definition : declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 289; {
/* line 9640 "mpcPars.lalr" */

			  yySynAttribute.external_definition.Tree  =  yyAttrStackPtr [1-1].declaration.Tree;

			  yySynAttribute.external_definition.Ignore  =  yyAttrStackPtr [1-1].declaration.Ignore;

			  
			;

} break;
case 1380: /* function_definition : function_declarator compound_statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 290; {
/* line 9648 "mpcPars.lalr" */

			    tTree Type, ParamList;
			    if(Opened_ParameterScope) {
			      Close_Scope();
			      Scope_Depth--;
			      Opened_ParameterScope = false;
			    }
			    if(yyAttrStackPtr [1-1].function_declarator.Ignore) {
			      Type = Default_FunctionType;
			      ParamList = mMPC_FreeNode(NoTree);
			    }
			    else {
			      Type = yyAttrStackPtr [1-1].function_declarator.Type;
			      ParamList = Original_ParamList; 
			      if(Tree_IsType(Type->MPC_FunctionType.ParamList,kMPC_Decls))
			        Type->MPC_FunctionType.ParamList->MPC_Decls.Prev->
								  MPC_FreeNode.Parent = Type;
			      else if(Type->MPC_FunctionType.ParamList) 
			        Type->MPC_FunctionType.ParamList->MPC_FreeNode.Parent = Type;
			    }
			    yySynAttribute.function_definition.Tree = mMPC_Function(yyAttrStackPtr [1-1].function_declarator.Position,  
					NoTree, NoTree,
				        Type->MPC_FunctionType.Kind, NoDeclFlag, 
					yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Distribution,
					Add_Ident(yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Ident,
					          IDENT, yyAttrStackPtr [1-1].function_declarator.Var),
					Type, ParamList, yyAttrStackPtr [2-1].compound_statement.Tree
				   );
			    while(LabelList) {
			      if(LabelList->MPC_Label.PrevLabel)
				LabelList->MPC_Label.PrevLabel->MPC_Label.NextLabel = LabelList;
			      yySynAttribute.function_definition.Tree->MPC_Function.LabelList = LabelList;
			      LabelList = LabelList->MPC_Label.PrevLabel;
			    }
			    yySynAttribute.function_definition.Tree->MPC_Function.EndPos = yyAttrStackPtr [2-1].compound_statement.EndPos;  
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Ignore |=
				  Check_LabelList(yySynAttribute.function_definition.Tree->MPC_Function.LabelList);
			    yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Next =
				yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Prev = mMPC_FreeNode(yySynAttribute.function_definition.Tree);
			    yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Stats.Next =
				yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.function_definition.Tree);
			    yyAttrStackPtr [2-1].compound_statement.Tree->MPC_Compound.FunctionBody = YES;
			    if(Tree_IsType(ParamList, kMPC_Decls)) 
			      ParamList->MPC_Decls.Prev->MPC_FreeNode.Parent = yySynAttribute.function_definition.Tree;
			    else if(ParamList)
			      ParamList->MPC_FreeNode.Parent = yySynAttribute.function_definition.Tree;
			    Default_Class = EXTERN;
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Exported =
				yySynAttribute.function_definition.Tree->MPC_Function.Name->MPC_Var.Flag.Exported = YES;
			    yySynAttribute.function_definition.Tree->MPC_Function.Flag.Ignore = yySynAttribute.function_definition.Ignore = yyAttrStackPtr [1-1].function_declarator.Ignore
								     || yyAttrStackPtr [2-1].compound_statement.Ignore;
			    if(Scope_Depth>0) 
			      Scope_Depth = 0;

#ifndef __CB_COMPILER__
			    if(DEMO_MODE)
			      WL_Add(yyAttrStackPtr [1-1].function_declarator.Var->MPC_Var.Ident);
#endif
			  ;

			;

} break;
case 1381: /* function_declarator : declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 291; {
/* line 9710 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					IntType, yyAttrStackPtr [1-1].declarator.Distribution, yyAttrStackPtr [1-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var( yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declarator.Position,  
					yyAttrStackPtr [1-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].declarator.Distribution, NoTree
				  );
			    if(yyAttrStackPtr [1-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].declarator.EndPos;  
			  ;

			;

} break;
case 1382: /* function_declarator : declaration_specifier declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9737 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var( yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 	yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1383: /* function_declarator : type_specifier declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9776 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1384: /* function_declarator : declaration_qualifier_list declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9804 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1385: /* function_declarator : type_qualifier_list declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9848 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore || yyAttrStackPtr [2-1].declarator.Ignore;
			    if(Opened_PrototypeScope)
			      Opened_ParameterScope = true, Opened_PrototypeScope = false;

			    Original_ParamList = Find_FunctionType();  
			    if(Original_ParamList!=NoTree)
			      Original_ParamList = Original_ParamList->MPC_FunctionType.ParamList;  
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].declarator.Distribution,yyAttrStackPtr [2-1].declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].declarator.Distribution, NoTree
				  );
			    if(yyAttrStackPtr [2-1].declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].declarator.EndPos;  
			  ;

			;

} break;
case 1386: /* function_declarator : old_function_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 291; {
/* line 9881 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(IntType,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution,
					yyAttrStackPtr [1-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].old_function_declarator.Position,  
					yyAttrStackPtr [1-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [1-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [1-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1387: /* function_declarator : declaration_specifier old_function_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9905 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
						 yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1388: /* function_declarator : type_specifier old_function_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9942 "mpcPars.lalr" */

			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1389: /* function_declarator : declaration_qualifier_list old_function_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 9968 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
					yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
					
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1390: /* function_declarator : type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 291; {
/* line 10010 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					NoTree  ));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			  ;

			;

} break;
case 1391: /* function_declarator : old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 291; {
/* line 10041 "mpcPars.lalr" */

			    Close_Scope(), Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(IntType,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution,
					yyAttrStackPtr [1-1].old_function_declarator.Position,
					yyAttrStackPtr [4-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].old_function_declarator.Position,  
					yyAttrStackPtr [1-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type,
					yyAttrStackPtr [1-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [1-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [4-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1392: /* function_declarator : declaration_specifier old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 291; {
/* line 10066 "mpcPars.lalr" */

			    Close_Scope(),Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_specifier.Ignore ||
						 yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].declaration_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_specifier.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 yyAttrStackPtr [1-1].declaration_specifier.Position, NoTree);
		
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1393: /* function_declarator : type_specifier old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 291; {
/* line 10104 "mpcPars.lalr" */

			    Close_Scope(), Scope_Depth--;  
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_specifier.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					yyAttrStackPtr [1-1].type_specifier.Type,
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_specifier.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1394: /* function_declarator : declaration_qualifier_list old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 291; {
/* line 10131 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Close_Scope(), Scope_Depth--;  
			    Flag.Const = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].declaration_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].declaration_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].declaration_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    switch(yyAttrStackPtr [1-1].declaration_qualifier_list.Class) {
			      case UNDEFINED:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Exported = YES; break;
			      case STATIC:
				yySynAttribute.function_declarator.Var->MPC_Var.Flag.Static = YES; break;
			      default:
				Make_Message(472, xxError,
				 yyAttrStackPtr [1-1].declaration_qualifier_list.Position, NoTree);
		
				yySynAttribute.function_declarator.Ignore = true;
			    }
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1395: /* function_declarator : type_qualifier_list old_function_declarator new_scope nested_type_on declaration_list nested_type_off .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 291; {
/* line 10174 "mpcPars.lalr" */

			    tTypeFlags Flag = NoTypeFlag;
			    Close_Scope(), Scope_Depth--;  
			    Flag.Const = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Const;
			    Flag.Volatile = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Volatile;
			    Flag.Repl = yyAttrStackPtr [1-1].type_qualifier_list.Qual.Repl;
			    yySynAttribute.function_declarator.Ignore = yyAttrStackPtr [1-1].type_qualifier_list.Ignore ||
						yyAttrStackPtr [2-1].old_function_declarator.Ignore;
			    Opened_ParameterScope = true, Opened_PrototypeScope = false;
			    yySynAttribute.function_declarator.Ignore |=
				!(yySynAttribute.function_declarator.Type=Make_FunctionType(
					mMPC_BasicType(NoPosition,
						NoTree,NoTree,Flag,INT),
					yyAttrStackPtr [2-1].old_function_declarator.Distribution,
					yyAttrStackPtr [2-1].old_function_declarator.Position,
					yyAttrStackPtr [5-1].declaration_list.Tree));
			    yySynAttribute.function_declarator.Var = mMPC_Var(yySynAttribute.function_declarator.Position = yyAttrStackPtr [1-1].type_qualifier_list.Position,  
					yyAttrStackPtr [2-1].old_function_declarator.Ident, NoDeclFlag,
					NoTree, NoTree, yySynAttribute.function_declarator.Type, 
					yyAttrStackPtr [2-1].old_function_declarator.Distribution, NoTree
				  );
			    Original_ParamList = yySynAttribute.function_declarator.Type->MPC_FunctionType.ParamList;  
			    if(yyAttrStackPtr [2-1].old_function_declarator.Distribution!=NO_NET)
			      yySynAttribute.function_declarator.Var->MPC_Var.Flag.ExplDistr = YES;
			    yySynAttribute.function_declarator.Var = Add_Ident(yySynAttribute.function_declarator.Var->MPC_Var.Ident, IDENT, yySynAttribute.function_declarator.Var);
				
			    yySynAttribute.function_declarator.Var->MPC_Var.Flag.Ignore = yySynAttribute.function_declarator.Ignore;
			    yySynAttribute.function_declarator.Var->MPC_Var.EndPos = yyAttrStackPtr [5-1].declaration_list.EndPos;  
			  ;

			;

} break;
case 1396: /* declarator : unary_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 245; {
/* line 10206 "mpcPars.lalr" */

			  yySynAttribute.declarator.Ident  =  yyAttrStackPtr [1-1].unary_declarator.Ident;

			  yySynAttribute.declarator.Distribution  =  yyAttrStackPtr [1-1].unary_declarator.Distribution;

			  yySynAttribute.declarator.Ignore  =  yyAttrStackPtr [1-1].unary_declarator.Ignore;

			  yySynAttribute.declarator.Position  =  yyAttrStackPtr [1-1].unary_declarator.Position;

			  yySynAttribute.declarator.EndPos  =  yyAttrStackPtr [1-1].unary_declarator.EndPos;
  
			;

} break;
case 1397: /* declarator : paren_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 245; {
/* line 10219 "mpcPars.lalr" */

			  yySynAttribute.declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			  yySynAttribute.declarator.Distribution  =  yyAttrStackPtr [1-1].paren_declarator.Distribution;

			  yySynAttribute.declarator.Ignore  =  yyAttrStackPtr [1-1].paren_declarator.Ignore;

			  yySynAttribute.declarator.Position  =  yyAttrStackPtr [1-1].paren_declarator.Position;

			  yySynAttribute.declarator.EndPos  =  yyAttrStackPtr [1-1].paren_declarator.EndPos;
  
			;

} break;
case 1398: /* unary_declarator : postfix_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 293; {
/* line 10232 "mpcPars.lalr" */

			  yySynAttribute.unary_declarator.Ident  =  yyAttrStackPtr [1-1].postfix_declarator.Ident;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [1-1].postfix_declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = NO;

			  yySynAttribute.unary_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_declarator.Ignore;

			  yySynAttribute.unary_declarator.Position  =  yyAttrStackPtr [1-1].postfix_declarator.Position;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_declarator.EndPos;
  
			;

} break;
case 1399: /* unary_declarator : '*' declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 293; {
/* line 10247 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [2-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [2-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			  yySynAttribute.unary_declarator.Ignore  =  yyAttrStackPtr [2-1].declarator.Ignore;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [2-1].declarator.EndPos;
  
			;

} break;
case 1400: /* unary_declarator : '*' step declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 293; {
/* line 10270 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [3-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [3-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [3-1].declarator.EndPos;
  
			;

} break;
case 1401: /* unary_declarator : '*' type_qualifier_list declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 293; {
/* line 10295 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [3-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].type_qualifier_list.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [3-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore || yyAttrStackPtr [3-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [3-1].declarator.EndPos;
  
			;

} break;
case 1402: /* unary_declarator : '*' step type_qualifier_list declarator .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 293; {
/* line 10325 "mpcPars.lalr" */
  
			    yySynAttribute.unary_declarator.Ident = yyAttrStackPtr [4-1].declarator.Ident;
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.unary_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].step.Ignore ||
						yyAttrStackPtr [3-1].type_qualifier_list.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			  yySynAttribute.unary_declarator.Distribution  =  yyAttrStackPtr [4-1].declarator.Distribution;

			  yySynAttribute.unary_declarator.Pointer = YES;

			    yySynAttribute.unary_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore ||
					 yyAttrStackPtr [3-1].type_qualifier_list.Ignore ||
							yyAttrStackPtr [4-1].declarator.Ignore;
			  ;

			  yySynAttribute.unary_declarator.EndPos  =  yyAttrStackPtr [4-1].declarator.EndPos;
  
			;

} break;
case 1403: /* postfix_declarator : paren_declarator postfixing_abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 295; {
/* line 10358 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [1-1].paren_declarator.Ignore ||
					yyAttrStackPtr [2-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [1-1].paren_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        type->MPC_FunctionType.NetParam = yySynAttribute.postfix_declarator.Distribution;
			        if(yySynAttribute.postfix_declarator.Distribution!=NoTree && yySynAttribute.postfix_declarator.Distribution->Kind==kMPC_Net &&
				   yySynAttribute.postfix_declarator.Distribution->MPC_Net.Topology==PARAMETER) {
				  type->MPC_FunctionType.NetParamType =
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.NetType;
				  Add_Ident(
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.Ident, IDENT, yySynAttribute.postfix_declarator.Distribution
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [2-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].paren_declarator.Position;
  
			;

} break;
case 1404: /* postfix_declarator : '(' unary_declarator close_prototype_scope ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 295; {
/* line 10388 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [2-1].unary_declarator.Ident;

			  yySynAttribute.postfix_declarator.Distribution  =  yyAttrStackPtr [2-1].unary_declarator.Distribution;

			  yySynAttribute.postfix_declarator.Ignore  =  yyAttrStackPtr [2-1].unary_declarator.Ignore;
  
			    yySynAttribute.postfix_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.postfix_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1405: /* postfix_declarator : '(' unary_declarator close_prototype_scope ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 295; {
/* line 10401 "mpcPars.lalr" */

			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [2-1].unary_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [2-1].unary_declarator.Ignore ||
					yyAttrStackPtr [5-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [2-1].unary_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        if(!yyAttrStackPtr [2-1].unary_declarator.Pointer)
				  type->MPC_FunctionType.NetParam = yySynAttribute.postfix_declarator.Distribution;
			        if(yySynAttribute.postfix_declarator.Distribution!=NoTree && yySynAttribute.postfix_declarator.Distribution->Kind==kMPC_Net &&
				   yySynAttribute.postfix_declarator.Distribution->MPC_Net.Topology==PARAMETER) {
				  if(!yyAttrStackPtr [2-1].unary_declarator.Pointer)
				    type->MPC_FunctionType.NetParamType =
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.NetType;
				  Add_Ident(
					yySynAttribute.postfix_declarator.Distribution->MPC_Net.Ident, IDENT, yySynAttribute.postfix_declarator.Distribution
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [5-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1406: /* postfix_declarator : net_specifier '(' unary_declarator close_prototype_scope ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 295; {
/* line 10433 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.postfix_declarator.Ident  =  yyAttrStackPtr [3-1].unary_declarator.Ident;

			    yySynAttribute.postfix_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [3-1].unary_declarator.Ignore ||
					yyAttrStackPtr [6-1].postfixing_abstract_declarator.Ignore;
			    if(yySynAttribute.postfix_declarator.Ignore)
			      yySynAttribute.postfix_declarator.Distribution = NO_NET;
			    else {
			      tTree type, netparam;
			      yySynAttribute.postfix_declarator.Distribution = yyAttrStackPtr [3-1].unary_declarator.Distribution;
			      if((type=TopType())!=NoTree && type->Kind==kMPC_FunctionType) {
			        type->MPC_FunctionType.NetParam = netparam = yyAttrStackPtr [1-1].net_specifier.Tree;
			        if(netparam!=NoTree && netparam->Kind==kMPC_Net &&
				   netparam->MPC_Net.Topology==PARAMETER) {
				  type->MPC_FunctionType.NetParamType =
					netparam->MPC_Net.NetType;
				  Add_Ident(
					netparam->MPC_Net.Ident, IDENT, netparam
				  );  
				}
			      }
			    }
			  ;

			  yySynAttribute.postfix_declarator.EndPos  =  yyAttrStackPtr [6-1].postfixing_abstract_declarator.EndPos;
  
			  yySynAttribute.postfix_declarator.Position  =  yyAttrStackPtr [1-1].net_specifier.Position;
  
			;

} break;
case 1407: /* paren_declarator : net_specifier IDENTIFIER .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 294; {
/* line 10472 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [1-1].net_specifier.Tree;

			  yySynAttribute.paren_declarator.Ignore = yyAttrStackPtr [1-1].net_specifier.Ignore || yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].net_specifier.Position;  
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [2-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1408: /* paren_declarator : subnet_specifier IDENTIFIER .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 294; {
/* line 10496 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].subnet_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].subnet_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [1-1].subnet_specifier.Tree;

			  yySynAttribute.paren_declarator.Ignore = yyAttrStackPtr [1-1].subnet_specifier.Ignore || yyAttrStackPtr [2-1].Scan.IDENTIFIER.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].subnet_specifier.Position;  
			    CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [2-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [2-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1409: /* paren_declarator : IDENTIFIER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 294; {
/* line 10520 "mpcPars.lalr" */

			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.paren_declarator.Distribution = NO_NET;

			  yySynAttribute.paren_declarator.Ignore = false;
  
			    yySynAttribute.paren_declarator.Position = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;
			    yySynAttribute.paren_declarator.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			  ;

			;

} break;
case 1410: /* paren_declarator : '(' paren_declarator ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 294; {
/* line 10534 "mpcPars.lalr" */

			  yySynAttribute.paren_declarator.Ident  =  yyAttrStackPtr [2-1].paren_declarator.Ident;

			  yySynAttribute.paren_declarator.Distribution  =  yyAttrStackPtr [2-1].paren_declarator.Distribution;

			  yySynAttribute.paren_declarator.Ignore  =  yyAttrStackPtr [2-1].paren_declarator.Ignore;
  
			    yySynAttribute.paren_declarator.Position = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.paren_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1411: /* net_specifier : '[' host ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 210; {
/* line 10547 "mpcPars.lalr" */
 yySynAttribute.net_specifier.Tree = TreeRoot->MPC_Root.Host; ;

			  yySynAttribute.net_specifier.Simple = true;

			  yySynAttribute.net_specifier.Ignore = false;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1412: /* net_specifier : '[*]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 210; {
/* line 10557 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].Scan.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].Scan.Position, NoTree);
					 
#endif
			  ; } yySynAttribute.net_specifier.Tree = TreeRoot->MPC_Root.ComputingSpace; ;

			  yySynAttribute.net_specifier.Simple = true;

			  yySynAttribute.net_specifier.Ignore = false;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			;

} break;
case 1413: /* net_specifier : net_name_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 210; {
/* line 10576 "mpcPars.lalr" */

			  ;
{ 
#ifdef __CB_COMPILER__
			    Make_ErrorMessage(xxSyntaxError, xxError, yyAttrStackPtr [1-1].net_name_specifier.Position);
			    Make_Message(23, xxInformation, 
					 yyAttrStackPtr [1-1].net_name_specifier.Position, NoTree);
					 
#endif
			  ; }
			  yySynAttribute.net_specifier.Tree  =  yyAttrStackPtr [1-1].net_name_specifier.Tree;

			  yySynAttribute.net_specifier.Simple  =  yyAttrStackPtr [1-1].net_name_specifier.Simple;

			  yySynAttribute.net_specifier.Ignore  =  yyAttrStackPtr [1-1].net_name_specifier.Ignore;

			  yySynAttribute.net_specifier.Position  =  yyAttrStackPtr [1-1].net_name_specifier.Position;

			;

} break;
case 1414: /* net_name_specifier : '[' NETorSUBNETname ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 144; {
/* line 10596 "mpcPars.lalr" */

			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ignore;
			    if(!yySynAttribute.net_name_specifier.Ignore) {
			      if(!(yySynAttribute.net_name_specifier.Tree=Find_Ident(yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident,IDENT)))
				Make_MessageI(103, xxError,
					yyAttrStackPtr [2-1].Scan.Position, xxIdent,
					(char *) & yyAttrStackPtr [2-1].Scan.NETorSUBNETname.Ident, NoTree
					
				), yySynAttribute.net_name_specifier.Ignore = true;
			    }
			    else
			      yySynAttribute.net_name_specifier.Tree = ErrorNet; 
			  ;

			  yySynAttribute.net_name_specifier.Simple = true;

			  yySynAttribute.net_name_specifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			;

} break;
case 1415: /* net_name_specifier : '[' net_type_specifier ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 144; {
/* line 10616 "mpcPars.lalr" */
  
			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].net_type_specifier.Ignore;
			    if(yySynAttribute.net_name_specifier.Ignore) {
                              yySynAttribute.net_name_specifier.Tree = ErrorNet;
                              yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;
                            }
                            else {
			      tTree tmp;
			      tmp = nMPC_FreeNode();
			      yySynAttribute.net_name_specifier.Tree = mMPC_Net(
					  yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					  NoIdent, PRAGMA_BIG,
					  SINGLE_NODE, tmp, tmp, PARAMETER,
					  yyAttrStackPtr [2-1].net_type_specifier.Tree
				     );
			      Clean_OutAttributes(yySynAttribute.net_name_specifier.Tree);
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.EndPos = yyAttrStackPtr [3-1].Scan.Position;  
			    }
			  ;

			  yySynAttribute.net_name_specifier.Simple = false;

			;

} break;
case 1416: /* net_name_specifier : '[' net_type_specifier general_identifier ']' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 144; {
/* line 10640 "mpcPars.lalr" */
  
			    yySynAttribute.net_name_specifier.Ignore = yyAttrStackPtr [2-1].net_type_specifier.Ignore || yyAttrStackPtr [3-1].general_identifier.Ignore;
			    if(yySynAttribute.net_name_specifier.Ignore) {
                              yySynAttribute.net_name_specifier.Tree = ErrorNet;
                              yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position;
                            }
                            else {
			      tTree tmp;
			      tmp = nMPC_FreeNode();
			      yySynAttribute.net_name_specifier.Tree = mMPC_Net(
					  yySynAttribute.net_name_specifier.Position = yyAttrStackPtr [1-1].Scan.Position,  
					  yyAttrStackPtr [3-1].general_identifier.Ident, PRAGMA_BIG,
					  SINGLE_NODE, tmp, tmp, PARAMETER,
					  yyAttrStackPtr [2-1].net_type_specifier.Tree
				     );
			      Clean_OutAttributes(yySynAttribute.net_name_specifier.Tree);
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.SingleNode = false;
			      yySynAttribute.net_name_specifier.Tree->MPC_Net.EndPos = yyAttrStackPtr [4-1].Scan.Position;  
			    }
			  ;

			  yySynAttribute.net_name_specifier.Simple = false;

			;

} break;
case 1417: /* general_identifier : IDENTIFIER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 209; {
/* line 10665 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.IDENTIFIER.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			     yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			     yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.IDENTIFIER.Length - 1 ;  
			     ;
  
			;

} break;
case 1418: /* general_identifier : NETorSUBNETname .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 209; {
/* line 10678 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			     yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			     yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.NETorSUBNETname.Length - 1 ;  
			     ;
  
			;

} break;
case 1419: /* general_identifier : TYPEDEFname .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 209; {
/* line 10691 "mpcPars.lalr" */

			  yySynAttribute.general_identifier.Ident  =  yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ident;

			  yySynAttribute.general_identifier.Ignore  =  yyAttrStackPtr [1-1].Scan.TYPEDEFname.Ignore;

			  yySynAttribute.general_identifier.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			    yySynAttribute.general_identifier.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			    yySynAttribute.general_identifier.EndPos.Column += yyAttrStackPtr [1-1].Scan.TYPEDEFname.Length - 1 ;  
			    ;
  
			;

} break;
case 1420: /* old_function_declarator : postfix_old_function_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 292; {
/* line 10704 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Ignore;

			  yySynAttribute.old_function_declarator.Position  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.Position;

			  yySynAttribute.old_function_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_old_function_declarator.EndPos;
  
			;

} break;
case 1421: /* old_function_declarator : '*' old_function_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 292; {
/* line 10717 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore  =  yyAttrStackPtr [2-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [2-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			;

} break;
case 1422: /* old_function_declarator : '*' step old_function_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 292; {
/* line 10738 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [3-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [3-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [3-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			    TopType()->MPC_Type.Flag.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			  ;

			;

} break;
case 1423: /* old_function_declarator : '*' type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 292; {
/* line 10760 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [3-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [3-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore || yyAttrStackPtr [3-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [3-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].type_qualifier_list.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			  ;

			;

} break;
case 1424: /* old_function_declarator : '*' step type_qualifier_list old_function_declarator .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 292; {
/* line 10787 "mpcPars.lalr" */

			  yySynAttribute.old_function_declarator.Ident  =  yyAttrStackPtr [4-1].old_function_declarator.Ident;

			  yySynAttribute.old_function_declarator.Distribution  =  yyAttrStackPtr [4-1].old_function_declarator.Distribution;

			  yySynAttribute.old_function_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore ||
				    yyAttrStackPtr [4-1].old_function_declarator.Ignore;
  
			    yySynAttribute.old_function_declarator.EndPos = yyAttrStackPtr [4-1].old_function_declarator.EndPos;  
			    Push_Pattern(
				mMPC_PointerType(
					yySynAttribute.old_function_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
					NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yyAttrStackPtr [2-1].step.Ignore ||
						yyAttrStackPtr [3-1].type_qualifier_list.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree;
			  ;

			;

} break;
case 1425: /* postfix_old_function_declarator : paren_declarator '(' new_scope identifier_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 299; {
/* line 10816 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [1-1].paren_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [1-1].paren_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore = yyAttrStackPtr [1-1].paren_declarator.Ignore || yyAttrStackPtr [4-1].identifier_list.Ignore;
  
			    Opened_PrototypeScope = false; 
			    Push_Pattern(
			      mMPC_FunctionType(yySynAttribute.postfix_old_function_declarator.Position=yyAttrStackPtr [1-1].paren_declarator.Position,  
				NoTree, NoTree, NoTypeFlag,
				yyAttrStackPtr [4-1].identifier_list.Length, UNDEFINED, NoTree,
				NoTree, NoTree,
				nMPC_FreeNode(),
				ReverseTree(yyAttrStackPtr [4-1].identifier_list.Tree)
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				 yySynAttribute.postfix_old_function_declarator.EndPos = CurrentPosition=yyAttrStackPtr [5-1].Scan.Position  
			  ;

			;

} break;
case 1426: /* postfix_old_function_declarator : '(' old_function_declarator ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 299; {
/* line 10840 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore  =  yyAttrStackPtr [2-1].old_function_declarator.Ignore;

			  yySynAttribute.postfix_old_function_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			  yySynAttribute.postfix_old_function_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1427: /* postfix_old_function_declarator : '(' old_function_declarator ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 299; {
/* line 10853 "mpcPars.lalr" */

			  yySynAttribute.postfix_old_function_declarator.Ident  =  yyAttrStackPtr [2-1].old_function_declarator.Ident;

			  yySynAttribute.postfix_old_function_declarator.Distribution  =  yyAttrStackPtr [2-1].old_function_declarator.Distribution;

			  yySynAttribute.postfix_old_function_declarator.Ignore = yyAttrStackPtr [2-1].old_function_declarator.Ignore ||
				    yyAttrStackPtr [4-1].postfixing_abstract_declarator.Ignore;

			  yySynAttribute.postfix_old_function_declarator.Position  =  yyAttrStackPtr [1-1].Scan.Position;
  
			  yySynAttribute.postfix_old_function_declarator.EndPos  =  yyAttrStackPtr [4-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1428: /* abstract_declarator : unary_abstract_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 273; {
/* line 10867 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].unary_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].unary_abstract_declarator.EndPos;
  
			;

} break;
case 1429: /* abstract_declarator : postfix_abstract_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 273; {
/* line 10875 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].postfix_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].postfix_abstract_declarator.EndPos;
  
			;

} break;
case 1430: /* abstract_declarator : postfixing_abstract_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 273; {
/* line 10883 "mpcPars.lalr" */

			  yySynAttribute.abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].postfixing_abstract_declarator.Ignore;

			  
			  yySynAttribute.abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1431: /* postfixing_abstract_declarator : array_abstract_declarator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 297; {
/* line 10891 "mpcPars.lalr" */

			  yySynAttribute.postfixing_abstract_declarator.Ignore  =  yyAttrStackPtr [1-1].array_abstract_declarator.Ignore;

			  yySynAttribute.postfixing_abstract_declarator.Position  =  yyAttrStackPtr [1-1].array_abstract_declarator.Position;

			  yySynAttribute.postfixing_abstract_declarator.EndPos  =  yyAttrStackPtr [1-1].array_abstract_declarator.EndPos;
  
			;

} break;
case 1432: /* postfixing_abstract_declarator : '(' new_scope open_prototype_scope ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 297; {
/* line 10900 "mpcPars.lalr" */

			  yySynAttribute.postfixing_abstract_declarator.Ignore = false;
  
			    Opened_PrototypeScope = true;
			    Is_PrototypeScope = false;
			    Push_Pattern(
			      mMPC_FunctionType( yySynAttribute.postfixing_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree, NoTree,
				NoTypeFlag, UNDEFINED, UNDEFINED,
				NoTree, NoTree, NoTree,
				nMPC_FreeNode(),
				nMPC_FreeNode()
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				yySynAttribute.postfixing_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1433: /* postfixing_abstract_declarator : '(' new_scope open_prototype_scope parameter_type_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 297; {
/* line 10921 "mpcPars.lalr" */
  
			    Opened_PrototypeScope = true;
			    Is_PrototypeScope = false;
			    Push_Pattern(
			      mMPC_FunctionType(yySynAttribute.postfixing_abstract_declarator.Position = yyAttrStackPtr [5-1].Scan.Position,  
				NoTree, NoTree,
				NoTypeFlag, yyAttrStackPtr [4-1].parameter_type_list.Length, UNDEFINED,
				NoTree, NoTree, NoTree,
				nMPC_FreeNode(),
				yyAttrStackPtr [4-1].parameter_type_list.Tree
			      )
			    );
			    TopType()->MPC_FunctionType.Flag.Native = NativeMode;
			    
				yySynAttribute.postfixing_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			    {
			      tTree Type;
			      Type = TopType();
			      if(Type->MPC_FunctionType.NumberOfComponents==1 &&
				 Type->MPC_FunctionType.ParamList->Kind==kMPC_VarDecl &&
				 Type->MPC_FunctionType.ParamList->
					MPC_VarDecl.DeclSpecifier==VoidType &&
				 Type->MPC_FunctionType.ParamList->
					MPC_VarDecl.Var->Kind==kMPC_FreeNode)
				Type->MPC_FunctionType.NumberOfComponents = 0; 
			    }
			    yySynAttribute.postfixing_abstract_declarator.Ignore = yyAttrStackPtr [4-1].parameter_type_list.Ignore;
			  ;

			;

} break;
case 1434: /* array_abstract_declarator : '[]' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 10952 "mpcPars.lalr" */

			  yySynAttribute.array_abstract_declarator.Ignore = false;
  
			    Push_Pattern(
			      mMPC_ArrayType(
				yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
				NoTypeFlag, UNDEFINED ,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			     yySynAttribute.array_abstract_declarator.Position =  
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			;

} break;
case 1435: /* array_abstract_declarator : '[' ']' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 218; {
/* line 10970 "mpcPars.lalr" */

			  yySynAttribute.array_abstract_declarator.Ignore = false;
  
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,  
				NoTypeFlag, UNDEFINED ,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [2-1].Scan.Position;  
			  ;

			;

} break;
case 1436: /* array_abstract_declarator : '[' step ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 218; {
/* line 10988 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, UNDEFINED ,
				yyAttrStackPtr [2-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [2-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1437: /* array_abstract_declarator : '[' constant_expression ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 218; {
/* line 11008 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.Value<=0 && yyAttrStackPtr [2-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [2-1].constant_expression.Value,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [2-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [3-1].Scan.Position;  
			  ;

			;

} break;
case 1438: /* array_abstract_declarator : '[' constant_expression step ']' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 218; {
/* line 11036 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore || yyAttrStackPtr [3-1].step.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.Value<=0 && yyAttrStackPtr [2-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].Scan.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [2-1].constant_expression.Value,
				yyAttrStackPtr [3-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [2-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [3-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1439: /* array_abstract_declarator : array_abstract_declarator '[' constant_expression ']' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 218; {
/* line 11065 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [1-1].array_abstract_declarator.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.Value<=0 && yyAttrStackPtr [3-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [3-1].constant_expression.Position, yyAttrStackPtr [3-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].array_abstract_declarator.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [3-1].constant_expression.Value,
				1 , NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [3-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = nMPC_FreeNode();
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [4-1].Scan.Position;  
			  ;

			;

} break;
case 1440: /* array_abstract_declarator : array_abstract_declarator '[' constant_expression step ']' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 218; {
/* line 11094 "mpcPars.lalr" */
  
			    yySynAttribute.array_abstract_declarator.Ignore = yyAttrStackPtr [1-1].array_abstract_declarator.Ignore ||
				     yyAttrStackPtr [3-1].constant_expression.Ignore || yyAttrStackPtr [4-1].step.Ignore;
			    if(yyAttrStackPtr [3-1].constant_expression.Value<=0 && yyAttrStackPtr [3-1].constant_expression.IsIntConst) {
			      yySynAttribute.array_abstract_declarator.Ignore = true;
			      Make_Message(473, xxError,
					   yyAttrStackPtr [3-1].constant_expression.Position, yyAttrStackPtr [3-1].constant_expression.Tree);
					   
			    }
			    Push_Pattern(
			      mMPC_ArrayType(
				yySynAttribute.array_abstract_declarator.Position = yyAttrStackPtr [1-1].array_abstract_declarator.Position,  
				NoTree , NoTree ,
				NoTypeFlag, yyAttrStackPtr [3-1].constant_expression.Value,
				yyAttrStackPtr [4-1].step.Value, NoTree 
			      )
			    );
			    TopType()->MPC_ArrayType.Flag.Ignore = yySynAttribute.array_abstract_declarator.Ignore;
			    TopType()->MPC_ArrayType.Flag.ExplStep = YES;
			    if(yyAttrStackPtr [3-1].constant_expression.IsIntConst)
			      TopType()->MPC_ArrayType.ArraySize = nMPC_FreeNode();
			    else
			      TopType()->MPC_ArrayType.ArraySize = yyAttrStackPtr [3-1].constant_expression.Tree;
			    TopType()->MPC_ArrayType.DynStep = yyAttrStackPtr [4-1].step.Tree;  
			    
				 yySynAttribute.array_abstract_declarator.EndPos = CurrentPosition = yyAttrStackPtr [5-1].Scan.Position;  
			  ;

			;

} break;
case 1441: /* unary_abstract_declarator : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 300; {
/* line 11124 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = false;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [1-1].Scan.Position;  
			  ;

			  
			;

} break;
case 1442: /* unary_abstract_declarator : '*' step .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 300; {
/* line 11140 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].step.EndPos;  
			  ;

			  
			;

} break;
case 1443: /* unary_abstract_declarator : '*' type_qualifier_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 300; {
/* line 11157 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].type_qualifier_list.EndPos;  
			  ;

			  
			;

} break;
case 1444: /* unary_abstract_declarator : '*' step type_qualifier_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 300; {
/* line 11180 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].type_qualifier_list.EndPos;  
			  ;

			  
			;

} break;
case 1445: /* unary_abstract_declarator : '*' abstract_declarator .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 300; {
/* line 11203 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = false;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [2-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1446: /* unary_abstract_declarator : '*' step abstract_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 300; {
/* line 11219 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					NoTypeFlag, 1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1447: /* unary_abstract_declarator : '*' type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 300; {
/* line 11236 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [2-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [2-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					1 , NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = nMPC_FreeNode();
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [3-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1448: /* unary_abstract_declarator : '*' step type_qualifier_list abstract_declarator .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 300; {
/* line 11259 "mpcPars.lalr" */
  
			    yySynAttribute.unary_abstract_declarator.Ignore = yyAttrStackPtr [2-1].step.Ignore || yyAttrStackPtr [3-1].type_qualifier_list.Ignore;
			    Push_Pattern(
				mMPC_PointerType(
					yyAttrStackPtr [1-1].Scan.Position, NoTree , NoTree ,
					Make_TypeFlag(yyAttrStackPtr [3-1].type_qualifier_list.Qual.Const,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Volatile,
						yyAttrStackPtr [3-1].type_qualifier_list.Qual.Repl,
						NO , NO ,
						NO, NO, NO ,
						YES , yySynAttribute.unary_abstract_declarator.Ignore),
					1 ,
					yyAttrStackPtr [2-1].step.Value, NoTree 
				)
			    );
			    TopType()->MPC_Type.Flag.Ignore = yySynAttribute.unary_abstract_declarator.Ignore;
			    TopType()->MPC_PointerType.DynStep = yyAttrStackPtr [2-1].step.Tree; 
			     yySynAttribute.unary_abstract_declarator.EndPos = yyAttrStackPtr [4-1].abstract_declarator.EndPos;  
			  ;

			  
			;

} break;
case 1449: /* postfix_abstract_declarator : '(' unary_abstract_declarator ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 301; {
/* line 11282 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].unary_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1450: /* postfix_abstract_declarator : '(' postfix_abstract_declarator ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 301; {
/* line 11290 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].postfix_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1451: /* postfix_abstract_declarator : '(' postfixing_abstract_declarator ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 301; {
/* line 11298 "mpcPars.lalr" */

			  yySynAttribute.postfix_abstract_declarator.Ignore  =  yyAttrStackPtr [2-1].postfixing_abstract_declarator.Ignore;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [3-1].Scan.Position;
  
			;

} break;
case 1452: /* postfix_abstract_declarator : '(' unary_abstract_declarator ')' postfixing_abstract_declarator .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 301; {
/* line 11306 "mpcPars.lalr" */

			    yySynAttribute.postfix_abstract_declarator.Ignore = yyAttrStackPtr [2-1].unary_abstract_declarator.Ignore ||
					yyAttrStackPtr [4-1].postfixing_abstract_declarator.Ignore;
			  ;

			  
			  yySynAttribute.postfix_abstract_declarator.EndPos  =  yyAttrStackPtr [4-1].postfixing_abstract_declarator.EndPos;
  
			;

} break;
case 1453: /* step : ':' constant_expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 296; {
/* line 11316 "mpcPars.lalr" */

			    yySynAttribute.step.Ignore = yyAttrStackPtr [2-1].constant_expression.Ignore;
			    if(yyAttrStackPtr [2-1].constant_expression.IsIntConst &&
			       yyAttrStackPtr [2-1].constant_expression.Value<=0) {
			      yySynAttribute.step.Ignore = true;
			      yySynAttribute.step.Value = UNDEFINED;
			      Make_Message(474, xxError,
					   yyAttrStackPtr [2-1].constant_expression.Position, yyAttrStackPtr [2-1].constant_expression.Tree);
					   
			    }
			    else {
			      yySynAttribute.step.Value = yyAttrStackPtr [2-1].constant_expression.Value;
			      if(yyAttrStackPtr [2-1].constant_expression.IsIntConst)
				yySynAttribute.step.Tree = nMPC_FreeNode();
			      else
				yySynAttribute.step.Tree = yyAttrStackPtr [2-1].constant_expression.Tree;
			    }
			  ;

			  
			  yySynAttribute.step.EndPos  =  yyAttrStackPtr [2-1].constant_expression.EndPos;
  
			;

} break;
case 1454: /* grid_step : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 147; {
/* line 11340 "mpcPars.lalr" */

			  yySynAttribute.grid_step.Tree = NoTree;

			  yySynAttribute.grid_step.IsIntConst = true;

			  yySynAttribute.grid_step.Value = 1;
   
			  yySynAttribute.grid_step.Scope = false;

			  yySynAttribute.grid_step.Ignore = false;

			  yySynAttribute.grid_step.Position = NoPosition;

			;

} break;
case 1455: /* grid_step : ':' expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 147; {
/* line 11355 "mpcPars.lalr" */

			  yySynAttribute.grid_step.Tree  =  yyAttrStackPtr [2-1].expression.Tree;

			  yySynAttribute.grid_step.IsIntConst  =  yyAttrStackPtr [2-1].expression.IsIntConst;

			  yySynAttribute.grid_step.Value  =  yyAttrStackPtr [2-1].expression.Value;

			  yySynAttribute.grid_step.Scope  =  yyAttrStackPtr [2-1].expression.Scope;

			  yySynAttribute.grid_step.Ignore  =  yyAttrStackPtr [2-1].expression.Ignore;

			  yySynAttribute.grid_step.Position  =  yyAttrStackPtr [1-1].Scan.Position;

			;

} break;
case 1456: /* new_scope : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 160; {
/* line 11370 "mpcPars.lalr" */
 ;
{  Open_Scope(); Scope_Depth++; Default_Class = AUTO; ; } ;

} break;
case 1457: /* open_prototype_scope : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 302; {
/* line 11373 "mpcPars.lalr" */
 ;
{  Is_PrototypeScope = true; ; } ;

} break;
case 1458: /* close_prototype_scope : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 298; {
/* line 11376 "mpcPars.lalr" */
 ;
{  if(Opened_PrototypeScope){ Close_Scope(); Scope_Depth--;
					      Opened_PrototypeScope = false; } ; } ;

} break;
case 1459: /* nested_type_on : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 157; {
/* line 11380 "mpcPars.lalr" */
 ;
{  NestedType_ON(); ; } ;

} break;
case 1460: /* nested_type_off : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 159; {
/* line 11383 "mpcPars.lalr" */
 ;
{  NestedType_OFF(); ; } ;

} break;
case 1461: /* enable_dyn_array : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 163; {
/* line 11386 "mpcPars.lalr" */
 ;
{  DynArray_Possible++; ; } ;

} break;
case 1462: /* disable_dyn_array : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 164; {
/* line 11389 "mpcPars.lalr" */
 ;
{  DynArray_Possible--; ; } ;

} break;
case 1463: /* empty_net_declaring_list : net_declaration_specifier .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 161; {
/* line 11392 "mpcPars.lalr" */

			    tTree tmp;
			    yySynAttribute.empty_net_declaring_list.Tree = mMPC_NetDecl(yyAttrStackPtr [1-1].net_declaration_specifier.Position,
					NoTree, NoTree,
					yySynAttribute.empty_net_declaring_list.Class=yyAttrStackPtr [1-1].net_declaration_specifier.Class, NoDeclFlag,
					yyAttrStackPtr [1-1].net_declaration_specifier.Tree,
					NoTree
				   );
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Net = mMPC_FreeNode(yySynAttribute.empty_net_declaring_list.Tree);
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Flag.Exported = yyAttrStackPtr [1-1].net_declaration_specifier.Exported;
			    yySynAttribute.empty_net_declaring_list.Tree->MPC_NetDecl.Flag.Ignore = yySynAttribute.empty_net_declaring_list.Ignore = yyAttrStackPtr [1-1].net_declaration_specifier.Ignore;
			  ;

			;

} break;
case 1464: /* scheme_declaration : scheme '{' scheme_declaring_list '}' ';' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 223; {
/* line 11407 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaration.Tree = mMPC_Compound(yyAttrStackPtr [5-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						 NoTree, NO, NoTree,
						 ReverseTree(yyAttrStackPtr [3-1].scheme_declaring_list.Tree)
				   );
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Stats->MPC_Stat.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Decls = mMPC_FreeNode(yySynAttribute.scheme_declaration.Tree);
			    yySynAttribute.scheme_declaration.Tree = mMPC_Scheme(yyAttrStackPtr [5-1].Scan.Position, yySynAttribute.scheme_declaration.Tree);
			  ;

			  yySynAttribute.scheme_declaration.Ignore = yyAttrStackPtr [1-1].Scan.scheme.Ignore || yyAttrStackPtr [3-1].scheme_declaring_list.Ignore;

			;

} break;
case 1465: /* scheme_declaration : scheme '{' declaration_list scheme_declaring_list '}' ';' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 223; {
/* line 11421 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaration.Tree = mMPC_Compound(yyAttrStackPtr [6-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						 NoTree, NO,
						 ReverseTree(yyAttrStackPtr [3-1].declaration_list.Tree),
						 ReverseTree(yyAttrStackPtr [4-1].scheme_declaring_list.Tree)
				   );
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Stats->MPC_Stat.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree->MPC_Compound.Decls->MPC_Decls.Prev->MPC_FreeNode.Parent = yySynAttribute.scheme_declaration.Tree;
			    yySynAttribute.scheme_declaration.Tree = mMPC_Scheme(yyAttrStackPtr [6-1].Scan.Position, yySynAttribute.scheme_declaration.Tree);
			  ;

			  yySynAttribute.scheme_declaration.Ignore = yyAttrStackPtr [1-1].Scan.scheme.Ignore || yyAttrStackPtr [4-1].scheme_declaring_list.Ignore;

			;

} break;
case 1466: /* scheme_declaring_list : statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 303; {
/* line 11436 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaring_list.Tree = yyAttrStackPtr [1-1].statement.Tree;
			    yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Next =
				 yyAttrStackPtr [1-1].statement.Chain->MPC_Stats.Prev = nMPC_FreeNode();
			  ;

			  yySynAttribute.scheme_declaring_list.Ignore  =  yyAttrStackPtr [1-1].statement.Ignore;

			;

} break;
case 1467: /* scheme_declaring_list : scheme_declaring_list statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 303; {
/* line 11446 "mpcPars.lalr" */

			    yySynAttribute.scheme_declaring_list.Tree = yyAttrStackPtr [2-1].statement.Tree;
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				 yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = yyAttrStackPtr [1-1].scheme_declaring_list.Tree;
			  ;

			  yySynAttribute.scheme_declaring_list.Ignore = yyAttrStackPtr [1-1].scheme_declaring_list.Ignore || yyAttrStackPtr [2-1].statement.Ignore;

			;

} break;
case 1468: /* scheme_statement : computation_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 286; {
/* line 11456 "mpcPars.lalr" */

			  yySynAttribute.scheme_statement.Tree  =  yyAttrStackPtr [1-1].computation_statement.Tree;

			  yySynAttribute.scheme_statement.Chain  =  yyAttrStackPtr [1-1].computation_statement.Tree;

			  yySynAttribute.scheme_statement.Ignore  =  yyAttrStackPtr [1-1].computation_statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [1-1].computation_statement.EndPos;

			;

} break;
case 1469: /* scheme_statement : communication_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 286; {
/* line 11467 "mpcPars.lalr" */

			  yySynAttribute.scheme_statement.Tree  =  yyAttrStackPtr [1-1].communication_statement.Tree;

			  yySynAttribute.scheme_statement.Chain  =  yyAttrStackPtr [1-1].communication_statement.Tree;

			  yySynAttribute.scheme_statement.Ignore  =  yyAttrStackPtr [1-1].communication_statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [1-1].communication_statement.EndPos;

			;

} break;
case 1470: /* scheme_statement : par statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 286; {
/* line 11478 "mpcPars.lalr" */

			    yySynAttribute.scheme_statement.Tree = yySynAttribute.scheme_statement.Chain = mMPC_ParScheme(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						  SINGLE_NODE_LIST, NoTree, NoTree, NoTree, NoTree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Init = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Cond = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Reinit = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [2-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Stats = ReverseTree(yyAttrStackPtr [2-1].statement.Tree);
			  ;

			  yySynAttribute.scheme_statement.Ignore = yyAttrStackPtr [1-1].Scan.par.Ignore || yyAttrStackPtr [2-1].statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [2-1].statement.EndPos;

			;

} break;
case 1471: /* scheme_statement : par '(' expression_opt ';' expression_opt ';' expression_opt ')' statement .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 286; {
/* line 11495 "mpcPars.lalr" */

			    yySynAttribute.scheme_statement.Tree = yySynAttribute.scheme_statement.Chain = mMPC_ParScheme(yyAttrStackPtr [1-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						  SINGLE_NODE_LIST, yyAttrStackPtr [3-1].expression_opt.Tree,
						  yyAttrStackPtr [5-1].expression_opt.Tree, yyAttrStackPtr [7-1].expression_opt.Tree, NoTree);
			    yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Next =
				yyAttrStackPtr [9-1].statement.Chain->MPC_Stats.Prev = mMPC_FreeNode(yySynAttribute.scheme_statement.Tree);
			    yySynAttribute.scheme_statement.Tree->MPC_ParScheme.Stats = ReverseTree(yyAttrStackPtr [9-1].statement.Tree);
			  ;

			  yySynAttribute.scheme_statement.Ignore = yyAttrStackPtr [1-1].Scan.par.Ignore || yyAttrStackPtr [3-1].expression_opt.Ignore || yyAttrStackPtr [5-1].expression_opt.Ignore ||
				    yyAttrStackPtr [7-1].expression_opt.Ignore || yyAttrStackPtr [9-1].statement.Ignore;

			  yySynAttribute.scheme_statement.EndPos  =  yyAttrStackPtr [9-1].statement.EndPos;

			;

} break;
case 1472: /* computation_statement : expression '%%' '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 304; {
/* line 11511 "mpcPars.lalr" */

			    yySynAttribute.computation_statement.Tree = mMPC_CompScheme(yyAttrStackPtr [2-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						   SINGLE_NODE_LIST, yyAttrStackPtr [1-1].expression.Tree,
						   ReverseTree(yyAttrStackPtr [4-1].constant_expression_list.Tree));
			    yySynAttribute.computation_statement.Tree->MPC_CompScheme.Node->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.computation_statement.Tree;
			  ;

			  yySynAttribute.computation_statement.Ignore = yyAttrStackPtr [1-1].expression.Ignore || yyAttrStackPtr [4-1].constant_expression_list.Ignore;

			  yySynAttribute.computation_statement.EndPos  =  yyAttrStackPtr [6-1].Scan.Position;

			;

} break;
case 1473: /* communication_statement : expression '%%' '[' constant_expression_list ']' '->' '[' constant_expression_list ']' ';' .*/
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 305; {
/* line 11524 "mpcPars.lalr" */

			    yySynAttribute.communication_statement.Tree = mMPC_CommScheme(yyAttrStackPtr [2-1].Scan.Position, NoTree, NoTree, NoStatFlag,
						   SINGLE_NODE_LIST, yyAttrStackPtr [1-1].expression.Tree,
						   ReverseTree(yyAttrStackPtr [4-1].constant_expression_list.Tree), ReverseTree(yyAttrStackPtr [8-1].constant_expression_list.Tree));
			    yySynAttribute.communication_statement.Tree->MPC_CommScheme.From->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.communication_statement.Tree;
			    yySynAttribute.communication_statement.Tree->MPC_CommScheme.To->MPC_Exprs.Prev->MPC_FreeNode.Parent = yySynAttribute.communication_statement.Tree;
			  ;

			  yySynAttribute.communication_statement.Ignore = yyAttrStackPtr [1-1].expression.Ignore || yyAttrStackPtr [4-1].constant_expression_list.Ignore || yyAttrStackPtr [8-1].constant_expression_list.Ignore;

			  yySynAttribute.communication_statement.EndPos  =  yyAttrStackPtr [10-1].Scan.Position;

			;

} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop; /* read nonterminal reduce ? */
	       yyState = yyFinalToProd [yyState - yyFirstReadTermState];
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, mpcScan_Attribute);
	    yyTerminal = mpcScan_GetToken ();
	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, mpcScan_Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = mpcPars_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, mpcScan_Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = mpcScan_GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, mpcScan_Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadTermState) {		/* read or read terminal reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadTermState];	/* read nonterminal reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadTermState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadTermState]; /* read nonterminal reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginmpcPars ()
   {
/* line 404 "mpcPars.lalr" */



  /*Errors_Exit = Print_Messages;  **** call this function when xxFatal-error; */

  IgnoreAll = false;

  NativeMode = NATIVE_MPC;

  InitIdents();
  Init_TypeTable();
  Init_ScopeStack();
  Init_SubnetTable();
  (void)Make_UniqueNumber(NoTree);

#ifndef __CB_COMPILER__
  if(DEMO_MODE) WL_Init();
#endif

  LabelList = NoTree;
  Original_ParamList = NoTree;

  TreeRoot = mMPC_Root (NoTree, NoTree, NoTree,
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_Net()),
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_Net()), 
			Clean_OutAttributes(nMPC_Net()), Clean_OutAttributes(nMPC_NetList()), 
			Clean_OutAttributes(nMPC_NetList()), Clean_OutAttributes(nMPC_NetList()), 
			Clean_OutAttributes(nMPC_NetList()), Clean_OutAttributes(nMPC_NetList())
	     );
  TreeRoot->MPC_Root.Source = mMPC_FreeNode (TreeRoot);
  TreeRoot->MPC_Root.Messages = mMPC_FreeNode (TreeRoot);
  TreeRoot->MPC_Root.Host->MPC_Net.Ident = MakeIdent(HOST_NAME, strlen(HOST_NAME));
  TreeRoot->MPC_Root.Host->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Host->MPC_Net.SingleNode = true;
  TreeRoot->MPC_Root.SingleNode->MPC_Net.Ident =
				 MakeIdent(SINGLE_NODE_NAME,strlen(SINGLE_NODE_NAME));
  TreeRoot->MPC_Root.SingleNode->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.SingleNode->MPC_Net.SingleNode = true;
  TreeRoot->MPC_Root.ComputingSpace->MPC_Net.Ident = MakeIdent(ALL_NAME, strlen(ALL_NAME));
  TreeRoot->MPC_Root.ComputingSpace->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Const->MPC_Net.Ident = MakeIdent(CONST_NET_NAME, strlen(CONST_NET_NAME));
  TreeRoot->MPC_Root.Const->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.Recon->MPC_Net.Ident = MakeIdent(RECON_NAME, strlen(RECON_NAME));
  TreeRoot->MPC_Root.Recon->MPC_Net.Topology = CONST;
  TreeRoot->MPC_Root.HostList->MPC_NetList.Net = HOST;
  TreeRoot->MPC_Root.HostList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.HostList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Net = SINGLE_NODE;
  TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.SingleNodeList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Net = COMPUTING_SPACE;
  TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ComputingSpaceList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ReconList->MPC_NetList.Net = RECON_NET;
  TreeRoot->MPC_Root.ReconList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ReconList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);
  TreeRoot->MPC_Root.ConstList->MPC_NetList.Net = CONST_NET;
  TreeRoot->MPC_Root.ConstList->MPC_NetList.Next =
	    TreeRoot->MPC_Root.ConstList->MPC_NetList.Prev = mMPC_FreeNode(TreeRoot);

  ErrorNet = mMPC_Net(NoPosition, MakeIdent(ERROR_NAME, strlen(ERROR_NAME)),
		      false, HOST, NoTree, NoTree, CONST, NoTree);
  ErrorNetList = mMPC_NetList(NoTree, NoTree, ErrorNet);
  ErrorNetList->MPC_NetList.Next = ErrorNetList->MPC_NetList.Prev = nMPC_FreeNode();
  ErrorNetList->MPC_NetList.UnReduceable = true;


  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, VOID));
  VoidType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, CHAR));
  CharType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, INT));
  IntType = Make_Type();

  ConstIntType = CopyTree(IntType);
  ConstIntType->MPC_Type.Flag.Const = YES;
  Push_Pattern(ConstIntType);
  ConstIntType = Make_Type();

  ReplIntType = CopyTree(IntType);
  ReplIntType->MPC_Type.Flag.Repl = YES;
  Push_Pattern(ReplIntType);
  ReplIntType = Make_Type();

  ReplConstIntType = CopyTree(ConstIntType);
  ReplConstIntType->MPC_Type.Flag.Repl = YES;
  Push_Pattern(ReplConstIntType);
  ReplConstIntType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, UNSIGNED));
  UnsignedType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, LONG));
  LongType = Make_Type();

  Push_Pattern(
	mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, UNSIGNED_LONG
	)
  );
  UnsignedLongType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, FLOAT));
  FloatType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag, DOUBLE));
  DoubleType = Make_Type();

  ReplConstDoubleType = CopyTree(DoubleType);
  ReplConstDoubleType->MPC_Type.Flag.Repl = YES;
  ReplConstDoubleType->MPC_Type.Flag.Const = YES;
  Push_Pattern(ReplConstDoubleType);
  ReplConstDoubleType = Make_Type();

  Push_Pattern(mMPC_BasicType(NoPosition,NoTree/*Next*/,NoTree/*Prev*/,NoTypeFlag,LONG_DOUBLE));
  LongDoubleType = Make_Type();

	/* 'long long' extensions: */

  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("mpC_long_long", 13), LongType)
  );
  LongLongType = Make_Type();
  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("mpC_unsigned_long_long", 22), UnsignedLongType)
  );
  UnsignedLongLongType = Make_Type();


  Push_Pattern(mMPC_BasicType(NoPosition,NoTree/*Next*/,NoTree/*Prev*/,NoTypeFlag,NO_TYPE));
  ErrorType = Make_Type();

  Push_Pattern(
	mMPC_FunctionType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag,
		UNDEFINED/*NumberOfComponents*/, NODAL/*Kind*/,
		IntType/*ResultType*/, NoTree/*NetParamType*/, NoTree/*NetParam*/,
		NoTree/*NetworkParamList*/, NoTree/*ParamList*/
	)
  );
  Default_FunctionType = Make_Type();
  Default_FunctionType->MPC_FunctionType.NetworkParamList = mMPC_FreeNode(Default_FunctionType);
  Default_FunctionType->MPC_FunctionType.ParamList = mMPC_FreeNode(Default_FunctionType);
  Default_FunctionType->MPC_FunctionType.Flag.Source = NO;
  Default_FunctionType->MPC_FunctionType.Flag.Nodal = YES;
  Default_FunctionType->MPC_FunctionType.Flag.Native = NativeMode;

  Push_Pattern(
	mMPC_FunctionType(NoPosition, NoTree/*Next*/, NoTree/*Prev*/, NoTypeFlag,
		UNDEFINED/*NumberOfComponents*/, BASIC/*Kind*/,
		IntType/*ResultType*/, NoTree/*NetParamType*/, NoTree/*NetParam*/,
		NoTree/*NetworkParamList*/, NoTree/*ParamList*/
	)
  );
  Barrier_FunctionType = Make_Type();
  Barrier_FunctionType->MPC_FunctionType.NetworkParamList = mMPC_FreeNode(Barrier_FunctionType);
  Barrier_FunctionType->MPC_FunctionType.ParamList = mMPC_FreeNode(Barrier_FunctionType);
  Barrier_FunctionType->MPC_FunctionType.Flag.Source = NO;
  Barrier_FunctionType->MPC_FunctionType.Flag.Network = YES;
  Barrier_FunctionType->MPC_FunctionType.Flag.Native = NativeMode;

  /* Subtree needed for 'coordof'(2) implementation: */
  DummyIdent = NoIdent;


#ifndef __CB_COMPILER__
	/* Patterns for generation of topo-functions: */

  Emit_TopoTypes();

	/* Type "Int" for runtime functions: */

  Push_Pattern(
    mMPC_Typedef(NoPosition, NoTree, NoTree, NoTypeFlag, MakeIdent("Int", 3), IntType)
  );
  MPI_Int_Type = Make_Type();

#endif



   }

void ClosempcPars ()
   {
/* line 586 "mpcPars.lalr" */



  TreeRoot->MPC_Root.Source =
    ReverseTree(TreeRoot->MPC_Root.Source);




   }
