/* $Id: Scanner.c,v 2.17 1992/09/24 13:14:00 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "mpcScan.h"

# ifdef __cplusplus
extern "C" {
#    include "mpcScanSource.h"
#    include "System.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Positions.h"
}
# else
#    include "mpcScanSource.h"
#    include "System.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Positions.h"
# endif
 
# include <stdio.h>
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = mpcScan_TokenPtr + mpcScan_TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (mpcScan_TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= mpcScan_TokenLength - n; mpcScan_TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\377'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	586
# define yyTableSize	3810
# define yyEobState	80
# define yyDefaultState	81
# define STD	1
# define comment	3
# define linecomment	5
# define position	7
# define file	9
# define pragma	11
# define header	13
# define keywords	15
# define native	17
# define unused	19
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		mpcScan_TokenPtr	;
	short		mpcScan_TokenLength	;
	mpcScan_tScanAttribute	mpcScan_Attribute	;
	void		(* mpcScan_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 84},
{1, 82},
{0, 0},
{1, 33},
{1, 33},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 87},
{1, 394},
{1, 40},
{1, 527},
{28, 28},
{1, 292},
{1, 350},
{1, 64},
{1, 500},
{1, 498},
{1, 364},
{1, 359},
{1, 499},
{1, 357},
{1, 60},
{1, 362},
{1, 51},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 47},
{1, 497},
{1, 435},
{1, 335},
{1, 396},
{1, 352},
{1, 391},
{1, 344},
{25, 25},
{30, 584},
{74, 37},
{336, 337},
{21, 21},
{21, 22},
{73, 63},
{344, 345},
{73, 63},
{348, 349},
{353, 354},
{1, 50},
{355, 356},
{364, 365},
{44, 27},
{383, 386},
{49, 31},
{383, 384},
{391, 401},
{394, 395},
{391, 400},
{396, 397},
{402, 403},
{25, 25},
{43, 27},
{48, 31},
{1, 367},
{21, 21},
{1, 503},
{1, 348},
{21, 21},
{95, 96},
{1, 410},
{1, 287},
{1, 275},
{1, 314},
{1, 326},
{1, 256},
{1, 308},
{1, 248},
{1, 330},
{94, 95},
{21, 21},
{1, 230},
{1, 93},
{1, 199},
{44, 27},
{1, 189},
{49, 31},
{1, 161},
{1, 127},
{1, 115},
{1, 437},
{1, 103},
{1, 316},
{97, 98},
{43, 27},
{48, 31},
{1, 436},
{1, 346},
{1, 434},
{1, 496},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{22, 80},
{79, 80},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 88},
{3, 46},
{3, 46},
{3, 528},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 30},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 577},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{98, 99},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{3, 46},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{99, 100},
{5, 575},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 89},
{5, 45},
{5, 45},
{5, 529},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 29},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 579},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{100, 101},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{5, 45},
{7, 84},
{7, 526},
{101, 102},
{51, 62},
{104, 105},
{105, 106},
{106, 107},
{52, 34},
{107, 108},
{109, 110},
{110, 111},
{9, 85},
{9, 525},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{63, 55},
{7, 90},
{111, 112},
{112, 113},
{7, 527},
{113, 114},
{116, 117},
{117, 118},
{118, 119},
{119, 120},
{122, 123},
{123, 124},
{9, 91},
{51, 62},
{9, 65},
{9, 527},
{7, 581},
{52, 34},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{7, 42},
{9, 581},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{124, 125},
{125, 126},
{53, 34},
{128, 129},
{11, 24},
{129, 130},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{11, 24},
{13, 84},
{13, 82},
{53, 34},
{15, 84},
{15, 82},
{17, 84},
{17, 82},
{130, 131},
{57, 36},
{131, 132},
{58, 36},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{115, 116},
{133, 134},
{13, 87},
{55, 54},
{13, 66},
{15, 87},
{93, 221},
{17, 87},
{15, 527},
{55, 54},
{17, 527},
{35, 73},
{35, 54},
{134, 135},
{56, 57},
{103, 104},
{115, 424},
{93, 94},
{35, 54},
{57, 36},
{15, 581},
{58, 36},
{17, 581},
{56, 58},
{136, 137},
{103, 446},
{137, 138},
{121, 139},
{140, 141},
{141, 142},
{13, 67},
{142, 143},
{139, 149},
{121, 487},
{145, 146},
{55, 54},
{121, 133},
{146, 147},
{15, 510},
{139, 140},
{144, 153},
{55, 54},
{17, 504},
{35, 73},
{35, 54},
{121, 122},
{56, 57},
{144, 145},
{147, 148},
{15, 513},
{35, 54},
{149, 150},
{150, 151},
{151, 152},
{153, 154},
{56, 58},
{15, 517},
{60, 402},
{154, 155},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{60, 35},
{155, 156},
{157, 158},
{159, 160},
{161, 162},
{163, 164},
{165, 166},
{166, 167},
{167, 168},
{168, 169},
{169, 170},
{171, 172},
{172, 173},
{173, 174},
{174, 175},
{175, 176},
{17, 507},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 86},
{19, 83},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 92},
{19, 21},
{19, 21},
{19, 530},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 582},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{177, 178},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{19, 21},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{178, 179},
{180, 181},
{181, 182},
{183, 184},
{184, 185},
{185, 186},
{186, 187},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{187, 188},
{189, 190},
{190, 191},
{191, 192},
{24, 24},
{192, 193},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{193, 194},
{196, 197},
{197, 198},
{200, 201},
{201, 202},
{203, 204},
{204, 205},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{205, 206},
{206, 207},
{207, 208},
{209, 210},
{32, 32},
{210, 211},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{32, 32},
{39, 40},
{195, 203},
{199, 209},
{211, 212},
{212, 213},
{39, 40},
{213, 214},
{215, 216},
{216, 217},
{217, 218},
{218, 219},
{195, 196},
{199, 200},
{158, 177},
{39, 40},
{39, 40},
{39, 40},
{39, 40},
{39, 40},
{39, 40},
{39, 40},
{39, 40},
{158, 165},
{219, 220},
{221, 222},
{222, 223},
{158, 159},
{223, 224},
{61, 35},
{39, 40},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{61, 61},
{162, 180},
{224, 225},
{226, 234},
{227, 228},
{162, 404},
{228, 229},
{226, 227},
{231, 232},
{232, 233},
{162, 171},
{230, 239},
{61, 73},
{234, 235},
{162, 163},
{230, 231},
{96, 282},
{96, 268},
{162, 294},
{39, 40},
{96, 252},
{230, 473},
{96, 244},
{235, 236},
{39, 40},
{39, 40},
{96, 226},
{96, 215},
{96, 195},
{39, 40},
{96, 183},
{236, 237},
{96, 157},
{96, 121},
{96, 109},
{237, 238},
{96, 97},
{39, 40},
{239, 240},
{240, 241},
{241, 242},
{39, 40},
{242, 243},
{39, 40},
{61, 73},
{39, 40},
{244, 245},
{39, 59},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{245, 246},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 38},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{246, 247},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{248, 249},
{249, 250},
{250, 251},
{253, 254},
{252, 260},
{254, 255},
{258, 259},
{261, 262},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{252, 253},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 39},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{260, 266},
{264, 265},
{40, 40},
{40, 40},
{40, 40},
{260, 261},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{268, 269},
{40, 40},
{40, 40},
{40, 40},
{269, 270},
{40, 40},
{270, 271},
{40, 40},
{271, 272},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{272, 273},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{40, 40},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{273, 274},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{277, 278},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 41},
{41, 67},
{41, 67},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 78},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{59, 40},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{278, 279},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{41, 67},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{42, 42},
{279, 280},
{256, 263},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{256, 257},
{276, 302},
{276, 277},
{256, 312},
{257, 258},
{280, 281},
{42, 43},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{127, 144},
{257, 470},
{42, 44},
{263, 267},
{282, 283},
{127, 478},
{127, 461},
{275, 332},
{263, 264},
{127, 136},
{283, 284},
{284, 285},
{285, 286},
{288, 289},
{275, 482},
{289, 290},
{290, 291},
{127, 414},
{127, 128},
{287, 288},
{127, 321},
{275, 276},
{294, 295},
{295, 296},
{296, 297},
{42, 43},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{62, 56},
{287, 298},
{298, 299},
{42, 44},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{299, 300},
{300, 301},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{303, 304},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{304, 305},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{302, 453},
{302, 303},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{305, 306},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{306, 307},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{46, 46},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{47, 47},
{308, 309},
{309, 310},
{292, 293},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{310, 311},
{312, 313},
{315, 466},
{316, 317},
{317, 318},
{47, 48},
{314, 338},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{292, 361},
{47, 49},
{318, 319},
{314, 315},
{319, 320},
{321, 322},
{322, 323},
{323, 324},
{324, 325},
{326, 327},
{327, 328},
{326, 431},
{328, 329},
{332, 333},
{330, 331},
{333, 334},
{338, 339},
{339, 340},
{340, 341},
{341, 342},
{50, 40},
{326, 419},
{330, 476},
{342, 343},
{47, 48},
{50, 64},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{69, 74},
{335, 336},
{47, 49},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{372, 373},
{352, 398},
{352, 353},
{335, 355},
{335, 399},
{375, 376},
{378, 379},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{352, 369},
{381, 382},
{384, 385},
{335, 366},
{50, 32},
{386, 387},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{50, 32},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{404, 405},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{405, 406},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 75},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{70, 65},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{406, 407},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{64, 74},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{407, 408},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 26},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 76},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{71, 66},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{408, 409},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{65, 65},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{410, 411},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 23},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 77},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{72, 67},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{411, 412},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{66, 66},
{68, 68},
{68, 68},
{68, 68},
{68, 68},
{68, 68},
{68, 68},
{68, 68},
{68, 68},
{346, 347},
{357, 388},
{371, 377},
{412, 413},
{415, 416},
{416, 417},
{417, 418},
{75, 74},
{350, 393},
{374, 375},
{419, 420},
{362, 585},
{75, 74},
{420, 421},
{359, 389},
{421, 422},
{362, 576},
{357, 358},
{357, 390},
{422, 423},
{68, 52},
{75, 74},
{75, 74},
{75, 74},
{75, 74},
{75, 74},
{75, 74},
{75, 74},
{75, 74},
{68, 53},
{362, 363},
{350, 351},
{359, 360},
{371, 372},
{414, 415},
{424, 425},
{75, 74},
{425, 426},
{426, 427},
{76, 65},
{427, 428},
{428, 429},
{431, 432},
{432, 433},
{76, 65},
{437, 438},
{439, 440},
{440, 441},
{442, 443},
{443, 444},
{444, 445},
{414, 442},
{68, 52},
{76, 65},
{76, 65},
{76, 65},
{76, 65},
{76, 65},
{76, 65},
{76, 65},
{76, 65},
{68, 53},
{438, 439},
{346, 392},
{374, 380},
{75, 74},
{446, 485},
{447, 448},
{76, 65},
{446, 447},
{75, 74},
{75, 74},
{438, 455},
{448, 449},
{449, 450},
{75, 74},
{450, 451},
{451, 452},
{453, 454},
{455, 456},
{456, 457},
{457, 458},
{458, 459},
{75, 74},
{459, 460},
{461, 462},
{462, 463},
{75, 74},
{463, 464},
{75, 74},
{464, 465},
{75, 74},
{466, 467},
{75, 69},
{467, 468},
{468, 469},
{470, 471},
{76, 65},
{471, 472},
{473, 474},
{474, 475},
{476, 477},
{76, 65},
{76, 65},
{461, 492},
{478, 479},
{479, 480},
{76, 65},
{480, 481},
{482, 483},
{483, 484},
{485, 486},
{77, 66},
{487, 488},
{488, 489},
{76, 65},
{489, 490},
{77, 66},
{490, 491},
{76, 65},
{492, 493},
{76, 65},
{493, 494},
{76, 65},
{494, 495},
{76, 70},
{77, 66},
{77, 66},
{77, 66},
{77, 66},
{77, 66},
{77, 66},
{77, 66},
{77, 66},
{501, 502},
{504, 505},
{505, 506},
{78, 67},
{507, 508},
{508, 509},
{511, 512},
{77, 66},
{78, 67},
{510, 511},
{513, 514},
{510, 522},
{514, 515},
{515, 516},
{517, 518},
{518, 519},
{519, 520},
{78, 67},
{78, 67},
{78, 67},
{78, 67},
{78, 67},
{78, 67},
{78, 67},
{78, 67},
{367, 374},
{520, 521},
{522, 523},
{523, 524},
{367, 501},
{367, 381},
{527, 555},
{78, 67},
{528, 560},
{531, 532},
{532, 533},
{77, 66},
{529, 565},
{527, 531},
{533, 534},
{528, 537},
{77, 66},
{77, 66},
{534, 535},
{529, 543},
{530, 570},
{77, 66},
{367, 370},
{535, 536},
{367, 368},
{367, 383},
{537, 538},
{530, 549},
{538, 539},
{77, 66},
{539, 540},
{540, 541},
{541, 542},
{77, 66},
{543, 544},
{77, 66},
{78, 67},
{77, 66},
{544, 545},
{77, 71},
{545, 546},
{78, 67},
{78, 67},
{546, 547},
{547, 548},
{549, 550},
{78, 67},
{550, 551},
{551, 552},
{552, 553},
{553, 554},
{555, 556},
{556, 557},
{557, 558},
{78, 67},
{367, 430},
{367, 378},
{558, 559},
{78, 67},
{560, 561},
{78, 67},
{561, 562},
{78, 67},
{562, 563},
{78, 72},
{563, 564},
{565, 566},
{566, 567},
{567, 568},
{568, 569},
{570, 571},
{571, 572},
{572, 573},
{573, 574},
{577, 585},
{579, 585},
{581, 585},
{582, 586},
{0, 0},
{577, 578},
{579, 580},
{581, 576},
{582, 583},
{0, 0},
{0, 0},
{0, 0},
{367, 371},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [127],
& yyComb [0],
& yyComb [383],
& yyComb [0],
& yyComb [630],
& yyComb [0],
& yyComb [641],
& yyComb [0],
& yyComb [624],
& yyComb [0],
& yyComb [738],
& yyComb [0],
& yyComb [741],
& yyComb [0],
& yyComb [743],
& yyComb [0],
& yyComb [853],
& yyComb [0],
& yyComb [60],
& yyComb [9],
& yyComb [0],
& yyComb [1061],
& yyComb [56],
& yyComb [0],
& yyComb [0],
& yyComb [4],
& yyComb [0],
& yyComb [19],
& yyComb [0],
& yyComb [1136],
& yyComb [0],
& yyComb [0],
& yyComb [710],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1225],
& yyComb [1346],
& yyComb [1602],
& yyComb [1810],
& yyComb [4],
& yyComb [3],
& yyComb [1928],
& yyComb [2184],
& yyComb [2392],
& yyComb [5],
& yyComb [5],
& yyComb [2462],
& yyComb [554],
& yyComb [561],
& yyComb [641],
& yyComb [0],
& yyComb [701],
& yyComb [706],
& yyComb [670],
& yyComb [681],
& yyComb [1602],
& yyComb [779],
& yyComb [1241],
& yyComb [1822],
& yyComb [604],
& yyComb [2585],
& yyComb [2841],
& yyComb [3097],
& yyComb [0],
& yyComb [3305],
& yyComb [2405],
& yyComb [2585],
& yyComb [2841],
& yyComb [3097],
& yyComb [28],
& yyComb [28],
& yyComb [3334],
& yyComb [3366],
& yyComb [3439],
& yyComb [3464],
& yyComb [10],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [673],
& yyComb [7],
& yyComb [1],
& yyComb [1216],
& yyComb [19],
& yyComb [155],
& yyComb [276],
& yyComb [399],
& yyComb [527],
& yyComb [0],
& yyComb [682],
& yyComb [544],
& yyComb [528],
& yyComb [534],
& yyComb [533],
& yyComb [0],
& yyComb [543],
& yyComb [540],
& yyComb [562],
& yyComb [553],
& yyComb [564],
& yyComb [0],
& yyComb [663],
& yyComb [558],
& yyComb [567],
& yyComb [558],
& yyComb [568],
& yyComb [0],
& yyComb [696],
& yyComb [573],
& yyComb [562],
& yyComb [614],
& yyComb [600],
& yyComb [0],
& yyComb [1794],
& yyComb [620],
& yyComb [610],
& yyComb [653],
& yyComb [640],
& yyComb [0],
& yyComb [658],
& yyComb [662],
& yyComb [0],
& yyComb [681],
& yyComb [675],
& yyComb [0],
& yyComb [703],
& yyComb [695],
& yyComb [688],
& yyComb [698],
& yyComb [0],
& yyComb [711],
& yyComb [701],
& yyComb [696],
& yyComb [715],
& yyComb [0],
& yyComb [711],
& yyComb [723],
& yyComb [707],
& yyComb [0],
& yyComb [714],
& yyComb [729],
& yyComb [723],
& yyComb [0],
& yyComb [737],
& yyComb [1173],
& yyComb [731],
& yyComb [0],
& yyComb [739],
& yyComb [1200],
& yyComb [733],
& yyComb [0],
& yyComb [745],
& yyComb [727],
& yyComb [739],
& yyComb [734],
& yyComb [736],
& yyComb [0],
& yyComb [750],
& yyComb [732],
& yyComb [744],
& yyComb [739],
& yyComb [741],
& yyComb [0],
& yyComb [869],
& yyComb [1009],
& yyComb [0],
& yyComb [1009],
& yyComb [1011],
& yyComb [0],
& yyComb [1025],
& yyComb [1009],
& yyComb [1023],
& yyComb [1015],
& yyComb [1036],
& yyComb [0],
& yyComb [1056],
& yyComb [1040],
& yyComb [1054],
& yyComb [1047],
& yyComb [1078],
& yyComb [0],
& yyComb [1159],
& yyComb [1095],
& yyComb [1095],
& yyComb [0],
& yyComb [1160],
& yyComb [1097],
& yyComb [1097],
& yyComb [0],
& yyComb [1083],
& yyComb [1084],
& yyComb [1106],
& yyComb [1116],
& yyComb [1128],
& yyComb [0],
& yyComb [1114],
& yyComb [1116],
& yyComb [1141],
& yyComb [1151],
& yyComb [1164],
& yyComb [0],
& yyComb [1165],
& yyComb [1158],
& yyComb [1157],
& yyComb [1155],
& yyComb [1161],
& yyComb [0],
& yyComb [1174],
& yyComb [1173],
& yyComb [1172],
& yyComb [1179],
& yyComb [0],
& yyComb [1200],
& yyComb [1192],
& yyComb [1197],
& yyComb [0],
& yyComb [1208],
& yyComb [1196],
& yyComb [1200],
& yyComb [0],
& yyComb [1201],
& yyComb [1218],
& yyComb [1213],
& yyComb [1229],
& yyComb [0],
& yyComb [1226],
& yyComb [1234],
& yyComb [1222],
& yyComb [1236],
& yyComb [0],
& yyComb [1233],
& yyComb [1241],
& yyComb [1269],
& yyComb [0],
& yyComb [1283],
& yyComb [1280],
& yyComb [1280],
& yyComb [0],
& yyComb [1301],
& yyComb [1296],
& yyComb [1279],
& yyComb [0],
& yyComb [1772],
& yyComb [1783],
& yyComb [1280],
& yyComb [0],
& yyComb [1333],
& yyComb [1285],
& yyComb [0],
& yyComb [1786],
& yyComb [1328],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1345],
& yyComb [1349],
& yyComb [1348],
& yyComb [1364],
& yyComb [1362],
& yyComb [1510],
& yyComb [0],
& yyComb [1803],
& yyComb [1771],
& yyComb [1522],
& yyComb [1629],
& yyComb [1757],
& yyComb [1783],
& yyComb [0],
& yyComb [1796],
& yyComb [1793],
& yyComb [1805],
& yyComb [1801],
& yyComb [0],
& yyComb [1811],
& yyComb [1796],
& yyComb [1809],
& yyComb [1805],
& yyComb [0],
& yyComb [2415],
& yyComb [0],
& yyComb [1798],
& yyComb [1802],
& yyComb [1807],
& yyComb [0],
& yyComb [1825],
& yyComb [1840],
& yyComb [1831],
& yyComb [0],
& yyComb [2078],
& yyComb [1865],
& yyComb [1945],
& yyComb [2109],
& yyComb [2210],
& yyComb [0],
& yyComb [2339],
& yyComb [2335],
& yyComb [2352],
& yyComb [0],
& yyComb [2350],
& yyComb [0],
& yyComb [2368],
& yyComb [2348],
& yyComb [2362],
& yyComb [2362],
& yyComb [2370],
& yyComb [2379],
& yyComb [0],
& yyComb [2376],
& yyComb [2366],
& yyComb [2384],
& yyComb [2380],
& yyComb [0],
& yyComb [2377],
& yyComb [2371],
& yyComb [2387],
& yyComb [0],
& yyComb [2388],
& yyComb [0],
& yyComb [2374],
& yyComb [2390],
& yyComb [0],
& yyComb [2463],
& yyComb [6],
& yyComb [0],
& yyComb [2390],
& yyComb [2396],
& yyComb [2377],
& yyComb [2387],
& yyComb [2383],
& yyComb [0],
& yyComb [8],
& yyComb [0],
& yyComb [3300],
& yyComb [0],
& yyComb [13],
& yyComb [0],
& yyComb [3331],
& yyComb [0],
& yyComb [2460],
& yyComb [14],
& yyComb [0],
& yyComb [16],
& yyComb [0],
& yyComb [3317],
& yyComb [0],
& yyComb [3332],
& yyComb [0],
& yyComb [0],
& yyComb [3330],
& yyComb [0],
& yyComb [17],
& yyComb [0],
& yyComb [0],
& yyComb [3482],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3270],
& yyComb [2427],
& yyComb [0],
& yyComb [3332],
& yyComb [2432],
& yyComb [0],
& yyComb [0],
& yyComb [2433],
& yyComb [0],
& yyComb [0],
& yyComb [2461],
& yyComb [0],
& yyComb [20],
& yyComb [2462],
& yyComb [0],
& yyComb [2465],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [23],
& yyComb [0],
& yyComb [0],
& yyComb [23],
& yyComb [0],
& yyComb [25],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [41],
& yyComb [0],
& yyComb [2490],
& yyComb [2509],
& yyComb [2596],
& yyComb [2750],
& yyComb [2854],
& yyComb [0],
& yyComb [2990],
& yyComb [3108],
& yyComb [3253],
& yyComb [0],
& yyComb [3298],
& yyComb [3249],
& yyComb [3261],
& yyComb [3268],
& yyComb [0],
& yyComb [3255],
& yyComb [3273],
& yyComb [3262],
& yyComb [3270],
& yyComb [0],
& yyComb [3284],
& yyComb [3297],
& yyComb [3299],
& yyComb [3300],
& yyComb [3300],
& yyComb [0],
& yyComb [0],
& yyComb [3286],
& yyComb [3295],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3296],
& yyComb [3318],
& yyComb [3296],
& yyComb [3298],
& yyComb [0],
& yyComb [3292],
& yyComb [3311],
& yyComb [3295],
& yyComb [0],
& yyComb [3322],
& yyComb [3331],
& yyComb [3318],
& yyComb [3330],
& yyComb [3329],
& yyComb [3337],
& yyComb [0],
& yyComb [3323],
& yyComb [0],
& yyComb [3335],
& yyComb [3338],
& yyComb [3332],
& yyComb [3342],
& yyComb [3345],
& yyComb [0],
& yyComb [3343],
& yyComb [3337],
& yyComb [3348],
& yyComb [3351],
& yyComb [0],
& yyComb [3355],
& yyComb [3347],
& yyComb [3355],
& yyComb [0],
& yyComb [3360],
& yyComb [3343],
& yyComb [0],
& yyComb [3350],
& yyComb [3358],
& yyComb [0],
& yyComb [3346],
& yyComb [0],
& yyComb [3355],
& yyComb [3353],
& yyComb [3353],
& yyComb [0],
& yyComb [3373],
& yyComb [3357],
& yyComb [0],
& yyComb [3372],
& yyComb [0],
& yyComb [3352],
& yyComb [3374],
& yyComb [3366],
& yyComb [3377],
& yyComb [0],
& yyComb [3380],
& yyComb [3372],
& yyComb [3383],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3402],
& yyComb [0],
& yyComb [0],
& yyComb [3405],
& yyComb [3404],
& yyComb [0],
& yyComb [3387],
& yyComb [3433],
& yyComb [0],
& yyComb [3428],
& yyComb [3425],
& yyComb [0],
& yyComb [3426],
& yyComb [3429],
& yyComb [3437],
& yyComb [0],
& yyComb [3437],
& yyComb [3431],
& yyComb [3429],
& yyComb [3437],
& yyComb [0],
& yyComb [3439],
& yyComb [3450],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3421],
& yyComb [3423],
& yyComb [3427],
& yyComb [3435],
& yyComb [3415],
& yyComb [3433],
& yyComb [3431],
& yyComb [3429],
& yyComb [3446],
& yyComb [0],
& yyComb [3432],
& yyComb [3451],
& yyComb [3447],
& yyComb [3442],
& yyComb [3455],
& yyComb [0],
& yyComb [3440],
& yyComb [3461],
& yyComb [3457],
& yyComb [3454],
& yyComb [3467],
& yyComb [0],
& yyComb [3451],
& yyComb [3470],
& yyComb [3465],
& yyComb [3460],
& yyComb [3473],
& yyComb [0],
& yyComb [3471],
& yyComb [3471],
& yyComb [3463],
& yyComb [3461],
& yyComb [0],
& yyComb [3479],
& yyComb [3480],
& yyComb [3473],
& yyComb [3469],
& yyComb [0],
& yyComb [3486],
& yyComb [3486],
& yyComb [3478],
& yyComb [3473],
& yyComb [0],
& yyComb [3490],
& yyComb [3490],
& yyComb [3482],
& yyComb [3477],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3552],
& yyComb [0],
& yyComb [3553],
& yyComb [0],
& yyComb [3554],
& yyComb [3555],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
32,
1,
1,
3,
1,
5,
25,
7,
25,
9,
15,
11,
9,
13,
25,
15,
25,
17,
24,
19,
19,
0,
0,
22,
22,
0,
0,
22,
0,
22,
0,
22,
0,
0,
22,
0,
0,
0,
22,
39,
72,
79,
79,
79,
79,
79,
61,
79,
79,
79,
68,
79,
79,
0,
63,
62,
79,
79,
79,
79,
79,
79,
79,
69,
70,
71,
41,
61,
79,
79,
79,
79,
63,
64,
79,
79,
79,
79,
0,
0,
0,
79,
22,
0,
25,
21,
0,
46,
45,
28,
25,
21,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
79,
0,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
79,
79,
0,
32,
32,
32,
32,
32,
32,
79,
0,
79,
0,
79,
0,
79,
0,
79,
79,
0,
79,
0,
79,
0,
79,
0,
0,
79,
0,
79,
0,
0,
79,
0,
0,
0,
79,
79,
0,
79,
79,
0,
0,
79,
0,
0,
79,
0,
79,
79,
0,
79,
0,
0,
0,
0,
79,
0,
0,
79,
0,
79,
0,
0,
0,
0,
0,
79,
0,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
0,
32,
32,
32,
0,
0,
0,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
0,
0,
0,
0,
0,
79,
0,
0,
79,
79,
0,
79,
79,
0,
79,
79,
0,
79,
79,
79,
0,
79,
79,
79,
79,
0,
79,
79,
0,
82,
82,
79,
46,
45,
21,
79,
79,
79,
79,
79,
0,
46,
46,
46,
46,
46,
46,
45,
45,
45,
45,
45,
45,
21,
21,
21,
21,
21,
21,
79,
79,
79,
79,
0,
46,
46,
46,
46,
46,
45,
45,
45,
45,
45,
21,
21,
21,
21,
21,
82,
0,
46,
46,
45,
45,
79,
21,
21,
0,
0,
21,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
0,
0,
46,
46,
45,
45,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
21,
21,
21,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
40,
67,
0,
0,
0,
45,
46,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
74,
65,
66,
67,
0,
0,
0,
0,
0,
0,
74,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
21,
0,
46,
45,
0,
0,
21,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
46,
45,
21,
0,
0,
0,
0,
0,
0,
46,
46,
46,
46,
46,
46,
45,
45,
45,
45,
45,
45,
21,
21,
21,
21,
21,
21,
0,
0,
0,
0,
0,
46,
46,
46,
46,
46,
45,
45,
45,
45,
45,
21,
21,
21,
21,
21,
0,
0,
46,
46,
45,
45,
0,
21,
21,
0,
0,
21,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 110 "mpc.rex" */


    /* Copyright (C) 1993 Ilya N. Ledovskikh, All rights reserved.
       Portions Copyright (C) 1989,1990 James A. Roskind.          */

# include <string.h>



void mpcScan_ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, mpcScan_tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; mpcScan_tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = mpcScan_Attribute.Position;
 switch (Token) {
 case /* IDENTIFIER */ 1: 
 pAttribute->IDENTIFIER.SymForm=NULL;
 pAttribute->IDENTIFIER.Ignore=YES;
 pAttribute->IDENTIFIER.Length=0;
 ;
 pAttribute->IDENTIFIER.Ident=NoIdent;
 ;
 break;
 case /* NETorSUBNETname */ 2: 
 pAttribute->NETorSUBNETname.SymForm=NULL;
 pAttribute->NETorSUBNETname.Ignore=YES;
 pAttribute->NETorSUBNETname.Length=0;
 ;
 pAttribute->NETorSUBNETname.Ident=NoIdent;
 ;
 break;
 case /* TYPEDEFname */ 3: 
 pAttribute->TYPEDEFname.SymForm=NULL;
 pAttribute->TYPEDEFname.Ignore=YES;
 pAttribute->TYPEDEFname.Length=0;
 ;
 pAttribute->TYPEDEFname.Ident=NoIdent;
 ;
 break;
 case /* FLOATINGconstant */ 4: 
 pAttribute->FLOATINGconstant.SymForm=NULL;
 pAttribute->FLOATINGconstant.Ignore=YES;
 pAttribute->FLOATINGconstant.Length=0;
 ;
 pAttribute->FLOATINGconstant.FloatConst=0.0;
 ;
 break;
 case /* INTEGERconstant */ 5: 
 pAttribute->INTEGERconstant.SymForm=NULL;
 pAttribute->INTEGERconstant.Ignore=YES;
 pAttribute->INTEGERconstant.Length=0;
 ;
 pAttribute->INTEGERconstant.IntConst=0;
 ;
 break;
 case /* OCTALconstant */ 6: 
 pAttribute->OCTALconstant.SymForm=NULL;
 pAttribute->OCTALconstant.Ignore=YES;
 pAttribute->OCTALconstant.Length=0;
 ;
 pAttribute->OCTALconstant.OctConst=0;
 ;
 break;
 case /* HEXconstant */ 7: 
 pAttribute->HEXconstant.SymForm=NULL;
 pAttribute->HEXconstant.Ignore=YES;
 pAttribute->HEXconstant.Length=0;
 ;
 pAttribute->HEXconstant.HexConst=0;
 ;
 break;
 case /* CHARACTERconstant */ 8: 
 pAttribute->CHARACTERconstant.SymForm=NULL;
 pAttribute->CHARACTERconstant.Ignore=YES;
 pAttribute->CHARACTERconstant.Length=0;
 ;
 pAttribute->CHARACTERconstant.CharConst=0;
 ;
 break;
 case /* STRINGliteral */ 9: 
 pAttribute->STRINGliteral.SymForm=NULL;
 pAttribute->STRINGliteral.Ignore=YES;
 pAttribute->STRINGliteral.Length=0;
 ;
 pAttribute->STRINGliteral.StrLit=NULL;
 ;
 break;
 case /* HEADER */ 10: 
 pAttribute->HEADER.SymForm=NULL;
 pAttribute->HEADER.Ignore=YES;
 pAttribute->HEADER.Length=0;
 ;
 break;
 case /* SOURCE */ 11: 
 pAttribute->SOURCE.SymForm=NULL;
 pAttribute->SOURCE.Ignore=YES;
 pAttribute->SOURCE.Length=0;
 ;
 break;
 case /* bench */ 12: 
pAttribute->bench.Ignore=true;
 break;
 case /* coord */ 13: 
pAttribute->coord.Ignore=true;
 break;
 case /* coordof */ 14: 
pAttribute->coordof.Ignore=true;
 break;
 case /* fan */ 15: 
pAttribute->fan.Ignore=true;
 break;
 case /* fast */ 16: 
pAttribute->fast.Ignore=true;
 break;
 case /* flex */ 17: 
pAttribute->flex.Ignore=true;
 break;
 case /* host */ 18: 
pAttribute->host.Ignore=true;
 break;
 case /* length */ 19: 
pAttribute->length.Ignore=true;
 break;
 case /* link */ 20: 
pAttribute->link.Ignore=true;
 break;
 case /* memory */ 21: 
pAttribute->memory.Ignore=true;
 break;
 case /* net */ 22: 
pAttribute->net.Ignore=true;
 break;
 case /* nettype */ 23: 
pAttribute->nettype.Ignore=true;
 break;
 case /* node */ 24: 
pAttribute->node.Ignore=true;
 break;
 case /* parent */ 25: 
pAttribute->parent.Ignore=true;
 break;
 case /* recon */ 26: 
pAttribute->recon.Ignore=true;
 break;
 case /* relation */ 27: 
pAttribute->relation.Ignore=true;
 break;
 case /* repl */ 28: 
pAttribute->repl.Ignore=true;
 break;
 case /* scalar */ 29: 
pAttribute->scalar.Ignore=true;
 break;
 case /* slow */ 30: 
pAttribute->slow.Ignore=true;
 break;
 case /* subnet */ 31: 
pAttribute->subnet.Ignore=true;
 break;
 case /* vector */ 32: 
pAttribute->vector.Ignore=true;
 break;
 case /* par */ 33: 
pAttribute->par.Ignore=true;
 break;
 case /* scheme */ 34: 
pAttribute->scheme.Ignore=true;
 break;
 case /* timeof */ 35: 
pAttribute->timeof.Ignore=true;
 break;
 }
}



int  isaTYPE(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_Typedef);
    return res;
  }
  return 0;
}

int  isaNET(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_NetOrSubnet);
    return res;
  }
  return 0;
}

int Treat_As_Ident(void) {
  char Word[32];
  int length;
  length = mpcScan_GetWord (Word);
  mpcScan_Attribute.IDENTIFIER.Ignore = NO;
  mpcScan_Attribute.IDENTIFIER.Ident =
    MakeIdent (Word, length);
  if(isaTYPE (mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 3;
  }
  else if(isaNET(mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 2;
  }
  else {
    return 1;
  }

}

# define MAX_BYTE_VALUE 256    /** tmp-definition!!! **/

static int Get_Oct_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 8; break;
      case '1': code = code * 8 + 1; break;
      case '2': code = code * 8 + 2; break;
      case '3': code = code * 8 + 3; break;
      case '4': code = code * 8 + 4; break;
      case '5': code = code * 8 + 5; break;
      case '6': code = code * 8 + 6; break;
      case '7': code = code * 8 + 7; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Get_Hex_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 16; break;
      case '1': code = code * 16 + 1; break;
      case '2': code = code * 16 + 2; break;
      case '3': code = code * 16 + 3; break;
      case '4': code = code * 16 + 4; break;
      case '5': code = code * 16 + 5; break;
      case '6': code = code * 16 + 6; break;
      case '7': code = code * 16 + 7; break;
      case '8': code = code * 16 + 8; break;
      case '9': code = code * 16 + 9; break;
      case 'a':
      case 'A': code = code * 16 + 10; break;
      case 'b':
      case 'B': code = code * 16 + 11; break;
      case 'c':
      case 'C': code = code * 16 + 12; break;
      case 'd':
      case 'D': code = code * 16 + 13; break;
      case 'e':
      case 'E': code = code * 16 + 14; break;
      case 'f':
      case 'F': code = code * 16 + 15; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Str_to_Char (char *Image, tPosition Position)
{
  int value=0, index=1 /* first character after '; */;

  while(Image[index] && Image[index]!='\''){
    switch(Image[index]){
      case '\\':
	switch(Image[++index]){
	  case '\'': value = MAX_BYTE_VALUE*value + '\''; index++; break;
	  case '"' : value = MAX_BYTE_VALUE*value + '"';  index++; break;
	  case '?' : value = MAX_BYTE_VALUE*value + '?';  index++; break;
	  case '\\': value = MAX_BYTE_VALUE*value + '\\'; index++; break;
	  case 'a' : value = MAX_BYTE_VALUE*value + '\a'; index++; break;
	  case 'b' : value = MAX_BYTE_VALUE*value + '\b'; index++; break;
	  case 'f' : value = MAX_BYTE_VALUE*value + '\f'; index++; break;
	  case 'n' : value = MAX_BYTE_VALUE*value + '\n'; index++; break;
	  case 'r' : value = MAX_BYTE_VALUE*value + '\r'; index++; break;
	  case 't': value = MAX_BYTE_VALUE*value + '\t'; index++; break;
	  case 'v': value = MAX_BYTE_VALUE*value + '\v'; index++; break;
	  default:
	    if(Image[index]>='0' && Image[index]<='7') {  /* octal code: */
	      value = MAX_BYTE_VALUE*value +
			Get_Oct_Code(Image+index, &index);
	    }
	    else if(Image[index]=='x')
	      value = MAX_BYTE_VALUE*value +
			Get_Hex_Code(Image + ++index, &index);
	    else
	      Make_Message(50, xxError, Position, NoTree); break;
		/* "Invalid escape sequence in character constant" */
	}
	break;
      default:
	value = MAX_BYTE_VALUE*value + Image[index++];
    }
  }
  return value;
}


 
int mpcScan_GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
/* line 425 "mpc.rex" */


#define MAX_TOKEN_LENGTH 2048

          char Word[MAX_TOKEN_LENGTH]; 
          short length;
	  int index;
	  tPosition Pos;
	  static tString CurrentFileName;
#ifdef __CB_COMPILER__
	  bool EmptyHeader;   /* only for correct compilation of scanner... */
#endif

   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   mpcScan_TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      mpcScan_TokenLength = yyChBufferIndexReg - (unsigned char *) mpcScan_TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 585:;
case 586:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 490 "mpc.rex" */
{ yyStart(comment); 
} yyy1: goto yyBegin;
case 584:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 491 "mpc.rex" */
{ yyStart(STD); 
} yyy2: goto yyBegin;
case 30:;
case 46:;
case 88:;
case 528:;
case 537:;
case 538:;
case 539:;
case 540:;
case 541:;
case 542:;
case 560:;
case 561:;
case 562:;
case 563:;
case 564:;
case 577:;
case 578:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 492 "mpc.rex" */
{
} yyy3: goto yyBegin;
case 576:;
case 580:;
case 583:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 494 "mpc.rex" */
{ yyStart(linecomment); 
} yyy4: goto yyBegin;
case 575:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 495 "mpc.rex" */
{ yyEol(0); yyStart(STD); 
} yyy5: goto yyBegin;
case 29:;
case 45:;
case 89:;
case 529:;
case 543:;
case 544:;
case 545:;
case 546:;
case 547:;
case 548:;
case 565:;
case 566:;
case 567:;
case 568:;
case 569:;
case 579:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 496 "mpc.rex" */
{
} yyy6: goto yyBegin;
case 559:;
case 574:;
/* line 498 "mpc.rex" */
{ yyStart(unused); 
} yyy7: goto yyBegin;
case 536:;
case 554:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 499 "mpc.rex" */
{ yyStart(pragma); yyLineCount++; 
} yyy8: goto yyBegin;
case 527:;
case 530:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 500 "mpc.rex" */
{ yyStart(position); 
} yyy9: goto yyBegin;
case 526:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 501 "mpc.rex" */
{ yyStart(STD); 
} yyy10: goto yyBegin;
case 27:;
case 42:;
case 43:;
case 44:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 502 "mpc.rex" */
{
		length = mpcScan_GetWord(Word);
		Pos.Line = atoi(Word);
		Pos.Column = 1;
		yyStart(file);

} yyy11: goto yyBegin;
case 525:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 508 "mpc.rex" */
{
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		New_SourceFile(CurrentFileName,
			       mpcScan_Attribute.Position, Pos);
		yyStart(STD);

} yyy12: goto yyBegin;
case 26:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 514 "mpc.rex" */
{
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		New_SourceFile(s, mpcScan_Attribute.Position, Pos);
		CurrentFileName = s;
		yyStart(unused);

} yyy13: goto yyBegin;
case 28:;
case 90:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 527 "mpc.rex" */
{
} yyy14: goto yyBegin;
case 25:;
case 85:;
case 91:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 528 "mpc.rex" */
{
} yyy15: goto yyBegin;
case 22:;
case 83:;
/* line 530 "mpc.rex" */
{ yyStart(STD); 
} yyy16: goto yyBegin;
case 24:;
/* line 532 "mpc.rex" */
{
				     length = mpcScan_GetWord(Word);
				     if(!strcmp(Word,"keywords"))
				       {yyStart(keywords);}
				     else if(!strcmp(Word,"native"))
				       {yyStart(native);}
#ifdef __WRK
#ifndef __CB_COMPILER__
				     else if(!strcmp(Word,"header")) {
					C_2_MPC_SOURCE = false;
					//HEADER_NAME_GENERATED = false;
					//EmptyHeader = true;
					yyStart(header);
				     }
				     else if(!strcmp(Word,"source")) {
					C_2_MPC_SOURCE = true;
					//PRAGMA_SOURCE_GENERATED = false;
					yyStart(unused);
					return 11;
				     }
#endif
#endif
				     else
				       {yyStart(unused);}
				   
} yyy17: goto yyBegin;
case 524:;
/* line 557 "mpc.rex" */
{ KEYWORDS = K_ANSI; yyStart(unused); 
} yyy18: goto yyBegin;
case 521:;
/* line 558 "mpc.rex" */
{ KEYWORDS = K_SHORT; yyStart(unused); 
} yyy19: goto yyBegin;
case 516:;
/* line 559 "mpc.rex" */
{ KEYWORDS = K_LONG; yyStart(unused); 
} yyy20: goto yyBegin;
case 512:;
/* line 560 "mpc.rex" */
{ KEYWORDS = K_ALL; yyStart(unused); 
} yyy21: goto yyBegin;
case 509:;
/* line 562 "mpc.rex" */
{ NativeMode = NATIVE_MPC; yyStart(unused); 
} yyy22: goto yyBegin;
case 506:;
/* line 563 "mpc.rex" */
{ NativeMode = NATIVE_CBR; yyStart(unused); 
} yyy23: goto yyBegin;
case 504:;
/* line 564 "mpc.rex" */
{ NativeMode = NATIVE_C; yyStart(unused); 
} yyy24: goto yyBegin;
case 23:;
case 41:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 566 "mpc.rex" */
{
#ifdef __WRK
#ifndef __CB_COMPILER__
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		mpcScan_Attribute.HEADER.SymForm = s;
		//CurrentHeaderName = s;
		yyStart(unused);
		return 10;
#endif
#endif

} yyy25: goto yyBegin;
case 367:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 595 "mpc.rex" */
{ return 36; 
} yyy26: goto yyBegin;
case 503:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 596 "mpc.rex" */
{ return 37; 
} yyy27: goto yyBegin;
case 502:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 597 "mpc.rex" */
{ return 38; 
} yyy28: goto yyBegin;
case 500:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 598 "mpc.rex" */
{ return 39; 
} yyy29: goto yyBegin;
case 499:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 599 "mpc.rex" */
{ return 40; 
} yyy30: goto yyBegin;
case 498:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 600 "mpc.rex" */
{ return 41; 
} yyy31: goto yyBegin;
case 497:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 601 "mpc.rex" */
{ return 42; 
} yyy32: goto yyBegin;
case 359:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 602 "mpc.rex" */
{ return 43; 
} yyy33: goto yyBegin;
case 357:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 603 "mpc.rex" */
{ return 44; 
} yyy34: goto yyBegin;
case 496:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 604 "mpc.rex" */
{ return 45; 
} yyy35: goto yyBegin;
case 394:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 605 "mpc.rex" */
{ return 46; 
} yyy36: goto yyBegin;
case 495:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 606 "mpc.rex" */
{ return 47; 
} yyy37: goto yyBegin;
case 491:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 607 "mpc.rex" */
{ return 48; 
} yyy38: goto yyBegin;
case 486:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 608 "mpc.rex" */
{ return 49; 
} yyy39: goto yyBegin;
case 484:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 609 "mpc.rex" */
{ return 50; 
} yyy40: goto yyBegin;
case 481:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 610 "mpc.rex" */
{ return 51; 
} yyy41: goto yyBegin;
case 477:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 611 "mpc.rex" */
{ return 52; 
} yyy42: goto yyBegin;
case 475:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 612 "mpc.rex" */
{ return 53; 
} yyy43: goto yyBegin;
case 472:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 613 "mpc.rex" */
{ return 54; 
} yyy44: goto yyBegin;
case 469:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 614 "mpc.rex" */
{ return 55; 
} yyy45: goto yyBegin;
case 465:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 615 "mpc.rex" */
{ return 56; 
} yyy46: goto yyBegin;
case 460:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 616 "mpc.rex" */
{ return 57; 
} yyy47: goto yyBegin;
case 454:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 617 "mpc.rex" */
{ return 58; 
} yyy48: goto yyBegin;
case 452:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 618 "mpc.rex" */
{ return 59; 
} yyy49: goto yyBegin;
case 445:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 619 "mpc.rex" */
{ return 60; 
} yyy50: goto yyBegin;
case 441:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 620 "mpc.rex" */
{ return 61; 
} yyy51: goto yyBegin;
case 436:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 621 "mpc.rex" */
{ return 62; 
} yyy52: goto yyBegin;
case 435:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 622 "mpc.rex" */
{ return 63; 
} yyy53: goto yyBegin;
case 434:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 623 "mpc.rex" */
{ return 64; 
} yyy54: goto yyBegin;
case 433:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 624 "mpc.rex" */
{ return 65; 
} yyy55: goto yyBegin;
case 396:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 625 "mpc.rex" */
{ return 66; 
} yyy56: goto yyBegin;
case 364:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 626 "mpc.rex" */
{ return 67; 
} yyy57: goto yyBegin;
case 430:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 627 "mpc.rex" */
{ return 68; 
} yyy58: goto yyBegin;
case 429:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 628 "mpc.rex" */
{ return 69; 
} yyy59: goto yyBegin;
case 423:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 629 "mpc.rex" */
{ return 70; 
} yyy60: goto yyBegin;
case 418:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 630 "mpc.rex" */
{ return 71; 
} yyy61: goto yyBegin;
case 413:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 631 "mpc.rex" */
{ return 72; 
} yyy62: goto yyBegin;
case 409:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 632 "mpc.rex" */
{ return 73; 
} yyy63: goto yyBegin;
case 403:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 633 "mpc.rex" */
{ return 74; 
} yyy64: goto yyBegin;
case 362:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 634 "mpc.rex" */
{ return 75; 
} yyy65: goto yyBegin;
case 292:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 635 "mpc.rex" */
{ return 76; 
} yyy66: goto yyBegin;
case 401:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 636 "mpc.rex" */
{ return 77; 
} yyy67: goto yyBegin;
case 400:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 637 "mpc.rex" */
{ return 78; 
} yyy68: goto yyBegin;
case 355:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 638 "mpc.rex" */
{ return 79; 
} yyy69: goto yyBegin;
case 353:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 639 "mpc.rex" */
{ return 80; 
} yyy70: goto yyBegin;
case 335:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 640 "mpc.rex" */
{ return 81; 
} yyy71: goto yyBegin;
case 352:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 641 "mpc.rex" */
{ return 82; 
} yyy72: goto yyBegin;
case 399:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 642 "mpc.rex" */
{ return 83; 
} yyy73: goto yyBegin;
case 398:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 643 "mpc.rex" */
{ return 84; 
} yyy74: goto yyBegin;
case 397:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 644 "mpc.rex" */
{ return 85; 
} yyy75: goto yyBegin;
case 395:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 645 "mpc.rex" */
{ return 86; 
} yyy76: goto yyBegin;
case 350:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 646 "mpc.rex" */
{ return 87; 
} yyy77: goto yyBegin;
case 348:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 647 "mpc.rex" */
{ return 88; 
} yyy78: goto yyBegin;
case 346:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 648 "mpc.rex" */
{ return 89; 
} yyy79: goto yyBegin;
case 393:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 649 "mpc.rex" */
{ return 90; 
} yyy80: goto yyBegin;
case 392:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 650 "mpc.rex" */
{ return 91; 
} yyy81: goto yyBegin;
case 391:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 651 "mpc.rex" */
{ return 92; 
} yyy82: goto yyBegin;
case 60:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 652 "mpc.rex" */
{ return 93; 
} yyy83: goto yyBegin;
case 390:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 653 "mpc.rex" */
{ return 94; 
} yyy84: goto yyBegin;
case 389:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 654 "mpc.rex" */
{ return 95; 
} yyy85: goto yyBegin;
case 388:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 655 "mpc.rex" */
{ return 96; 
} yyy86: goto yyBegin;
case 387:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 656 "mpc.rex" */
{ return 97; 
} yyy87: goto yyBegin;
case 385:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 657 "mpc.rex" */
{ return 98; 
} yyy88: goto yyBegin;
case 382:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 658 "mpc.rex" */
{ return 99; 
} yyy89: goto yyBegin;
case 380:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 659 "mpc.rex" */
{ return 100; 
} yyy90: goto yyBegin;
case 379:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 660 "mpc.rex" */
{ return 101; 
} yyy91: goto yyBegin;
case 377:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 661 "mpc.rex" */
{ return 102; 
} yyy92: goto yyBegin;
case 376:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 662 "mpc.rex" */
{ return 103; 
} yyy93: goto yyBegin;
case 373:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 663 "mpc.rex" */
{ return 104; 
} yyy94: goto yyBegin;
case 370:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 664 "mpc.rex" */
{ return 105; 
} yyy95: goto yyBegin;
case 369:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 665 "mpc.rex" */
{ return 106; 
} yyy96: goto yyBegin;
case 368:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 666 "mpc.rex" */
{ return 107; 
} yyy97: goto yyBegin;
case 366:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 667 "mpc.rex" */
{ return 108; 
} yyy98: goto yyBegin;
case 365:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 668 "mpc.rex" */
{ return 109; 
} yyy99: goto yyBegin;
case 363:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 669 "mpc.rex" */
{ return 110; 
} yyy100: goto yyBegin;
case 361:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 670 "mpc.rex" */
{ return 111; 
} yyy101: goto yyBegin;
case 360:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 671 "mpc.rex" */
{ return 112; 
} yyy102: goto yyBegin;
case 358:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 672 "mpc.rex" */
{ return 113; 
} yyy103: goto yyBegin;
case 356:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 673 "mpc.rex" */
{ return 114; 
} yyy104: goto yyBegin;
case 354:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 674 "mpc.rex" */
{ return 115; 
} yyy105: goto yyBegin;
case 351:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 675 "mpc.rex" */
{ return 116; 
} yyy106: goto yyBegin;
case 349:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 676 "mpc.rex" */
{ return 117; 
} yyy107: goto yyBegin;
case 347:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 677 "mpc.rex" */
{ return 118; 
} yyy108: goto yyBegin;
case 336:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 678 "mpc.rex" */
{ return 119; 
} yyy109: goto yyBegin;
case 344:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 679 "mpc.rex" */
{ return 120; 
} yyy110: goto yyBegin;
case 345:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 680 "mpc.rex" */
{ return 121; 
} yyy111: goto yyBegin;
case 343:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 681 "mpc.rex" */
{ return 122; 
} yyy112: goto yyBegin;
case 337:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 682 "mpc.rex" */
{ return 123; 
} yyy113: goto yyBegin;
case 334:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 683 "mpc.rex" */
{ return 124; 
} yyy114: goto yyBegin;
case 331:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 684 "mpc.rex" */
{ return 125; 
} yyy115: goto yyBegin;
case 329:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 685 "mpc.rex" */
{ return 126; 
} yyy116: goto yyBegin;
case 325:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 686 "mpc.rex" */
{ return 127; 
} yyy117: goto yyBegin;
case 320:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 687 "mpc.rex" */
{ return 128; 
} yyy118: goto yyBegin;
case 315:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 688 "mpc.rex" */
{ return 129; 
} yyy119: goto yyBegin;
case 313:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 689 "mpc.rex" */
{ return 130; 
} yyy120: goto yyBegin;
case 311:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 690 "mpc.rex" */
{ return 131; 
} yyy121: goto yyBegin;
case 307:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 691 "mpc.rex" */
{ return 132; 
} yyy122: goto yyBegin;
case 301:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 692 "mpc.rex" */
{ return 133; 
} yyy123: goto yyBegin;
case 297:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 693 "mpc.rex" */
{ return 134; 
} yyy124: goto yyBegin;
case 293:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 694 "mpc.rex" */
{ return 135; 
} yyy125: goto yyBegin;
case 291:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 699 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 12;
			    }
			  
} yyy126: goto yyBegin;
case 286:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 708 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 12;
			    }
			  
} yyy127: goto yyBegin;
case 279:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 718 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 13;
			    }
			  
} yyy128: goto yyBegin;
case 272:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 727 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 13;
			    }
			  
} yyy129: goto yyBegin;
case 281:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 737 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 14;
			    }
			  
} yyy130: goto yyBegin;
case 274:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 746 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 14;
			    }
			  
} yyy131: goto yyBegin;
case 267:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 756 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 15;
			    }
			  
} yyy132: goto yyBegin;
case 266:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 765 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 15;
			    }
			  
} yyy133: goto yyBegin;
case 265:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 775 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 16;
			    }
			  
} yyy134: goto yyBegin;
case 262:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 784 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 16;
			    }
			  
} yyy135: goto yyBegin;
case 259:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 794 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 17;
			    }
			  
} yyy136: goto yyBegin;
case 255:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 803 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 17;
			    }
			  
} yyy137: goto yyBegin;
case 251:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 813 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 18;
			    }
			  
} yyy138: goto yyBegin;
case 247:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 822 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 18;
			    }
			  
} yyy139: goto yyBegin;
case 243:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 832 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 19;
			    }
			  
} yyy140: goto yyBegin;
case 238:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 841 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 19;
			    }
			  
} yyy141: goto yyBegin;
case 233:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 851 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 20;
			    }
			  
} yyy142: goto yyBegin;
case 229:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 860 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 20;
			    }
			  
} yyy143: goto yyBegin;
case 225:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 870 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 21;
			    }
			  
} yyy144: goto yyBegin;
case 220:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 879 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 21;
			    }
			  
} yyy145: goto yyBegin;
case 210:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 889 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 22;
			    }
			  
} yyy146: goto yyBegin;
case 204:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 898 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 22;
			    }
			  
} yyy147: goto yyBegin;
case 214:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 908 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 23;
			    }
			  
} yyy148: goto yyBegin;
case 208:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 917 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 23;
			    }
			  
} yyy149: goto yyBegin;
case 202:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 927 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 24;
			    }
			  
} yyy150: goto yyBegin;
case 198:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 936 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 24;
			    }
			  
} yyy151: goto yyBegin;
case 191:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 946 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 33;
			    }
			  
} yyy152: goto yyBegin;
case 185:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 955 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 33;
			    }
			  
} yyy153: goto yyBegin;
case 194:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 965 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 25;
			    }
			  
} yyy154: goto yyBegin;
case 188:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 974 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 25;
			    }
			  
} yyy155: goto yyBegin;
case 182:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 984 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 26;
			    }
			  
} yyy156: goto yyBegin;
case 179:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 993 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 26;
			    }
			  
} yyy157: goto yyBegin;
case 176:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1003 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 27;
			    }
			  
} yyy158: goto yyBegin;
case 170:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1012 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 27;
			    }
			  
} yyy159: goto yyBegin;
case 164:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1022 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 28;
			    }
			  
} yyy160: goto yyBegin;
case 160:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1031 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 28;
			    }
			  
} yyy161: goto yyBegin;
case 156:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1041 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 29;
			    }
			  
} yyy162: goto yyBegin;
case 152:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1050 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 29;
			    }
			  
} yyy163: goto yyBegin;
case 148:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1060 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 34;
			    }
			  
} yyy164: goto yyBegin;
case 143:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1069 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 34;
			    }
			  
} yyy165: goto yyBegin;
case 138:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1079 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 30;
			    }
			  
} yyy166: goto yyBegin;
case 135:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1088 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 30;
			    }
			  
} yyy167: goto yyBegin;
case 132:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1098 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 31;
			    }
			  
} yyy168: goto yyBegin;
case 126:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1107 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 31;
			    }
			  
} yyy169: goto yyBegin;
case 120:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1117 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 35;
			    }
			  
} yyy170: goto yyBegin;
case 114:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1126 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 35;
			    }
			  
} yyy171: goto yyBegin;
case 108:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1136 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 32;
			    }
			  
} yyy172: goto yyBegin;
case 102:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1145 "mpc.rex" */
{ EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 32;
			    }
			  
} yyy173: goto yyBegin;
case 32:;
case 50:;
case 93:;
case 94:;
case 95:;
case 96:;
case 97:;
case 98:;
case 99:;
case 100:;
case 101:;
case 103:;
case 104:;
case 105:;
case 106:;
case 107:;
case 109:;
case 110:;
case 111:;
case 112:;
case 113:;
case 115:;
case 116:;
case 117:;
case 118:;
case 119:;
case 121:;
case 122:;
case 123:;
case 124:;
case 125:;
case 127:;
case 128:;
case 129:;
case 130:;
case 131:;
case 133:;
case 134:;
case 136:;
case 137:;
case 139:;
case 140:;
case 141:;
case 142:;
case 144:;
case 145:;
case 146:;
case 147:;
case 149:;
case 150:;
case 151:;
case 153:;
case 154:;
case 155:;
case 157:;
case 158:;
case 159:;
case 161:;
case 162:;
case 163:;
case 165:;
case 166:;
case 167:;
case 168:;
case 169:;
case 171:;
case 172:;
case 173:;
case 174:;
case 175:;
case 177:;
case 178:;
case 180:;
case 181:;
case 183:;
case 184:;
case 186:;
case 187:;
case 189:;
case 190:;
case 192:;
case 193:;
case 195:;
case 196:;
case 197:;
case 199:;
case 200:;
case 201:;
case 203:;
case 205:;
case 206:;
case 207:;
case 209:;
case 211:;
case 212:;
case 213:;
case 215:;
case 216:;
case 217:;
case 218:;
case 219:;
case 221:;
case 222:;
case 223:;
case 224:;
case 226:;
case 227:;
case 228:;
case 230:;
case 231:;
case 232:;
case 234:;
case 235:;
case 236:;
case 237:;
case 239:;
case 240:;
case 241:;
case 242:;
case 244:;
case 245:;
case 246:;
case 248:;
case 249:;
case 250:;
case 252:;
case 253:;
case 254:;
case 256:;
case 257:;
case 258:;
case 260:;
case 261:;
case 263:;
case 264:;
case 268:;
case 269:;
case 270:;
case 271:;
case 273:;
case 275:;
case 276:;
case 277:;
case 278:;
case 280:;
case 282:;
case 283:;
case 284:;
case 285:;
case 287:;
case 288:;
case 289:;
case 290:;
case 294:;
case 295:;
case 296:;
case 298:;
case 299:;
case 300:;
case 302:;
case 303:;
case 304:;
case 305:;
case 306:;
case 308:;
case 309:;
case 310:;
case 312:;
case 314:;
case 316:;
case 317:;
case 318:;
case 319:;
case 321:;
case 322:;
case 323:;
case 324:;
case 326:;
case 327:;
case 328:;
case 330:;
case 332:;
case 333:;
case 338:;
case 339:;
case 340:;
case 341:;
case 342:;
case 404:;
case 405:;
case 406:;
case 407:;
case 408:;
case 410:;
case 411:;
case 412:;
case 414:;
case 415:;
case 416:;
case 417:;
case 419:;
case 420:;
case 421:;
case 422:;
case 424:;
case 425:;
case 426:;
case 427:;
case 428:;
case 431:;
case 432:;
case 437:;
case 438:;
case 439:;
case 440:;
case 442:;
case 443:;
case 444:;
case 446:;
case 447:;
case 448:;
case 449:;
case 450:;
case 451:;
case 453:;
case 455:;
case 456:;
case 457:;
case 458:;
case 459:;
case 461:;
case 462:;
case 463:;
case 464:;
case 466:;
case 467:;
case 468:;
case 470:;
case 471:;
case 473:;
case 474:;
case 476:;
case 478:;
case 479:;
case 480:;
case 482:;
case 483:;
case 485:;
case 487:;
case 488:;
case 489:;
case 490:;
case 492:;
case 493:;
case 494:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1157 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.IDENTIFIER.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.IDENTIFIER.Ignore = NO;
                            mpcScan_Attribute.IDENTIFIER.Ident =
					 MakeIdent (Word, length);
			    if (isaTYPE (
				mpcScan_Attribute.IDENTIFIER.Ident)) {
                                return 3;
			    }
                            else if(isaNET(
				    mpcScan_Attribute.IDENTIFIER.Ident)) {
				    return 2;
			    }
			    else {
				return 1;
			    }
			  
} yyy174: goto yyBegin;
case 31:;
case 47:;
case 48:;
case 49:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1176 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.INTEGERconstant.Length = 
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.INTEGERconstant.Ignore = NO;
			    mpcScan_Attribute.INTEGERconstant.IntConst =
					atoi (Word);
			    mpcScan_Attribute.INTEGERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.INTEGERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.INTEGERconstant.SymForm+length) = '\0';
                  	    return 5; 
} yyy175: goto yyBegin;
case 34:;
case 51:;
case 52:;
case 53:;
case 68:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1189 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.OCTALconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.OCTALconstant.Ignore = NO;
                            mpcScan_Attribute.OCTALconstant.OctConst =
				(int) strtol (Word, (char * *)NULL, 8);
			    mpcScan_Attribute.OCTALconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.OCTALconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.OCTALconstant.SymForm+length) = '\0';
                            return 6; 
} yyy176: goto yyBegin;
case 36:;
case 56:;
case 57:;
case 58:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1202 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.HEXconstant.Length =
			    		length = mpcScan_GetWord (Word);
                            mpcScan_Attribute.HEXconstant.Ignore = NO;
                            mpcScan_Attribute.HEXconstant.HexConst =
				(int) strtol (Word, (char * *)NULL, 16);
			    mpcScan_Attribute.HEXconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.HEXconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.HEXconstant.SymForm+length) = '\0';
                            return 7	; 
} yyy177: goto yyBegin;
case 35:;
case 54:;
case 55:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1215 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.FLOATINGconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.FLOATINGconstant.Ignore = NO;
			    mpcScan_Attribute.FLOATINGconstant.FloatConst = atof (Word);
			    mpcScan_Attribute.FLOATINGconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.FLOATINGconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.FLOATINGconstant.SymForm+length) = '\0';
                            return 4; 
} yyy178: goto yyBegin;
case 37:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1227 "mpc.rex" */
{ EmptyHeader = false;
			    mpcScan_Attribute.CHARACTERconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.CHARACTERconstant.Ignore = NO;
			    mpcScan_Attribute.CHARACTERconstant.CharConst =
					Str_to_Char (Word,
						     mpcScan_Attribute.Position);
				/***	Str_to_Char (PutString(Word, length));*/
			    mpcScan_Attribute.CHARACTERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.CHARACTERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.CHARACTERconstant.SymForm+length) = '\0';
                            return 8; 
} yyy179: goto yyBegin;
case 38:;
mpcScan_Attribute.Position.Line   = yyLineCount;
mpcScan_Attribute.Position.Column = (unsigned char *) mpcScan_TokenPtr - yyLineStart;
/* line 1242 "mpc.rex" */
{ int i;
			    EmptyHeader = false;
			    mpcScan_Attribute.STRINGliteral.Length =
			    		length = mpcScan_GetWord (Word);
			/**************************************/
			    mpcScan_Attribute.STRINGliteral.Ignore = NO;
			    mpcScan_Attribute.STRINGliteral.SymForm = 
						(char*)malloc(length+1);
			    *(Word+length) = '\0';
			    mpcScan_Attribute.STRINGliteral.SymForm =
				memcpy (mpcScan_Attribute.STRINGliteral.SymForm,
					Word, length+1);
			    length -= 2;   /* remove begin- and end-'"',then *
					    * convert esc. seq. to code:     */
			    for(index=i=1; index<=length; index++,i++) {
			      if(Word[index]=='\\') { /* escape sequence: */
				index++;
				switch(Word[index]){
				  case'\'': Word[i] = '\''; break;
				  case'"': Word[i] = '\"'; break;
				  case'?': Word[i] = '\?'; break;
				  case'\\': Word[i] = '\\'; break;
				  case'a': Word[i] = '\a'; break;
				  case'b': Word[i] = '\b'; break;
				  case'f': Word[i] = '\f'; break;
				  case'n': Word[i] = '\n'; break;
				  case'r': Word[i] = '\r'; break;
				  case't': Word[i] = '\t'; break;
				  case'v': Word[i] = '\v'; break;
				  default:
				    if(Word[index]>='0' && Word[index]<='7')
					Word[i] = Get_Oct_Code(
							Word+index, &index);
				    else
				    if(Word[index]=='x')
					Word[i] = Get_Hex_Code(
							Word + ++index, &index);
				    else
				      Make_Message(
					54, xxError, mpcScan_Attribute.Position, NoTree);
				/* "Invalid escape sequence in string literal" */
				    index--;
				}
			      }
			      else
				Word[i] = Word[index];
			    }
			    length = i-1;
			    mpcScan_Attribute.STRINGliteral.Length = i; /*bytes*/
			    mpcScan_Attribute.STRINGliteral.StrLit =
						(char*)malloc(i);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.STRINGliteral.StrLit+index) =
							Word[index+1];
			    *(mpcScan_Attribute.STRINGliteral.StrLit+length) = '\0';
                            return 9; 
} yyy180: goto yyBegin;
case 33:;
/* line 1299 "mpc.rex" */
{
} yyy181: goto yyBegin;
case 87:;
case 92:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
mpcScan_TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yyy182: goto yyBegin;
case 84:;
case 86:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) mpcScan_TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yyy183: goto yyBegin;
case 82:;
{/* EolAction */
yyLineCount ++;
yyLineStart = yyChBufferIndexReg - 1;
} yyy184: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 7:;
case 8:;
case 9:;
case 10:;
case 11:;
case 12:;
case 13:;
case 14:;
case 15:;
case 16:;
case 17:;
case 18:;
case 19:;
case 20:;
case 21:;
case 39:;
case 40:;
case 59:;
case 61:;
case 62:;
case 63:;
case 64:;
case 65:;
case 66:;
case 67:;
case 69:;
case 70:;
case 71:;
case 72:;
case 73:;
case 74:;
case 75:;
case 76:;
case 77:;
case 78:;
case 79:;
case 371:;
case 372:;
case 374:;
case 375:;
case 378:;
case 381:;
case 383:;
case 384:;
case 386:;
case 402:;
case 501:;
case 505:;
case 507:;
case 508:;
case 510:;
case 511:;
case 513:;
case 514:;
case 515:;
case 517:;
case 518:;
case 519:;
case 520:;
case 522:;
case 523:;
case 531:;
case 532:;
case 533:;
case 534:;
case 535:;
case 549:;
case 550:;
case 551:;
case 552:;
case 553:;
case 555:;
case 556:;
case 557:;
case 558:;
case 570:;
case 571:;
case 572:;
case 573:;
case 581:;
case 582:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 81:
	 mpcScan_Attribute.Position.Line   = yyLineCount;
	 mpcScan_Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* mpcScan_TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 439 "mpc.rex" */

  Make_MessageI(51, xxError, mpcScan_Attribute.Position, xxCharacter, mpcScan_TokenPtr, NoTree);
		/* "Illegal character" */
  /********
  switch(yyStartState) {
    case comment: printf("---- comment ----\n"); break;
    case linecomment: printf("---- linecomment ----\n"); break;
    case position: printf("---- position ----\n"); break;
    case file: printf("---- file ----\n"); break;
    case pragma: printf("---- pragma ----\n"); break;
    case keywords: printf("---- keywords ----\n"); break;
    case native: printf("---- native ----\n"); break;
    case unused: printf("---- unused ----\n"); break;
    default: printf("---- STD ----\n"); break;
  }*******/

  if(yyStartState==position || yyStartState==pragma || yyStartState==unused) {
    Make_Message(52, xxInformation, mpcScan_Attribute.Position, NoTree);
		/* "Maybe your 'cpp' don't allows some ANSI C facilities" */
    Print_Messages();
    exit(1);
  }

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 80:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- mpcScan_TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = mpcScan_TokenPtr;
	    register char * yyTarget = mpcScan_TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - mpcScan_TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - mpcScan_TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       mpcScan_TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - mpcScan_TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = mpcScan_GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (mpcScan_TokenLength == 0) {		/* end of file reached */
	    mpcScan_Attribute.Position.Line   = yyLineCount;
	    mpcScan_Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    mpcScan_CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
/* line 463 "mpc.rex" */
 if( yyStartState == comment )
            Make_Message(53, xxError, mpcScan_Attribute.Position, NoTree);
		/* "Unclosed comment" */

	    }
	    if (yyFileStackPtr == yyFileStack) return mpcScan_EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void mpcScan_BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = mpcScan_BeginSource (yyFileName);
      if (yySourceFile < 0) yyErrorMessage (4);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void mpcScan_CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      mpcScan_CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int mpcScan_GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
int mpcScan_GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
int mpcScan_GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= mpcScan_TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - mpcScan_TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = mpcScan_GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void mpcScan_BeginScanner ()
   {
   }
 
void mpcScan_CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, mpcScan_Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": mpcScan: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": mpcScan: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": mpcScan: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": mpcScan: file stack underflow (too many calls of mpcScan_CloseFile)\n"); break;
      case 4: (void) fprintf (stderr, ": mpcScan: cannot open input file\n"); break;
      }
      mpcScan_Exit ();
   }
